#include <rf_core.hh>
#include <refal/Access.hh>
#include <refal/Arithm.hh>
#include <refal/Apply.hh>
#include <refal/Compare.hh>
#include <refal/Class.hh>
#include <refal/JavaMangle.hh>
#include <refal/Convert.hh>
#include <refal/Box.hh>
#include <refal/StdIO.hh>
#include <refal/Table.hh>
#include "rfpc.hh"
#include "rfp_helper.hh"
#include <refal/List.hh>

namespace refal
{

using namespace rfrt;

namespace rfp__asail__java
{

static Expr Int;

static Expr Exports;

static Expr Inputs;

static Expr Module_m_Name;

static Expr Entry;

static Expr Entry_m_Name;

static Expr Current_m_Namespace;

static Expr Func_m_Name;

static Expr Ress;

static Expr Result;

static Expr Res_m_Assigns;

static Expr Iter_m_Vars;

static Expr Free_m_Idx;

RF_DECL (RFP_m_ASAIL_m_To_m_Java);

RF_DECL (ASAIL_m_To_m_Java);

RF_DECL (Declare_m_Results);

RF_DECL (Expr_m_To_m_Java);

RF_DECL (Expr_m_Ref_m_To_m_Java);

RF_DECL (Term_m_Ref_m_To_m_Java);

RF_DECL (Expr_m_Int_m_To_m_Java);

RF_DECL (Cond_m_To_m_Java);

RF_DECL (Infix_m_To_m_Java);

RF_DECL (Step_m_To_m_Java);

RF_DECL (Const_m_Expr_m_To_m_Java);

RF_DECL (Const_m_Expr_m_Aux);

RF_DECL (Symbol_m_To_m_Java);

RF_DECL (Int_m_Args_m_To_m_Java);

RF_DECL (Var_m_Args_m_To_m_Java);

RF_DECL (Expr_m_Args_m_To_m_Java);

RF_DECL (Name_m_To_m_Java);

RF_DECL (Var_m_To_m_Java);

RF_DECL (Access_m_Mode);

RF_DECL (Free_m_Index);

RF_DECL (Expr_m_Int_m_To_m_Java__0);

RF_DECL (Term_m_Ref_m_To_m_Java__0);

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_6;

static Expr _c_4;

static Expr _c_5;

static Expr _c_7;

static Expr _c_171;

static Expr _c_172;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_149;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_26;

static Expr _c_27;

static Expr _c_28;

static Expr _c_29;

static Expr _c_30;

static Expr _c_49;

static Expr _c_31;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

static Expr _c_36;

static Expr _c_37;

static Expr _c_38;

static Expr _c_39;

static Expr _c_173;

static Expr _c_40;

static Expr _c_41;

static Expr _c_42;

static Expr _c_43;

static Expr _c_44;

static Expr _c_45;

static Expr _c_46;

static Expr _c_47;

static Expr _c_48;

static Expr _c_50;

static Expr _c_51;

static Expr _c_52;

static Expr _c_53;

static Expr _c_54;

static Expr _c_174;

static Expr _c_100;

static Expr _c_55;

static Expr _c_56;

static Expr _c_57;

static Expr _c_58;

static Expr _c_59;

static Expr _c_60;

static Expr _c_61;

static Expr _c_62;

static Expr _c_63;

static Expr _c_64;

static Expr _c_65;

static Expr _c_66;

static Expr _c_67;

static Expr _c_68;

static Expr _c_69;

static Expr _c_70;

static Expr _c_71;

static Expr _c_72;

static Expr _c_73;

static Expr _c_74;

static Expr _c_75;

static Expr _c_76;

static Expr _c_77;

static Expr _c_78;

static Expr _c_96;

static Expr _c_79;

static Expr _c_80;

static Expr _c_81;

static Expr _c_82;

static Expr _c_83;

static Expr _c_84;

static Expr _c_85;

static Expr _c_86;

static Expr _c_87;

static Expr _c_88;

static Expr _c_89;

static Expr _c_90;

static Expr _c_91;

static Expr _c_92;

static Expr _c_93;

static Expr _c_94;

static Expr _c_95;

static Expr _c_97;

static Expr _c_98;

static Expr _c_99;

static Expr _c_101;

static Expr _c_102;

static Expr _c_103;

static Expr _c_104;

static Expr _c_105;

static Expr _c_106;

static Expr _c_107;

static Expr _c_108;

static Expr _c_109;

static Expr _c_110;

static Expr _c_111;

static Expr _c_112;

static Expr _c_113;

static Expr _c_114;

static Expr _c_144;

static Expr _c_115;

static Expr _c_116;

static Expr _c_117;

static Expr _c_118;

static Expr _c_119;

static Expr _c_120;

static Expr _c_121;

static Expr _c_122;

static Expr _c_123;

static Expr _c_124;

static Expr _c_125;

static Expr _c_126;

static Expr _c_127;

static Expr _c_128;

static Expr _c_129;

static Expr _c_130;

static Expr _c_131;

static Expr _c_132;

static Expr _c_133;

static Expr _c_134;

static Expr _c_135;

static Expr _c_136;

static Expr _c_137;

static Expr _c_138;

static Expr _c_139;

static Expr _c_140;

static Expr _c_141;

static Expr _c_142;

static Expr _c_143;

static Expr _c_145;

static Expr _c_146;

static Expr _c_147;

static Expr _c_148;

static Expr _c_150;

static Expr _c_151;

static Expr _c_152;

static Expr _c_153;

static Expr _c_154;

static Expr _c_155;

static Expr _c_157;

static Expr _c_156;

static Expr _c_158;

static Expr _c_159;

static Expr _c_160;

static Expr _c_161;

static Expr _c_162;

static Expr _c_163;

static Expr _c_164;

static Expr _c_165;

static Expr _c_166;

static Expr _c_167;

static Expr _c_168;

static Expr _c_169;

static Expr _c_170;

RF_FUNC (RFP_m_ASAIL_m_To_m_Java, (RF_ARG _gt_arg1, _ge_arg2, _ge_arg3;;), (RF_RES _v_res1, _v_res2, _v_res3;;))
  uintptr_t _v_len1 = (_ge_arg3.get_len () + 2);
  uintptr_t _v_len2 = 2;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__asail = (_v_len1 - _v_len2);
  Expr _v_compose1 ((_gt_arg1 + _ge_arg2 () + _ge_arg3));
  if (_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (_v_compose1, 0);
  Expr _v_deref__compose12 (_v_compose1, (0 + 1));
  uintptr_t _v_len3 = _v_deref__compose12.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__exports = (_v_len3 - _v_len4);
  uintptr_t _v_len5 = _v_deref__compose1.get_len ();
  uintptr_t _v_len6 = 0;
  if (_v_len5 < _v_len6)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__ModuleName = (_v_len5 - _v_len6);
  Expr _ve_asail (_v_compose1, (0 + 1 + 1), _v_len__asail);
  Expr _ve_ModuleName (_v_deref__compose1, 0, _v_len__ModuleName);
  Expr _ve_exports (_v_deref__compose12, 0, _v_len__exports);
  RF_CALL (Box::Store, (Free_m_Idx, empty), /*void*/);
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, Iter_m_Vars, /*void*/);
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, Inputs, /*void*/);
  {
    {
      Expr _ge_auxcall1;
      if (!RF_CALL (Table::Lookup, (rfp__helper::RFP_m_Options, _c_0), _ge_auxcall1))
      {
        goto _block1__branch1;
      }
      RF_CALL (Box::Store, (Int, _ge_auxcall1), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Box::Store, (Int, _c_1), /*void*/);
  }
_block1: {}
  RF_CALL (Box::Store, (Exports, _ve_exports), /*void*/);
  RF_CALL (Box::Store, (Current_m_Namespace, _ve_ModuleName), /*void*/);
  {
    {
      Expr _ge_auxcall2;
      if (!RF_CALL (Table::Lookup, (rfp__helper::RFP_m_Options, _c_2), _ge_auxcall2))
      {
        goto _block2__branch1;
      }
      RF_CALL (Box::Store, (Entry, _ge_auxcall2), /*void*/);
      goto _block2;
    }
  _block2__branch1: {}
    RF_CALL (Box::Store, (Entry, (_ve_ModuleName + _c_3) ()), /*void*/);
  }
_block2: {}
  RF_CALL (Box::Store, (Entry_m_Name, empty), /*void*/);
  Expr _ge_auxcall3;
  RF_CALL (List::Intersperse, (_c_4, _ve_ModuleName), _ge_auxcall3);
  RF_CALL (Box::Store, (Module_m_Name, _ge_auxcall3), /*void*/);
  Expr _ve_java_m_module_m_name;
  RF_CALL (JavaMangle::Rfp2Java, _ve_ModuleName, _ve_java_m_module_m_name);
  {
    {
      Expr _v_ASAIL_m_To_m_Java1;
      RF_CALL (ASAIL_m_To_m_Java, _ve_asail, _v_ASAIL_m_To_m_Java1);
      uintptr_t _v_len7 = _v_ASAIL_m_To_m_Java1.get_len ();
      uintptr_t _v_len8 = 0;
      if (_v_len7 < (_v_len8 + 1))
      {
        goto _block3__branch1;
      }
      uintptr_t _v_len__java = (_v_len7 - _v_len8);
      Expr _vv_java (_v_ASAIL_m_To_m_Java1, 0, _v_len__java);
      Expr _ve_entry;
      {
        {
          Expr _v__q_1;
          RF_CALL (Box::_q_, Entry_m_Name, _v__q_1);
          uintptr_t _v_len9 = _v__q_1.get_len ();
          uintptr_t _v_len10 = 0;
          if (_v_len9 < (_v_len10 + 1))
          {
            goto _block4__branch1;
          }
          uintptr_t _v_len__name = (_v_len9 - _v_len10);
          Expr _vv_name (_v__q_1, 0, _v_len__name);
          _ve_entry = (_c_12 + (_c_11 + ((_c_6 + _ve_java_m_module_m_name + _c_5) () + (_c_9 + (_vv_name + _c_7) () + _c_8) () + _c_10) () + _c_8) ());
          goto _block4;
        }
      _block4__branch1: {}
        _ve_entry = empty;
      }
    _block4: {}
      Expr _ge_auxcall4;
      RF_CALL (Table::Domain, Inputs, _ge_auxcall4);
      _v_res1 = _ve_java_m_module_m_name;
      _v_res2 = _ge_auxcall4;
      _v_res3 = (_c_14 + _ve_java_m_module_m_name + _c_13 + (_vv_java + _ve_entry) () + _c_8) ();
      goto _block3;
    }
  _block3__branch1: {}
    _v_res1 = _ve_java_m_module_m_name;
    _v_res2 = empty;
    _v_res3 = empty;
  }
_block3: {}
RF_END

RF_FUNC (ASAIL_m_To_m_Java, (RF_ARG _ve_asail;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ve_asail.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_item (_ve_asail, 0, 1);
      Expr _ve_rest (_ve_asail, (0 + 1), _v_len__rest);
      Expr _ve_java_m_item;
      {
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__item (_vt_item, 0);
          uintptr_t _v_len3 = _v_deref__item.get_len ();
          uintptr_t _v_len4 = 2;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__asail__javarf_m_106_m_20 = (_v_len3 - _v_len4);
          if (!_v_deref__item.symbol_at (0))
          {
            goto _block2__branch1;
          }
          if (!_c_15.term_eq (_v_deref__item, (0 + 1)))
          {
            goto _block2__branch1;
          }
          Expr _vs_tag (_v_deref__item, 0, 1);
          Expr _ve__e__e_tmp_m_rfp__asail__javarf_m_106_m_20 (_v_deref__item, (0 + 1 + 1), _v_len___e__e_tmp_m_rfp__asail__javarf_m_106_m_20);
          _ve_java_m_item = empty;
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__item2 (_vt_item, 0);
          uintptr_t _v_len5 = _v_deref__item2.get_len ();
          uintptr_t _v_len6 = 5;
          if (_v_len5 < _v_len6)
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len__body = (_v_len5 - _v_len6);
          if (_v_deref__item2.symbol_at ((0 + 1 + 1 + 1)))
          {
            goto _block2__branch2;
          }
          if (_v_deref__item2.symbol_at ((0 + 1 + 1 + 1 + 1)))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__deref__item2 (_v_deref__item2, (0 + 1 + 1 + 1));
          Expr _v_deref__deref__item22 (_v_deref__item2, (0 + 1 + 1 + 1 + 1));
          uintptr_t _v_len7 = _v_deref__deref__item22.get_len ();
          uintptr_t _v_len8 = 0;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len__ress = (_v_len7 - _v_len8);
          uintptr_t _v_len9 = _v_deref__deref__item2.get_len ();
          uintptr_t _v_len10 = 0;
          if (_v_len9 < _v_len10)
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len__args = (_v_len9 - _v_len10);
          if (!_v_deref__item2.symbol_at (0))
          {
            goto _block2__branch2;
          }
          if (!_v_deref__item2.symbol_at ((0 + 1)))
          {
            goto _block2__branch2;
          }
          Expr _vs_tag (_v_deref__item2, 0, 1);
          Expr _vs_linkage (_v_deref__item2, (0 + 1), 1);
          Expr _vt_name (_v_deref__item2, (0 + 1 + 1), 1);
          Expr _ve_body (_v_deref__item2, (0 + 1 + 1 + 1 + 1 + 1), _v_len__body);
          Expr _ve_args (_v_deref__deref__item2, 0, _v_len__args);
          Expr _ve_ress (_v_deref__deref__item22, 0, _v_len__ress);
          Expr _ve_return_m_type;
          Expr _ve_return;
          {
            {
              if (!_vs_tag.term_eq (_c_16, 0))
              {
                goto _block3__branch1;
              }
              _ve_return_m_type = _c_17;
              _ve_return = empty;
              goto _block3;
            }
          _block3__branch1: {}
            if (!_vs_tag.term_eq (_c_18, 0))
            {
              goto _block2__branch2;
            }
            _ve_return_m_type = _c_19;
            _ve_return = _c_20;
          }
        _block3: {}
          RF_CALL (Box::Store, (Ress, _ve_ress), /*void*/);
          RF_CALL (rfp__helper::RFP_m_Clear_m_Table, Result, /*void*/);
          {
            {
              Expr _v__q_1;
              RF_CALL (Box::_q_, Entry, _v__q_1);
              if (_v__q_1.get_len () < 1)
              {
                goto _block4__branch1;
              }
              RF_lsplit (_v__q_1, 0, _ve__e__e_tmp_m_rfp__asail__javarf_m_114_m_23, _v_lsplit___q_1);
              for ( ; ; RF_iter(_v__q_1)++)
              {
                {
                  if (!RF_iter(_v__q_1))
                  {
                    goto _block4__branch1;
                  }
                  uintptr_t _v_len11 = _v_lsplit___q_1.get_len ();
                  uintptr_t _v_len12 = 1;
                  if (_v_len11 < _v_len12)
                  {
                    goto _block4__branch1;
                  }
                  uintptr_t _v_len___e__e_tmp_m_rfp__asail__javarf_m_114_m_32 = (_v_len11 - _v_len12);
                  if (!_vt_name.term_eq (_v_lsplit___q_1, 0))
                  {
                    goto _continue1;
                  }
                  Expr _ve__e__e_tmp_m_rfp__asail__javarf_m_114_m_32 (_v_lsplit___q_1, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__javarf_m_114_m_32);
                  Expr _ge_auxcall1;
                  RF_CALL (JavaMangle::Rfp2Java, _vt_name, _ge_auxcall1);
                  RF_CALL (Box::Store, (Entry_m_Name, _ge_auxcall1), /*void*/);
                  goto _exit1;
                }
            _continue1: {}
              }
            _exit1: {}
              goto _block4;
            }
          _block4__branch1: {}
          }
        _block4: {}
          Expr _ge_auxcall2;
          RF_CALL (Name_m_To_m_Java, _vt_name, _ge_auxcall2);
          RF_CALL (Box::Store, (Func_m_Name, _ge_auxcall2), /*void*/);
          Expr _ge_auxcall3;
          RF_CALL (Access_m_Mode, _vt_name, _ge_auxcall3);
          Expr _ge_auxcall4;
          RF_CALL (Box::_q_, Func_m_Name, _ge_auxcall4);
          Expr _ge_auxcall5;
          RF_CALL (Var_m_Args_m_To_m_Java, (_c_22 + _ve_args + _c_21 + _ve_ress), _ge_auxcall5);
          Expr _ge_auxcall6;
          RF_CALL (ASAIL_m_To_m_Java, _ve_body, _ge_auxcall6);
          _ve_java_m_item = (_c_12 + (_c_26 + _ge_auxcall3 + _c_25 + _ve_return_m_type + _c_25 + _ge_auxcall4 + _c_24 + _ge_auxcall5 + _c_23) () + (_c_27 + (_ge_auxcall6 + _ve_return) () + _c_8) ());
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__item3 (_vt_item, 0);
          if (_v_deref__item3.get_len () != 2)
          {
            goto _block2__branch3;
          }
          if (!_c_28.term_eq (_v_deref__item3, 0))
          {
            goto _block2__branch3;
          }
          Expr _vt_name (_v_deref__item3, (0 + 1), 1);
          RF_CALL (Table::Bind, (rfpc::RFP_m_Trace, _vt_name, empty), /*void*/);
          _ve_java_m_item = empty;
          goto _block2;
        }
      _block2__branch3: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__item4 (_vt_item, 0);
          uintptr_t _v_len13 = _v_deref__item4.get_len ();
          uintptr_t _v_len14 = 4;
          if (_v_len13 < _v_len14)
          {
            goto _block2__branch4;
          }
          uintptr_t _v_len__body2 = (_v_len13 - _v_len14);
          if (_v_deref__item4.symbol_at ((0 + 1 + 1)))
          {
            goto _block2__branch4;
          }
          if (_v_deref__item4.symbol_at ((0 + 1 + 1 + 1)))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__deref__item4 (_v_deref__item4, (0 + 1 + 1));
          Expr _v_deref__deref__item42 (_v_deref__item4, (0 + 1 + 1 + 1));
          uintptr_t _v_len15 = _v_deref__deref__item42.get_len ();
          uintptr_t _v_len16 = 0;
          if (_v_len15 < _v_len16)
          {
            goto _block2__branch4;
          }
          uintptr_t _v_len__arg2 = (_v_len15 - _v_len16);
          uintptr_t _v_len17 = _v_deref__deref__item4.get_len ();
          uintptr_t _v_len18 = 0;
          if (_v_len17 < _v_len18)
          {
            goto _block2__branch4;
          }
          uintptr_t _v_len__arg1 = (_v_len17 - _v_len18);
          if (!_c_29.term_eq (_v_deref__item4, 0))
          {
            goto _block2__branch4;
          }
          if (!_v_deref__item4.symbol_at ((0 + 1)))
          {
            goto _block2__branch4;
          }
          Expr _vs_op (_v_deref__item4, (0 + 1), 1);
          Expr _ve_body (_v_deref__item4, (0 + 1 + 1 + 1 + 1), _v_len__body2);
          Expr _ve_arg1 (_v_deref__deref__item4, 0, _v_len__arg1);
          Expr _ve_arg2 (_v_deref__deref__item42, 0, _v_len__arg2);
          Expr _vs_acc;
          RF_CALL (Box::Box, empty, _vs_acc);
          Expr _ge_auxcall7;
          RF_CALL (Expr_m_Int_m_To_m_Java, (_vs_acc, _ve_arg1), _ge_auxcall7);
          Expr _v_Expr_m_Int_m_To_m_Java1;
          RF_CALL (Expr_m_Int_m_To_m_Java, (_vs_acc, _ve_arg2), _v_Expr_m_Int_m_To_m_Java1);
          Expr _ve_cond ((_ge_auxcall7 + _c_25 + _vs_op + _c_25 + _v_Expr_m_Int_m_To_m_Java1));
          Expr _ge_auxcall8;
          RF_CALL (Box::_q_, _vs_acc, _ge_auxcall8);
          Expr _ge_auxcall9;
          RF_CALL (ASAIL_m_To_m_Java, _ve_body, _ge_auxcall9);
          _ve_java_m_item = (_ge_auxcall8 + (_c_31 + _ve_cond + _c_30) () + (_c_27 + _ge_auxcall9 () + _c_8) ());
          goto _block2;
        }
      _block2__branch4: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch5;
          }
          Expr _v_deref__item5 (_vt_item, 0);
          uintptr_t _v_len19 = _v_deref__item5.get_len ();
          uintptr_t _v_len20 = 2;
          if (_v_len19 < _v_len20)
          {
            goto _block2__branch5;
          }
          uintptr_t _v_len__body3 = (_v_len19 - _v_len20);
          if (!_c_32.term_eq (_v_deref__item5, 0))
          {
            goto _block2__branch5;
          }
          Expr _vt_cond (_v_deref__item5, (0 + 1), 1);
          Expr _ve_body (_v_deref__item5, (0 + 1 + 1), _v_len__body3);
          Expr _vs_acc;
          RF_CALL (Box::Box, empty, _vs_acc);
          Expr _ve_j_m_cond;
          RF_CALL (Cond_m_To_m_Java, (_vs_acc, _vt_cond), _ve_j_m_cond);
          Expr _ve_if_m_yes_m_assigns;
          Expr _ve_if_m_not_m_assigns;
          {
            {
              if (_vt_cond.symbol_at (0))
              {
                goto _block5__branch1;
              }
              Expr _v_deref__cond (_vt_cond, 0);
              uintptr_t _v_len21 = _v_deref__cond.get_len ();
              uintptr_t _v_len22 = 1;
              if (_v_len21 < _v_len22)
              {
                goto _block5__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__asail__javarf_m_133_m_31 = (_v_len21 - _v_len22);
              if (!_c_33.term_eq (_v_deref__cond, 0))
              {
                goto _block5__branch1;
              }
              Expr _ve__e__e_tmp_m_rfp__asail__javarf_m_133_m_31 (_v_deref__cond, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__javarf_m_133_m_31);
              Expr _ge_auxcall10;
              RF_CALL (Box::_q_, Res_m_Assigns, _ge_auxcall10);
              RF_CALL (Box::Store, (Res_m_Assigns, empty), /*void*/);
              _ve_if_m_yes_m_assigns = empty;
              _ve_if_m_not_m_assigns = _ge_auxcall10;
              goto _block5;
            }
          _block5__branch1: {}
            Expr _ge_auxcall11;
            RF_CALL (Box::_q_, Res_m_Assigns, _ge_auxcall11);
            RF_CALL (Box::Store, (Res_m_Assigns, empty), /*void*/);
            _ve_if_m_yes_m_assigns = _ge_auxcall11;
            _ve_if_m_not_m_assigns = empty;
          }
        _block5: {}
          Expr _ge_auxcall12;
          RF_CALL (Box::_q_, _vs_acc, _ge_auxcall12);
          Expr _ge_auxcall13;
          RF_CALL (ASAIL_m_To_m_Java, _ve_body, _ge_auxcall13);
          _ve_java_m_item = (_ge_auxcall12 + (_c_31 + _ve_j_m_cond + _c_30) () + (_c_27 + (_ve_if_m_yes_m_assigns + _ge_auxcall13) () + _c_8) () + _ve_if_m_not_m_assigns);
          goto _block2;
        }
      _block2__branch5: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch6;
          }
          Expr _v_deref__item6 (_vt_item, 0);
          uintptr_t _v_len23 = _v_deref__item6.get_len ();
          uintptr_t _v_len24 = 5;
          if (_v_len23 < _v_len24)
          {
            goto _block2__branch6;
          }
          uintptr_t _v_len__body4 = (_v_len23 - _v_len24);
          if (_v_deref__item6.symbol_at ((0 + 1)))
          {
            goto _block2__branch6;
          }
          if (_v_deref__item6.symbol_at ((0 + 1 + 1)))
          {
            goto _block2__branch6;
          }
          if (_v_deref__item6.symbol_at ((0 + 1 + 1 + 1 + 1)))
          {
            goto _block2__branch6;
          }
          Expr _v_deref__deref__item6 (_v_deref__item6, (0 + 1));
          Expr _v_deref__deref__item62 (_v_deref__item6, (0 + 1 + 1));
          Expr _v_deref__deref__item63 (_v_deref__item6, (0 + 1 + 1 + 1 + 1));
          uintptr_t _v_len25 = _v_deref__deref__item6.get_len ();
          uintptr_t _v_len26 = 0;
          if (_v_len25 < _v_len26)
          {
            goto _block2__branch6;
          }
          uintptr_t _v_len__cont_m_label = (_v_len25 - _v_len26);
          uintptr_t _v_len27 = _v_deref__deref__item63.get_len ();
          uintptr_t _v_len28 = 0;
          if (_v_len27 < _v_len28)
          {
            goto _block2__branch6;
          }
          uintptr_t _v_len__step = (_v_len27 - _v_len28);
          uintptr_t _v_len29 = _v_deref__deref__item62.get_len ();
          uintptr_t _v_len30 = 0;
          if (_v_len29 < _v_len30)
          {
            goto _block2__branch6;
          }
          uintptr_t _v_len__break_m_label = (_v_len29 - _v_len30);
          if (!_c_34.term_eq (_v_deref__item6, 0))
          {
            goto _block2__branch6;
          }
          if (!_c_12.term_eq (_v_deref__item6, (0 + 1 + 1 + 1)))
          {
            goto _block2__branch6;
          }
          Expr _ve_body (_v_deref__item6, (0 + 1 + 1 + 1 + 1 + 1), _v_len__body4);
          Expr _ve_cont_m_label (_v_deref__deref__item6, 0, _v_len__cont_m_label);
          Expr _ve_break_m_label (_v_deref__deref__item62, 0, _v_len__break_m_label);
          Expr _ve_step (_v_deref__deref__item63, 0, _v_len__step);
          Expr _ve_cont;
          {
            {
              if (_v_len__cont_m_label != 1)
              {
                goto _block6__branch1;
              }
              Expr _vt__e__e_tmp_m_rfp__asail__javarf_m_146_m_25 (_ve_cont_m_label, 0, 1);
              Expr _ge_auxcall14;
              RF_CALL (JavaMangle::Rfp2Java, (_c_35 + _ve_cont_m_label) (), _ge_auxcall14);
              _ve_cont = (_ge_auxcall14 + _c_36);
              goto _block6;
            }
          _block6__branch1: {}
            _ve_cont = empty;
          }
        _block6: {}
          Expr _ve_break;
          {
            {
              if (_v_len__break_m_label != 1)
              {
                goto _block7__branch1;
              }
              Expr _vt__e__e_tmp_m_rfp__asail__javarf_m_149_m_26 (_ve_break_m_label, 0, 1);
              Expr _ge_auxcall15;
              RF_CALL (JavaMangle::Rfp2Java, (_c_35 + _ve_break_m_label) (), _ge_auxcall15);
              _ve_break = (_ge_auxcall15 + _c_36);
              goto _block7;
            }
          _block7__branch1: {}
            _ve_break = empty;
          }
        _block7: {}
          Expr _ve_split_m_vars;
          {
            {
              if (_v_len__step != 1)
              {
                goto _block8__branch1;
              }
              if (_ve_step.symbol_at (0))
              {
                goto _block8__branch1;
              }
              Expr _v_deref__step (_ve_step, 0);
              uintptr_t _v_len31 = _v_deref__step.get_len ();
              uintptr_t _v_len32 = 1;
              if (_v_len31 < _v_len32)
              {
                goto _block8__branch1;
              }
              uintptr_t _v_len__var = (_v_len31 - _v_len32);
              if (!_v_deref__step.symbol_at (0))
              {
                goto _block8__branch1;
              }
              Expr _vs_d (_v_deref__step, 0, 1);
              Expr _ve_var (_v_deref__step, (0 + 1), _v_len__var);
              {
                {
                  if (!_vs_d.term_eq (_c_37, 0))
                  {
                    goto _block9__branch1;
                  }
                  goto _block9;
                }
              _block9__branch1: {}
                if (!_vs_d.term_eq (_c_38, 0))
                {
                  goto _block8__branch1;
                }
              }
            _block9: {}
              Expr _v_Lookup1;
              if (!RF_CALL (Table::Lookup, (Iter_m_Vars, _ve_var), _v_Lookup1))
              {
                goto _block1__branch1;
              }
              uintptr_t _v_len33 = _v_Lookup1.get_len ();
              uintptr_t _v_len34 = 2;
              if (_v_len33 < _v_len34)
              {
                goto _block1__branch1;
              }
              uintptr_t _v_len__new_m_var = (_v_len33 - _v_len34);
              Expr _ve_new_m_var (_v_Lookup1, 0, _v_len__new_m_var);
              Expr _vt_var1 (_v_Lookup1, (0 + _v_len__new_m_var), 1);
              Expr _vt_var2 (_v_Lookup1, (0 + _v_len__new_m_var + 1), 1);
              Expr _ge_auxcall16;
              RF_CALL (JavaMangle::Rfp2Java, _vt_var1, _ge_auxcall16);
              Expr _ge_auxcall17;
              RF_CALL (JavaMangle::Rfp2Java, _vt_var2, _ge_auxcall17);
              _ve_split_m_vars = ((_c_41 + _ge_auxcall16 + _c_40 + _ve_new_m_var + _c_39) () + (_c_41 + _ge_auxcall17 + _c_40 + _ve_new_m_var + _c_42) ());
              goto _block8;
            }
          _block8__branch1: {}
            _ve_split_m_vars = empty;
          }
        _block8: {}
          Expr _ge_auxcall18;
          RF_CALL (Step_m_To_m_Java, _ve_step, _ge_auxcall18);
          Expr _ge_auxcall19;
          RF_CALL (Box::_q_, Res_m_Assigns, _ge_auxcall19);
          RF_CALL (Box::Store, (Res_m_Assigns, empty), /*void*/);
          Expr _ge_auxcall20;
          RF_CALL (ASAIL_m_To_m_Java, _ve_body, _ge_auxcall20);
          _ve_java_m_item = ((_ve_break + _ve_cont + _c_43 + _ge_auxcall18 + _c_30) () + (_c_27 + (_ve_split_m_vars + _ge_auxcall19 + _ge_auxcall20) () + _c_8) ());
          goto _block2;
        }
      _block2__branch6: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch7;
          }
          Expr _v_deref__item7 (_vt_item, 0);
          uintptr_t _v_len35 = _v_deref__item7.get_len ();
          uintptr_t _v_len36 = 2;
          if (_v_len35 < _v_len36)
          {
            goto _block2__branch7;
          }
          uintptr_t _v_len__body5 = (_v_len35 - _v_len36);
          if (_v_deref__item7.symbol_at ((0 + 1)))
          {
            goto _block2__branch7;
          }
          Expr _v_deref__deref__item7 (_v_deref__item7, (0 + 1));
          uintptr_t _v_len37 = _v_deref__deref__item7.get_len ();
          uintptr_t _v_len38 = 0;
          if (_v_len37 < _v_len38)
          {
            goto _block2__branch7;
          }
          uintptr_t _v_len__label = (_v_len37 - _v_len38);
          if (!_c_35.term_eq (_v_deref__item7, 0))
          {
            goto _block2__branch7;
          }
          Expr _ve_body (_v_deref__item7, (0 + 1 + 1), _v_len__body5);
          Expr _ve_label (_v_deref__deref__item7, 0, _v_len__label);
          Expr _ge_auxcall21;
          RF_CALL (JavaMangle::Rfp2Java, (_c_35 + _ve_label) (), _ge_auxcall21);
          Expr _ge_auxcall22;
          RF_CALL (ASAIL_m_To_m_Java, _ve_body, _ge_auxcall22);
          _ve_java_m_item = (_ge_auxcall21 + _c_44 + _ge_auxcall22 () + _c_8) ();
          goto _block2;
        }
      _block2__branch7: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch8;
          }
          Expr _v_deref__item8 (_vt_item, 0);
          uintptr_t _v_len39 = _v_deref__item8.get_len ();
          uintptr_t _v_len40 = 1;
          if (_v_len39 < _v_len40)
          {
            goto _block2__branch8;
          }
          uintptr_t _v_len__body6 = (_v_len39 - _v_len40);
          if (!_c_45.term_eq (_v_deref__item8, 0))
          {
            goto _block2__branch8;
          }
          Expr _ve_body (_v_deref__item8, (0 + 1), _v_len__body6);
          Expr _ge_auxcall23;
          RF_CALL (Box::_q_, Module_m_Name, _ge_auxcall23);
          Expr _ge_auxcall24;
          RF_CALL (Box::_q_, Func_m_Name, _ge_auxcall24);
          Expr _ge_auxcall25;
          RF_CALL (ASAIL_m_To_m_Java, _ve_body, _ge_auxcall25);
          _ve_java_m_item = (_c_50 + (_c_27 + ((_c_49 + (_c_48 + _ge_auxcall23 + _c_47 + _ge_auxcall24 + _c_46) ()) () + _ge_auxcall25) () + _c_8) ());
          goto _block2;
        }
      _block2__branch8: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch9;
          }
          Expr _v_deref__item9 (_vt_item, 0);
          uintptr_t _v_len41 = _v_deref__item9.get_len ();
          uintptr_t _v_len42 = 1;
          if (_v_len41 < _v_len42)
          {
            goto _block2__branch9;
          }
          uintptr_t _v_len__body7 = (_v_len41 - _v_len42);
          if (!_c_51.term_eq (_v_deref__item9, 0))
          {
            goto _block2__branch9;
          }
          Expr _ve_body (_v_deref__item9, (0 + 1), _v_len__body7);
          Expr _ge_auxcall26;
          RF_CALL (ASAIL_m_To_m_Java, _ve_body, _ge_auxcall26);
          _ve_java_m_item = (_c_53 + (_c_52 + _ge_auxcall26 ()) () + _c_8) ();
          goto _block2;
        }
      _block2__branch9: {}
        {
          if (!_vt_item.term_eq (_c_54, 0))
          {
            goto _block2__branch10;
          }
          _ve_java_m_item = _c_55;
          goto _block2;
        }
      _block2__branch10: {}
        {
          if (!_vt_item.term_eq (_c_56, 0))
          {
            goto _block2__branch11;
          }
          Expr _ge_auxcall27;
          RF_CALL (Box::_q_, Module_m_Name, _ge_auxcall27);
          Expr _ge_auxcall28;
          RF_CALL (Box::_q_, Func_m_Name, _ge_auxcall28);
          _ve_java_m_item = (_c_48 + _ge_auxcall27 + _c_47 + _ge_auxcall28 + _c_57) ();
          goto _block2;
        }
      _block2__branch11: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch12;
          }
          Expr _v_deref__item10 (_vt_item, 0);
          if (_v_deref__item10.get_len () != 5)
          {
            goto _block2__branch12;
          }
          if (_v_deref__item10.symbol_at ((0 + 1 + 1)))
          {
            goto _block2__branch12;
          }
          Expr _v_deref__deref__item10 (_v_deref__item10, (0 + 1 + 1));
          uintptr_t _v_len43 = _v_deref__deref__item10.get_len ();
          uintptr_t _v_len44 = 0;
          if (_v_len43 < _v_len44)
          {
            goto _block2__branch12;
          }
          uintptr_t _v_len__min = (_v_len43 - _v_len44);
          if (!_c_58.term_eq (_v_deref__item10, 0))
          {
            goto _block2__branch12;
          }
          Expr _vt_name (_v_deref__item10, (0 + 1), 1);
          Expr _vt_var1 (_v_deref__item10, (0 + 1 + 1 + 1), 1);
          Expr _vt_var2 (_v_deref__item10, (0 + 1 + 1 + 1 + 1), 1);
          Expr _ve_min (_v_deref__deref__item10, 0, _v_len__min);
          Expr _ve_a;
          Expr _ve_n;
          RF_CALL (Expr_m_Ref_m_To_m_Java, _vt_name, (_ve_a, _ve_n));
          Expr _v_Free_m_Index1;
          RF_CALL (Free_m_Index, /*void*/, _v_Free_m_Index1);
          Expr _ve_new_m_var ((_c_59 + _v_Free_m_Index1));
          RF_CALL (Table::Bind, (Iter_m_Vars, _vt_name, (_ve_new_m_var + _vt_var1 + _vt_var2)), /*void*/);
          Expr _vs_acc;
          RF_CALL (Box::Box, empty, _vs_acc);
          RF_CALL (Expr_m_Int_m_To_m_Java, (_vs_acc, _ve_min), _ve_min);
          Expr _ge_auxcall29;
          RF_CALL (Box::_q_, _vs_acc, _ge_auxcall29);
          _ve_java_m_item = (_ve_a + _ge_auxcall29 + (_c_62 + _ve_new_m_var + _c_40 + _ve_n + _c_61 + _ve_min + _c_60) ());
          goto _block2;
        }
      _block2__branch12: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch13;
          }
          Expr _v_deref__item11 (_vt_item, 0);
          if (_v_deref__item11.get_len () != 5)
          {
            goto _block2__branch13;
          }
          if (_v_deref__item11.symbol_at ((0 + 1 + 1)))
          {
            goto _block2__branch13;
          }
          Expr _v_deref__deref__item11 (_v_deref__item11, (0 + 1 + 1));
          uintptr_t _v_len45 = _v_deref__deref__item11.get_len ();
          uintptr_t _v_len46 = 0;
          if (_v_len45 < _v_len46)
          {
            goto _block2__branch13;
          }
          uintptr_t _v_len__min2 = (_v_len45 - _v_len46);
          if (!_c_63.term_eq (_v_deref__item11, 0))
          {
            goto _block2__branch13;
          }
          Expr _vt_name (_v_deref__item11, (0 + 1), 1);
          Expr _vt_var1 (_v_deref__item11, (0 + 1 + 1 + 1), 1);
          Expr _vt_var2 (_v_deref__item11, (0 + 1 + 1 + 1 + 1), 1);
          Expr _ve_min (_v_deref__deref__item11, 0, _v_len__min2);
          Expr _ve_a;
          Expr _ve_n;
          RF_CALL (Expr_m_Ref_m_To_m_Java, _vt_name, (_ve_a, _ve_n));
          Expr _v_Free_m_Index2;
          RF_CALL (Free_m_Index, /*void*/, _v_Free_m_Index2);
          Expr _ve_new_m_var ((_c_59 + _v_Free_m_Index2));
          RF_CALL (Table::Bind, (Iter_m_Vars, _vt_name, (_ve_new_m_var + _vt_var1 + _vt_var2)), /*void*/);
          Expr _vs_acc;
          RF_CALL (Box::Box, empty, _vs_acc);
          RF_CALL (Expr_m_Int_m_To_m_Java, (_vs_acc, _ve_min), _ve_min);
          Expr _ge_auxcall30;
          RF_CALL (Box::_q_, _vs_acc, _ge_auxcall30);
          _ve_java_m_item = (_ve_a + _ge_auxcall30 + (_c_62 + _ve_new_m_var + _c_40 + _ve_n + _c_64 + _ve_min + _c_60) ());
          goto _block2;
        }
      _block2__branch13: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch14;
          }
          Expr _v_deref__item12 (_vt_item, 0);
          uintptr_t _v_len47 = _v_deref__item12.get_len ();
          uintptr_t _v_len48 = 2;
          if (_v_len47 < _v_len48)
          {
            goto _block2__branch14;
          }
          uintptr_t _v_len__expr = (_v_len47 - _v_len48);
          if (!_c_65.term_eq (_v_deref__item12, 0))
          {
            goto _block2__branch14;
          }
          Expr _vt_var (_v_deref__item12, (0 + 1), 1);
          Expr _ve_expr (_v_deref__item12, (0 + 1 + 1), _v_len__expr);
          Expr _ve_a;
          Expr _ve_j_m_expr;
          RF_CALL (Expr_m_To_m_Java, (empty, _ve_expr), (_ve_a, _ve_j_m_expr));
          {
            {
              Expr _v__q_2;
              RF_CALL (Box::_q_, Ress, _v__q_2);
              if (_v__q_2.get_len () < 1)
              {
                goto _block10__branch1;
              }
              RF_lsplit (_v__q_2, 0, _ve__e__e_tmp_m_rfp__asail__javarf_m_199_m_22, _v_lsplit___q_2);
              for ( ; ; RF_iter(_v__q_2)++)
              {
                {
                  if (!RF_iter(_v__q_2))
                  {
                    goto _block10__branch1;
                  }
                  uintptr_t _v_len49 = _v_lsplit___q_2.get_len ();
                  uintptr_t _v_len50 = 1;
                  if (_v_len49 < _v_len50)
                  {
                    goto _block10__branch1;
                  }
                  uintptr_t _v_len___e__e_tmp_m_rfp__asail__javarf_m_199_m_30 = (_v_len49 - _v_len50);
                  if (!_vt_var.term_eq (_v_lsplit___q_2, 0))
                  {
                    goto _continue2;
                  }
                  Expr _ve__e__e_tmp_m_rfp__asail__javarf_m_199_m_30 (_v_lsplit___q_2, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__javarf_m_199_m_30);
                  Expr _ge_auxcall31;
                  RF_CALL (JavaMangle::Rfp2Java, _vt_var, _ge_auxcall31);
                  _ve_java_m_item = (_ve_a + (_ge_auxcall31 + _c_66 + _ve_j_m_expr + _c_60) ());
                  goto _exit2;
                }
            _continue2: {}
              }
            _exit2: {}
              goto _block10;
            }
          _block10__branch1: {}
            {
              Expr _ge_auxcall32;
              if (!RF_CALL (Table::Lookup, (Result, _vt_var), _ge_auxcall32))
              {
                goto _block10__branch2;
              }
              _ve_java_m_item = (_ve_a + (_ge_auxcall32 + _c_66 + _ve_j_m_expr + _c_60) ());
              goto _block10;
            }
          _block10__branch2: {}
            Expr _ge_auxcall33;
            RF_CALL (JavaMangle::Rfp2Java, _vt_var, _ge_auxcall33);
            _ve_java_m_item = (_ve_a + (_ge_auxcall33 + _c_40 + _ve_j_m_expr + _c_67) ());
          }
        _block10: {}
          goto _block2;
        }
      _block2__branch14: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch15;
          }
          Expr _v_deref__item13 (_vt_item, 0);
          if (_v_deref__item13.get_len () != 3)
          {
            goto _block2__branch15;
          }
          if (!_c_68.term_eq (_v_deref__item13, 0))
          {
            goto _block2__branch15;
          }
          if (!_v_deref__item13.symbol_at ((0 + 1)))
          {
            goto _block2__branch15;
          }
          Expr _vs_type (_v_deref__item13, (0 + 1), 1);
          Expr _vt_var (_v_deref__item13, (0 + 1 + 1), 1);
          Expr _ve_j_m_var;
          RF_CALL (JavaMangle::Rfp2Java, _vt_var, _ve_j_m_var);
          {
            {
              if (!_vs_type.term_eq (_c_21, 0))
              {
                goto _block11__branch1;
              }
              RF_CALL (Table::Bind, (Result, _vt_var, _ve_j_m_var), /*void*/);
              _ve_java_m_item = (_c_70 + _ve_j_m_var + _c_69) ();
              goto _block11;
            }
          _block11__branch1: {}
            RF_CALL (Table::Unbind, (Result, _vt_var), /*void*/);
            _ve_java_m_item = (_c_41 + _ve_j_m_var + _c_71) ();
          }
        _block11: {}
          goto _block2;
        }
      _block2__branch15: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch16;
          }
          Expr _v_deref__item14 (_vt_item, 0);
          uintptr_t _v_len51 = _v_deref__item14.get_len ();
          uintptr_t _v_len52 = 2;
          if (_v_len51 < _v_len52)
          {
            goto _block2__branch16;
          }
          uintptr_t _v_len__expr2 = (_v_len51 - _v_len52);
          if (!_c_0.term_eq (_v_deref__item14, 0))
          {
            goto _block2__branch16;
          }
          Expr _vt_var (_v_deref__item14, (0 + 1), 1);
          Expr _ve_expr (_v_deref__item14, (0 + 1 + 1), _v_len__expr2);
          Expr _vs_acc;
          RF_CALL (Box::Box, empty, _vs_acc);
          RF_CALL (Expr_m_Int_m_To_m_Java, (_vs_acc, _ve_expr), _ve_expr);
          Expr _ge_auxcall34;
          RF_CALL (Box::_q_, _vs_acc, _ge_auxcall34);
          Expr _ge_auxcall35;
          RF_CALL (JavaMangle::Rfp2Java, _vt_var, _ge_auxcall35);
          _ve_java_m_item = (_ge_auxcall34 + (_c_72 + _ge_auxcall35 + _c_40 + _ve_expr + _c_67) ());
          goto _block2;
        }
      _block2__branch16: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch17;
          }
          Expr _v_deref__item15 (_vt_item, 0);
          uintptr_t _v_len53 = _v_deref__item15.get_len ();
          uintptr_t _v_len54 = 2;
          if (_v_len53 < _v_len54)
          {
            goto _block2__branch17;
          }
          uintptr_t _v_len__expr3 = (_v_len53 - _v_len54);
          if (!_c_73.term_eq (_v_deref__item15, 0))
          {
            goto _block2__branch17;
          }
          Expr _vt_var (_v_deref__item15, (0 + 1), 1);
          Expr _ve_expr (_v_deref__item15, (0 + 1 + 1), _v_len__expr3);
          RF_CALL (Table::Unbind, (Result, _vt_var), /*void*/);
          Expr _ve_a;
          Expr _ve_j_m_expr;
          RF_CALL (Expr_m_Ref_m_To_m_Java, _ve_expr, (_ve_a, _ve_j_m_expr));
          Expr _ge_auxcall36;
          RF_CALL (JavaMangle::Rfp2Java, _vt_var, _ge_auxcall36);
          _ve_java_m_item = (_ve_a + (_c_41 + _ge_auxcall36 + _c_40 + _ve_j_m_expr + _c_67) ());
          goto _block2;
        }
      _block2__branch17: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch18;
          }
          Expr _v_deref__item16 (_vt_item, 0);
          uintptr_t _v_len55 = _v_deref__item16.get_len ();
          uintptr_t _v_len56 = 3;
          if (_v_len55 < _v_len56)
          {
            goto _block2__branch18;
          }
          uintptr_t _v_len__expr4 = (_v_len55 - _v_len56);
          if (_v_deref__item16.symbol_at ((0 + 1 + 1 + _v_len__expr4)))
          {
            goto _block2__branch18;
          }
          Expr _v_deref__deref__item16 (_v_deref__item16, (0 + 1 + 1 + _v_len__expr4));
          uintptr_t _v_len57 = _v_deref__deref__item16.get_len ();
          uintptr_t _v_len58 = 0;
          if (_v_len57 < _v_len58)
          {
            goto _block2__branch18;
          }
          uintptr_t _v_len__pos = (_v_len57 - _v_len58);
          if (!_c_74.term_eq (_v_deref__item16, 0))
          {
            goto _block2__branch18;
          }
          Expr _vt_var (_v_deref__item16, (0 + 1), 1);
          Expr _ve_expr (_v_deref__item16, (0 + 1 + 1), _v_len__expr4);
          Expr _ve_pos (_v_deref__deref__item16, 0, _v_len__pos);
          RF_CALL (Table::Unbind, (Result, _vt_var), /*void*/);
          Expr _ve_a;
          Expr _ve_j_m_expr;
          RF_CALL (Expr_m_Ref_m_To_m_Java, _ve_expr, (_ve_a, _ve_j_m_expr));
          Expr _vs_acc;
          RF_CALL (Box::Box, empty, _vs_acc);
          RF_CALL (Expr_m_Int_m_To_m_Java, (_vs_acc, _ve_pos), _ve_pos);
          Expr _ge_auxcall37;
          RF_CALL (Box::_q_, _vs_acc, _ge_auxcall37);
          Expr _ge_auxcall38;
          RF_CALL (JavaMangle::Rfp2Java, _vt_var, _ge_auxcall38);
          _ve_java_m_item = (_ve_a + _ge_auxcall37 + (_c_41 + _ge_auxcall38 + _c_76 + _ve_j_m_expr + _c_75 + _ve_pos + _c_60) ());
          goto _block2;
        }
      _block2__branch18: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch19;
          }
          Expr _v_deref__item17 (_vt_item, 0);
          uintptr_t _v_len59 = _v_deref__item17.get_len ();
          uintptr_t _v_len60 = 4;
          if (_v_len59 < _v_len60)
          {
            goto _block2__branch19;
          }
          uintptr_t _v_len__expr5 = (_v_len59 - _v_len60);
          if (_v_deref__item17.symbol_at ((0 + 1 + 1 + _v_len__expr5)))
          {
            goto _block2__branch19;
          }
          if (_v_deref__item17.symbol_at ((0 + 1 + 1 + _v_len__expr5 + 1)))
          {
            goto _block2__branch19;
          }
          Expr _v_deref__deref__item17 (_v_deref__item17, (0 + 1 + 1 + _v_len__expr5));
          Expr _v_deref__deref__item172 (_v_deref__item17, (0 + 1 + 1 + _v_len__expr5 + 1));
          uintptr_t _v_len61 = _v_deref__deref__item172.get_len ();
          uintptr_t _v_len62 = 0;
          if (_v_len61 < _v_len62)
          {
            goto _block2__branch19;
          }
          uintptr_t _v_len__len = (_v_len61 - _v_len62);
          uintptr_t _v_len63 = _v_deref__deref__item17.get_len ();
          uintptr_t _v_len64 = 0;
          if (_v_len63 < _v_len64)
          {
            goto _block2__branch19;
          }
          uintptr_t _v_len__pos2 = (_v_len63 - _v_len64);
          if (!_c_77.term_eq (_v_deref__item17, 0))
          {
            goto _block2__branch19;
          }
          Expr _vt_var (_v_deref__item17, (0 + 1), 1);
          Expr _ve_expr (_v_deref__item17, (0 + 1 + 1), _v_len__expr5);
          Expr _ve_pos (_v_deref__deref__item17, 0, _v_len__pos2);
          Expr _ve_len (_v_deref__deref__item172, 0, _v_len__len);
          RF_CALL (Table::Unbind, (Result, _vt_var), /*void*/);
          Expr _ve_a;
          Expr _ve_j_m_expr;
          RF_CALL (Expr_m_Ref_m_To_m_Java, _ve_expr, (_ve_a, _ve_j_m_expr));
          Expr _vs_acc;
          RF_CALL (Box::Box, empty, _vs_acc);
          RF_CALL (Expr_m_Int_m_To_m_Java, (_vs_acc, _ve_pos), _ve_pos);
          RF_CALL (Expr_m_Int_m_To_m_Java, (_vs_acc, _ve_len), _ve_len);
          Expr _ge_auxcall39;
          RF_CALL (Box::_q_, _vs_acc, _ge_auxcall39);
          Expr _ge_auxcall40;
          RF_CALL (JavaMangle::Rfp2Java, _vt_var, _ge_auxcall40);
          _ve_java_m_item = (_ve_a + _ge_auxcall39 + (_c_41 + _ge_auxcall40 + _c_79 + _ve_j_m_expr + _c_78 + _ve_pos + _c_78 + _ve_len + _c_60) ());
          goto _block2;
        }
      _block2__branch19: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch20;
          }
          Expr _v_deref__item18 (_vt_item, 0);
          if (_v_deref__item18.get_len () != 2)
          {
            goto _block2__branch20;
          }
          if (!_c_80.term_eq (_v_deref__item18, 0))
          {
            goto _block2__branch20;
          }
          Expr _vt_var (_v_deref__item18, (0 + 1), 1);
          Expr _ge_auxcall41;
          RF_CALL (Var_m_To_m_Java, _vt_var, _ge_auxcall41);
          _ve_java_m_item = (_ge_auxcall41 + _c_81) ();
          goto _block2;
        }
      _block2__branch20: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch21;
          }
          Expr _v_deref__item19 (_vt_item, 0);
          if (_v_deref__item19.get_len () != 2)
          {
            goto _block2__branch21;
          }
          if (!_c_82.term_eq (_v_deref__item19, 0))
          {
            goto _block2__branch21;
          }
          Expr _vt_label (_v_deref__item19, (0 + 1), 1);
          Expr _ge_auxcall42;
          RF_CALL (JavaMangle::Rfp2Java, (_c_35 + _vt_label) (), _ge_auxcall42);
          _ve_java_m_item = (_c_83 + _ge_auxcall42 + _c_67) ();
          goto _block2;
        }
      _block2__branch21: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch22;
          }
          Expr _v_deref__item20 (_vt_item, 0);
          if (_v_deref__item20.get_len () != 2)
          {
            goto _block2__branch22;
          }
          if (!_c_84.term_eq (_v_deref__item20, 0))
          {
            goto _block2__branch22;
          }
          Expr _vt_label (_v_deref__item20, (0 + 1), 1);
          Expr _ge_auxcall43;
          RF_CALL (JavaMangle::Rfp2Java, (_c_35 + _vt_label) (), _ge_auxcall43);
          _ve_java_m_item = (_c_85 + _ge_auxcall43 + _c_67) ();
          goto _block2;
        }
      _block2__branch22: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch23;
          }
          Expr _v_deref__item21 (_vt_item, 0);
          uintptr_t _v_len65 = _v_deref__item21.get_len ();
          uintptr_t _v_len66 = 1;
          if (_v_len65 < _v_len66)
          {
            goto _block2__branch23;
          }
          uintptr_t _v_len__expr6 = (_v_len65 - _v_len66);
          if (!_c_86.term_eq (_v_deref__item21, 0))
          {
            goto _block2__branch23;
          }
          Expr _ve_expr (_v_deref__item21, (0 + 1), _v_len__expr6);
          Expr _ve_a;
          Expr _ve_j_m_expr;
          RF_CALL (Expr_m_Ref_m_To_m_Java, _ve_expr, (_ve_a, _ve_j_m_expr));
          _ve_java_m_item = (_ve_a + (_c_87 + _ve_j_m_expr + _c_60) ());
          goto _block2;
        }
      _block2__branch23: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch24;
          }
          Expr _v_deref__item22 (_vt_item, 0);
          uintptr_t _v_len67 = _v_deref__item22.get_len ();
          uintptr_t _v_len68 = 4;
          if (_v_len67 < _v_len68)
          {
            goto _block2__branch24;
          }
          uintptr_t _v_len__expr7 = (_v_len67 - _v_len68);
          if (_v_deref__item22.symbol_at ((0 + 1 + 1 + 1)))
          {
            goto _block2__branch24;
          }
          Expr _v_deref__deref__item222 (_v_deref__item22, (0 + 1 + 1 + 1));
          uintptr_t _v_len69 = _v_deref__deref__item222.get_len ();
          uintptr_t _v_len70 = 0;
          if (_v_len69 < _v_len70)
          {
            goto _block2__branch24;
          }
          uintptr_t _v_len__comment = (_v_len69 - _v_len70);
          if (!_c_88.term_eq (_v_deref__item22, 0))
          {
            goto _block2__branch24;
          }
          if (!_v_deref__item22.symbol_at ((0 + 1)))
          {
            goto _block2__branch24;
          }
          Expr _vs_linkage (_v_deref__item22, (0 + 1), 1);
          Expr _vt_name (_v_deref__item22, (0 + 1 + 1), 1);
          Expr _ve_expr (_v_deref__item22, (0 + 1 + 1 + 1 + 1), _v_len__expr7);
          Expr _ve_comment (_v_deref__deref__item222, 0, _v_len__comment);
          Expr _ve_n;
          {
            {
              if (_vt_name.symbol_at (0))
              {
                goto _block12__branch1;
              }
              Expr _v_deref__name (_vt_name, 0);
              uintptr_t _v_len71 = _v_deref__name.get_len ();
              uintptr_t _v_len72 = 1;
              if (_v_len71 < _v_len72)
              {
                goto _block12__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__asail__javarf_m_245_m_27 = (_v_len71 - _v_len72);
              if (!_c_89.term_eq (_v_deref__name, 0))
              {
                goto _block12__branch1;
              }
              Expr _ve__e__e_tmp_m_rfp__asail__javarf_m_245_m_27 (_v_deref__name, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__javarf_m_245_m_27);
              RF_CALL (JavaMangle::Rfp2Java, _vt_name, _ve_n);
              goto _block12;
            }
          _block12__branch1: {}
            RF_CALL (Name_m_To_m_Java, _vt_name, _ve_n);
          }
        _block12: {}
          Expr _ve_a;
          Expr _ve_j_m_expr;
          RF_CALL (Const_m_Expr_m_To_m_Java, _ve_expr, (_ve_a, _ve_j_m_expr));
          Expr _ge_auxcall44;
          RF_CALL (Access_m_Mode, _vt_name, _ge_auxcall44);
          _ve_java_m_item = (_ve_a + (_c_26 + _ge_auxcall44 + _c_90 + _ve_n + _c_40 + _ve_j_m_expr + _c_67) ());
          goto _block2;
        }
      _block2__branch24: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch25;
          }
          Expr _v_deref__item23 (_vt_item, 0);
          if (_v_deref__item23.get_len () != 4)
          {
            goto _block2__branch25;
          }
          if (!_c_91.term_eq (_v_deref__item23, 0))
          {
            goto _block2__branch25;
          }
          if (!_v_deref__item23.symbol_at ((0 + 1)))
          {
            goto _block2__branch25;
          }
          if (!_v_deref__item23.symbol_at ((0 + 1 + 1)))
          {
            goto _block2__branch25;
          }
          Expr _vs_linkage (_v_deref__item23, (0 + 1), 1);
          Expr _vs_tag (_v_deref__item23, (0 + 1 + 1), 1);
          Expr _vt_name (_v_deref__item23, (0 + 1 + 1 + 1), 1);
          Expr _v_To_m_Chars1;
          RF_CALL (Convert::To_m_Chars, _vs_tag, _v_To_m_Chars1);
          uintptr_t _v_len73 = _v_To_m_Chars1.get_len ();
          uintptr_t _v_len74 = 1;
          if (_v_len73 < _v_len74)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__2 = (_v_len73 - _v_len74);
          if (!_v_To_m_Chars1.symbol_at (0))
          {
            goto _block1__branch1;
          }
          Expr _vs_1 (_v_To_m_Chars1, 0, 1);
          Expr _ve_2 (_v_To_m_Chars1, (0 + 1), _v_len__2);
          Expr _v_To_m_Lower1;
          RF_CALL (Convert::To_m_Lower, _ve_2, _v_To_m_Lower1);
          Expr _ve_class_m_name ((_c_92 + _vs_1 + _v_To_m_Lower1));
          RF_CALL (Table::Bind, (Inputs, (_c_93 + _ve_class_m_name), empty), /*void*/);
          Expr _ve_qualifiers;
          Expr _ve_n;
          RF_CALL (rfp__helper::RFP_m_Extract_m_Qualifiers, _vt_name, (_ve_qualifiers, _ve_n));
          Expr _ge_auxcall45;
          RF_CALL (Access_m_Mode, _vt_name, _ge_auxcall45);
          Expr _ge_auxcall46;
          RF_CALL (Name_m_To_m_Java, _vt_name, _ge_auxcall46);
          _ve_java_m_item = (_c_26 + _ge_auxcall45 + _c_90 + _ge_auxcall46 + _c_96 + _ve_class_m_name + _c_95 + _ve_n + _c_94) ();
          goto _block2;
        }
      _block2__branch25: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch26;
          }
          Expr _v_deref__item24 (_vt_item, 0);
          if (_v_deref__item24.get_len () != 2)
          {
            goto _block2__branch26;
          }
          if (!_c_97.term_eq (_v_deref__item24, 0))
          {
            goto _block2__branch26;
          }
          Expr _vt_name (_v_deref__item24, (0 + 1), 1);
          _ve_java_m_item = empty;
          goto _block2;
        }
      _block2__branch26: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch27;
          }
          Expr _v_deref__item25 (_vt_item, 0);
          if (_v_deref__item25.get_len () != 2)
          {
            goto _block2__branch27;
          }
          if (!_c_98.term_eq (_v_deref__item25, 0))
          {
            goto _block2__branch27;
          }
          Expr _vt_name (_v_deref__item25, (0 + 1), 1);
          _ve_java_m_item = empty;
          goto _block2;
        }
      _block2__branch27: {}
        if (_vt_item.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__item26 (_vt_item, 0);
        if (_v_deref__item26.get_len () != 4)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        if (_v_deref__item26.symbol_at ((0 + 1 + 1)))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        if (_v_deref__item26.symbol_at ((0 + 1 + 1 + 1)))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__deref__item26 (_v_deref__item26, (0 + 1 + 1));
        Expr _v_deref__deref__item262 (_v_deref__item26, (0 + 1 + 1 + 1));
        uintptr_t _v_len75 = _v_deref__deref__item262.get_len ();
        uintptr_t _v_len76 = 0;
        if (_v_len75 < _v_len76)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len__ress2 = (_v_len75 - _v_len76);
        uintptr_t _v_len77 = _v_deref__deref__item26.get_len ();
        uintptr_t _v_len78 = 0;
        if (_v_len77 < _v_len78)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len__args2 = (_v_len77 - _v_len78);
        if (!_v_deref__item26.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _vs_call (_v_deref__item26, 0, 1);
        Expr _vt_name (_v_deref__item26, (0 + 1), 1);
        Expr _ve_args (_v_deref__deref__item26, 0, _v_len__args2);
        Expr _ve_ress (_v_deref__deref__item262, 0, _v_len__ress2);
        Expr _ve_decls;
        RF_CALL (Declare_m_Results, (_ve_ress, empty), (_ve_decls, _ve_ress));
        Expr _ve_arrays;
        RF_CALL (Expr_m_Args_m_To_m_Java, (_ve_args + _c_21 + _ve_ress), (_ve_arrays, _ve_args));
        Expr _ge_auxcall47;
        RF_CALL (Name_m_To_m_Java, _vt_name, _ge_auxcall47);
        Expr _ve_c ((_ge_auxcall47 + _c_24 + _ve_args + _c_30));
        {
          {
            if (!_vs_call.term_eq (_c_99, 0))
            {
              goto _block13__branch1;
            }
            _ve_java_m_item = (_ve_arrays + _ve_decls + (_c_101 + _ve_c + _c_100) ());
            goto _block13;
          }
        _block13__branch1: {}
          Expr _ge_auxcall48;
          RF_CALL (Box::_q_, Res_m_Assigns, _ge_auxcall48);
          RF_CALL (Box::Store, (Res_m_Assigns, empty), /*void*/);
          _ve_java_m_item = (_ve_arrays + _ve_decls + (_ve_c + _c_67) () + _ge_auxcall48);
        }
      _block13: {}
      }
    _block2: {}
      {
        {
          if (_ve_java_m_item.get_len () != 1)
          {
            goto _block14__branch1;
          }
          if (_ve_java_m_item.symbol_at (0))
          {
            goto _block14__branch1;
          }
          Expr _v_deref__java_m_item (_ve_java_m_item, 0);
          uintptr_t _v_len79 = _v_deref__java_m_item.get_len ();
          uintptr_t _v_len80 = 6;
          if (_v_len79 < _v_len80)
          {
            goto _block14__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__asail__javarf_m_275_m_32 = (_v_len79 - _v_len80);
          if (!_c_85.eq (_v_deref__java_m_item, 0))
          {
            goto _block14__branch1;
          }
          Expr _ve__e__e_tmp_m_rfp__asail__javarf_m_275_m_32 (_v_deref__java_m_item, (0 + 1 + 1 + 1 + 1 + 1 + 1), _v_len___e__e_tmp_m_rfp__asail__javarf_m_275_m_32);
          _v_res1 = _ve_java_m_item;
          goto _block14;
        }
      _block14__branch1: {}
        Expr _v_ASAIL_m_To_m_Java1;
        RF_CALL (ASAIL_m_To_m_Java, _ve_rest, _v_ASAIL_m_To_m_Java1);
        _v_res1 = (_ve_java_m_item + _v_ASAIL_m_To_m_Java1);
      }
    _block14: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Declare_m_Results, (RF_ARG _ge_arg1, _ge_arg2;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      uintptr_t _v_len1 = (_ge_arg2.get_len () + 1);
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__ress = (_v_len1 - _v_len2);
      Expr _v_compose1 ((_ge_arg1 () + _ge_arg2));
      if (_v_compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__compose1 (_v_compose1, 0);
      uintptr_t _v_len3 = _v_deref__compose1.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__r = (_v_len3 - _v_len4);
      Expr _ve_ress (_v_compose1, (0 + 1), _v_len__ress);
      Expr _vt_var (_v_deref__compose1, 0, 1);
      Expr _ve_r (_v_deref__compose1, (0 + 1), _v_len__r);
      {
        {
          if (!RF_CALL (Table::In_m_Table_q_, (Result, _vt_var), /*void*/))
          {
            goto _block2__branch1;
          }
          Expr _ge_auxcall1;
          RF_CALL (JavaMangle::Rfp2Java, _vt_var, _ge_auxcall1);
          RF_TAILCALL (Declare_m_Results, (_ve_r, (_ve_ress + _ge_auxcall1 ())), (_v_res1, _v_res2));
          goto _block2;
        }
      _block2__branch1: {}
        {
          Expr _v__q_1;
          RF_CALL (Box::_q_, Ress, _v__q_1);
          if (_v__q_1.get_len () < 1)
          {
            goto _block2__branch2;
          }
          RF_lsplit (_v__q_1, 0, _ve__e__e_tmp_m_rfp__asail__javarf_m_284_m_18, _v_lsplit___q_1);
          for ( ; ; RF_iter(_v__q_1)++)
          {
            {
              if (!RF_iter(_v__q_1))
              {
                goto _block2__branch2;
              }
              uintptr_t _v_len5 = _v_lsplit___q_1.get_len ();
              uintptr_t _v_len6 = 1;
              if (_v_len5 < _v_len6)
              {
                goto _block2__branch2;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__asail__javarf_m_284_m_26 = (_v_len5 - _v_len6);
              if (!_vt_var.term_eq (_v_lsplit___q_1, 0))
              {
                goto _continue1;
              }
              Expr _ve__e__e_tmp_m_rfp__asail__javarf_m_284_m_26 (_v_lsplit___q_1, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__javarf_m_284_m_26);
              Expr _ge_auxcall2;
              RF_CALL (JavaMangle::Rfp2Java, _vt_var, _ge_auxcall2);
              RF_TAILCALL (Declare_m_Results, (_ve_r, (_ve_ress + _ge_auxcall2 ())), (_v_res1, _v_res2));
              goto _exit1;
            }
        _continue1: {}
          }
        _exit1: {}
          goto _block2;
        }
      _block2__branch2: {}
        Expr _v_Free_m_Index1;
        RF_CALL (Free_m_Index, /*void*/, _v_Free_m_Index1);
        Expr _ve_new_m_var ((_c_59 + _v_Free_m_Index1));
        Expr _ge_auxcall3;
        RF_CALL (JavaMangle::Rfp2Java, _vt_var, _ge_auxcall3);
        RF_CALL (Box::Put, (Res_m_Assigns, (_ge_auxcall3 + _c_40 + _ve_new_m_var + _c_102) ()), /*void*/);
        Expr _v_Declare_m_Results1;
        RF_CALL (Declare_m_Results, (_ve_r, (_ve_ress + _ve_new_m_var ())), (_v_Declare_m_Results1, _v_res2));
        _v_res1 = ((_c_70 + _ve_new_m_var + _c_69) () + _v_Declare_m_Results1);
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    uintptr_t _v_len7 = (_ge_arg2.get_len () + 1);
    uintptr_t _v_len8 = 1;
    if (_v_len7 < _v_len8)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__ress2 = (_v_len7 - _v_len8);
    Expr _v_compose2 ((_ge_arg1 () + _ge_arg2));
    if (!_c_12.term_eq (_v_compose2, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_ress (_v_compose2, (0 + 1), _v_len__ress2);
    _v_res1 = empty;
    _v_res2 = _ve_ress;
  }
_block1: {}
RF_END

RF_FUNC (Expr_m_To_m_Java, (RF_ARG _ve_init, _ve_expr_m_all;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      if (_ve_expr_m_all.get_len () != 0)
      {
        goto _block1__branch1;
      }
      RF_TAILCALL (Expr_m_Ref_m_To_m_Java, _ve_init, (_v_res1, _v_res2));
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len1 = _ve_expr_m_all.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      if (_ve_expr_m_all.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__expr_m_all (_ve_expr_m_all, 0);
      uintptr_t _v_len3 = _v_deref__expr_m_all.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__expr = (_v_len3 - _v_len4);
      if (!_c_103.term_eq (_v_deref__expr_m_all, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest);
      Expr _ve_expr (_v_deref__expr_m_all, (0 + 1), _v_len__expr);
      RF_TAILCALL (Expr_m_Ref_m_To_m_Java, (_ve_init + _ve_expr_m_all), (_v_res1, _v_res2));
      goto _block1;
    }
  _block1__branch2: {}
    {
      uintptr_t _v_len5 = _ve_expr_m_all.get_len ();
      uintptr_t _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__rest2 = (_v_len5 - _v_len6);
      if (_ve_expr_m_all.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__expr_m_all2 (_ve_expr_m_all, 0);
      uintptr_t _v_len7 = _v_deref__expr_m_all2.get_len ();
      uintptr_t _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__expr2 = (_v_len7 - _v_len8);
      if (!_c_73.term_eq (_v_deref__expr_m_all2, 0))
      {
        goto _block1__branch3;
      }
      Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest2);
      Expr _ve_expr (_v_deref__expr_m_all2, (0 + 1), _v_len__expr2);
      RF_TAILCALL (Expr_m_Ref_m_To_m_Java, (_ve_init + _ve_expr_m_all), (_v_res1, _v_res2));
      goto _block1;
    }
  _block1__branch3: {}
    {
      uintptr_t _v_len9 = _ve_expr_m_all.get_len ();
      uintptr_t _v_len10 = 1;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__rest3 = (_v_len9 - _v_len10);
      if (_ve_expr_m_all.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__expr_m_all3 (_ve_expr_m_all, 0);
      uintptr_t _v_len11 = _v_deref__expr_m_all3.get_len ();
      uintptr_t _v_len12 = 1;
      if (_v_len11 < _v_len12)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__expr3 = (_v_len11 - _v_len12);
      if (!_c_74.term_eq (_v_deref__expr_m_all3, 0))
      {
        goto _block1__branch4;
      }
      Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest3);
      Expr _ve_expr (_v_deref__expr_m_all3, (0 + 1), _v_len__expr3);
      RF_TAILCALL (Expr_m_Ref_m_To_m_Java, (_ve_init + _ve_expr_m_all), (_v_res1, _v_res2));
      goto _block1;
    }
  _block1__branch4: {}
    {
      uintptr_t _v_len13 = _ve_expr_m_all.get_len ();
      uintptr_t _v_len14 = 1;
      if (_v_len13 < _v_len14)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__rest4 = (_v_len13 - _v_len14);
      if (_ve_expr_m_all.symbol_at (0))
      {
        goto _block1__branch5;
      }
      Expr _v_deref__expr_m_all4 (_ve_expr_m_all, 0);
      uintptr_t _v_len15 = _v_deref__expr_m_all4.get_len ();
      uintptr_t _v_len16 = 1;
      if (_v_len15 < _v_len16)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__expr4 = (_v_len15 - _v_len16);
      if (!_c_77.term_eq (_v_deref__expr_m_all4, 0))
      {
        goto _block1__branch5;
      }
      Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest4);
      Expr _ve_expr (_v_deref__expr_m_all4, (0 + 1), _v_len__expr4);
      RF_TAILCALL (Expr_m_Ref_m_To_m_Java, (_ve_init + _ve_expr_m_all), (_v_res1, _v_res2));
      goto _block1;
    }
  _block1__branch5: {}
    {
      uintptr_t _v_len17 = _ve_expr_m_all.get_len ();
      uintptr_t _v_len18 = 1;
      if (_v_len17 < _v_len18)
      {
        goto _block1__branch6;
      }
      uintptr_t _v_len__rest5 = (_v_len17 - _v_len18);
      if (_ve_expr_m_all.symbol_at (0))
      {
        goto _block1__branch6;
      }
      Expr _v_deref__expr_m_all5 (_ve_expr_m_all, 0);
      uintptr_t _v_len19 = _v_deref__expr_m_all5.get_len ();
      uintptr_t _v_len20 = 1;
      if (_v_len19 < _v_len20)
      {
        goto _block1__branch6;
      }
      uintptr_t _v_len__expr5 = (_v_len19 - _v_len20);
      if (!_c_104.term_eq (_v_deref__expr_m_all5, 0))
      {
        goto _block1__branch6;
      }
      Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest5);
      Expr _ve_expr (_v_deref__expr_m_all5, (0 + 1), _v_len__expr5);
      Expr _ge_auxcall1;
      RF_CALL (Expr_m_Int_m_To_m_Java, (_c_105, (_ve_init + _ve_expr_m_all)), _ge_auxcall1);
      _v_res1 = empty;
      _v_res2 = _ge_auxcall1;
      goto _block1;
    }
  _block1__branch6: {}
    {
      uintptr_t _v_len21 = _ve_expr_m_all.get_len ();
      uintptr_t _v_len22 = 1;
      if (_v_len21 < _v_len22)
      {
        goto _block1__branch7;
      }
      uintptr_t _v_len__rest6 = (_v_len21 - _v_len22);
      if (_ve_expr_m_all.symbol_at (0))
      {
        goto _block1__branch7;
      }
      Expr _v_deref__expr_m_all6 (_ve_expr_m_all, 0);
      uintptr_t _v_len23 = _v_deref__expr_m_all6.get_len ();
      uintptr_t _v_len24 = 1;
      if (_v_len23 < _v_len24)
      {
        goto _block1__branch7;
      }
      uintptr_t _v_len__args = (_v_len23 - _v_len24);
      if (!_c_106.term_eq (_v_deref__expr_m_all6, 0))
      {
        goto _block1__branch7;
      }
      Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest6);
      Expr _ve_args (_v_deref__expr_m_all6, (0 + 1), _v_len__args);
      Expr _ge_auxcall2;
      RF_CALL (Expr_m_Int_m_To_m_Java, (_c_105, (_ve_init + _ve_expr_m_all)), _ge_auxcall2);
      _v_res1 = empty;
      _v_res2 = _ge_auxcall2;
      goto _block1;
    }
  _block1__branch7: {}
    {
      uintptr_t _v_len25 = _ve_expr_m_all.get_len ();
      uintptr_t _v_len26 = 1;
      if (_v_len25 < _v_len26)
      {
        goto _block1__branch8;
      }
      uintptr_t _v_len__rest7 = (_v_len25 - _v_len26);
      if (_ve_expr_m_all.symbol_at (0))
      {
        goto _block1__branch8;
      }
      Expr _v_deref__expr_m_all7 (_ve_expr_m_all, 0);
      uintptr_t _v_len27 = _v_deref__expr_m_all7.get_len ();
      uintptr_t _v_len28 = 1;
      if (_v_len27 < _v_len28)
      {
        goto _block1__branch8;
      }
      uintptr_t _v_len__args2 = (_v_len27 - _v_len28);
      if (!_c_107.term_eq (_v_deref__expr_m_all7, 0))
      {
        goto _block1__branch8;
      }
      Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest7);
      Expr _ve_args (_v_deref__expr_m_all7, (0 + 1), _v_len__args2);
      Expr _ge_auxcall3;
      RF_CALL (Expr_m_Int_m_To_m_Java, (_c_105, (_ve_init + _ve_expr_m_all)), _ge_auxcall3);
      _v_res1 = empty;
      _v_res2 = _ge_auxcall3;
      goto _block1;
    }
  _block1__branch8: {}
    {
      uintptr_t _v_len29 = _ve_expr_m_all.get_len ();
      uintptr_t _v_len30 = 1;
      if (_v_len29 < _v_len30)
      {
        goto _block1__branch9;
      }
      uintptr_t _v_len__rest8 = (_v_len29 - _v_len30);
      if (_ve_expr_m_all.symbol_at (0))
      {
        goto _block1__branch9;
      }
      Expr _v_deref__expr_m_all8 (_ve_expr_m_all, 0);
      uintptr_t _v_len31 = _v_deref__expr_m_all8.get_len ();
      uintptr_t _v_len32 = 2;
      if (_v_len31 < _v_len32)
      {
        goto _block1__branch9;
      }
      uintptr_t _v_len__args3 = (_v_len31 - _v_len32);
      if (!_c_108.term_eq (_v_deref__expr_m_all8, 0))
      {
        goto _block1__branch9;
      }
      if (!_v_deref__expr_m_all8.symbol_at ((0 + 1)))
      {
        goto _block1__branch9;
      }
      Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest8);
      Expr _vs_op (_v_deref__expr_m_all8, (0 + 1), 1);
      Expr _ve_args (_v_deref__expr_m_all8, (0 + 1 + 1), _v_len__args3);
      Expr _ge_auxcall4;
      RF_CALL (Expr_m_Int_m_To_m_Java, (_c_105, (_ve_init + _ve_expr_m_all)), _ge_auxcall4);
      _v_res1 = empty;
      _v_res2 = _ge_auxcall4;
      goto _block1;
    }
  _block1__branch9: {}
    uintptr_t _v_len33 = _ve_expr_m_all.get_len ();
    uintptr_t _v_len34 = 1;
    if (_v_len33 < _v_len34)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__rest9 = (_v_len33 - _v_len34);
    if (_ve_expr_m_all.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__expr_m_all9 (_ve_expr_m_all, 0);
    if (_v_deref__expr_m_all9.get_len () != 2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_v_deref__expr_m_all9.symbol_at ((0 + 1)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__deref__expr_m_all9 (_v_deref__expr_m_all9, (0 + 1));
    uintptr_t _v_len35 = _v_deref__deref__expr_m_all9.get_len ();
    uintptr_t _v_len36 = 0;
    if (_v_len35 < _v_len36)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__QualifiedName = (_v_len35 - _v_len36);
    if (!_v_deref__expr_m_all9.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest9);
    Expr _vs_var_m_tag (_v_deref__expr_m_all9, 0, 1);
    Expr _ve_QualifiedName (_v_deref__deref__expr_m_all9, 0, _v_len__QualifiedName);
    RF_TAILCALL (Expr_m_To_m_Java, ((_ve_init + (_vs_var_m_tag + _ve_QualifiedName ()) ()), _ve_rest), (_v_res1, _v_res2));
  }
_block1: {}
RF_END

RF_FUNC (Expr_m_Ref_m_To_m_Java, (RF_ARG _ge_arg1;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      if (_ge_arg1.get_len () != 0)
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      _v_res2 = _c_109;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      Expr _vt_erm (_ge_arg1, 0, 1);
      Expr _vs_acc;
      RF_CALL (Box::Box, empty, _vs_acc);
      Expr _ve_term;
      RF_CALL (Term_m_Ref_m_To_m_Java, (_vs_acc, _vt_erm), _ve_term);
      Expr _ge_auxcall1;
      RF_CALL (Box::_q_, _vs_acc, _ge_auxcall1);
      _v_res1 = _ge_auxcall1;
      _v_res2 = _ve_term;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (_ge_arg1.get_len () != 2)
      {
        goto _block1__branch3;
      }
      Expr _vt_1 (_ge_arg1, 0, 1);
      Expr _vt_2 (_ge_arg1, (0 + 1), 1);
      Expr _vs_acc;
      RF_CALL (Box::Box, empty, _vs_acc);
      Expr _ve_t1;
      RF_CALL (Term_m_Ref_m_To_m_Java, (_vs_acc, _vt_1), _ve_t1);
      Expr _ve_t2;
      RF_CALL (Term_m_Ref_m_To_m_Java, (_vs_acc, _vt_2), _ve_t2);
      Expr _ge_auxcall2;
      RF_CALL (Box::_q_, _vs_acc, _ge_auxcall2);
      _v_res1 = _ge_auxcall2;
      _v_res2 = (_c_110 + _ve_t1 + _c_78 + _ve_t2 + _c_30);
      goto _block1;
    }
  _block1__branch3: {}
    Expr _v_Free_m_Index1;
    RF_CALL (Free_m_Index, /*void*/, _v_Free_m_Index1);
    Expr _ve_new_m_var ((_c_59 + _v_Free_m_Index1));
    Expr _vs_acc;
    RF_CALL (Box::Box, empty, _vs_acc);
    Expr _ge_auxcall3;
    RF_CALL (List::Paren, _ge_arg1, _ge_auxcall3);
    Expr _ve_arr_m_init;
    RF_CALL (Infix_m_To_m_Java, (_vs_acc, _c_111, _c_112, _ge_auxcall3), _ve_arr_m_init);
    Expr _ge_auxcall4;
    RF_CALL (Box::_q_, _vs_acc, _ge_auxcall4);
    _v_res1 = (_ge_auxcall4 + (_c_115 + _ve_new_m_var + _c_114 + _ve_arr_m_init + _c_113) ());
    _v_res2 = (_c_116 + _ve_new_m_var + _c_30);
  }
_block1: {}
RF_END

RF_FUNC (Term_m_Ref_m_To_m_Java, (RF_ARG _vs_acc, _vt_erm;;), (RF_RES _v_res1;;))
  {
    {
      if (_vt_erm.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__erm (_vt_erm, 0);
      uintptr_t _v_len1 = _v_deref__erm.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__expr = (_v_len1 - _v_len2);
      if (!_c_103.term_eq (_v_deref__erm, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve_expr (_v_deref__erm, (0 + 1), _v_len__expr);
      Expr _ve_a;
      Expr _ve_j_m_expr;
      RF_CALL (Expr_m_Ref_m_To_m_Java, _ve_expr, (_ve_a, _ve_j_m_expr));
      RF_CALL (Box::Put, (_vs_acc, _ve_a), /*void*/);
      _v_res1 = (_c_117 + _ve_j_m_expr + _c_30);
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_vt_erm.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__erm2 (_vt_erm, 0);
      uintptr_t _v_len3 = _v_deref__erm2.get_len ();
      uintptr_t _v_len4 = 2;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__expr2 = (_v_len3 - _v_len4);
      if (_v_deref__erm2.symbol_at ((0 + 1 + _v_len__expr2)))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__deref__erm2 (_v_deref__erm2, (0 + 1 + _v_len__expr2));
      uintptr_t _v_len5 = _v_deref__deref__erm2.get_len ();
      uintptr_t _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__pos = (_v_len5 - _v_len6);
      if (!_c_74.term_eq (_v_deref__erm2, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_expr (_v_deref__erm2, (0 + 1), _v_len__expr2);
      Expr _ve_pos (_v_deref__deref__erm2, 0, _v_len__pos);
      Expr _ve_a;
      Expr _ve_j_m_expr;
      RF_CALL (Expr_m_Ref_m_To_m_Java, _ve_expr, (_ve_a, _ve_j_m_expr));
      RF_CALL (Box::Put, (_vs_acc, _ve_a), /*void*/);
      RF_CALL (Expr_m_Int_m_To_m_Java, (_vs_acc, _ve_pos), _ve_pos);
      _v_res1 = (_c_118 + _ve_j_m_expr + _c_75 + _ve_pos + _c_30);
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (_vt_erm.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__erm3 (_vt_erm, 0);
      uintptr_t _v_len7 = _v_deref__erm3.get_len ();
      uintptr_t _v_len8 = 3;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__expr3 = (_v_len7 - _v_len8);
      if (_v_deref__erm3.symbol_at ((0 + 1 + _v_len__expr3)))
      {
        goto _block1__branch3;
      }
      if (_v_deref__erm3.symbol_at ((0 + 1 + _v_len__expr3 + 1)))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__deref__erm3 (_v_deref__erm3, (0 + 1 + _v_len__expr3));
      Expr _v_deref__deref__erm32 (_v_deref__erm3, (0 + 1 + _v_len__expr3 + 1));
      uintptr_t _v_len9 = _v_deref__deref__erm32.get_len ();
      uintptr_t _v_len10 = 0;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__len = (_v_len9 - _v_len10);
      uintptr_t _v_len11 = _v_deref__deref__erm3.get_len ();
      uintptr_t _v_len12 = 0;
      if (_v_len11 < _v_len12)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__pos2 = (_v_len11 - _v_len12);
      if (!_c_77.term_eq (_v_deref__erm3, 0))
      {
        goto _block1__branch3;
      }
      Expr _ve_expr (_v_deref__erm3, (0 + 1), _v_len__expr3);
      Expr _ve_pos (_v_deref__deref__erm3, 0, _v_len__pos2);
      Expr _ve_len (_v_deref__deref__erm32, 0, _v_len__len);
      Expr _ve_a;
      Expr _ve_j_m_expr;
      RF_CALL (Expr_m_Ref_m_To_m_Java, _ve_expr, (_ve_a, _ve_j_m_expr));
      RF_CALL (Box::Put, (_vs_acc, _ve_a), /*void*/);
      RF_CALL (Expr_m_Int_m_To_m_Java, (_vs_acc, _ve_pos), _ve_pos);
      RF_CALL (Expr_m_Int_m_To_m_Java, (_vs_acc, _ve_len), _ve_len);
      _v_res1 = (_c_110 + _ve_j_m_expr + _c_78 + _ve_pos + _c_78 + _ve_len + _c_30);
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (_vt_erm.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__erm4 (_vt_erm, 0);
      if (_v_deref__erm4.get_len () != 2)
      {
        goto _block1__branch4;
      }
      if (!_c_119.term_eq (_v_deref__erm4, 0))
      {
        goto _block1__branch4;
      }
      Expr _vt_name (_v_deref__erm4, (0 + 1), 1);
      RF_TAILCALL (Name_m_To_m_Java, _vt_name, _v_res1);
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (!_vt_erm.term_eq (_c_120, 0))
      {
        goto _block1__branch5;
      }
      _v_res1 = _c_121;
      goto _block1;
    }
  _block1__branch5: {}
    if (_vt_erm.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__erm5 (_vt_erm, 0);
    uintptr_t _v_len13 = _v_deref__erm5.get_len ();
    uintptr_t _v_len14 = 2;
    if (_v_len13 < _v_len14)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__ns = (_v_len13 - _v_len14);
    if (!_v_deref__erm5.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_var_m_tag (_v_deref__erm5, 0, 1);
    Expr _ve_ns (_v_deref__erm5, (0 + 1), _v_len__ns);
    Expr _vt_name (_v_deref__erm5, (0 + 1 + _v_len__ns), 1);
    RF_TAILCALL (Var_m_To_m_Java, _vt_erm, _v_res1);
  }
_block1: {}
RF_END

RF_FUNC (Expr_m_Int_m_To_m_Java, (RF_ARG _vs_acc, _ve_xpr;;), (RF_RES _v_res1;;))
  {
    {
      if (_ve_xpr.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_ve_xpr.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_ObjectSymbol (_ve_xpr, 0, 1);
      {
        {
          if (!RF_CALL (Class::Int_q_, _vs_ObjectSymbol, /*void*/))
          {
            goto _block2__branch1;
          }
          _v_res1 = _vs_ObjectSymbol;
          goto _block2;
        }
      _block2__branch1: {}
        RF_ERROR ((_c_122 + _vs_ObjectSymbol) ());
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ve_xpr.get_len () != 1)
      {
        goto _block1__branch2;
      }
      if (_ve_xpr.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__xpr (_ve_xpr, 0);
      uintptr_t _v_len1 = _v_deref__xpr.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__expr = (_v_len1 - _v_len2);
      if (!_c_104.term_eq (_v_deref__xpr, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_expr (_v_deref__xpr, (0 + 1), _v_len__expr);
      Expr _ve_a;
      Expr _ve_j_m_expr;
      RF_CALL (Expr_m_Ref_m_To_m_Java, _ve_expr, (_ve_a, _ve_j_m_expr));
      RF_CALL (Box::Put, (_vs_acc, _ve_a), /*void*/);
      _v_res1 = (_ve_j_m_expr + _c_123);
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (_ve_xpr.get_len () != 1)
      {
        goto _block1__branch3;
      }
      if (_ve_xpr.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__xpr2 (_ve_xpr, 0);
      uintptr_t _v_len3 = _v_deref__xpr2.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__args = (_v_len3 - _v_len4);
      if (!_c_106.term_eq (_v_deref__xpr2, 0))
      {
        goto _block1__branch3;
      }
      Expr _ve_args (_v_deref__xpr2, (0 + 1), _v_len__args);
      Expr _ge_auxcall1;
      RF_CALL (Int_m_Args_m_To_m_Java, (_vs_acc, _ve_args), _ge_auxcall1);
      _v_res1 = (_c_124 + _ge_auxcall1 + _c_30);
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (_ve_xpr.get_len () != 1)
      {
        goto _block1__branch4;
      }
      if (_ve_xpr.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__xpr3 (_ve_xpr, 0);
      uintptr_t _v_len5 = _v_deref__xpr3.get_len ();
      uintptr_t _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__args2 = (_v_len5 - _v_len6);
      if (!_c_107.term_eq (_v_deref__xpr3, 0))
      {
        goto _block1__branch4;
      }
      Expr _ve_args (_v_deref__xpr3, (0 + 1), _v_len__args2);
      Expr _ge_auxcall2;
      RF_CALL (Int_m_Args_m_To_m_Java, (_vs_acc, _ve_args), _ge_auxcall2);
      _v_res1 = (_c_125 + _ge_auxcall2 + _c_30);
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (_ve_xpr.get_len () != 1)
      {
        goto _block1__branch5;
      }
      if (_ve_xpr.symbol_at (0))
      {
        goto _block1__branch5;
      }
      Expr _v_deref__xpr4 (_ve_xpr, 0);
      uintptr_t _v_len7 = _v_deref__xpr4.get_len ();
      uintptr_t _v_len8 = 2;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__args3 = (_v_len7 - _v_len8);
      if (!_c_108.term_eq (_v_deref__xpr4, 0))
      {
        goto _block1__branch5;
      }
      if (!_v_deref__xpr4.symbol_at ((0 + 1)))
      {
        goto _block1__branch5;
      }
      Expr _vs_op (_v_deref__xpr4, (0 + 1), 1);
      Expr _ve_args (_v_deref__xpr4, (0 + 1 + 1), _v_len__args3);
      Expr _ge_auxcall3;
      RF_CALL (Infix_m_To_m_Java, (_vs_acc, _c_126, _vs_op, _ve_args), _ge_auxcall3);
      _v_res1 = (_c_127 + _ge_auxcall3 + _c_30);
      goto _block1;
    }
  _block1__branch5: {}
    {
      if (_ve_xpr.get_len () != 1)
      {
        goto _block1__branch6;
      }
      if (_ve_xpr.symbol_at (0))
      {
        goto _block1__branch6;
      }
      Expr _v_deref__xpr5 (_ve_xpr, 0);
      if (_v_deref__xpr5.get_len () != 2)
      {
        goto _block1__branch6;
      }
      if (!_v_deref__xpr5.symbol_at (0))
      {
        goto _block1__branch6;
      }
      Expr _vs_var_m_tag (_v_deref__xpr5, 0, 1);
      Expr _vt_name (_v_deref__xpr5, (0 + 1), 1);
      RF_TAILCALL (JavaMangle::Rfp2Java, (_vs_var_m_tag + _vt_name) (), _v_res1);
      goto _block1;
    }
  _block1__branch6: {}
    if (!_ve_xpr.eq (_ve_xpr, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ge_auxcall4;
    RF_CALL (List::Paren, _ve_xpr, _ge_auxcall4);
    Expr _ge_auxcall5;
    RF_CALL (Infix_m_To_m_Java, (_vs_acc, _c_126, _c_128, _ge_auxcall4), _ge_auxcall5);
    _v_res1 = (_c_127 + _ge_auxcall5 + _c_30);
  }
_block1: {}
RF_END

RF_FUNC (Cond_m_To_m_Java, (RF_ARG _vs_acc, _vt_cond;;), (RF_RES _v_res1;;))
  {
    {
      if (_vt_cond.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__cond (_vt_cond, 0);
      if (_v_deref__cond.get_len () != 2)
      {
        goto _block1__branch1;
      }
      if (_v_deref__cond.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__deref__cond (_v_deref__cond, (0 + 1));
      if (_v_deref__deref__cond.get_len () != 4)
      {
        goto _block1__branch1;
      }
      if (_v_deref__deref__cond.symbol_at ((0 + 1 + 1)))
      {
        goto _block1__branch1;
      }
      if (_v_deref__deref__cond.symbol_at ((0 + 1 + 1 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__deref__deref__cond (_v_deref__deref__cond, (0 + 1 + 1));
      Expr _v_deref__deref__deref__cond2 (_v_deref__deref__cond, (0 + 1 + 1 + 1));
      uintptr_t _v_len1 = _v_deref__deref__deref__cond2.get_len ();
      uintptr_t _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__ress = (_v_len1 - _v_len2);
      uintptr_t _v_len3 = _v_deref__deref__deref__cond.get_len ();
      uintptr_t _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__exprs = (_v_len3 - _v_len4);
      if (!_c_33.term_eq (_v_deref__cond, 0))
      {
        goto _block1__branch1;
      }
      if (!_c_129.term_eq (_v_deref__deref__cond, 0))
      {
        goto _block1__branch1;
      }
      Expr _vt_name (_v_deref__deref__cond, (0 + 1), 1);
      Expr _ve_exprs (_v_deref__deref__deref__cond, 0, _v_len__exprs);
      Expr _ve_ress (_v_deref__deref__deref__cond2, 0, _v_len__ress);
      Expr _ve_decls;
      RF_CALL (Declare_m_Results, (_ve_ress, empty), (_ve_decls, _ve_ress));
      Expr _ve_arrays;
      Expr _ve_args;
      RF_CALL (Expr_m_Args_m_To_m_Java, (_ve_exprs + _c_21 + _ve_ress), (_ve_arrays, _ve_args));
      RF_CALL (Box::Put, (_vs_acc, (_ve_arrays + _ve_decls)), /*void*/);
      Expr _ge_auxcall1;
      RF_CALL (Name_m_To_m_Java, _vt_name, _ge_auxcall1);
      _v_res1 = (_c_130 + _ge_auxcall1 + _c_24 + _ve_args + _c_30);
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_vt_cond.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__cond2 (_vt_cond, 0);
      uintptr_t _v_len5 = _v_deref__cond2.get_len ();
      uintptr_t _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__expr = (_v_len5 - _v_len6);
      if (!_c_131.term_eq (_v_deref__cond2, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_expr (_v_deref__cond2, (0 + 1), _v_len__expr);
      Expr _ge_auxcall2;
      if (!RF_CALL (Table::Lookup, (Iter_m_Vars, _ve_expr), _ge_auxcall2))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _ge_auxcall3;
      if (!RF_CALL (Access::Middle, (_c_132, _c_133, _ge_auxcall2), _ge_auxcall3))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      _v_res1 = (_c_130 + _ge_auxcall3 + _c_134);
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (_vt_cond.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__cond3 (_vt_cond, 0);
      uintptr_t _v_len7 = _v_deref__cond3.get_len ();
      uintptr_t _v_len8 = 2;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__expr2 = (_v_len7 - _v_len8);
      if (_v_deref__cond3.symbol_at ((0 + 1 + _v_len__expr2)))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__deref__cond3 (_v_deref__cond3, (0 + 1 + _v_len__expr2));
      uintptr_t _v_len9 = _v_deref__deref__cond3.get_len ();
      uintptr_t _v_len10 = 0;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__pos = (_v_len9 - _v_len10);
      if (!_c_135.term_eq (_v_deref__cond3, 0))
      {
        goto _block1__branch3;
      }
      Expr _ve_expr (_v_deref__cond3, (0 + 1), _v_len__expr2);
      Expr _ve_pos (_v_deref__deref__cond3, 0, _v_len__pos);
      Expr _ve_a;
      Expr _ve_j_m_expr;
      RF_CALL (Expr_m_Ref_m_To_m_Java, _ve_expr, (_ve_a, _ve_j_m_expr));
      RF_CALL (Box::Put, (_vs_acc, _ve_a), /*void*/);
      Expr _ge_auxcall4;
      RF_CALL (Expr_m_Int_m_To_m_Java, (_vs_acc, _ve_pos), _ge_auxcall4);
      _v_res1 = (_ve_j_m_expr + _c_136 + _ge_auxcall4 + _c_30);
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (_vt_cond.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__cond4 (_vt_cond, 0);
      uintptr_t _v_len11 = _v_deref__cond4.get_len ();
      uintptr_t _v_len12 = 3;
      if (_v_len11 < _v_len12)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__expr1 = (_v_len11 - _v_len12);
      if (_v_deref__cond4.symbol_at ((0 + 1 + _v_len__expr1)))
      {
        goto _block1__branch4;
      }
      if (_v_deref__cond4.symbol_at ((0 + 1 + _v_len__expr1 + 1)))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__deref__cond4 (_v_deref__cond4, (0 + 1 + _v_len__expr1));
      Expr _v_deref__deref__cond42 (_v_deref__cond4, (0 + 1 + _v_len__expr1 + 1));
      uintptr_t _v_len13 = _v_deref__deref__cond42.get_len ();
      uintptr_t _v_len14 = 0;
      if (_v_len13 < _v_len14)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__pos2 = (_v_len13 - _v_len14);
      uintptr_t _v_len15 = _v_deref__deref__cond4.get_len ();
      uintptr_t _v_len16 = 0;
      if (_v_len15 < _v_len16)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__expr22 = (_v_len15 - _v_len16);
      if (!_c_137.term_eq (_v_deref__cond4, 0))
      {
        goto _block1__branch4;
      }
      Expr _ve_expr1 (_v_deref__cond4, (0 + 1), _v_len__expr1);
      Expr _ve_expr2 (_v_deref__deref__cond4, 0, _v_len__expr22);
      Expr _ve_pos (_v_deref__deref__cond42, 0, _v_len__pos2);
      Expr _ve_a1;
      Expr _ve_j_m_expr1;
      RF_CALL (Expr_m_Ref_m_To_m_Java, _ve_expr1, (_ve_a1, _ve_j_m_expr1));
      Expr _ve_a2;
      Expr _ve_j_m_expr2;
      RF_CALL (Expr_m_Ref_m_To_m_Java, _ve_expr2, (_ve_a2, _ve_j_m_expr2));
      RF_CALL (Box::Put, (_vs_acc, (_ve_a1 + _ve_a2)), /*void*/);
      Expr _ge_auxcall5;
      RF_CALL (Expr_m_Int_m_To_m_Java, (_vs_acc, _ve_pos), _ge_auxcall5);
      _v_res1 = (_ve_j_m_expr1 + _c_138 + _ve_j_m_expr2 + _c_78 + _ge_auxcall5 + _c_30);
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (_vt_cond.symbol_at (0))
      {
        goto _block1__branch5;
      }
      Expr _v_deref__cond5 (_vt_cond, 0);
      uintptr_t _v_len17 = _v_deref__cond5.get_len ();
      uintptr_t _v_len18 = 3;
      if (_v_len17 < _v_len18)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__expr12 = (_v_len17 - _v_len18);
      if (_v_deref__cond5.symbol_at ((0 + 1 + _v_len__expr12)))
      {
        goto _block1__branch5;
      }
      if (_v_deref__cond5.symbol_at ((0 + 1 + _v_len__expr12 + 1)))
      {
        goto _block1__branch5;
      }
      Expr _v_deref__deref__cond5 (_v_deref__cond5, (0 + 1 + _v_len__expr12));
      Expr _v_deref__deref__cond52 (_v_deref__cond5, (0 + 1 + _v_len__expr12 + 1));
      uintptr_t _v_len19 = _v_deref__deref__cond52.get_len ();
      uintptr_t _v_len20 = 0;
      if (_v_len19 < _v_len20)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__pos3 = (_v_len19 - _v_len20);
      uintptr_t _v_len21 = _v_deref__deref__cond5.get_len ();
      uintptr_t _v_len22 = 0;
      if (_v_len21 < _v_len22)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__expr23 = (_v_len21 - _v_len22);
      if (!_c_139.term_eq (_v_deref__cond5, 0))
      {
        goto _block1__branch5;
      }
      Expr _ve_expr1 (_v_deref__cond5, (0 + 1), _v_len__expr12);
      Expr _ve_expr2 (_v_deref__deref__cond5, 0, _v_len__expr23);
      Expr _ve_pos (_v_deref__deref__cond52, 0, _v_len__pos3);
      Expr _ve_a1;
      Expr _ve_j_m_expr1;
      RF_CALL (Expr_m_Ref_m_To_m_Java, _ve_expr1, (_ve_a1, _ve_j_m_expr1));
      Expr _ve_a2;
      Expr _ve_j_m_expr2;
      RF_CALL (Expr_m_Ref_m_To_m_Java, _ve_expr2, (_ve_a2, _ve_j_m_expr2));
      RF_CALL (Box::Put, (_vs_acc, (_ve_a1 + _ve_a2)), /*void*/);
      Expr _ge_auxcall6;
      RF_CALL (Expr_m_Int_m_To_m_Java, (_vs_acc, _ve_pos), _ge_auxcall6);
      _v_res1 = (_ve_j_m_expr1 + _c_140 + _ve_j_m_expr2 + _c_78 + _ge_auxcall6 + _c_30);
      goto _block1;
    }
  _block1__branch5: {}
    if (_vt_cond.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__cond6 (_vt_cond, 0);
    if (_v_deref__cond6.get_len () != 2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (!_c_141.term_eq (_v_deref__cond6, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vt_not_m_cond (_v_deref__cond6, (0 + 1), 1);
    Expr _v_Cond_m_To_m_Java1;
    RF_CALL (Cond_m_To_m_Java, (_vs_acc, _vt_not_m_cond), _v_Cond_m_To_m_Java1);
    _v_res1 = (_c_130 + _v_Cond_m_To_m_Java1);
  }
_block1: {}
RF_END

RF_FUNC (Infix_m_To_m_Java, (RF_ARG _vs_acc, _vs_arg2java, _vs_op, _ve_args;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ve_args.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      if (_ve_args.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__args (_ve_args, 0);
      uintptr_t _v_len3 = _v_deref__args.get_len ();
      uintptr_t _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__arg = (_v_len3 - _v_len4);
      Expr _ve_rest (_ve_args, (0 + 1), _v_len__rest);
      Expr _ve_arg (_v_deref__args, 0, _v_len__arg);
      if (!RF_CALL (Apply::Apply, (_vs_arg2java, (_vs_acc + _ve_arg)), _ve_arg))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      RF_CALL (Infix_m_To_m_Java, (_vs_acc, _vs_arg2java, _vs_op, _ve_rest), _ve_rest);
      {
        {
          uintptr_t _v_len5 = _ve_rest.get_len ();
          uintptr_t _v_len6 = 0;
          if (_v_len5 < (_v_len6 + 1))
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__asail__javarf_m_408_m_28 = (_v_len5 - _v_len6);
          uintptr_t _v_len7 = _ve_arg.get_len ();
          uintptr_t _v_len8 = 0;
          if (_v_len7 < (_v_len8 + 1))
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__asail__javarf_m_408_m_16 = (_v_len7 - _v_len8);
          Expr _vv__e__e_tmp_m_rfp__asail__javarf_m_408_m_16 (_ve_arg, 0, _v_len___e__e_tmp_m_rfp__asail__javarf_m_408_m_16);
          Expr _vv__e__e_tmp_m_rfp__asail__javarf_m_408_m_28 (_ve_rest, 0, _v_len___e__e_tmp_m_rfp__asail__javarf_m_408_m_28);
          _v_res1 = (_ve_arg + _c_25 + _vs_op + _c_25 + _ve_rest);
          goto _block2;
        }
      _block2__branch1: {}
        _v_res1 = (_ve_arg + _ve_rest);
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Step_m_To_m_Java, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () != 0)
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg1 (_ge_arg1, 0);
      uintptr_t _v_len1 = _v_deref__arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__expr = (_v_len1 - _v_len2);
      if (!_c_37.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_expr (_v_deref__arg1, (0 + 1), _v_len__expr);
      Expr _ge_auxcall1;
      if (!RF_CALL (Table::Lookup, (Iter_m_Vars, _ve_expr), _ge_auxcall1))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _ge_auxcall2;
      if (!RF_CALL (Access::Middle, (_c_132, _c_133, _ge_auxcall1), _ge_auxcall2))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      _v_res1 = (_ge_auxcall2 + _c_142);
      goto _block1;
    }
  _block1__branch2: {}
    if (_ge_arg1.get_len () != 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_ge_arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__arg12 (_ge_arg1, 0);
    uintptr_t _v_len3 = _v_deref__arg12.get_len ();
    uintptr_t _v_len4 = 1;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__expr2 = (_v_len3 - _v_len4);
    if (!_c_38.term_eq (_v_deref__arg12, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_expr (_v_deref__arg12, (0 + 1), _v_len__expr2);
    Expr _ge_auxcall3;
    if (!RF_CALL (Table::Lookup, (Iter_m_Vars, _ve_expr), _ge_auxcall3))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ge_auxcall4;
    if (!RF_CALL (Access::Middle, (_c_132, _c_133, _ge_auxcall3), _ge_auxcall4))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = (_ge_auxcall4 + _c_143);
  }
_block1: {}
RF_END

RF_FUNC (Const_m_Expr_m_To_m_Java, (RF_ARG _ge_arg1;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      if (_ge_arg1.get_len () != 0)
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      _v_res2 = _c_109;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg1 (_ge_arg1, 0);
      if (_v_deref__arg1.get_len () != 4)
      {
        goto _block1__branch2;
      }
      if (!_c_77.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch2;
      }
      if (!_v_deref__arg1.symbol_at ((0 + 1 + 1)))
      {
        goto _block1__branch2;
      }
      if (!_v_deref__arg1.symbol_at ((0 + 1 + 1 + 1)))
      {
        goto _block1__branch2;
      }
      Expr _vt_name (_v_deref__arg1, (0 + 1), 1);
      Expr _vs_pos (_v_deref__arg1, (0 + 1 + 1), 1);
      Expr _vs_len (_v_deref__arg1, (0 + 1 + 1 + 1), 1);
      Expr _ge_auxcall1;
      RF_CALL (JavaMangle::Rfp2Java, _vt_name, _ge_auxcall1);
      _v_res1 = empty;
      _v_res2 = (_c_110 + _ge_auxcall1 + _c_78 + _vs_pos + _c_78 + _vs_len + _c_30);
      goto _block1;
    }
  _block1__branch2: {}
    Expr _v_Const_m_Expr_m_Aux1;
    Expr _v_Const_m_Expr_m_Aux2;
    RF_CALL (Const_m_Expr_m_Aux, (empty, _ge_arg1), (_v_Const_m_Expr_m_Aux1, _v_Const_m_Expr_m_Aux2));
    {
      {
        if ((_v_Const_m_Expr_m_Aux2.get_len () + 1) != 2)
        {
          goto _block2__branch1;
        }
        Expr _v_compose1 ((_v_Const_m_Expr_m_Aux1 () + _v_Const_m_Expr_m_Aux2));
        if (_v_compose1.symbol_at (0))
        {
          goto _block2__branch1;
        }
        if (_v_compose1.symbol_at ((0 + 1)))
        {
          goto _block2__branch1;
        }
        Expr _v_deref__compose1 (_v_compose1, 0);
        Expr _v_deref__compose12 (_v_compose1, (0 + 1));
        uintptr_t _v_len1 = _v_deref__compose12.get_len ();
        uintptr_t _v_len2 = 0;
        if (_v_len1 < _v_len2)
        {
          goto _block2__branch1;
        }
        uintptr_t _v_len__1 = (_v_len1 - _v_len2);
        uintptr_t _v_len3 = _v_deref__compose1.get_len ();
        uintptr_t _v_len4 = 0;
        if (_v_len3 < _v_len4)
        {
          goto _block2__branch1;
        }
        uintptr_t _v_len__arrays = (_v_len3 - _v_len4);
        Expr _ve_arrays (_v_deref__compose1, 0, _v_len__arrays);
        Expr _ve_1 (_v_deref__compose12, 0, _v_len__1);
        _v_res1 = _ve_arrays;
        _v_res2 = _ve_1;
        goto _block2;
      }
    _block2__branch1: {}
      {
        if ((_v_Const_m_Expr_m_Aux2.get_len () + 1) != 3)
        {
          goto _block2__branch2;
        }
        Expr _v_compose2 ((_v_Const_m_Expr_m_Aux1 () + _v_Const_m_Expr_m_Aux2));
        if (_v_compose2.symbol_at (0))
        {
          goto _block2__branch2;
        }
        if (_v_compose2.symbol_at ((0 + 1)))
        {
          goto _block2__branch2;
        }
        if (_v_compose2.symbol_at ((0 + 1 + 1)))
        {
          goto _block2__branch2;
        }
        Expr _v_deref__compose2 (_v_compose2, 0);
        Expr _v_deref__compose22 (_v_compose2, (0 + 1));
        Expr _v_deref__compose23 (_v_compose2, (0 + 1 + 1));
        uintptr_t _v_len5 = _v_deref__compose2.get_len ();
        uintptr_t _v_len6 = 0;
        if (_v_len5 < _v_len6)
        {
          goto _block2__branch2;
        }
        uintptr_t _v_len__arrays2 = (_v_len5 - _v_len6);
        uintptr_t _v_len7 = _v_deref__compose23.get_len ();
        uintptr_t _v_len8 = 0;
        if (_v_len7 < _v_len8)
        {
          goto _block2__branch2;
        }
        uintptr_t _v_len__2 = (_v_len7 - _v_len8);
        uintptr_t _v_len9 = _v_deref__compose22.get_len ();
        uintptr_t _v_len10 = 0;
        if (_v_len9 < _v_len10)
        {
          goto _block2__branch2;
        }
        uintptr_t _v_len__12 = (_v_len9 - _v_len10);
        Expr _ve_arrays (_v_deref__compose2, 0, _v_len__arrays2);
        Expr _ve_1 (_v_deref__compose22, 0, _v_len__12);
        Expr _ve_2 (_v_deref__compose23, 0, _v_len__2);
        _v_res1 = _ve_arrays;
        _v_res2 = (_c_110 + _ve_1 + _c_78 + _ve_2 + _c_30);
        goto _block2;
      }
    _block2__branch2: {}
      uintptr_t _v_len11 = (_v_Const_m_Expr_m_Aux2.get_len () + 1);
      uintptr_t _v_len12 = 1;
      if (_v_len11 < _v_len12)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__concat = (_v_len11 - _v_len12);
      Expr _v_compose3 ((_v_Const_m_Expr_m_Aux1 () + _v_Const_m_Expr_m_Aux2));
      if (_v_compose3.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__compose3 (_v_compose3, 0);
      uintptr_t _v_len13 = _v_deref__compose3.get_len ();
      uintptr_t _v_len14 = 0;
      if (_v_len13 < _v_len14)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__arrays3 = (_v_len13 - _v_len14);
      Expr _ve_concat (_v_compose3, (0 + 1), _v_len__concat);
      Expr _ve_arrays (_v_deref__compose3, 0, _v_len__arrays3);
      Expr _v_Free_m_Index1;
      RF_CALL (Free_m_Index, /*void*/, _v_Free_m_Index1);
      Expr _ve_new_m_var ((_c_59 + _v_Free_m_Index1));
      Expr _ge_auxcall2;
      RF_CALL (List::Intersperse, (_c_78, _ve_concat), _ge_auxcall2);
      Expr _ge_auxcall3;
      RF_CALL (List::Concat, _ge_auxcall2, _ge_auxcall3);
      _v_res1 = (_ve_arrays + (_c_144 + _ve_new_m_var + _c_114 + _ge_auxcall3 + _c_113) ());
      _v_res2 = (_c_116 + _ve_new_m_var + _c_30);
    }
  _block2: {}
  }
_block1: {}
RF_END

RF_FUNC (Const_m_Expr_m_Aux, (RF_ARG _ve_accum, _ve_expr;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      uintptr_t _v_len1 = _ve_expr.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      if (!_ve_expr.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_sym (_ve_expr, 0, 1);
      Expr _ve_rest (_ve_expr, (0 + 1), _v_len__rest);
      if (!RF_CALL (Class::Char_q_, _vs_sym, /*void*/))
      {
        goto _block1__branch1;
      }
      Expr _ge_auxcall1;
      RF_CALL (Symbol_m_To_m_Java, _vs_sym, _ge_auxcall1);
      RF_TAILCALL (Const_m_Expr_m_Aux, ((_ve_accum + _ge_auxcall1), _ve_rest), (_v_res1, _v_res2));
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len3 = _ve_accum.get_len ();
      uintptr_t _v_len4 = 0;
      if (_v_len3 < (_v_len4 + 1))
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__asail__javarf_m_442_m_14 = (_v_len3 - _v_len4);
      Expr _vv__e__e_tmp_m_rfp__asail__javarf_m_442_m_14 (_ve_accum, 0, _v_len___e__e_tmp_m_rfp__asail__javarf_m_442_m_14);
      Expr _ve_arrays;
      Expr _ve_j_m_expr;
      RF_CALL (Const_m_Expr_m_Aux, (empty, _ve_expr), (_ve_arrays, _ve_j_m_expr));
      _v_res1 = _ve_arrays;
      _v_res2 = ((_c_146 + _ve_accum + _c_145) () + _ve_j_m_expr);
      goto _block1;
    }
  _block1__branch2: {}
    {
      uintptr_t _v_len5 = _ve_expr.get_len ();
      uintptr_t _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__rest2 = (_v_len5 - _v_len6);
      Expr _vt_item (_ve_expr, 0, 1);
      Expr _ve_rest (_ve_expr, (0 + 1), _v_len__rest2);
      Expr _ve_arrays;
      Expr _ve_java_m_item;
      {
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__item (_vt_item, 0);
          uintptr_t _v_len7 = _v_deref__item.get_len ();
          uintptr_t _v_len8 = 1;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__paren_m_expr = (_v_len7 - _v_len8);
          if (!_c_103.term_eq (_v_deref__item, 0))
          {
            goto _block2__branch1;
          }
          Expr _ve_paren_m_expr (_v_deref__item, (0 + 1), _v_len__paren_m_expr);
          Expr _ge_arrays__4;
          Expr _ve_j_m_expr;
          RF_CALL (Const_m_Expr_m_To_m_Java, _ve_paren_m_expr, (_ge_arrays__4, _ve_j_m_expr));
          _ve_arrays = _ge_arrays__4;
          _ve_java_m_item = (_c_110 + _ve_j_m_expr + _c_30) ();
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__item2 (_vt_item, 0);
          if (_v_deref__item2.get_len () != 2)
          {
            goto _block2__branch2;
          }
          if (!_c_119.term_eq (_v_deref__item2, 0))
          {
            goto _block2__branch2;
          }
          Expr _vt_name (_v_deref__item2, (0 + 1), 1);
          Expr _ge_auxcall2;
          RF_CALL (Name_m_To_m_Java, _vt_name, _ge_auxcall2);
          _ve_arrays = empty;
          _ve_java_m_item = _ge_auxcall2 ();
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__item3 (_vt_item, 0);
          uintptr_t _v_len9 = _v_deref__item3.get_len ();
          uintptr_t _v_len10 = 1;
          if (_v_len9 < _v_len10)
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__asail__javarf_m_451_m_14 = (_v_len9 - _v_len10);
          if (!_c_89.term_eq (_v_deref__item3, 0))
          {
            goto _block2__branch3;
          }
          Expr _ve__e__e_tmp_m_rfp__asail__javarf_m_451_m_14 (_v_deref__item3, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__javarf_m_451_m_14);
          Expr _ge_auxcall3;
          RF_CALL (JavaMangle::Rfp2Java, _vt_item, _ge_auxcall3);
          _ve_arrays = empty;
          _ve_java_m_item = _ge_auxcall3 ();
          goto _block2;
        }
      _block2__branch3: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__item4 (_vt_item, 0);
          if (_v_deref__item4.get_len () != 2)
          {
            goto _block2__branch4;
          }
          if (!_c_18.term_eq (_v_deref__item4, 0))
          {
            goto _block2__branch4;
          }
          Expr _vt_name (_v_deref__item4, (0 + 1), 1);
          Expr _ge_auxcall4;
          RF_CALL (Name_m_To_m_Java, _vt_name, _ge_auxcall4);
          _ve_arrays = empty;
          _ve_java_m_item = (_c_151 + (_c_149 + (_c_148 + _ge_auxcall4 + _c_147) () + _c_8) () + _c_150) ();
          goto _block2;
        }
      _block2__branch4: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch5;
          }
          Expr _v_deref__item5 (_vt_item, 0);
          if (_v_deref__item5.get_len () != 2)
          {
            goto _block2__branch5;
          }
          if (!_c_16.term_eq (_v_deref__item5, 0))
          {
            goto _block2__branch5;
          }
          Expr _vt_name (_v_deref__item5, (0 + 1), 1);
          Expr _ge_auxcall5;
          RF_CALL (Name_m_To_m_Java, _vt_name, _ge_auxcall5);
          _ve_arrays = empty;
          _ve_java_m_item = (_c_151 + (_c_149 + ((_ge_auxcall5 + _c_147) () + _c_20) () + _c_8) () + _c_150) ();
          goto _block2;
        }
      _block2__branch5: {}
        if (!_vt_item.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _vs_sym (_vt_item, 0, 1);
        {
          {
            if (!RF_CALL (Class::Int_q_, _vs_sym, /*void*/))
            {
              goto _block3__branch1;
            }
            {
              {
                Expr _v__q_1;
                RF_CALL (Box::_q_, Int, _v__q_1);
                if (_v__q_1.get_len () != 1)
                {
                  goto _block4__branch1;
                }
                if (!_c_1.term_eq (_v__q_1, 0))
                {
                  goto _block4__branch1;
                }
                RF_CALL (Table::Bind, (Inputs, _c_152, empty), /*void*/);
                goto _block4;
              }
            _block4__branch1: {}
            }
          _block4: {}
            Expr _ge_auxcall6;
            RF_CALL (Box::_q_, Int, _ge_auxcall6);
            _ve_arrays = empty;
            _ve_java_m_item = (_c_154 + _ge_auxcall6 + _c_95 + _vs_sym + _c_153) ();
            goto _block3;
          }
        _block3__branch1: {}
          if (!RF_CALL (Class::Word_q_, _vs_sym, /*void*/))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _ge_auxcall7;
          RF_CALL (Symbol_m_To_m_Java, _vs_sym, _ge_auxcall7);
          _ve_arrays = empty;
          _ve_java_m_item = (_c_155 + _ge_auxcall7 + _c_153) ();
        }
      _block3: {}
      }
    _block2: {}
      Expr _ve_new_m_arrays;
      Expr _ve_java_m_rest;
      RF_CALL (Const_m_Expr_m_Aux, (empty, _ve_rest), (_ve_new_m_arrays, _ve_java_m_rest));
      _v_res1 = (_ve_arrays + _ve_new_m_arrays);
      _v_res2 = (_ve_java_m_item + _ve_java_m_rest);
      goto _block1;
    }
  _block1__branch3: {}
    _v_res1 = empty;
    _v_res2 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Symbol_m_To_m_Java, (RF_ARG _vs_ObjectSymbol;;), (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  RF_CALL (Convert::To_m_Chars, _vs_ObjectSymbol, _ge_auxcall1);
  Expr _ve_symbol (_ge_auxcall1);
  Expr _ve_java_m_symbol (empty);
  for ( ; ; )
  {
    {
      if (_ve_symbol.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_java_m_symbol;
      goto _exit__iter1;
    }
  _iter1: {}
    uintptr_t _v_len1 = _ve_symbol.get_len ();
    uintptr_t _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__rest = (_v_len1 - _v_len2);
    if (!_ve_symbol.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_char (_ve_symbol, 0, 1);
    Expr _ve_rest (_ve_symbol, (0 + 1), _v_len__rest);
    Expr _ve_java_m_char;
    {
      {
        if (!_vs_char.term_eq (_c_156, 0))
        {
          goto _block3__branch1;
        }
        _ve_java_m_char = _c_157;
        goto _block3;
      }
    _block3__branch1: {}
      {
        if (!_vs_char.term_eq (_c_158, 0))
        {
          goto _block3__branch2;
        }
        _ve_java_m_char = _c_159;
        goto _block3;
      }
    _block3__branch2: {}
      {
        if (!_vs_char.term_eq (_c_160, 0))
        {
          goto _block3__branch3;
        }
        _ve_java_m_char = _c_161;
        goto _block3;
      }
    _block3__branch3: {}
      {
        if (!_vs_char.term_eq (_c_162, 0))
        {
          goto _block3__branch4;
        }
        _ve_java_m_char = _c_163;
        goto _block3;
      }
    _block3__branch4: {}
      {
        if (!_vs_char.term_eq (_c_164, 0))
        {
          goto _block3__branch5;
        }
        _ve_java_m_char = _c_165;
        goto _block3;
      }
    _block3__branch5: {}
      if (!_vs_char.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _vs__e__e_tmp_m_rfp__asail__javarf_m_490_m_8 (_vs_char, 0, 1);
      _ve_java_m_char = _vs_char;
    }
  _block3: {}
    _ve_symbol = _ve_rest;
    _ve_java_m_symbol = (_ve_java_m_symbol + _ve_java_m_char);
  }
_exit__iter1: {}
RF_END

RF_FUNC (Int_m_Args_m_To_m_Java, (RF_ARG _vs_acc, _ve_args;;), (RF_RES _v_res1;;))
  Expr _ge_args__0 (_ve_args);
  Expr _ve_java_m_args (empty);
  for ( ; ; )
  {
    {
      if (_ge_args__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_java_m_args;
      goto _exit__iter1;
    }
  _iter1: {}
    uintptr_t _v_len1 = _ge_args__0.get_len ();
    uintptr_t _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__rest = (_v_len1 - _v_len2);
    if (_ge_args__0.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__args__0 (_ge_args__0, 0);
    uintptr_t _v_len3 = _v_deref__args__0.get_len ();
    uintptr_t _v_len4 = 0;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__arg = (_v_len3 - _v_len4);
    Expr _ve_rest (_ge_args__0, (0 + 1), _v_len__rest);
    Expr _ve_arg (_v_deref__args__0, 0, _v_len__arg);
    Expr _ve_comma;
    {
      {
        uintptr_t _v_len5 = _v_len__rest;
        uintptr_t _v_len6 = 0;
        if (_v_len5 < (_v_len6 + 1))
        {
          goto _block2__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__asail__javarf_m_502_m_19 = (_v_len5 - _v_len6);
        Expr _vv__e__e_tmp_m_rfp__asail__javarf_m_502_m_19 (_ve_rest, 0, _v_len___e__e_tmp_m_rfp__asail__javarf_m_502_m_19);
        _ve_comma = _c_78;
        goto _block2;
      }
    _block2__branch1: {}
      _ve_comma = empty;
    }
  _block2: {}
    Expr _ge_auxcall1;
    RF_CALL (Expr_m_Int_m_To_m_Java, (_vs_acc, _ve_arg), _ge_auxcall1);
    _ge_args__0 = _ve_rest;
    _ve_java_m_args = (_ve_java_m_args + _ge_auxcall1 + _ve_comma);
  }
_exit__iter1: {}
RF_END

RF_FUNC (Var_m_Args_m_To_m_Java, (RF_ARG _ve_args;;), (RF_RES _v_res1;;))
  Expr _ge_args__0 (_ve_args);
  Expr _ve_type (empty);
  Expr _ve_java_m_args (empty);
  for ( ; ; )
  {
    {
      if (_ge_args__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_java_m_args;
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        uintptr_t _v_len1 = _ge_args__0.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len__rest = (_v_len1 - _v_len2);
        if (!_ge_args__0.symbol_at (0))
        {
          goto _block1__branch1;
        }
        Expr _vs_t (_ge_args__0, 0, 1);
        Expr _ve_rest (_ge_args__0, (0 + 1), _v_len__rest);
        _ge_args__0 = _ve_rest;
        _ve_type = _vs_t;
        goto _block1;
      }
    _block1__branch1: {}
      uintptr_t _v_len3 = _ge_args__0.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__rest2 = (_v_len3 - _v_len4);
      Expr _vt_arg (_ge_args__0, 0, 1);
      Expr _ve_rest (_ge_args__0, (0 + 1), _v_len__rest2);
      Expr _ve_comma;
      {
        {
          if (_v_len__rest2 < 1)
          {
            goto _block2__branch1;
          }
          RF_lsplit (_ve_rest, 0, _ve__e__e_tmp_m_rfp__asail__javarf_m_516_m_19, _v_lsplit__rest);
          for ( ; ; RF_iter(_ve_rest)++)
          {
            {
              if (!RF_iter(_ve_rest))
              {
                goto _block2__branch1;
              }
              uintptr_t _v_len5 = _v_lsplit__rest.get_len ();
              uintptr_t _v_len6 = 1;
              if (_v_len5 < _v_len6)
              {
                goto _block2__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__asail__javarf_m_516_m_25 = (_v_len5 - _v_len6);
              if (_v_lsplit__rest.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__lsplit__rest (_v_lsplit__rest, 0);
              uintptr_t _v_len7 = _v_deref__lsplit__rest.get_len ();
              uintptr_t _v_len8 = 0;
              if (_v_len7 < _v_len8)
              {
                goto _continue1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__asail__javarf_m_516_m_22 = (_v_len7 - _v_len8);
              Expr _ve__e__e_tmp_m_rfp__asail__javarf_m_516_m_25 (_v_lsplit__rest, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__javarf_m_516_m_25);
              Expr _ve__e__e_tmp_m_rfp__asail__javarf_m_516_m_22 (_v_deref__lsplit__rest, 0, _v_len___e__e_tmp_m_rfp__asail__javarf_m_516_m_22);
              _ve_comma = _c_78;
              goto _exit1;
            }
        _continue1: {}
          }
        _exit1: {}
          goto _block2;
        }
      _block2__branch1: {}
        _ve_comma = empty;
      }
    _block2: {}
      Expr _ge_auxcall1;
      RF_CALL (JavaMangle::Rfp2Java, _vt_arg, _ge_auxcall1);
      _ge_args__0 = _ve_rest;
      _ve_java_m_args = (_ve_java_m_args + _ve_type + _c_25 + _ge_auxcall1 + _ve_comma);
    }
  _block1: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Expr_m_Args_m_To_m_Java, (RF_ARG _ve_args;;), (RF_RES _v_res1, _v_res2;;))
  Expr _ge_args__0 (_ve_args);
  Expr _ve_type (empty);
  Expr _ve_java_m_args (empty);
  Expr _ve_arrays (empty);
  for ( ; ; )
  {
    {
      if (_ge_args__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_arrays;
      _v_res2 = _ve_java_m_args;
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        uintptr_t _v_len1 = _ge_args__0.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len__rest = (_v_len1 - _v_len2);
        if (!_ge_args__0.symbol_at (0))
        {
          goto _block1__branch1;
        }
        Expr _vs_t (_ge_args__0, 0, 1);
        Expr _ve_rest (_ge_args__0, (0 + 1), _v_len__rest);
        _ge_args__0 = _ve_rest;
        _ve_type = _vs_t;
        goto _block1;
      }
    _block1__branch1: {}
      uintptr_t _v_len3 = _ge_args__0.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__rest2 = (_v_len3 - _v_len4);
      if (_ge_args__0.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__args__0 (_ge_args__0, 0);
      uintptr_t _v_len5 = _v_deref__args__0.get_len ();
      uintptr_t _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__arg = (_v_len5 - _v_len6);
      Expr _ve_rest (_ge_args__0, (0 + 1), _v_len__rest2);
      Expr _ve_arg (_v_deref__args__0, 0, _v_len__arg);
      Expr _ve_comma;
      {
        {
          if (_v_len__rest2 < 1)
          {
            goto _block2__branch1;
          }
          RF_lsplit (_ve_rest, 0, _ve__e__e_tmp_m_rfp__asail__javarf_m_530_m_19, _v_lsplit__rest);
          for ( ; ; RF_iter(_ve_rest)++)
          {
            {
              if (!RF_iter(_ve_rest))
              {
                goto _block2__branch1;
              }
              uintptr_t _v_len7 = _v_lsplit__rest.get_len ();
              uintptr_t _v_len8 = 1;
              if (_v_len7 < _v_len8)
              {
                goto _block2__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__asail__javarf_m_530_m_25 = (_v_len7 - _v_len8);
              if (_v_lsplit__rest.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__lsplit__rest (_v_lsplit__rest, 0);
              uintptr_t _v_len9 = _v_deref__lsplit__rest.get_len ();
              uintptr_t _v_len10 = 0;
              if (_v_len9 < _v_len10)
              {
                goto _continue1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__asail__javarf_m_530_m_22 = (_v_len9 - _v_len10);
              Expr _ve__e__e_tmp_m_rfp__asail__javarf_m_530_m_25 (_v_lsplit__rest, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__javarf_m_530_m_25);
              Expr _ve__e__e_tmp_m_rfp__asail__javarf_m_530_m_22 (_v_deref__lsplit__rest, 0, _v_len___e__e_tmp_m_rfp__asail__javarf_m_530_m_22);
              _ve_comma = _c_78;
              goto _exit1;
            }
        _continue1: {}
          }
        _exit1: {}
          goto _block2;
        }
      _block2__branch1: {}
        _ve_comma = empty;
      }
    _block2: {}
      {
        {
          if (_ve_type.get_len () != 0)
          {
            goto _block3__branch1;
          }
          Expr _ve_a;
          Expr _ve_j_m_arg;
          RF_CALL (Expr_m_Ref_m_To_m_Java, _ve_arg, (_ve_a, _ve_j_m_arg));
          _ge_args__0 = _ve_rest;
          _ve_java_m_args = (_ve_java_m_args + _ve_j_m_arg + _ve_comma);
          _ve_arrays = (_ve_arrays + _ve_a);
          goto _block3;
        }
      _block3__branch1: {}
        _ge_args__0 = _ve_rest;
        _ve_java_m_args = (_ve_java_m_args + _ve_arg + _ve_comma);
      }
    _block3: {}
    }
  _block1: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Name_m_To_m_Java, (RF_ARG _vt_obj_m_name;;), (RF_RES _v_res1;;))
  Expr _ve_qualifiers;
  Expr _ve_name;
  RF_CALL (rfp__helper::RFP_m_Extract_m_Qualifiers, _vt_obj_m_name, (_ve_qualifiers, _ve_name));
  Expr _ve_namespace;
  RF_CALL (Box::_q_, Current_m_Namespace, _ve_namespace);
  {
    {
      uintptr_t _v_len1 = _ve_qualifiers.get_len ();
      uintptr_t _v_len2 = _ve_namespace.get_len ();
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__cont = (_v_len1 - _v_len2);
      if (!_ve_namespace.eq (_ve_qualifiers, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve_cont (_ve_qualifiers, (0 + _ve_namespace.get_len ()), _v_len__cont);
      RF_TAILCALL (JavaMangle::Rfp2Java, (_ve_cont + _ve_name), _v_res1);
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Table::Bind, (Inputs, _ve_qualifiers, empty), /*void*/);
    RF_TAILCALL (JavaMangle::Rfp2Java, (_ve_qualifiers + _ve_name) (), _v_res1);
  }
_block1: {}
RF_END

RF_FUNC (Var_m_To_m_Java, (RF_ARG _vt_var;;), (RF_RES _v_res1;;))
  {
    {
      Expr _ge_auxcall1;
      if (!RF_CALL (Table::Lookup, (Result, _vt_var), _ge_auxcall1))
      {
        goto _block1__branch1;
      }
      _v_res1 = (_ge_auxcall1 + _c_166);
      goto _block1;
    }
  _block1__branch1: {}
    RF_TAILCALL (JavaMangle::Rfp2Java, _vt_var, _v_res1);
  }
_block1: {}
RF_END

RF_FUNC (Access_m_Mode, (RF_ARG _vt_name;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, Exports, _v__q_1);
      if (_v__q_1.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_v__q_1, 0, _ve__e__e_tmp_m_rfp__asail__javarf_m_558_m_19, _v_lsplit___q_1);
      for ( ; ; RF_iter(_v__q_1)++)
      {
        {
          if (!RF_iter(_v__q_1))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_lsplit___q_1.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__asail__javarf_m_558_m_28 = (_v_len1 - _v_len2);
          if (!_vt_name.term_eq (_v_lsplit___q_1, 0))
          {
            goto _continue1;
          }
          Expr _ve__e__e_tmp_m_rfp__asail__javarf_m_558_m_28 (_v_lsplit___q_1, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__javarf_m_558_m_28);
          _v_res1 = _c_167;
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _c_168;
  }
_block1: {}
RF_END

RF_FUNC (Free_m_Index, RF_VOID, (RF_RES _v_res1;;))
  Expr _v__q_1;
  RF_CALL (Box::_q_, Free_m_Idx, _v__q_1);
  Expr _vs_idx;
  {
    {
      if (_v__q_1.get_len () != 0)
      {
        goto _block1__branch1;
      }
      _vs_idx = _c_169;
      goto _block1;
    }
  _block1__branch1: {}
    if (_v__q_1.get_len () != 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (!_v__q_1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _gs_idx__2 (_v__q_1, 0, 1);
    RF_CALL (Arithm::_p_, (_gs_idx__2, _c_169), _vs_idx);
  }
_block1: {}
  RF_CALL (Box::Store, (Free_m_Idx, _vs_idx), /*void*/);
  _v_res1 = _vs_idx;
RF_END

RF_FUNC (Expr_m_Int_m_To_m_Java__0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = _ge_arg1.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_170);
  }
  uintptr_t _v_len__stub1 = (_v_len1 - _v_len2);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_170);
  }
  Expr _v_stub2 (_ge_arg1, 0, 1);
  Expr _v_stub1 (_ge_arg1, (0 + 1), _v_len__stub1);
  RF_TAILCALL (Expr_m_Int_m_To_m_Java, (_v_stub2, _v_stub1), _v_res1);
RF_END

RF_FUNC (Term_m_Ref_m_To_m_Java__0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_ERROR (_c_170);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_170);
  }
  Expr _v_stub1 (_ge_arg1, 0, 1);
  Expr _v_stub2 (_ge_arg1, (0 + 1), 1);
  RF_TAILCALL (Term_m_Ref_m_To_m_Java, (_v_stub1, _v_stub2), _v_res1);
RF_END

}

namespace rfp__asail__java
{

static void init_ ()
{
  Int = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Int");
  Exports = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Exports");
  Inputs = new rftype::StaticObject<rftype::Table>(L"Inputs");
  Module_m_Name = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Module-Name");
  Entry = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Entry");
  Entry_m_Name = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Entry-Name");
  Current_m_Namespace = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Current-Namespace");
  Func_m_Name = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Func-Name");
  Ress = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Ress");
  Result = new rftype::StaticObject<rftype::Table>(L"Result");
  Res_m_Assigns = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Res-Assigns");
  Iter_m_Vars = new rftype::StaticObject<rftype::Table>(L"Iter-Vars");
  Free_m_Idx = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Free-Idx");
  _c_0 = Expr::create<rftype::Word>("INT");
  _c_1 = Expr::create<rftype::Word>("BigInteger");
  _c_2 = Expr::create<rftype::Word>("ENTRIES");
  _c_3 = Expr::create<rftype::Word>("Main");
  _c_6 = rftype::Char::create_expr (L"RefalRuntime.setArgs (\"");
  _c_4 = Expr (_c_6, 12, 1);
  _c_5 = rftype::Char::create_expr (L"\", args);");
  _c_7 = rftype::Char::create_expr (L" (new Result ());");
  _c_171 = rftype::Char::create_expr (L"java.lang.System.out.println (\"$error: \" + e);");
  _c_172 = rftype::Char::create_expr (L"catch (RefalException e) {") + ((_c_171) () + (rftype::Char::create_expr (L"java.lang.System.exit (100);")) ()) () + rftype::Char::create_expr (L"}");
  _c_8 = Expr (_c_172, 27, 1);
  _c_9 = rftype::Char::create_expr (L"try {");
  _c_10 = (_c_172) ();
  _c_11 = rftype::Char::create_expr (L"public static void main (java.lang.String[] args) {");
  _c_12 = (empty) ();
  _c_13 = rftype::Char::create_expr (L"\n{");
  _c_14 = rftype::Char::create_expr (L"public class ");
  _c_15 = Expr::create<rftype::Word>("IMPORT");
  _c_16 = Expr::create<rftype::Word>("FUNC");
  _c_17 = Expr (_c_11, 14, 4);
  _c_18 = Expr::create<rftype::Word>("FUNC?");
  _c_149 = rftype::Char::create_expr (L"public boolean eval (Expr arg, Result res) throws RefalException {");
  _c_19 = Expr (_c_149, 7, 7);
  _c_20 = (rftype::Char::create_expr (L"return true;")) ();
  _c_21 = Expr::create<rftype::Word>("Result");
  _c_22 = Expr::create<rftype::Word>("Expr");
  _c_23 = Expr (_c_149, 41, 23);
  _c_24 = Expr (_c_172, 5, 2);
  _c_25 = Expr (_c_24, 0, 1);
  _c_26 = Expr (_c_11, 7, 7);
  _c_27 = Expr (_c_13, 1, 1);
  _c_28 = Expr::create<rftype::Word>("TRACE");
  _c_29 = Expr::create<rftype::Word>("IF-INT-CMP");
  _c_30 = Expr (_c_5, 7, 1);
  _c_49 = rftype::Char::create_expr (L"if (false)");
  _c_31 = Expr (_c_49, 0, 4);
  _c_32 = Expr::create<rftype::Word>("IF");
  _c_33 = Expr::create<rftype::Word>("CALL-FAILS");
  _c_34 = Expr::create<rftype::Word>("FOR");
  _c_35 = Expr::create<rftype::Word>("LABEL");
  _c_36 = Expr (_c_171, 37, 2);
  _c_37 = Expr::create<rftype::Word>("INC-ITER");
  _c_38 = Expr::create<rftype::Word>("DEC-ITER");
  _c_39 = rftype::Char::create_expr (L".getLeft();");
  _c_173 = rftype::Char::create_expr (L"Expr err = error.getExpr ();");
  _c_40 = Expr (_c_173, 8, 3);
  _c_41 = Expr (_c_173, 0, 5);
  _c_42 = rftype::Char::create_expr (L".getRight();");
  _c_43 = rftype::Char::create_expr (L"for ( ; ; ");
  _c_44 = rftype::Char::create_expr (L": {");
  _c_45 = Expr::create<rftype::Word>("TRY");
  _c_46 = rftype::Char::create_expr (L"\", \"This is for avoiding 'Unreachable code' errors\");");
  _c_47 = Expr (_c_46, 0, 4);
  _c_48 = rftype::Char::create_expr (L"throw new RefalException (\"");
  _c_50 = (Expr (_c_9, 0, 3)) ();
  _c_51 = Expr::create<rftype::Word>("CATCH-ERROR");
  _c_52 = (_c_173) ();
  _c_53 = rftype::Char::create_expr (L"catch (RefalException error) {");
  _c_54 = Expr::create<rftype::Word>("RETFAIL");
  _c_174 = rftype::Char::create_expr (L"return false;");
  _c_100 = rftype::Char::create_expr (L") {") + (_c_174) () + rftype::Char::create_expr (L"}");
  _c_55 = Expr (_c_100, 3, 1);
  _c_56 = Expr::create<rftype::Word>("FATAL");
  _c_57 = rftype::Char::create_expr (L"\", \"Unexpected fail\");");
  _c_58 = Expr::create<rftype::Word>("LSPLIT");
  _c_59 = rftype::Char::create_expr (L"_va_");
  _c_60 = Expr (_c_5, 7, 2);
  _c_61 = rftype::Char::create_expr (L".leftSplit(");
  _c_62 = rftype::Char::create_expr (L"Expr.SplitIterator ");
  _c_63 = Expr::create<rftype::Word>("RSPLIT");
  _c_64 = rftype::Char::create_expr (L".rightSplit(");
  _c_65 = Expr::create<rftype::Word>("ASSIGN");
  _c_66 = rftype::Char::create_expr (L".assign (");
  _c_67 = Expr (_c_60, 1, 1);
  _c_68 = Expr::create<rftype::Word>("DECL");
  _c_69 = rftype::Char::create_expr (L" = new Result ();");
  _c_70 = Expr (_c_69, 7, 7);
  _c_71 = rftype::Char::create_expr (L" = Expr.empty;");
  _c_72 = rftype::Char::create_expr (L"int ");
  _c_73 = Expr::create<rftype::Word>("EXPR");
  _c_74 = Expr::create<rftype::Word>("DEREF");
  _c_75 = rftype::Char::create_expr (L".at (");
  _c_76 = rftype::Char::create_expr (L" = (Expr) ");
  _c_77 = Expr::create<rftype::Word>("SUBEXPR");
  _c_78 = Expr (_c_47, 1, 2);
  _c_96 = rftype::Char::create_expr (L" = new Expr (new ");
  _c_79 = Expr (_c_96, 0, 13);
  _c_80 = Expr::create<rftype::Word>("DROP");
  _c_81 = rftype::Char::create_expr (L".drop ();");
  _c_82 = Expr::create<rftype::Word>("CONTINUE");
  _c_83 = rftype::Char::create_expr (L"continue ");
  _c_84 = Expr::create<rftype::Word>("BREAK");
  _c_85 = rftype::Char::create_expr (L"break ");
  _c_86 = Expr::create<rftype::Word>("ERROR");
  _c_87 = Expr (_c_48, 0, 26);
  _c_88 = Expr::create<rftype::Word>("CONSTEXPR");
  _c_89 = Expr::create<rftype::Word>("STATIC");
  _c_90 = rftype::Char::create_expr (L" final Expr ");
  _c_91 = Expr::create<rftype::Word>("OBJ");
  _c_92 = rftype::Char::create_expr (L"Named");
  _c_93 = rftype::Char::create_expr (L"org.refal.plus.library.");
  _c_94 = rftype::Char::create_expr (L"\"));");
  _c_95 = Expr (_c_48, 24, 3);
  _c_97 = Expr::create<rftype::Word>("DECL-OBJ");
  _c_98 = Expr::create<rftype::Word>("DECL-FUNC");
  _c_99 = Expr::create<rftype::Word>("TAILCALL?");
  _c_101 = rftype::Char::create_expr (L"if (!");
  _c_102 = Expr (_c_173, 16, 12);
  _c_103 = Expr::create<rftype::Word>("PAREN");
  _c_104 = Expr::create<rftype::Word>("LENGTH");
  _c_105 = Expr::create<rftype::Word>("XXX");
  _c_106 = Expr::create<rftype::Word>("MAX");
  _c_107 = Expr::create<rftype::Word>("MIN");
  _c_108 = Expr::create<rftype::Word>("INFIX");
  _c_109 = Expr (_c_71, 3, 10);
  _c_110 = Expr (_c_79, 3, 10);
  _c_111 = Expr::create_sym<rftype::Func> (Term_m_Ref_m_To_m_Java__0);
  _c_112 = Expr::create<rftype::Word>(",");
  _c_113 = rftype::Char::create_expr (L" };");
  _c_114 = rftype::Char::create_expr (L" = { ");
  _c_144 = rftype::Char::create_expr (L"static private final Expr[] ");
  _c_115 = Expr (_c_144, 21, 7);
  _c_116 = rftype::Char::create_expr (L"Expr.concat (");
  _c_117 = rftype::Char::create_expr (L"new Expr(");
  _c_118 = Expr (_c_76, 3, 7);
  _c_119 = Expr::create<rftype::Word>("REF");
  _c_120 = Expr::create<rftype::Word>("ERROR-EXPR");
  _c_121 = Expr (_c_173, 5, 3);
  _c_122 = Expr::create<rftype::Word>("Illegal int-symbol: ");
  _c_123 = rftype::Char::create_expr (L".getLen ()");
  _c_124 = rftype::Char::create_expr (L"java.lang.Math.max (");
  _c_125 = rftype::Char::create_expr (L"java.lang.Math.min (");
  _c_126 = Expr::create_sym<rftype::Func> (Expr_m_Int_m_To_m_Java__0);
  _c_127 = Expr (_c_24, 1, 1);
  _c_128 = Expr::create<rftype::Word>("+");
  _c_129 = Expr::create<rftype::Word>("CALL");
  _c_130 = Expr (_c_101, 4, 1);
  _c_131 = Expr::create<rftype::Word>("ITER-FAILS");
  _c_132 = Expr::create<rftype::Integer>("0");
  _c_133 = Expr::create<rftype::Integer>("2");
  _c_134 = rftype::Char::create_expr (L".isValid ()");
  _c_135 = Expr::create<rftype::Word>("SYMBOL?");
  _c_136 = rftype::Char::create_expr (L".symbolAt (");
  _c_137 = Expr::create<rftype::Word>("EQ");
  _c_138 = rftype::Char::create_expr (L".eq (");
  _c_139 = Expr::create<rftype::Word>("TERM-EQ");
  _c_140 = rftype::Char::create_expr (L".termEq (");
  _c_141 = Expr::create<rftype::Word>("NOT");
  _c_142 = rftype::Char::create_expr (L".next ()");
  _c_143 = rftype::Char::create_expr (L".prev ()");
  _c_145 = Expr (_c_94, 0, 2);
  _c_146 = rftype::Char::create_expr (L"Expr.fromSequence (\"");
  _c_147 = rftype::Char::create_expr (L" (arg, res);");
  _c_148 = Expr (_c_174, 0, 7);
  _c_150 = rftype::Char::create_expr (L"})");
  _c_151 = rftype::Char::create_expr (L"new Expr (new Func () {");
  _c_152 = rftype::Char::create_expr (L"java.math.BigInteger");
  _c_153 = Expr (_c_94, 0, 3);
  _c_154 = Expr (_c_96, 3, 14);
  _c_155 = rftype::Char::create_expr (L"new Expr (new Word (\"");
  _c_157 = rftype::Char::create_expr (L"\\\\");
  _c_156 = Expr (_c_157, 0, 1);
  _c_158 = Expr (_c_13, 0, 1);
  _c_159 = rftype::Char::create_expr (L"\\n");
  _c_160 = rftype::Char::create_expr (L"\t");
  _c_161 = rftype::Char::create_expr (L"\\t");
  _c_162 = rftype::Char::create_expr (L"\r");
  _c_163 = rftype::Char::create_expr (L"\\r");
  _c_164 = Expr (_c_145, 0, 1);
  _c_165 = rftype::Char::create_expr (L"\\\"");
  _c_166 = Expr (_c_102, 0, 11);
  _c_167 = Expr (_c_14, 0, 6);
  _c_168 = Expr (_c_144, 7, 7);
  _c_169 = Expr::create<rftype::Integer>("1");
  _c_170 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}
