#ifndef __rfp__clashes_hh__
#define __rfp__clashes_hh__

#include <rf_core.hh>

namespace refal
{

using namespace rfrt;

namespace rfp__clashes
{

extern Expr Known_m_Lengths;

extern Expr Compute_m_Length;

extern Expr Unknown_m_Lengths;

extern Expr Checked_m_Lengths;

extern Expr Eqs;

RF_DECL (Init_m_Clashes);

RF_DECL (Reclassify_m_Clash);

RF_DECL (Update_m_Hard_m_Parts);

RF_DECL (Compose_m_Source);

RF_DECL (Get_m_Cycle);

RF_DECL (Get_m_Known_m_Length);

}

}

#endif // __rfp__clashes_hh__
