#include <rf_core.hh>
#include <refal/Access.hh>
#include <refal/StdIO.hh>
#include <refal/List.hh>
#include "rfp_compile.hh"
#include "rfp_vars.hh"
#include <refal/Table.hh>

namespace refal
{

using namespace rfrt;

namespace rfp__format
{

RF_DECL (Format_m_Exp);

RF_DECL (Split_m_Re);

RF_DECL (Split_m_Rt);

RF_DECL (MSG);

RF_DECL (MSG_m_Exprs);

RF_DECL (MSG_m_Terms);

RF_DECL (Subformat_q_);

RF_DECL (Empty_m_Const_q_);

RF_DECL (Empty_m_Expr_q_);

RF_DECL (Get_m_Const_m_Term);

RF_DECL (Get_m_Term);

RF_DECL (MSG_m_Exprs__0);

static Expr _c_0;

static Expr _c_20;

static Expr _c_16;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_21;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_15;

static Expr _c_14;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

RF_FUNC (Format_m_Exp, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_first (_ge_arg1, 0, 1);
      Expr _ve_rest (_ge_arg1, (0 + 1), _v_len__rest);
      Expr _ve_first_m_format;
      {
        {
          if (!_vt_first.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _vs_ObjectSymbol (_vt_first, 0, 1);
          _ve_first_m_format = _vs_ObjectSymbol;
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__first (_vt_first, 0);
          if (_v_deref__first.get_len () != 2)
          {
            goto _block2__branch2;
          }
          if (!_c_0.term_eq (_v_deref__first, 0))
          {
            goto _block2__branch2;
          }
          Expr _vt_Name (_v_deref__first, (0 + 1), 1);
          {
            {
              if (!RF_CALL (Table::In_m_Table_q_, (rfp__compile::Const, _vt_Name), /*void*/))
              {
                goto _block3__branch1;
              }
              _ve_first_m_format = (_c_0 + _vt_Name) ();
              goto _block3;
            }
          _block3__branch1: {}
            _ve_first_m_format = _c_1;
          }
        _block3: {}
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__first2 (_vt_first, 0);
          uintptr_t _v_len3 = _v_deref__first2.get_len ();
          uintptr_t _v_len4 = 3;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_42_m_31 = (_v_len3 - _v_len4);
          if (!_c_2.term_eq (_v_deref__first2, 0))
          {
            goto _block2__branch3;
          }
          Expr _vt_Pragma (_v_deref__first2, (0 + 1), 1);
          Expr _vt_Fname (_v_deref__first2, (0 + 1 + 1), 1);
          Expr _ve__e__e_tmp_m_rfp__formatrf_m_42_m_31 (_v_deref__first2, (0 + 1 + 1 + 1), _v_len___e__e_tmp_m_rfp__formatrf_m_42_m_31);
          Expr _gs_auxcall1;
          Expr _gs_auxcall2;
          Expr _gt_auxcall3;
          Expr _ge_auxcall4;
          Expr _ge_auxcall5;
          if (!RF_CALL (rfp__compile::Lookup_m_Func, _vt_Fname, (_gs_auxcall1, _gs_auxcall2, _gt_auxcall3, _ge_auxcall4, _ge_auxcall5)))
          {
            goto _block1__branch1;
          }
          Expr _v_L1;
          if (!RF_CALL (Access::L, (_c_3, (_gs_auxcall1 + _gs_auxcall2 + _gt_auxcall3 + _ge_auxcall4 () + _ge_auxcall5 ())), _v_L1))
          {
            goto _block1__branch1;
          }
          if (_v_L1.symbol_at (0))
          {
            goto _block1__branch1;
          }
          Expr _v_deref__L1 (_v_L1, 0);
          uintptr_t _v_len5 = _v_deref__L1.get_len ();
          uintptr_t _v_len6 = 0;
          if (_v_len5 < _v_len6)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__FOut = (_v_len5 - _v_len6);
          Expr _ve_FOut (_v_deref__L1, 0, _v_len__FOut);
          _ve_first_m_format = _ve_FOut;
          goto _block2;
        }
      _block2__branch3: {}
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__first3 (_vt_first, 0);
          uintptr_t _v_len7 = _v_deref__first3.get_len ();
          uintptr_t _v_len8 = 2;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch4;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_44_m_22 = (_v_len7 - _v_len8);
          if (!_c_2.term_eq (_v_deref__first3, 0))
          {
            goto _block2__branch4;
          }
          Expr _vt_Fname (_v_deref__first3, (0 + 1), 1);
          Expr _ve__e__e_tmp_m_rfp__formatrf_m_44_m_22 (_v_deref__first3, (0 + 1 + 1), _v_len___e__e_tmp_m_rfp__formatrf_m_44_m_22);
          Expr _gs_auxcall6;
          Expr _gs_auxcall7;
          Expr _gt_auxcall8;
          Expr _ge_auxcall9;
          Expr _ge_auxcall10;
          if (!RF_CALL (rfp__compile::Lookup_m_Func, _vt_Fname, (_gs_auxcall6, _gs_auxcall7, _gt_auxcall8, _ge_auxcall9, _ge_auxcall10)))
          {
            goto _block2__branch4;
          }
          Expr _v_L2;
          if (!RF_CALL (Access::L, (_c_3, (_gs_auxcall6 + _gs_auxcall7 + _gt_auxcall8 + _ge_auxcall9 () + _ge_auxcall10 ())), _v_L2))
          {
            goto _block2__branch4;
          }
          if (_v_L2.symbol_at (0))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__L2 (_v_L2, 0);
          uintptr_t _v_len9 = _v_deref__L2.get_len ();
          uintptr_t _v_len10 = 0;
          if (_v_len9 < _v_len10)
          {
            goto _block2__branch4;
          }
          uintptr_t _v_len__FOut2 = (_v_len9 - _v_len10);
          Expr _ve_FOut (_v_deref__L2, 0, _v_len__FOut2);
          _ve_first_m_format = _ve_FOut;
          goto _block2;
        }
      _block2__branch4: {}
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch5;
          }
          Expr _v_deref__first4 (_vt_first, 0);
          uintptr_t _v_len11 = _v_deref__first4.get_len ();
          uintptr_t _v_len12 = 1;
          if (_v_len11 < _v_len12)
          {
            goto _block2__branch5;
          }
          uintptr_t _v_len__Expression = (_v_len11 - _v_len12);
          if (!_c_4.term_eq (_v_deref__first4, 0))
          {
            goto _block2__branch5;
          }
          Expr _ve_Expression (_v_deref__first4, (0 + 1), _v_len__Expression);
          Expr _ge_auxcall11;
          RF_CALL (Format_m_Exp, _ve_Expression, _ge_auxcall11);
          _ve_first_m_format = (_c_4 + _ge_auxcall11) ();
          goto _block2;
        }
      _block2__branch5: {}
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch6;
          }
          Expr _v_deref__first5 (_vt_first, 0);
          if (_v_deref__first5.get_len () != 2)
          {
            goto _block2__branch6;
          }
          if (!_c_5.term_eq (_v_deref__first5, 0))
          {
            goto _block2__branch6;
          }
          Expr _vt_name (_v_deref__first5, (0 + 1), 1);
          goto _block1__branch1;
        }
      _block2__branch6: {}
        if (_vt_first.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__first6 (_vt_first, 0);
        uintptr_t _v_len13 = _v_deref__first6.get_len ();
        uintptr_t _v_len14 = 1;
        if (_v_len13 < _v_len14)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_49_m_23 = (_v_len13 - _v_len14);
        if (!_v_deref__first6.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _vs_VariableTag (_v_deref__first6, 0, 1);
        Expr _ve__e__e_tmp_m_rfp__formatrf_m_49_m_23 (_v_deref__first6, (0 + 1), _v_len___e__e_tmp_m_rfp__formatrf_m_49_m_23);
        _ve_first_m_format = _vs_VariableTag ();
      }
    _block2: {}
      Expr _v_Format_m_Exp1;
      RF_CALL (Format_m_Exp, _ve_rest, _v_Format_m_Exp1);
      _v_res1 = (_ve_first_m_format + _v_Format_m_Exp1);
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Split_m_Re, (RF_ARG _ge_arg1, _ge_arg2;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = (_ge_arg2.get_len () + 1);
      uintptr_t _v_len2 = 2;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__Re = (_v_len1 - _v_len2);
      Expr _v_compose1 ((_ge_arg1 () + _ge_arg2));
      if (_v_compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__compose1 (_v_compose1, 0);
      uintptr_t _v_len3 = _v_deref__compose1.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__Fe = (_v_len3 - _v_len4);
      Expr _vt_Rt (_v_compose1, (0 + 1), 1);
      Expr _ve_Re (_v_compose1, (0 + 1 + 1), _v_len__Re);
      Expr _vt_Ft (_v_deref__compose1, 0, 1);
      Expr _ve_Fe (_v_deref__compose1, (0 + 1), _v_len__Fe);
      {
        {
          {
            {
              {
                if (!_vt_Ft.term_eq (_c_6, 0))
                {
                  goto _block4__branch1;
                }
                goto _block4;
              }
            _block4__branch1: {}
              {
                if (!_vt_Ft.term_eq (_c_7, 0))
                {
                  goto _block4__branch2;
                }
                goto _block4;
              }
            _block4__branch2: {}
              if (_vt_Ft.symbol_at (0))
              {
                goto _block3__branch1;
              }
              Expr _v_deref__Ft (_vt_Ft, 0);
              uintptr_t _v_len5 = _v_deref__Ft.get_len ();
              uintptr_t _v_len6 = 1;
              if (_v_len5 < _v_len6)
              {
                goto _block3__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_67_m_41 = (_v_len5 - _v_len6);
              if (!_c_0.term_eq (_v_deref__Ft, 0))
              {
                goto _block3__branch1;
              }
              Expr _ve__e__e_tmp_m_rfp__formatrf_m_67_m_41 (_v_deref__Ft, (0 + 1), _v_len___e__e_tmp_m_rfp__formatrf_m_67_m_41);
            }
          _block4: {}
            goto _block3;
          }
        _block3__branch1: {}
          Expr _v_Format_m_Exp1;
          RF_CALL (Format_m_Exp, _vt_Rt, _v_Format_m_Exp1);
          if (_v_Format_m_Exp1.get_len () != 1)
          {
            goto _negation1;
          }
          if (_v_Format_m_Exp1.symbol_at (0))
          {
            goto _negation1;
          }
          Expr _v_deref__Format_m_Exp1 (_v_Format_m_Exp1, 0);
          uintptr_t _v_len7 = _v_deref__Format_m_Exp1.get_len ();
          uintptr_t _v_len8 = 1;
          if (_v_len7 < _v_len8)
          {
            goto _negation1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_68_m_35 = (_v_len7 - _v_len8);
          if (!_c_0.term_eq (_v_deref__Format_m_Exp1, 0))
          {
            goto _negation1;
          }
          Expr _ve__e__e_tmp_m_rfp__formatrf_m_68_m_35 (_v_deref__Format_m_Exp1, (0 + 1), _v_len___e__e_tmp_m_rfp__formatrf_m_68_m_35);
        }
      _block3: {}
        goto _block1__branch1;
      }
    _negation1: {}
      Expr _ge_auxcall1;
      RF_CALL (Split_m_Rt, (_vt_Ft, _vt_Rt), _ge_auxcall1);
      Expr _v_Split_m_Re1;
      RF_CALL (Split_m_Re, (_ve_Fe, _ve_Re), _v_Split_m_Re1);
      _v_res1 = (_ge_auxcall1 + _v_Split_m_Re1);
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len9 = (_ge_arg2.get_len () + 1);
      uintptr_t _v_len10 = 2;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__Re2 = (_v_len9 - _v_len10);
      Expr _v_compose2 ((_ge_arg1 () + _ge_arg2));
      if (_v_compose2.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__compose2 (_v_compose2, 0);
      uintptr_t _v_len11 = _v_deref__compose2.get_len ();
      uintptr_t _v_len12 = 1;
      if (_v_len11 < (_v_len12 + 1))
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__Fe2 = (_v_len11 - _v_len12);
      Expr _ve_Re (_v_compose2, (0 + 1), _v_len__Re2);
      Expr _vt_Rt (_v_compose2, (0 + 1 + _v_len__Re2), 1);
      Expr _vv_Fe (_v_deref__compose2, 0, _v_len__Fe2);
      Expr _vt_Ft (_v_deref__compose2, (0 + _v_len__Fe2), 1);
      {
        {
          {
            {
              {
                if (!_vt_Ft.term_eq (_c_6, 0))
                {
                  goto _block7__branch1;
                }
                goto _block7;
              }
            _block7__branch1: {}
              {
                if (!_vt_Ft.term_eq (_c_7, 0))
                {
                  goto _block7__branch2;
                }
                goto _block7;
              }
            _block7__branch2: {}
              if (_vt_Ft.symbol_at (0))
              {
                goto _block6__branch1;
              }
              Expr _v_deref__Ft2 (_vt_Ft, 0);
              uintptr_t _v_len13 = _v_deref__Ft2.get_len ();
              uintptr_t _v_len14 = 1;
              if (_v_len13 < _v_len14)
              {
                goto _block6__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_78_m_41 = (_v_len13 - _v_len14);
              if (!_c_0.term_eq (_v_deref__Ft2, 0))
              {
                goto _block6__branch1;
              }
              Expr _ve__e__e_tmp_m_rfp__formatrf_m_78_m_41 (_v_deref__Ft2, (0 + 1), _v_len___e__e_tmp_m_rfp__formatrf_m_78_m_41);
            }
          _block7: {}
            goto _block6;
          }
        _block6__branch1: {}
          Expr _v_Format_m_Exp2;
          RF_CALL (Format_m_Exp, _vt_Rt, _v_Format_m_Exp2);
          if (_v_Format_m_Exp2.get_len () != 1)
          {
            goto _negation2;
          }
          if (_v_Format_m_Exp2.symbol_at (0))
          {
            goto _negation2;
          }
          Expr _v_deref__Format_m_Exp2 (_v_Format_m_Exp2, 0);
          uintptr_t _v_len15 = _v_deref__Format_m_Exp2.get_len ();
          uintptr_t _v_len16 = 1;
          if (_v_len15 < _v_len16)
          {
            goto _negation2;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_79_m_35 = (_v_len15 - _v_len16);
          if (!_c_0.term_eq (_v_deref__Format_m_Exp2, 0))
          {
            goto _negation2;
          }
          Expr _ve__e__e_tmp_m_rfp__formatrf_m_79_m_35 (_v_deref__Format_m_Exp2, (0 + 1), _v_len___e__e_tmp_m_rfp__formatrf_m_79_m_35);
        }
      _block6: {}
        goto _block1__branch2;
      }
    _negation2: {}
      Expr _ge_auxcall2;
      RF_CALL (Split_m_Re, (_vv_Fe, _ve_Re), _ge_auxcall2);
      Expr _v_Split_m_Rt1;
      RF_CALL (Split_m_Rt, (_vt_Ft, _vt_Rt), _v_Split_m_Rt1);
      _v_res1 = (_ge_auxcall2 + _v_Split_m_Rt1);
      goto _block1;
    }
  _block1__branch2: {}
    {
      uintptr_t _v_len17 = (_ge_arg2.get_len () + 1);
      uintptr_t _v_len18 = 1;
      if (_v_len17 < _v_len18)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__Re3 = (_v_len17 - _v_len18);
      Expr _v_compose3 ((_ge_arg1 () + _ge_arg2));
      if (_v_compose3.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__compose3 (_v_compose3, 0);
      uintptr_t _v_len19 = _v_deref__compose3.get_len ();
      uintptr_t _v_len20 = 1;
      if (_v_len19 < _v_len20)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__Fe3 = (_v_len19 - _v_len20);
      if (_v_deref__compose3.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__deref__compose3 (_v_deref__compose3, 0);
      if (_v_deref__deref__compose3.get_len () != 2)
      {
        goto _block1__branch3;
      }
      if (!_c_0.term_eq (_v_deref__deref__compose3, 0))
      {
        goto _block1__branch3;
      }
      Expr _ve_Re (_v_compose3, (0 + 1), _v_len__Re3);
      Expr _ve_Fe (_v_deref__compose3, (0 + 1), _v_len__Fe3);
      Expr _vt_name (_v_deref__deref__compose3, (0 + 1), 1);
      {
        {
          uintptr_t _v_len21 = _v_len__Re3;
          uintptr_t _v_len22 = 1;
          if (_v_len21 < _v_len22)
          {
            goto _block8__branch1;
          }
          uintptr_t _v_len__Rest = (_v_len21 - _v_len22);
          Expr _vt_Rt (_ve_Re, 0, 1);
          Expr _ve_Rest (_ve_Re, (0 + 1), _v_len__Rest);
          Expr _v_Format_m_Exp3;
          RF_CALL (Format_m_Exp, _vt_Rt, _v_Format_m_Exp3);
          if (_v_Format_m_Exp3.get_len () != 1)
          {
            goto _block8__branch1;
          }
          if (_v_Format_m_Exp3.symbol_at (0))
          {
            goto _block8__branch1;
          }
          Expr _v_deref__Format_m_Exp3 (_v_Format_m_Exp3, 0);
          if (_v_deref__Format_m_Exp3.get_len () != 2)
          {
            goto _block8__branch1;
          }
          if (!_c_0.term_eq (_v_deref__Format_m_Exp3, 0))
          {
            goto _block8__branch1;
          }
          if (!_vt_name.term_eq (_v_deref__Format_m_Exp3, (0 + 1)))
          {
            goto _block8__branch1;
          }
          RF_TAILCALL (Split_m_Re, (_ve_Fe, _ve_Rest), _v_res1);
          goto _block8;
        }
      _block8__branch1: {}
        Expr _ge_auxcall3;
        if (!RF_CALL (Table::Lookup, (rfp__compile::Const, _vt_name), _ge_auxcall3))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _ge_auxcall4;
        if (!RF_CALL (Access::Middle, (_c_8, _c_9, _ge_auxcall3), _ge_auxcall4))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        RF_TAILCALL (Split_m_Re, ((_ge_auxcall4 + _ve_Fe), _ve_Re), _v_res1);
      }
    _block8: {}
      goto _block1;
    }
  _block1__branch3: {}
    {
      uintptr_t _v_len23 = (_ge_arg2.get_len () + 1);
      uintptr_t _v_len24 = 1;
      if (_v_len23 < _v_len24)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__Re4 = (_v_len23 - _v_len24);
      Expr _v_compose4 ((_ge_arg1 () + _ge_arg2));
      if (_v_compose4.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__compose4 (_v_compose4, 0);
      uintptr_t _v_len25 = _v_deref__compose4.get_len ();
      uintptr_t _v_len26 = 1;
      if (_v_len25 < (_v_len26 + 1))
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__Fe4 = (_v_len25 - _v_len26);
      if (_v_deref__compose4.symbol_at ((0 + _v_len__Fe4)))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__deref__compose4 (_v_deref__compose4, (0 + _v_len__Fe4));
      if (_v_deref__deref__compose4.get_len () != 2)
      {
        goto _block1__branch4;
      }
      if (!_c_0.term_eq (_v_deref__deref__compose4, 0))
      {
        goto _block1__branch4;
      }
      Expr _ve_Re (_v_compose4, (0 + 1), _v_len__Re4);
      Expr _vv_Fe (_v_deref__compose4, 0, _v_len__Fe4);
      Expr _vt_name (_v_deref__deref__compose4, (0 + 1), 1);
      {
        {
          uintptr_t _v_len27 = _v_len__Re4;
          uintptr_t _v_len28 = 1;
          if (_v_len27 < _v_len28)
          {
            goto _block9__branch1;
          }
          uintptr_t _v_len__Rest2 = (_v_len27 - _v_len28);
          Expr _ve_Rest (_ve_Re, 0, _v_len__Rest2);
          Expr _vt_Rt (_ve_Re, (0 + _v_len__Rest2), 1);
          Expr _v_Format_m_Exp4;
          RF_CALL (Format_m_Exp, _vt_Rt, _v_Format_m_Exp4);
          if (_v_Format_m_Exp4.get_len () != 1)
          {
            goto _block9__branch1;
          }
          if (_v_Format_m_Exp4.symbol_at (0))
          {
            goto _block9__branch1;
          }
          Expr _v_deref__Format_m_Exp4 (_v_Format_m_Exp4, 0);
          if (_v_deref__Format_m_Exp4.get_len () != 2)
          {
            goto _block9__branch1;
          }
          if (!_c_0.term_eq (_v_deref__Format_m_Exp4, 0))
          {
            goto _block9__branch1;
          }
          if (!_vt_name.term_eq (_v_deref__Format_m_Exp4, (0 + 1)))
          {
            goto _block9__branch1;
          }
          RF_TAILCALL (Split_m_Re, (_vv_Fe, _ve_Rest), _v_res1);
          goto _block9;
        }
      _block9__branch1: {}
        Expr _ge_auxcall5;
        if (!RF_CALL (Table::Lookup, (rfp__compile::Const, _vt_name), _ge_auxcall5))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _ge_auxcall6;
        if (!RF_CALL (Access::Middle, (_c_8, _c_9, _ge_auxcall5), _ge_auxcall6))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        RF_TAILCALL (Split_m_Re, ((_vv_Fe + _ge_auxcall6), _ve_Re), _v_res1);
      }
    _block9: {}
      goto _block1;
    }
  _block1__branch4: {}
    {
      uintptr_t _v_len29 = (_ge_arg2.get_len () + 1);
      uintptr_t _v_len30 = 1;
      if (_v_len29 < _v_len30)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__Re5 = (_v_len29 - _v_len30);
      Expr _v_compose5 ((_ge_arg1 () + _ge_arg2));
      if (!_c_10.term_eq (_v_compose5, 0))
      {
        goto _block1__branch5;
      }
      Expr _ve_Re (_v_compose5, (0 + 1), _v_len__Re5);
      _v_res1 = _ve_Re ();
      goto _block1;
    }
  _block1__branch5: {}
    {
      uintptr_t _v_len31 = (_ge_arg2.get_len () + 1);
      uintptr_t _v_len32 = 1;
      if (_v_len31 < _v_len32)
      {
        goto _block1__branch6;
      }
      uintptr_t _v_len__Re6 = (_v_len31 - _v_len32);
      Expr _v_compose6 ((_ge_arg1 () + _ge_arg2));
      if (!_c_11.term_eq (_v_compose6, 0))
      {
        goto _block1__branch6;
      }
      Expr _ve_Re (_v_compose6, (0 + 1), _v_len__Re6);
      _v_res1 = _ve_Re ();
      goto _block1;
    }
  _block1__branch6: {}
    {
      uintptr_t _v_len33 = (_ge_arg2.get_len () + 1);
      uintptr_t _v_len34 = 2;
      if (_v_len33 < _v_len34)
      {
        goto _block1__branch7;
      }
      uintptr_t _v_len__Re7 = (_v_len33 - _v_len34);
      Expr _v_compose7 ((_ge_arg1 () + _ge_arg2));
      if (_v_compose7.symbol_at (0))
      {
        goto _block1__branch7;
      }
      Expr _v_deref__compose7 (_v_compose7, 0);
      uintptr_t _v_len35 = _v_deref__compose7.get_len ();
      uintptr_t _v_len36 = 0;
      if (_v_len35 < _v_len36)
      {
        goto _block1__branch7;
      }
      uintptr_t _v_len__Fe5 = (_v_len35 - _v_len36);
      Expr _vt_Rt (_v_compose7, (0 + 1), 1);
      Expr _ve_Re (_v_compose7, (0 + 1 + 1), _v_len__Re7);
      Expr _ve_Fe (_v_deref__compose7, 0, _v_len__Fe5);
      Expr _v_Format_m_Exp5;
      RF_CALL (Format_m_Exp, _vt_Rt, _v_Format_m_Exp5);
      if (_v_Format_m_Exp5.get_len () != 1)
      {
        goto _block1__branch7;
      }
      if (_v_Format_m_Exp5.symbol_at (0))
      {
        goto _block1__branch7;
      }
      Expr _v_deref__Format_m_Exp5 (_v_Format_m_Exp5, 0);
      if (_v_deref__Format_m_Exp5.get_len () != 2)
      {
        goto _block1__branch7;
      }
      if (!_c_0.term_eq (_v_deref__Format_m_Exp5, 0))
      {
        goto _block1__branch7;
      }
      Expr _vt_name (_v_deref__Format_m_Exp5, (0 + 1), 1);
      Expr _ge_auxcall7;
      if (!RF_CALL (Table::Lookup, (rfp__compile::Const, _vt_name), _ge_auxcall7))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _ge_auxcall8;
      if (!RF_CALL (Access::Middle, (_c_8, _c_9, _ge_auxcall7), _ge_auxcall8))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      RF_TAILCALL (Split_m_Re, (_ve_Fe, (_ge_auxcall8 + _ve_Re)), _v_res1);
      goto _block1;
    }
  _block1__branch7: {}
    {
      uintptr_t _v_len37 = (_ge_arg2.get_len () + 1);
      uintptr_t _v_len38 = 2;
      if (_v_len37 < (_v_len38 + 1))
      {
        goto _block1__branch8;
      }
      uintptr_t _v_len__Re8 = (_v_len37 - _v_len38);
      Expr _v_compose8 ((_ge_arg1 () + _ge_arg2));
      if (_v_compose8.symbol_at (0))
      {
        goto _block1__branch8;
      }
      Expr _v_deref__compose8 (_v_compose8, 0);
      uintptr_t _v_len39 = _v_deref__compose8.get_len ();
      uintptr_t _v_len40 = 0;
      if (_v_len39 < _v_len40)
      {
        goto _block1__branch8;
      }
      uintptr_t _v_len__Fe6 = (_v_len39 - _v_len40);
      Expr _vv_Re (_v_compose8, (0 + 1), _v_len__Re8);
      Expr _vt_Rt (_v_compose8, (0 + 1 + _v_len__Re8), 1);
      Expr _ve_Fe (_v_deref__compose8, 0, _v_len__Fe6);
      Expr _v_Format_m_Exp6;
      RF_CALL (Format_m_Exp, _vt_Rt, _v_Format_m_Exp6);
      if (_v_Format_m_Exp6.get_len () != 1)
      {
        goto _block1__branch8;
      }
      if (_v_Format_m_Exp6.symbol_at (0))
      {
        goto _block1__branch8;
      }
      Expr _v_deref__Format_m_Exp6 (_v_Format_m_Exp6, 0);
      if (_v_deref__Format_m_Exp6.get_len () != 2)
      {
        goto _block1__branch8;
      }
      if (!_c_0.term_eq (_v_deref__Format_m_Exp6, 0))
      {
        goto _block1__branch8;
      }
      Expr _vt_name (_v_deref__Format_m_Exp6, (0 + 1), 1);
      Expr _ge_auxcall9;
      if (!RF_CALL (Table::Lookup, (rfp__compile::Const, _vt_name), _ge_auxcall9))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _ge_auxcall10;
      if (!RF_CALL (Access::Middle, (_c_8, _c_9, _ge_auxcall9), _ge_auxcall10))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      RF_TAILCALL (Split_m_Re, (_ve_Fe, (_vv_Re + _ge_auxcall10)), _v_res1);
      goto _block1;
    }
  _block1__branch8: {}
    if ((_ge_arg2.get_len () + 1) != 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_compose9 ((_ge_arg1 () + _ge_arg2));
    if (!_c_12.term_eq (_v_compose9, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Split_m_Rt, (RF_ARG _vt_Ft, _vt_Rt;;), (RF_RES _v_res1;;))
  {
    {
      if (!_vt_Ft.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_ObjectSymbol (_vt_Ft, 0, 1);
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_vt_Ft.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__Ft (_vt_Ft, 0);
      uintptr_t _v_len1 = _v_deref__Ft.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__Fe = (_v_len1 - _v_len2);
      if (!_c_4.term_eq (_v_deref__Ft, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_Fe (_v_deref__Ft, (0 + 1), _v_len__Fe);
      if (_vt_Rt.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__Rt (_vt_Rt, 0);
      uintptr_t _v_len3 = _v_deref__Rt.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__Re = (_v_len3 - _v_len4);
      if (!_c_4.term_eq (_v_deref__Rt, 0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _ve_Re (_v_deref__Rt, (0 + 1), _v_len__Re);
      RF_TAILCALL (Split_m_Re, (_ve_Fe, _ve_Re), _v_res1);
      goto _block1;
    }
  _block1__branch2: {}
    Expr _vt_VariableTag (_vt_Ft, 0, 1);
    _v_res1 = _vt_Rt ();
  }
_block1: {}
RF_END

RF_FUNC (MSG, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__xprs = (_v_len1 - _v_len2);
      if (_ge_arg1.symbol_at ((0 + _v_len__xprs)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (_ge_arg1, (0 + _v_len__xprs));
      uintptr_t _v_len3 = _v_deref__arg1.get_len ();
      uintptr_t _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__Fe = (_v_len3 - _v_len4);
      Expr _ve_xprs (_ge_arg1, 0, _v_len__xprs);
      Expr _ve_Fe (_v_deref__arg1, 0, _v_len__Fe);
      RF_TAILCALL (List::Foldr, (_c_13, empty, _ve_Fe, _ve_xprs), _v_res1);
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (MSG_m_Exprs, (RF_ARG _ge_arg1, _ge_arg2;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = (_ge_arg2.get_len () + 1);
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__Fe2 = (_v_len1 - _v_len2);
      Expr _v_compose1 ((_ge_arg1 () + _ge_arg2));
      if (!_c_14.term_eq (_v_compose1, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve_Fe2 (_v_compose1, (0 + 1), _v_len__Fe2);
      _v_res1 = _ve_Fe2;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if ((_ge_arg2.get_len () + 1) != 2)
      {
        goto _block1__branch2;
      }
      Expr _v_compose2 ((_ge_arg1 () + _ge_arg2));
      if (_v_compose2.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__compose2 (_v_compose2, 0);
      uintptr_t _v_len3 = _v_deref__compose2.get_len ();
      uintptr_t _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__Fe1 = (_v_len3 - _v_len4);
      if (!_c_15.term_eq (_v_compose2, (0 + 1)))
      {
        goto _block1__branch2;
      }
      Expr _ve_Fe1 (_v_deref__compose2, 0, _v_len__Fe1);
      _v_res1 = _ve_Fe1;
      goto _block1;
    }
  _block1__branch2: {}
    {
      uintptr_t _v_len5 = (_ge_arg2.get_len () + 1);
      uintptr_t _v_len6 = 2;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__Fe22 = (_v_len5 - _v_len6);
      Expr _v_compose3 ((_ge_arg1 () + _ge_arg2));
      if (_v_compose3.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__compose3 (_v_compose3, 0);
      uintptr_t _v_len7 = _v_deref__compose3.get_len ();
      uintptr_t _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__Fe12 = (_v_len7 - _v_len8);
      Expr _vt_Ft2 (_v_compose3, (0 + 1), 1);
      Expr _ve_Fe2 (_v_compose3, (0 + 1 + 1), _v_len__Fe22);
      Expr _vt_Ft1 (_v_deref__compose3, 0, 1);
      Expr _ve_Fe1 (_v_deref__compose3, (0 + 1), _v_len__Fe12);
      {
        {
          {
            if (!_vt_Ft1.term_eq (_c_7, 0))
            {
              goto _block3__branch1;
            }
            goto _block3;
          }
        _block3__branch1: {}
          {
            if (!_vt_Ft1.term_eq (_c_6, 0))
            {
              goto _block3__branch2;
            }
            goto _block3;
          }
        _block3__branch2: {}
          if (_vt_Ft1.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__Ft1 (_vt_Ft1, 0);
          uintptr_t _v_len9 = _v_deref__Ft1.get_len ();
          uintptr_t _v_len10 = 1;
          if (_v_len9 < _v_len10)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_125_m_40 = (_v_len9 - _v_len10);
          if (!_c_0.term_eq (_v_deref__Ft1, 0))
          {
            goto _block2__branch1;
          }
          Expr _ve__e__e_tmp_m_rfp__formatrf_m_125_m_40 (_v_deref__Ft1, (0 + 1), _v_len___e__e_tmp_m_rfp__formatrf_m_125_m_40);
        }
      _block3: {}
        goto _block1__branch3;
      }
    _block2__branch1: {}
      {
        {
          {
            if (!_vt_Ft2.term_eq (_c_7, 0))
            {
              goto _block4__branch1;
            }
            goto _block4;
          }
        _block4__branch1: {}
          {
            if (!_vt_Ft2.term_eq (_c_6, 0))
            {
              goto _block4__branch2;
            }
            goto _block4;
          }
        _block4__branch2: {}
          if (_vt_Ft2.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__Ft2 (_vt_Ft2, 0);
          uintptr_t _v_len11 = _v_deref__Ft2.get_len ();
          uintptr_t _v_len12 = 1;
          if (_v_len11 < _v_len12)
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_126_m_40 = (_v_len11 - _v_len12);
          if (!_c_0.term_eq (_v_deref__Ft2, 0))
          {
            goto _block2__branch2;
          }
          Expr _ve__e__e_tmp_m_rfp__formatrf_m_126_m_40 (_v_deref__Ft2, (0 + 1), _v_len___e__e_tmp_m_rfp__formatrf_m_126_m_40);
        }
      _block4: {}
        goto _block1__branch3;
      }
    _block2__branch2: {}
      Expr _gt_auxcall1;
      RF_CALL (MSG_m_Terms, (_vt_Ft1, _vt_Ft2), _gt_auxcall1);
      Expr _v_MSG_m_Exprs1;
      RF_CALL (MSG_m_Exprs, (_ve_Fe1, _ve_Fe2), _v_MSG_m_Exprs1);
      _v_res1 = (_gt_auxcall1 + _v_MSG_m_Exprs1);
      goto _block1;
    }
  _block1__branch3: {}
    {
      uintptr_t _v_len13 = (_ge_arg2.get_len () + 1);
      uintptr_t _v_len14 = 2;
      if (_v_len13 < _v_len14)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__Fe23 = (_v_len13 - _v_len14);
      Expr _v_compose4 ((_ge_arg1 () + _ge_arg2));
      if (_v_compose4.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__compose4 (_v_compose4, 0);
      uintptr_t _v_len15 = _v_deref__compose4.get_len ();
      uintptr_t _v_len16 = 1;
      if (_v_len15 < _v_len16)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__Fe13 = (_v_len15 - _v_len16);
      Expr _ve_Fe2 (_v_compose4, (0 + 1), _v_len__Fe23);
      Expr _vt_Ft2 (_v_compose4, (0 + 1 + _v_len__Fe23), 1);
      Expr _ve_Fe1 (_v_deref__compose4, 0, _v_len__Fe13);
      Expr _vt_Ft1 (_v_deref__compose4, (0 + _v_len__Fe13), 1);
      {
        {
          {
            if (!_vt_Ft1.term_eq (_c_7, 0))
            {
              goto _block6__branch1;
            }
            goto _block6;
          }
        _block6__branch1: {}
          {
            if (!_vt_Ft1.term_eq (_c_6, 0))
            {
              goto _block6__branch2;
            }
            goto _block6;
          }
        _block6__branch2: {}
          if (_vt_Ft1.symbol_at (0))
          {
            goto _block5__branch1;
          }
          Expr _v_deref__Ft12 (_vt_Ft1, 0);
          uintptr_t _v_len17 = _v_deref__Ft12.get_len ();
          uintptr_t _v_len18 = 1;
          if (_v_len17 < _v_len18)
          {
            goto _block5__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_135_m_40 = (_v_len17 - _v_len18);
          if (!_c_0.term_eq (_v_deref__Ft12, 0))
          {
            goto _block5__branch1;
          }
          Expr _ve__e__e_tmp_m_rfp__formatrf_m_135_m_40 (_v_deref__Ft12, (0 + 1), _v_len___e__e_tmp_m_rfp__formatrf_m_135_m_40);
        }
      _block6: {}
        goto _block1__branch4;
      }
    _block5__branch1: {}
      {
        {
          {
            if (!_vt_Ft2.term_eq (_c_7, 0))
            {
              goto _block7__branch1;
            }
            goto _block7;
          }
        _block7__branch1: {}
          {
            if (!_vt_Ft2.term_eq (_c_6, 0))
            {
              goto _block7__branch2;
            }
            goto _block7;
          }
        _block7__branch2: {}
          if (_vt_Ft2.symbol_at (0))
          {
            goto _block5__branch2;
          }
          Expr _v_deref__Ft22 (_vt_Ft2, 0);
          uintptr_t _v_len19 = _v_deref__Ft22.get_len ();
          uintptr_t _v_len20 = 1;
          if (_v_len19 < _v_len20)
          {
            goto _block5__branch2;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_136_m_40 = (_v_len19 - _v_len20);
          if (!_c_0.term_eq (_v_deref__Ft22, 0))
          {
            goto _block5__branch2;
          }
          Expr _ve__e__e_tmp_m_rfp__formatrf_m_136_m_40 (_v_deref__Ft22, (0 + 1), _v_len___e__e_tmp_m_rfp__formatrf_m_136_m_40);
        }
      _block7: {}
        goto _block1__branch4;
      }
    _block5__branch2: {}
      Expr _ge_auxcall2;
      RF_CALL (MSG_m_Exprs, (_ve_Fe1, _ve_Fe2), _ge_auxcall2);
      Expr _v_MSG_m_Terms1;
      RF_CALL (MSG_m_Terms, (_vt_Ft1, _vt_Ft2), _v_MSG_m_Terms1);
      _v_res1 = (_ge_auxcall2 + _v_MSG_m_Terms1);
      goto _block1;
    }
  _block1__branch4: {}
    {
      uintptr_t _v_len21 = (_ge_arg2.get_len () + 1);
      uintptr_t _v_len22 = 1;
      if (_v_len21 < _v_len22)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__Fe24 = (_v_len21 - _v_len22);
      Expr _v_compose5 ((_ge_arg1 () + _ge_arg2));
      if (_v_compose5.symbol_at (0))
      {
        goto _block1__branch5;
      }
      Expr _v_deref__compose5 (_v_compose5, 0);
      uintptr_t _v_len23 = _v_deref__compose5.get_len ();
      uintptr_t _v_len24 = 1;
      if (_v_len23 < _v_len24)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__Fe14 = (_v_len23 - _v_len24);
      if (_v_deref__compose5.symbol_at (0))
      {
        goto _block1__branch5;
      }
      Expr _v_deref__deref__compose5 (_v_deref__compose5, 0);
      if (_v_deref__deref__compose5.get_len () != 2)
      {
        goto _block1__branch5;
      }
      if (!_c_0.term_eq (_v_deref__deref__compose5, 0))
      {
        goto _block1__branch5;
      }
      Expr _ve_Fe2 (_v_compose5, (0 + 1), _v_len__Fe24);
      Expr _ve_Fe1 (_v_deref__compose5, (0 + 1), _v_len__Fe14);
      Expr _vt_name (_v_deref__deref__compose5, (0 + 1), 1);
      {
        {
          uintptr_t _v_len25 = _v_len__Fe24;
          uintptr_t _v_len26 = 1;
          if (_v_len25 < _v_len26)
          {
            goto _block8__branch1;
          }
          uintptr_t _v_len__Rest = (_v_len25 - _v_len26);
          if (_ve_Fe2.symbol_at (0))
          {
            goto _block8__branch1;
          }
          Expr _v_deref__Fe2 (_ve_Fe2, 0);
          if (_v_deref__Fe2.get_len () != 2)
          {
            goto _block8__branch1;
          }
          if (!_c_0.term_eq (_v_deref__Fe2, 0))
          {
            goto _block8__branch1;
          }
          if (!_vt_name.term_eq (_v_deref__Fe2, (0 + 1)))
          {
            goto _block8__branch1;
          }
          Expr _ve_Rest (_ve_Fe2, (0 + 1), _v_len__Rest);
          Expr _v_MSG_m_Exprs2;
          RF_CALL (MSG_m_Exprs, (_ve_Fe1, _ve_Rest), _v_MSG_m_Exprs2);
          _v_res1 = ((_c_0 + _vt_name) () + _v_MSG_m_Exprs2);
          goto _block8;
        }
      _block8__branch1: {}
        Expr _ge_auxcall3;
        if (!RF_CALL (Table::Lookup, (rfp__compile::Const, _vt_name), _ge_auxcall3))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _ge_auxcall4;
        RF_CALL (Format_m_Exp, _ge_auxcall3, _ge_auxcall4);
        RF_TAILCALL (MSG_m_Exprs, ((_ge_auxcall4 + _ve_Fe1), _ve_Fe2), _v_res1);
      }
    _block8: {}
      goto _block1;
    }
  _block1__branch5: {}
    {
      uintptr_t _v_len27 = (_ge_arg2.get_len () + 1);
      uintptr_t _v_len28 = 1;
      if (_v_len27 < _v_len28)
      {
        goto _block1__branch6;
      }
      uintptr_t _v_len__Fe25 = (_v_len27 - _v_len28);
      Expr _v_compose6 ((_ge_arg1 () + _ge_arg2));
      if (_v_compose6.symbol_at (0))
      {
        goto _block1__branch6;
      }
      Expr _v_deref__compose6 (_v_compose6, 0);
      uintptr_t _v_len29 = _v_deref__compose6.get_len ();
      uintptr_t _v_len30 = 1;
      if (_v_len29 < _v_len30)
      {
        goto _block1__branch6;
      }
      uintptr_t _v_len__Fe15 = (_v_len29 - _v_len30);
      if (_v_deref__compose6.symbol_at ((0 + _v_len__Fe15)))
      {
        goto _block1__branch6;
      }
      Expr _v_deref__deref__compose6 (_v_deref__compose6, (0 + _v_len__Fe15));
      if (_v_deref__deref__compose6.get_len () != 2)
      {
        goto _block1__branch6;
      }
      if (!_c_0.term_eq (_v_deref__deref__compose6, 0))
      {
        goto _block1__branch6;
      }
      Expr _ve_Fe2 (_v_compose6, (0 + 1), _v_len__Fe25);
      Expr _ve_Fe1 (_v_deref__compose6, 0, _v_len__Fe15);
      Expr _vt_name (_v_deref__deref__compose6, (0 + 1), 1);
      {
        {
          uintptr_t _v_len31 = _v_len__Fe25;
          uintptr_t _v_len32 = 1;
          if (_v_len31 < _v_len32)
          {
            goto _block9__branch1;
          }
          uintptr_t _v_len__Rest2 = (_v_len31 - _v_len32);
          if (_ve_Fe2.symbol_at ((0 + _v_len__Rest2)))
          {
            goto _block9__branch1;
          }
          Expr _v_deref__Fe22 (_ve_Fe2, (0 + _v_len__Rest2));
          if (_v_deref__Fe22.get_len () != 2)
          {
            goto _block9__branch1;
          }
          if (!_c_0.term_eq (_v_deref__Fe22, 0))
          {
            goto _block9__branch1;
          }
          if (!_vt_name.term_eq (_v_deref__Fe22, (0 + 1)))
          {
            goto _block9__branch1;
          }
          Expr _ve_Rest (_ve_Fe2, 0, _v_len__Rest2);
          Expr _ge_auxcall5;
          RF_CALL (MSG_m_Exprs, (_ve_Fe1, _ve_Rest), _ge_auxcall5);
          _v_res1 = (_ge_auxcall5 + (_c_0 + _vt_name) ());
          goto _block9;
        }
      _block9__branch1: {}
        Expr _ge_auxcall6;
        if (!RF_CALL (Table::Lookup, (rfp__compile::Const, _vt_name), _ge_auxcall6))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _ge_auxcall7;
        RF_CALL (Format_m_Exp, _ge_auxcall6, _ge_auxcall7);
        RF_TAILCALL (MSG_m_Exprs, ((_ve_Fe1 + _ge_auxcall7), _ve_Fe2), _v_res1);
      }
    _block9: {}
      goto _block1;
    }
  _block1__branch6: {}
    {
      uintptr_t _v_len33 = (_ge_arg2.get_len () + 1);
      uintptr_t _v_len34 = 2;
      if (_v_len33 < _v_len34)
      {
        goto _block1__branch7;
      }
      uintptr_t _v_len__Fe26 = (_v_len33 - _v_len34);
      Expr _v_compose7 ((_ge_arg1 () + _ge_arg2));
      if (_v_compose7.symbol_at (0))
      {
        goto _block1__branch7;
      }
      if (_v_compose7.symbol_at ((0 + 1)))
      {
        goto _block1__branch7;
      }
      Expr _v_deref__compose7 (_v_compose7, 0);
      Expr _v_deref__compose72 (_v_compose7, (0 + 1));
      if (_v_deref__compose72.get_len () != 2)
      {
        goto _block1__branch7;
      }
      uintptr_t _v_len35 = _v_deref__compose7.get_len ();
      uintptr_t _v_len36 = 0;
      if (_v_len35 < _v_len36)
      {
        goto _block1__branch7;
      }
      uintptr_t _v_len__Fe16 = (_v_len35 - _v_len36);
      if (!_c_0.term_eq (_v_deref__compose72, 0))
      {
        goto _block1__branch7;
      }
      Expr _ve_Fe2 (_v_compose7, (0 + 1 + 1), _v_len__Fe26);
      Expr _ve_Fe1 (_v_deref__compose7, 0, _v_len__Fe16);
      Expr _vt_name (_v_deref__compose72, (0 + 1), 1);
      Expr _ge_auxcall8;
      if (!RF_CALL (Table::Lookup, (rfp__compile::Const, _vt_name), _ge_auxcall8))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _ge_auxcall9;
      RF_CALL (Format_m_Exp, _ge_auxcall8, _ge_auxcall9);
      RF_TAILCALL (MSG_m_Exprs, (_ve_Fe1, (_ge_auxcall9 + _ve_Fe2)), _v_res1);
      goto _block1;
    }
  _block1__branch7: {}
    {
      uintptr_t _v_len37 = (_ge_arg2.get_len () + 1);
      uintptr_t _v_len38 = 2;
      if (_v_len37 < _v_len38)
      {
        goto _block1__branch8;
      }
      uintptr_t _v_len__Fe27 = (_v_len37 - _v_len38);
      Expr _v_compose8 ((_ge_arg1 () + _ge_arg2));
      if (_v_compose8.symbol_at (0))
      {
        goto _block1__branch8;
      }
      if (_v_compose8.symbol_at ((0 + 1 + _v_len__Fe27)))
      {
        goto _block1__branch8;
      }
      Expr _v_deref__compose8 (_v_compose8, 0);
      Expr _v_deref__compose82 (_v_compose8, (0 + 1 + _v_len__Fe27));
      if (_v_deref__compose82.get_len () != 2)
      {
        goto _block1__branch8;
      }
      uintptr_t _v_len39 = _v_deref__compose8.get_len ();
      uintptr_t _v_len40 = 0;
      if (_v_len39 < _v_len40)
      {
        goto _block1__branch8;
      }
      uintptr_t _v_len__Fe17 = (_v_len39 - _v_len40);
      if (!_c_0.term_eq (_v_deref__compose82, 0))
      {
        goto _block1__branch8;
      }
      Expr _ve_Fe2 (_v_compose8, (0 + 1), _v_len__Fe27);
      Expr _ve_Fe1 (_v_deref__compose8, 0, _v_len__Fe17);
      Expr _vt_name (_v_deref__compose82, (0 + 1), 1);
      Expr _ge_auxcall10;
      if (!RF_CALL (Table::Lookup, (rfp__compile::Const, _vt_name), _ge_auxcall10))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _ge_auxcall11;
      RF_CALL (Format_m_Exp, _ge_auxcall10, _ge_auxcall11);
      RF_TAILCALL (MSG_m_Exprs, (_ve_Fe1, (_ve_Fe2 + _ge_auxcall11)), _v_res1);
      goto _block1;
    }
  _block1__branch8: {}
    {
      {
        if (!RF_CALL (Empty_m_Expr_q_, _ge_arg1, /*void*/))
        {
          goto _block10__branch1;
        }
        if (!RF_CALL (Empty_m_Expr_q_, _ge_arg2, /*void*/))
        {
          goto _block10__branch1;
        }
        _v_res1 = empty;
        goto _block10;
      }
    _block10__branch1: {}
      {
        if (_ge_arg1.get_len () < 1)
        {
          goto _block10__branch2;
        }
        RF_lsplit (_ge_arg1, 0, _ve__e__e_tmp_m_rfp__formatrf_m_159_m_14, _v_lsplit__arg1);
        for ( ; ; RF_iter(_ge_arg1)++)
        {
          {
            if (!RF_iter(_ge_arg1))
            {
              goto _block10__branch2;
            }
            uintptr_t _v_len41 = _v_lsplit__arg1.get_len ();
            uintptr_t _v_len42 = 1;
            if (_v_len41 < _v_len42)
            {
              goto _block10__branch2;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_159_m_22 = (_v_len41 - _v_len42);
            Expr _vt_Ft1 (_v_lsplit__arg1, 0, 1);
            Expr _ve__e__e_tmp_m_rfp__formatrf_m_159_m_22 (_v_lsplit__arg1, (0 + 1), _v_len___e__e_tmp_m_rfp__formatrf_m_159_m_22);
            {
              {
                if (!_vt_Ft1.term_eq (_c_6, 0))
                {
                  goto _block11__branch1;
                }
                goto _block11;
              }
            _block11__branch1: {}
              if (_vt_Ft1.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__Ft13 (_vt_Ft1, 0);
              if (_v_deref__Ft13.get_len () != 2)
              {
                goto _continue1;
              }
              if (!_c_0.term_eq (_v_deref__Ft13, 0))
              {
                goto _continue1;
              }
              Expr _vt_name (_v_deref__Ft13, (0 + 1), 1);
              {
                if (!RF_CALL (Empty_m_Const_q_, _vt_name, /*void*/))
                {
                  goto _negation1;
                }
                goto _continue1;
              }
            _negation1: {}
            }
          _block11: {}
            if (_ge_arg2.get_len () < 1)
            {
              goto _block10__branch2;
            }
            RF_lsplit (_ge_arg2, 0, _ve__e__e_tmp_m_rfp__formatrf_m_163_m_16, _v_lsplit__arg2);
            for ( ; ; RF_iter(_ge_arg2)++)
            {
              {
                if (!RF_iter(_ge_arg2))
                {
                  goto _block10__branch2;
                }
                uintptr_t _v_len43 = _v_lsplit__arg2.get_len ();
                uintptr_t _v_len44 = 1;
                if (_v_len43 < _v_len44)
                {
                  goto _block10__branch2;
                }
                uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_163_m_24 = (_v_len43 - _v_len44);
                Expr _vt_Ft2 (_v_lsplit__arg2, 0, 1);
                Expr _ve__e__e_tmp_m_rfp__formatrf_m_163_m_24 (_v_lsplit__arg2, (0 + 1), _v_len___e__e_tmp_m_rfp__formatrf_m_163_m_24);
                {
                  {
                    if (!_vt_Ft2.term_eq (_c_6, 0))
                    {
                      goto _block12__branch1;
                    }
                    goto _block12;
                  }
                _block12__branch1: {}
                  if (_vt_Ft2.symbol_at (0))
                  {
                    goto _continue2;
                  }
                  Expr _v_deref__Ft23 (_vt_Ft2, 0);
                  if (_v_deref__Ft23.get_len () != 2)
                  {
                    goto _continue2;
                  }
                  if (!_c_0.term_eq (_v_deref__Ft23, 0))
                  {
                    goto _continue2;
                  }
                  Expr _vt_name (_v_deref__Ft23, (0 + 1), 1);
                  {
                    if (!RF_CALL (Empty_m_Const_q_, _vt_name, /*void*/))
                    {
                      goto _negation2;
                    }
                    goto _continue2;
                  }
                _negation2: {}
                }
              _block12: {}
                _v_res1 = _c_6;
                goto _exit2;
              }
          _continue2: {}
            }
          _exit2: {}
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
        goto _block10;
      }
    _block10__branch2: {}
      _v_res1 = _c_7;
    }
  _block10: {}
  }
_block1: {}
RF_END

RF_FUNC (MSG_m_Terms, (RF_ARG _gt_arg1, _gt_arg2;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v_compose1 ((_gt_arg1 + _gt_arg2));
      if (_v_compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v_compose1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__compose1 (_v_compose1, 0);
      Expr _v_deref__compose12 (_v_compose1, (0 + 1));
      uintptr_t _v_len1 = _v_deref__compose12.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__Fe2 = (_v_len1 - _v_len2);
      uintptr_t _v_len3 = _v_deref__compose1.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__Fe1 = (_v_len3 - _v_len4);
      if (!_c_4.term_eq (_v_deref__compose1, 0))
      {
        goto _block1__branch1;
      }
      if (!_c_4.term_eq (_v_deref__compose12, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve_Fe1 (_v_deref__compose1, (0 + 1), _v_len__Fe1);
      Expr _ve_Fe2 (_v_deref__compose12, (0 + 1), _v_len__Fe2);
      Expr _ge_auxcall1;
      RF_CALL (MSG_m_Exprs, (_ve_Fe1, _ve_Fe2), _ge_auxcall1);
      _v_res1 = (_c_4 + _ge_auxcall1) ();
      goto _block1;
    }
  _block1__branch1: {}
    {
      Expr _v_compose2 ((_gt_arg1 + _gt_arg2));
      Expr _vt_Ft (_v_compose2, 0, 1);
      if (!_vt_Ft.term_eq (_v_compose2, (0 + 1)))
      {
        goto _block1__branch2;
      }
      _v_res1 = _vt_Ft;
      goto _block1;
    }
  _block1__branch2: {}
    {
      Expr _v_compose3 ((_gt_arg1 + _gt_arg2));
      if (!_v_compose3.symbol_at (0))
      {
        goto _block1__branch3;
      }
      if (!_v_compose3.symbol_at ((0 + 1)))
      {
        goto _block1__branch3;
      }
      Expr _vs__e__e_tmp_m_rfp__formatrf_m_179_m_4 (_v_compose3, 0, 1);
      Expr _vs__e__e_tmp_m_rfp__formatrf_m_179_m_6 (_v_compose3, (0 + 1), 1);
      _v_res1 = _c_1;
      goto _block1;
    }
  _block1__branch3: {}
    {
      Expr _v_compose4 ((_gt_arg1 + _gt_arg2));
      if (!_c_1.term_eq (_v_compose4, 0))
      {
        goto _block1__branch4;
      }
      if (!_v_compose4.symbol_at ((0 + 1)))
      {
        goto _block1__branch4;
      }
      Expr _vs__e__e_tmp_m_rfp__formatrf_m_180_m_11 (_v_compose4, (0 + 1), 1);
      _v_res1 = _c_1;
      goto _block1;
    }
  _block1__branch4: {}
    {
      Expr _v_compose5 ((_gt_arg1 + _gt_arg2));
      if (!_v_compose5.symbol_at (0))
      {
        goto _block1__branch5;
      }
      if (!_c_1.term_eq (_v_compose5, (0 + 1)))
      {
        goto _block1__branch5;
      }
      Expr _vs__e__e_tmp_m_rfp__formatrf_m_181_m_4 (_v_compose5, 0, 1);
      _v_res1 = _c_1;
      goto _block1;
    }
  _block1__branch5: {}
    {
      Expr _v_compose6 ((_gt_arg1 + _gt_arg2));
      if (!_c_16.eq (_v_compose6, 0))
      {
        goto _block1__branch6;
      }
      _v_res1 = _c_1;
      goto _block1;
    }
  _block1__branch6: {}
    _v_res1 = _c_17;
  }
_block1: {}
RF_END

RF_FUNC (Subformat_q_, (RF_ARG _ve_Format1, _ve_Format2;;), RF_VOID)
  {
    {
      if (_ve_Format1.get_len () != _ve_Format2.get_len ())
      {
        goto _block1__branch1;
      }
      if (!_ve_Format2.eq (_ve_Format1, 0))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ve_Format1.get_len () != 0)
      {
        goto _block1__branch2;
      }
      RF_TAILCALL (Empty_m_Expr_q_, _ve_Format2, /*void*/);
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (_ve_Format1.get_len () != 1)
      {
        goto _block1__branch3;
      }
      if (!_c_7.term_eq (_ve_Format1, 0))
      {
        goto _block1__branch3;
      }
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (_ve_Format1.get_len () != 1)
      {
        goto _block1__branch4;
      }
      if (!_c_6.term_eq (_ve_Format1, 0))
      {
        goto _block1__branch4;
      }
      if (_ve_Format2.get_len () < 1)
      {
        RF_RETFAIL;
      }
      RF_lsplit (_ve_Format2, 0, _ve__e__e_tmp_m_rfp__formatrf_m_200_m_20, _v_lsplit__Format2);
      for ( ; ; RF_iter(_ve_Format2)++)
      {
        {
          if (!RF_iter(_ve_Format2))
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len1 = _v_lsplit__Format2.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_200_m_33 = (_v_len1 - _v_len2);
          Expr _vt_HardTerm (_v_lsplit__Format2, 0, 1);
          Expr _ve__e__e_tmp_m_rfp__formatrf_m_200_m_33 (_v_lsplit__Format2, (0 + 1), _v_len___e__e_tmp_m_rfp__formatrf_m_200_m_33);
          {
            {
              {
                if (!_vt_HardTerm.term_eq (_c_7, 0))
                {
                  goto _block2__branch1;
                }
                goto _block2;
              }
            _block2__branch1: {}
              if (_vt_HardTerm.symbol_at (0))
              {
                goto _negation1;
              }
              Expr _v_deref__HardTerm (_vt_HardTerm, 0);
              if (_v_deref__HardTerm.get_len () != 2)
              {
                goto _negation1;
              }
              if (!_c_0.term_eq (_v_deref__HardTerm, 0))
              {
                goto _negation1;
              }
              Expr _vt_Name (_v_deref__HardTerm, (0 + 1), 1);
              if (!RF_CALL (Empty_m_Const_q_, _vt_Name, /*void*/))
              {
                goto _negation1;
              }
            }
          _block2: {}
            goto _continue1;
          }
        _negation1: {}
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (_ve_Format1.get_len () != 1)
      {
        goto _block1__branch5;
      }
      if (!_c_17.term_eq (_ve_Format1, 0))
      {
        goto _block1__branch5;
      }
      if (_ve_Format2.get_len () < 1)
      {
        RF_RETFAIL;
      }
      RF_lsplit (_ve_Format2, 0, _ve_0, _v_lsplit__Format22);
      for ( ; ; RF_iter(_ve_Format2)++)
      {
        {
          if (!RF_iter(_ve_Format2))
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len3 = _v_lsplit__Format22.get_len ();
          uintptr_t _v_len4 = 1;
          if (_v_len3 < _v_len4)
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len__2 = (_v_len3 - _v_len4);
          Expr _vt_1 (_v_lsplit__Format22, 0, 1);
          Expr _ve_2 (_v_lsplit__Format22, (0 + 1), _v_len__2);
          {
            Expr _gt_0__4;
            if (!RF_CALL (Access::R, (_c_9, _ve_0), _gt_0__4))
            {
              goto _block3__branch1;
            }
            {
              if (!RF_CALL (Empty_m_Expr_q_, _gt_0__4, /*void*/))
              {
                goto _negation2;
              }
              goto _block3__branch1;
            }
          _negation2: {}
            RF_RETFAIL;
          }
        _block3__branch1: {}
          {
            {
              if (_vt_1.symbol_at (0))
              {
                goto _block4__branch1;
              }
              Expr _v_deref__1 (_vt_1, 0);
              if (_v_deref__1.get_len () != 2)
              {
                goto _block4__branch1;
              }
              if (!_c_0.term_eq (_v_deref__1, 0))
              {
                goto _block4__branch1;
              }
              Expr _vt_Name (_v_deref__1, (0 + 1), 1);
              Expr _v_Get_m_Const_m_Term1;
              if (!RF_CALL (Get_m_Const_m_Term, _vt_Name, _v_Get_m_Const_m_Term1))
              {
                goto _block4__branch1;
              }
              uintptr_t _v_len5 = 1;
              uintptr_t _v_len6 = 0;
              if (_v_len5 < _v_len6)
              {
                goto _block4__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_210_m_52 = (_v_len5 - _v_len6);
              Expr _ve__e__e_tmp_m_rfp__formatrf_m_210_m_52 (_v_Get_m_Const_m_Term1, 0, _v_len___e__e_tmp_m_rfp__formatrf_m_210_m_52);
              goto _block4;
            }
          _block4__branch1: {}
            {
              if (!_vt_1.symbol_at (0))
              {
                goto _block4__branch2;
              }
              Expr _vs_ObjectSymbol (_vt_1, 0, 1);
              goto _block4;
            }
          _block4__branch2: {}
            {
              if (!_vt_1.term_eq (_c_1, 0))
              {
                goto _block4__branch3;
              }
              goto _block4;
            }
          _block4__branch3: {}
            {
              if (_vt_1.symbol_at (0))
              {
                goto _block4__branch4;
              }
              Expr _v_deref__12 (_vt_1, 0);
              uintptr_t _v_len7 = _v_deref__12.get_len ();
              uintptr_t _v_len8 = 1;
              if (_v_len7 < _v_len8)
              {
                goto _block4__branch4;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_213_m_19 = (_v_len7 - _v_len8);
              if (!_c_4.term_eq (_v_deref__12, 0))
              {
                goto _block4__branch4;
              }
              Expr _ve__e__e_tmp_m_rfp__formatrf_m_213_m_19 (_v_deref__12, (0 + 1), _v_len___e__e_tmp_m_rfp__formatrf_m_213_m_19);
              goto _block4;
            }
          _block4__branch4: {}
            if (!_vt_1.term_eq (_c_17, 0))
            {
              goto _continue2;
            }
          }
        _block4: {}
          RF_TAILCALL (Empty_m_Expr_q_, _ve_2, /*void*/);
          goto _exit2;
        }
    _continue2: {}
      }
    _exit2: {}
      goto _block1;
    }
  _block1__branch5: {}
    {
      if (_ve_Format1.get_len () != 1)
      {
        goto _block1__branch6;
      }
      if (!_c_1.term_eq (_ve_Format1, 0))
      {
        goto _block1__branch6;
      }
      if (_ve_Format2.get_len () < 1)
      {
        RF_RETFAIL;
      }
      RF_lsplit (_ve_Format2, 0, _ve_0, _v_lsplit__Format23);
      for ( ; ; RF_iter(_ve_Format2)++)
      {
        {
          if (!RF_iter(_ve_Format2))
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len9 = _v_lsplit__Format23.get_len ();
          uintptr_t _v_len10 = 1;
          if (_v_len9 < _v_len10)
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len__22 = (_v_len9 - _v_len10);
          Expr _vt_1 (_v_lsplit__Format23, 0, 1);
          Expr _ve_2 (_v_lsplit__Format23, (0 + 1), _v_len__22);
          {
            Expr _gt_0__4;
            if (!RF_CALL (Access::R, (_c_9, _ve_0), _gt_0__4))
            {
              goto _block5__branch1;
            }
            {
              if (!RF_CALL (Empty_m_Expr_q_, _gt_0__4, /*void*/))
              {
                goto _negation3;
              }
              goto _block5__branch1;
            }
          _negation3: {}
            RF_RETFAIL;
          }
        _block5__branch1: {}
          {
            {
              if (_vt_1.symbol_at (0))
              {
                goto _block6__branch1;
              }
              Expr _v_deref__13 (_vt_1, 0);
              if (_v_deref__13.get_len () != 2)
              {
                goto _block6__branch1;
              }
              if (!_c_0.term_eq (_v_deref__13, 0))
              {
                goto _block6__branch1;
              }
              Expr _vt_Name (_v_deref__13, (0 + 1), 1);
              Expr _v_Get_m_Const_m_Term2;
              if (!RF_CALL (Get_m_Const_m_Term, _vt_Name, _v_Get_m_Const_m_Term2))
              {
                goto _block6__branch1;
              }
              Expr _vt_erm (_v_Get_m_Const_m_Term2, 0, 1);
              {
                {
                  if (!_vt_erm.symbol_at (0))
                  {
                    goto _block7__branch1;
                  }
                  Expr _vs_ObjectSymbol (_vt_erm, 0, 1);
                  goto _block7;
                }
              _block7__branch1: {}
                if (_vt_erm.symbol_at (0))
                {
                  RF_RETFAIL;
                }
                Expr _v_deref__erm (_vt_erm, 0);
                uintptr_t _v_len11 = _v_deref__erm.get_len ();
                uintptr_t _v_len12 = 1;
                if (_v_len11 < _v_len12)
                {
                  RF_RETFAIL;
                }
                uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_226_m_21 = (_v_len11 - _v_len12);
                if (!_c_0.term_eq (_v_deref__erm, 0))
                {
                  RF_RETFAIL;
                }
                Expr _ve__e__e_tmp_m_rfp__formatrf_m_226_m_21 (_v_deref__erm, (0 + 1), _v_len___e__e_tmp_m_rfp__formatrf_m_226_m_21);
              }
            _block7: {}
              RF_TAILCALL (Empty_m_Expr_q_, _ve_2, /*void*/);
              goto _block6;
            }
          _block6__branch1: {}
            {
              if (!_vt_1.symbol_at (0))
              {
                goto _block6__branch2;
              }
              Expr _vs_ObjectSymbol (_vt_1, 0, 1);
              RF_TAILCALL (Empty_m_Expr_q_, _ve_2, /*void*/);
              goto _block6;
            }
          _block6__branch2: {}
            if (!_vt_1.term_eq (_c_1, 0))
            {
              goto _continue3;
            }
            RF_TAILCALL (Empty_m_Expr_q_, _ve_2, /*void*/);
          }
        _block6: {}
          goto _exit3;
        }
    _continue3: {}
      }
    _exit3: {}
      goto _block1;
    }
  _block1__branch6: {}
    {
      if (_ve_Format1.get_len () != 1)
      {
        goto _block1__branch7;
      }
      if (_ve_Format1.symbol_at (0))
      {
        goto _block1__branch7;
      }
      Expr _v_deref__Format1 (_ve_Format1, 0);
      uintptr_t _v_len13 = _v_deref__Format1.get_len ();
      uintptr_t _v_len14 = 1;
      if (_v_len13 < _v_len14)
      {
        goto _block1__branch7;
      }
      uintptr_t _v_len__Format11 = (_v_len13 - _v_len14);
      if (!_c_4.term_eq (_v_deref__Format1, 0))
      {
        goto _block1__branch7;
      }
      Expr _ve_Format11 (_v_deref__Format1, (0 + 1), _v_len__Format11);
      if (_ve_Format2.get_len () < 1)
      {
        RF_RETFAIL;
      }
      RF_lsplit (_ve_Format2, 0, _ve_0, _v_lsplit__Format24);
      for ( ; ; RF_iter(_ve_Format2)++)
      {
        {
          if (!RF_iter(_ve_Format2))
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len15 = _v_lsplit__Format24.get_len ();
          uintptr_t _v_len16 = 1;
          if (_v_len15 < _v_len16)
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len__23 = (_v_len15 - _v_len16);
          Expr _vt_1 (_v_lsplit__Format24, 0, 1);
          Expr _ve_2 (_v_lsplit__Format24, (0 + 1), _v_len__23);
          {
            Expr _gt_0__4;
            if (!RF_CALL (Access::R, (_c_9, _ve_0), _gt_0__4))
            {
              goto _block8__branch1;
            }
            {
              if (!RF_CALL (Empty_m_Expr_q_, _gt_0__4, /*void*/))
              {
                goto _negation4;
              }
              goto _block8__branch1;
            }
          _negation4: {}
            RF_RETFAIL;
          }
        _block8__branch1: {}
          {
            {
              if (_vt_1.symbol_at (0))
              {
                goto _block9__branch1;
              }
              Expr _v_deref__14 (_vt_1, 0);
              if (_v_deref__14.get_len () != 2)
              {
                goto _block9__branch1;
              }
              if (!_c_0.term_eq (_v_deref__14, 0))
              {
                goto _block9__branch1;
              }
              Expr _vt_Name (_v_deref__14, (0 + 1), 1);
              Expr _v_Get_m_Const_m_Term3;
              if (!RF_CALL (Get_m_Const_m_Term, _vt_Name, _v_Get_m_Const_m_Term3))
              {
                goto _block9__branch1;
              }
              Expr _vt_erm (_v_Get_m_Const_m_Term3, 0, 1);
              if (_vt_erm.symbol_at (0))
              {
                RF_RETFAIL;
              }
              Expr _v_deref__erm2 (_vt_erm, 0);
              uintptr_t _v_len17 = _v_deref__erm2.get_len ();
              uintptr_t _v_len18 = 1;
              if (_v_len17 < _v_len18)
              {
                RF_RETFAIL;
              }
              uintptr_t _v_len__Format22 = (_v_len17 - _v_len18);
              if (!_c_4.term_eq (_v_deref__erm2, 0))
              {
                RF_RETFAIL;
              }
              Expr _ve_Format22 (_v_deref__erm2, (0 + 1), _v_len__Format22);
              if (!RF_CALL (Empty_m_Expr_q_, _ve_2, /*void*/))
              {
                RF_RETFAIL;
              }
              RF_TAILCALL (Subformat_q_, (_ve_Format11, _ve_Format22), /*void*/);
              goto _block9;
            }
          _block9__branch1: {}
            if (_vt_1.symbol_at (0))
            {
              goto _continue4;
            }
            Expr _v_deref__15 (_vt_1, 0);
            uintptr_t _v_len19 = _v_deref__15.get_len ();
            uintptr_t _v_len20 = 1;
            if (_v_len19 < _v_len20)
            {
              goto _continue4;
            }
            uintptr_t _v_len__Format222 = (_v_len19 - _v_len20);
            if (!_c_4.term_eq (_v_deref__15, 0))
            {
              goto _continue4;
            }
            Expr _ve_Format22 (_v_deref__15, (0 + 1), _v_len__Format222);
            if (!RF_CALL (Empty_m_Expr_q_, _ve_2, /*void*/))
            {
              RF_RETFAIL;
            }
            RF_TAILCALL (Subformat_q_, (_ve_Format11, _ve_Format22), /*void*/);
          }
        _block9: {}
          goto _exit4;
        }
    _continue4: {}
      }
    _exit4: {}
      goto _block1;
    }
  _block1__branch7: {}
    {
      if (_ve_Format1.get_len () != 1)
      {
        goto _block1__branch8;
      }
      if (!_ve_Format1.symbol_at (0))
      {
        goto _block1__branch8;
      }
      Expr _vs_ObjectSymbol (_ve_Format1, 0, 1);
      if (_ve_Format2.get_len () < 1)
      {
        RF_RETFAIL;
      }
      RF_lsplit (_ve_Format2, 0, _ve_0, _v_lsplit__Format25);
      for ( ; ; RF_iter(_ve_Format2)++)
      {
        {
          if (!RF_iter(_ve_Format2))
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len21 = _v_lsplit__Format25.get_len ();
          uintptr_t _v_len22 = 1;
          if (_v_len21 < _v_len22)
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len__24 = (_v_len21 - _v_len22);
          Expr _vt_1 (_v_lsplit__Format25, 0, 1);
          Expr _ve_2 (_v_lsplit__Format25, (0 + 1), _v_len__24);
          {
            Expr _gt_0__4;
            if (!RF_CALL (Access::R, (_c_9, _ve_0), _gt_0__4))
            {
              goto _block10__branch1;
            }
            {
              if (!RF_CALL (Empty_m_Expr_q_, _gt_0__4, /*void*/))
              {
                goto _negation5;
              }
              goto _block10__branch1;
            }
          _negation5: {}
            RF_RETFAIL;
          }
        _block10__branch1: {}
          {
            {
              if (_vt_1.symbol_at (0))
              {
                goto _block11__branch1;
              }
              Expr _v_deref__16 (_vt_1, 0);
              if (_v_deref__16.get_len () != 2)
              {
                goto _block11__branch1;
              }
              if (!_c_0.term_eq (_v_deref__16, 0))
              {
                goto _block11__branch1;
              }
              Expr _vt_Name (_v_deref__16, (0 + 1), 1);
              Expr _v_Get_m_Const_m_Term4;
              if (!RF_CALL (Get_m_Const_m_Term, _vt_Name, _v_Get_m_Const_m_Term4))
              {
                goto _block11__branch1;
              }
              Expr _vt_erm (_v_Get_m_Const_m_Term4, 0, 1);
              if (!RF_CALL (Empty_m_Expr_q_, _ve_2, /*void*/))
              {
                RF_RETFAIL;
              }
              if (!_vs_ObjectSymbol.term_eq (_vt_erm, 0))
              {
                RF_RETFAIL;
              }
              goto _block11;
            }
          _block11__branch1: {}
            if (!_vt_1.symbol_at (0))
            {
              goto _continue5;
            }
            Expr _vs_ymbol (_vt_1, 0, 1);
            if (!RF_CALL (Empty_m_Expr_q_, _ve_2, /*void*/))
            {
              RF_RETFAIL;
            }
            if (!_vs_ObjectSymbol.term_eq (_vs_ymbol, 0))
            {
              RF_RETFAIL;
            }
          }
        _block11: {}
          goto _exit5;
        }
    _continue5: {}
      }
    _exit5: {}
      goto _block1;
    }
  _block1__branch8: {}
    {
      if (_ve_Format1.get_len () != 1)
      {
        goto _block1__branch9;
      }
      if (_ve_Format1.symbol_at (0))
      {
        goto _block1__branch9;
      }
      Expr _v_deref__Format12 (_ve_Format1, 0);
      if (_v_deref__Format12.get_len () != 2)
      {
        goto _block1__branch9;
      }
      if (!_c_0.term_eq (_v_deref__Format12, 0))
      {
        goto _block1__branch9;
      }
      Expr _vt_Name (_v_deref__Format12, (0 + 1), 1);
      Expr _ge_auxcall1;
      if (!RF_CALL (Table::Lookup, (rfp__compile::Const, _vt_Name), _ge_auxcall1))
      {
        RF_RETFAIL;
      }
      Expr _ge_auxcall2;
      if (!RF_CALL (Access::Middle, (_c_8, _c_9, _ge_auxcall1), _ge_auxcall2))
      {
        RF_RETFAIL;
      }
      Expr _ge_auxcall3;
      RF_CALL (Format_m_Exp, _ge_auxcall2, _ge_auxcall3);
      RF_TAILCALL (Subformat_q_, (_ge_auxcall3, _ve_Format2), /*void*/);
      goto _block1;
    }
  _block1__branch9: {}
    {
      if (_ve_Format2.get_len () < 0)
      {
        goto _block1__branch10;
      }
      if (_ve_Format1.get_len () < 2)
      {
        goto _block1__branch10;
      }
      RF_lsplit (_ve_Format1, 1, _vv_first1, _vv_rest1);
      for ( ; ; RF_iter(_ve_Format1)++)
      {
        {
          if (!RF_iter(_ve_Format1))
          {
            goto _block1__branch10;
          }
          if (_vv_rest1.get_len () < 1)
          {
            goto _block1__branch10;
          }
          RF_lsplit (_ve_Format2, 0, _ve_first2, _ve_rest2);
          for ( ; ; RF_iter(_ve_Format2)++)
          {
            {
              if (!RF_iter(_ve_Format2))
              {
                goto _continue6;
              }
              if (_ve_rest2.get_len () < 0)
              {
                goto _continue6;
              }
              if (!RF_CALL (Subformat_q_, (_vv_first1, _ve_first2), /*void*/))
              {
                goto _continue7;
              }
              if (!RF_CALL (Subformat_q_, (_vv_rest1, _ve_rest2), /*void*/))
              {
                goto _continue7;
              }
              goto _exit7;
            }
        _continue7: {}
          }
        _exit7: {}
          goto _exit6;
        }
    _continue6: {}
      }
    _exit6: {}
      goto _block1;
    }
  _block1__branch10: {}
    uintptr_t _v_len23 = _ve_Format1.get_len ();
    uintptr_t _v_len24 = 0;
    if (_v_len23 < _v_len24)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_264_m_6 = (_v_len23 - _v_len24);
    Expr _ve__e__e_tmp_m_rfp__formatrf_m_264_m_6 (_ve_Format1, 0, _v_len___e__e_tmp_m_rfp__formatrf_m_264_m_6);
    Expr _ge_Format2__2 (_ve_Format2);
    Expr _ve_format (empty);
    Expr _vs_success_q_ (_c_9);
    for ( ; ; )
    {
      {
        if (_ge_Format2__2.get_len () != 0)
        {
          goto _iter1;
        }
        {
          if (!_vs_success_q_.term_eq (_c_9, 0))
          {
            goto _block12__branch1;
          }
          RF_RETFAIL;
        }
      _block12__branch1: {}
        RF_TAILCALL (Subformat_q_, (_ve_Format1, _ve_format), /*void*/);
        goto _exit__iter1;
      }
    _iter1: {}
      {
        {
          if (_ge_Format2__2.get_len () < 1)
          {
            goto _block13__branch1;
          }
          RF_lsplit (_ge_Format2__2, 0, _ve_1, _v_lsplit__Format2__2);
          for ( ; ; RF_iter(_ge_Format2__2)++)
          {
            {
              if (!RF_iter(_ge_Format2__2))
              {
                goto _block13__branch1;
              }
              uintptr_t _v_len25 = _v_lsplit__Format2__2.get_len ();
              uintptr_t _v_len26 = 1;
              if (_v_len25 < _v_len26)
              {
                goto _block13__branch1;
              }
              uintptr_t _v_len__25 = (_v_len25 - _v_len26);
              if (_v_lsplit__Format2__2.symbol_at (0))
              {
                goto _continue8;
              }
              Expr _v_deref__lsplit__Format2__2 (_v_lsplit__Format2__2, 0);
              if (_v_deref__lsplit__Format2__2.get_len () != 2)
              {
                goto _continue8;
              }
              if (!_c_0.term_eq (_v_deref__lsplit__Format2__2, 0))
              {
                goto _continue8;
              }
              Expr _ve_2 (_v_lsplit__Format2__2, (0 + 1), _v_len__25);
              Expr _vt_Name (_v_deref__lsplit__Format2__2, (0 + 1), 1);
              Expr _ge_auxcall4;
              if (!RF_CALL (Table::Lookup, (rfp__compile::Const, _vt_Name), _ge_auxcall4))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              Expr _ge_auxcall5;
              if (!RF_CALL (Access::Middle, (_c_8, _c_9, _ge_auxcall4), _ge_auxcall5))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              Expr _ge_auxcall6;
              RF_CALL (Format_m_Exp, _ge_auxcall5, _ge_auxcall6);
              _ge_Format2__2 = _ve_2;
              _ve_format = (_ve_format + _ve_1 + _ge_auxcall6);
              _vs_success_q_ = _c_18;
              goto _exit8;
            }
        _continue8: {}
          }
        _exit8: {}
          goto _block13;
        }
      _block13__branch1: {}
        _ve_format = (_ve_format + _ge_Format2__2);
        _ge_Format2__2 = empty;
      }
    _block13: {}
    }
  _exit__iter1: {}
  }
_block1: {}
RF_END

RF_FUNC (Empty_m_Const_q_, (RF_ARG _vt_name;;), RF_VOID)
  Expr _ge_auxcall1;
  if (!RF_CALL (Table::Lookup, (rfp__compile::Const, _vt_name), _ge_auxcall1))
  {
    RF_RETFAIL;
  }
  Expr _ge_auxcall2;
  if (!RF_CALL (Access::Middle, (_c_8, _c_9, _ge_auxcall1), _ge_auxcall2))
  {
    RF_RETFAIL;
  }
  RF_TAILCALL (Empty_m_Expr_q_, _ge_auxcall2, /*void*/);
RF_END

RF_FUNC (Empty_m_Expr_q_, (RF_ARG _ge_arg1;;), RF_VOID)
  {
    if (_ge_arg1.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_ge_arg1, 0, _ve__e__e_tmp_m_rfp__formatrf_m_286_m_4, _v_lsplit__arg1);
    for ( ; ; RF_iter(_ge_arg1)++)
    {
      {
        if (!RF_iter(_ge_arg1))
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len1 = _v_lsplit__arg1.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__formatrf_m_286_m_9 = (_v_len1 - _v_len2);
        Expr _vt_1 (_v_lsplit__arg1, 0, 1);
        Expr _ve__e__e_tmp_m_rfp__formatrf_m_286_m_9 (_v_lsplit__arg1, (0 + 1), _v_len___e__e_tmp_m_rfp__formatrf_m_286_m_9);
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__1 (_vt_1, 0);
          if (_v_deref__1.get_len () != 2)
          {
            goto _block2__branch1;
          }
          if (!_c_0.term_eq (_v_deref__1, 0))
          {
            goto _block2__branch1;
          }
          Expr _vt_2 (_v_deref__1, (0 + 1), 1);
          if (!RF_CALL (Empty_m_Const_q_, _vt_2, /*void*/))
          {
            goto _block2__branch1;
          }
          goto _continue1;
        }
      _block2__branch1: {}
        RF_RETFAIL;
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
RF_END

RF_FUNC (Get_m_Const_m_Term, (RF_ARG _vt_name;;), (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  if (!RF_CALL (Table::Lookup, (rfp__compile::Const, _vt_name), _ge_auxcall1))
  {
    RF_RETFAIL;
  }
  Expr _ge_auxcall2;
  if (!RF_CALL (Access::Middle, (_c_8, _c_9, _ge_auxcall1), _ge_auxcall2))
  {
    RF_RETFAIL;
  }
  RF_TAILCALL (Get_m_Term, _ge_auxcall2, _v_res1);
RF_END

RF_FUNC (Get_m_Term, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () < 1)
  {
    RF_RETFAIL;
  }
  RF_lsplit (_ge_arg1, 0, _ve_0, _v_lsplit__arg1);
  for ( ; ; RF_iter(_ge_arg1)++)
  {
    {
      if (!RF_iter(_ge_arg1))
      {
        RF_RETFAIL;
      }
      uintptr_t _v_len1 = _v_lsplit__arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        RF_RETFAIL;
      }
      uintptr_t _v_len__2 = (_v_len1 - _v_len2);
      Expr _vt_1 (_v_lsplit__arg1, 0, 1);
      Expr _ve_2 (_v_lsplit__arg1, (0 + 1), _v_len__2);
      {
        if (!RF_CALL (Empty_m_Expr_q_, _vt_1, /*void*/))
        {
          goto _negation1;
        }
        goto _continue1;
      }
    _negation1: {}
      if (!RF_CALL (Empty_m_Expr_q_, _ve_2, /*void*/))
      {
        RF_RETFAIL;
      }
      {
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block1__branch1;
          }
          Expr _v_deref__1 (_vt_1, 0);
          if (_v_deref__1.get_len () != 2)
          {
            goto _block1__branch1;
          }
          if (!_c_0.term_eq (_v_deref__1, 0))
          {
            goto _block1__branch1;
          }
          Expr _vt_Name (_v_deref__1, (0 + 1), 1);
          Expr _ve_const;
          if (!RF_CALL (Table::Lookup, (rfp__compile::Const, _vt_Name), _ve_const))
          {
            goto _block1__branch1;
          }
          Expr _ge_auxcall1;
          if (!RF_CALL (Access::Middle, (_c_8, _c_9, _ve_const), _ge_auxcall1))
          {
            RF_RETFAIL;
          }
          RF_TAILCALL (Get_m_Term, _ge_auxcall1, _v_res1);
          goto _block1;
        }
      _block1__branch1: {}
        _v_res1 = _vt_1;
      }
    _block1: {}
      goto _exit1;
    }
_continue1: {}
  }
_exit1: {}
RF_END

RF_FUNC (MSG_m_Exprs__0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = _ge_arg1.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_19);
  }
  uintptr_t _v_len__stub1 = (_v_len1 - _v_len2);
  if (_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_19);
  }
  Expr _v_deref__arg1 (_ge_arg1, 0);
  uintptr_t _v_len3 = _v_deref__arg1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_ERROR (_c_19);
  }
  uintptr_t _v_len__stub2 = (_v_len3 - _v_len4);
  Expr _v_stub1 (_ge_arg1, (0 + 1), _v_len__stub1);
  Expr _v_stub2 (_v_deref__arg1, 0, _v_len__stub2);
  RF_TAILCALL (MSG_m_Exprs, (_v_stub2, _v_stub1), _v_res1);
RF_END

}

namespace rfp__format
{

static void init_ ()
{
  _c_0 = Expr::create<rftype::Word>("REF");
  _c_20 = Expr::create<rftype::Word>("SVAR");
  _c_16 = (_c_20) () + (_c_20) ();
  _c_1 = Expr (_c_16, 0, 1);
  _c_2 = Expr::create<rftype::Word>("CALL");
  _c_3 = Expr::create<rftype::Integer>("4");
  _c_4 = Expr::create<rftype::Word>("PAREN");
  _c_5 = Expr::create<rftype::Word>("VAR");
  _c_6 = (Expr::create<rftype::Word>("VVAR")) ();
  _c_21 = Expr::create<rftype::Word>("EVAR");
  _c_7 = (_c_21) ();
  _c_8 = Expr::create<rftype::Integer>("3");
  _c_9 = Expr::create<rftype::Integer>("0");
  _c_10 = (_c_6) ();
  _c_11 = (_c_7) ();
  _c_12 = (empty) ();
  _c_13 = Expr::create_sym<rftype::Func> (MSG_m_Exprs__0);
  _c_15 = (Expr::create<rftype::Word>("FAIL")) ();
  _c_14 = (_c_15) ();
  _c_17 = (Expr::create<rftype::Word>("TVAR")) ();
  _c_18 = Expr::create<rftype::Integer>("1");
  _c_19 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}
