#include <rf_core.hh>

namespace refal
{

using namespace rfrt;

namespace Box
{

RF_DECL(_q_);

RF_FUNC (_q_, (RF_ARG _box;;), (RF_RES _expr;;))
  if (_box.get_len() == 1) {
    Term* t = _box.get_first();
    if (t->is_instance_of<BoxContents>()) {
        _expr = *(t->get_obj_ptr<BoxContents>());
    } else {
      RF_LIB_ERROR(L"Invalid argument");
    }
  } else {
    FATAL("Box::?(): Symbol expected");
  }
RF_END

}

}
