// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Fri, 15 Dec 2006) $
// $Author: orlov $

#include <rf_core.hh>

namespace refal
{

using namespace rfrt;
using namespace rftype;

namespace Class
{

RF_FUNC (Digit_q_, (RF_ARG e_Exp;;), RF_VOID)
  if (e_Exp.get_len() == 1) {
    Term* p = e_Exp.get_first();
    rftype::Char* b = p->cast_to<rftype::Char>(type_char);
    if (!b) 
      RF_RETFAIL;
    else {
      if (!(b->is_digit()))
        RF_RETFAIL;
    }
  }
  else
    RF_RETFAIL;
RF_END

}
  
}


