// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Fri, 15 Dec 2006) $
// $Author: orlov $

#include <rf_core.hh>

namespace refal
{

using namespace rfrt;
using namespace rftype;

namespace Convert
{

RF_FUNC (To_m_Int, (RF_ARG e_Exp;;), (RF_RES s_Int;;))
  pxx::WString ws = e_Exp;
  wchar_t const* pws = ws.get_data();
  size_t len = ws.get_length();
  while (iswspace(*pws)) {
    pws++;
    len--;
  }
  if (L'+' == *pws) {
    pws++;
    len--;
  }
  char* s  = static_cast<char*>(alloca(len));
  char* ps = s;
  if (L'-' == *pws) {
    *ps++ = '-';
    pws++;
    len--;
  }
  size_t const tmp_len = len;
  while (iswdigit(*pws)) {
    swscanf(pws++, L"%c", ps++);
    len--;
  }
  *ps = '\0';
  if (tmp_len == len)
    RF_RETFAIL;
  while (len--) {
    if (!iswspace(*pws++))
      RF_RETFAIL;
  }
  try {
//    s_Int = size_t(ps - s) > Int32::max_len - 1 ? Expr::create<Integer>(s)
//                                                : Expr::create<Int32>(s);
    s_Int = Expr::create<Integer>(s);
  }
  catch (Integer::InvalidParameter&) {
    RF_RETFAIL;
  }
RF_END

}
}
  
