#include <rf_core.hh>
#include <refal/Class.hh>
#include <refal/Convert.hh>
#include <refal/Compare.hh>
#include "cpp_specific.hh"

namespace refal
{

using namespace rfrt;

namespace cpp__specific
{

Expr Namespace_m_Delimeter;

static Expr Reserved_m_Words;

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

RF_FUNC (Reserved_m_Word_q_, (RF_ARG _ve_word;;), RF_VOID)
  {
    {
      Expr _v_To_m_Chars1;
      RF_CALL (Convert::To_m_Chars, _ve_word, _v_To_m_Chars1);
      uintptr_t _v_len1 = _v_To_m_Chars1.get_len ();
      uintptr_t _v_len2 = 2;
      if ((_v_len1 < _v_len2))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_cpp__specificrf_m_33_m_35 = (_v_len1 - _v_len2);
      if (!_c_0.term_eq (_v_To_m_Chars1, 0))
      {
        goto _block1__branch1;
      }
      if (!_v_To_m_Chars1.symbol_at (1))
      {
        goto _block1__branch1;
      }
      Expr _vs_char (_v_To_m_Chars1, 1, 1);
      Expr _ve__e__e_tmp_m_cpp__specificrf_m_33_m_35 (_v_To_m_Chars1, 2, _v_len___e__e_tmp_m_cpp__specificrf_m_33_m_35);
      {
        {
          if (!_vs_char.term_eq (_c_0, 0))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        if (!RF_CALL (Class::Letter_q_, _vs_char, /*void*/))
        {
          goto _block1__branch1;
        }
        {
          RF_lsplit (_c_1, 0, _ve__e__e_tmp_m_cpp__specificrf_m_35_m_36, _v_lsplit__1);
          for ( ; ; RF_iter(_c_1)++)
          {
            {
              if (!RF_iter(_c_1))
              {
                goto _negation1;
              }
              uintptr_t _v_len3 = _v_lsplit__1.get_len ();
              uintptr_t _v_len4 = 1;
              if ((_v_len3 < _v_len4))
              {
                goto _negation1;
              }
              uintptr_t _v_len___e__e_tmp_m_cpp__specificrf_m_35_m_45 = (_v_len3 - _v_len4);
              if (!_vs_char.term_eq (_v_lsplit__1, 0))
              {
                goto _continue1;
              }
              Expr _ve__e__e_tmp_m_cpp__specificrf_m_35_m_45 (_v_lsplit__1, 1, _v_len___e__e_tmp_m_cpp__specificrf_m_35_m_45);
              goto _exit1;
            }
        _continue1: {}
          }
        _exit1: {}
          goto _block1__branch1;
        }
      _negation1: {}
        if (!RF_CALL (Compare::_lt_, (_vs_char, _c_2), /*void*/))
        {
          goto _block1__branch1;
        }
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    Expr _vs_word;
    RF_CALL (Convert::To_m_Word, _ve_word, _vs_word);
    RF_lsplit (Reserved_m_Words, 0, _ve__e__e_tmp_m_cpp__specificrf_m_37_m_50, _v_lsplit__Reserved_m_Words);
    for ( ; ; RF_iter(Reserved_m_Words)++)
    {
      {
        if (!RF_iter(Reserved_m_Words))
        {
          RF_RETFAIL;
        }
        uintptr_t _v_len5 = _v_lsplit__Reserved_m_Words.get_len ();
        uintptr_t _v_len6 = 1;
        if ((_v_len5 < _v_len6))
        {
          RF_RETFAIL;
        }
        uintptr_t _v_len___e__e_tmp_m_cpp__specificrf_m_37_m_59 = (_v_len5 - _v_len6);
        if (!_vs_word.term_eq (_v_lsplit__Reserved_m_Words, 0))
        {
          goto _continue2;
        }
        Expr _ve__e__e_tmp_m_cpp__specificrf_m_37_m_59 (_v_lsplit__Reserved_m_Words, 1, _v_len___e__e_tmp_m_cpp__specificrf_m_37_m_59);
        goto _exit2;
      }
  _continue2: {}
    }
  _exit2: {}
  }
_block1: {}
RF_END

}

namespace cpp__specific
{

static void init_ ()
{
  Namespace_m_Delimeter = Char::create_expr ("::");
  Reserved_m_Words = Expr::create<Word>("asm") + Expr::create<Word>("do") + Expr::create<Word>("inline") + Expr::create<Word>("short") + Expr::create<Word>("typeid") + Expr::create<Word>("auto") + Expr::create<Word>("double") + Expr::create<Word>("int") + Expr::create<Word>("signed") + Expr::create<Word>("typename") + Expr::create<Word>("bool") + Expr::create<Word>("dynamic_cast") + Expr::create<Word>("long") + Expr::create<Word>("sizeof") + Expr::create<Word>("union") + Expr::create<Word>("break") + Expr::create<Word>("else") + Expr::create<Word>("mutable") + Expr::create<Word>("static") + Expr::create<Word>("unsigned") + Expr::create<Word>("case") + Expr::create<Word>("enum") + Expr::create<Word>("namespace") + Expr::create<Word>("static_cast") + Expr::create<Word>("using") + Expr::create<Word>("catch") + Expr::create<Word>("explicit") + Expr::create<Word>("new") + Expr::create<Word>("struct") + Expr::create<Word>("virtual") + Expr::create<Word>("char") + Expr::create<Word>("extern") + Expr::create<Word>("operator") + Expr::create<Word>("switch") + Expr::create<Word>("void") + Expr::create<Word>("class") + Expr::create<Word>("false") + Expr::create<Word>("private") + Expr::create<Word>("template") + Expr::create<Word>("volatile") + Expr::create<Word>("const") + Expr::create<Word>("float") + Expr::create<Word>("protected") + Expr::create<Word>("this") + Expr::create<Word>("wchar_t") + Expr::create<Word>("const_cast") + Expr::create<Word>("for") + Expr::create<Word>("public") + Expr::create<Word>("throw") + Expr::create<Word>("while") + Expr::create<Word>("continue") + Expr::create<Word>("friend") + Expr::create<Word>("register") + Expr::create<Word>("true") + Expr::create<Word>("default") + Expr::create<Word>("goto") + Expr::create<Word>("reinterpret_cast") + Expr::create<Word>("try") + Expr::create<Word>("delete") + Expr::create<Word>("if") + Expr::create<Word>("return") + Expr::create<Word>("typedef") + Expr::create<Word>("and") + Expr::create<Word>("and_eq") + Expr::create<Word>("bitand") + Expr::create<Word>("bitor") + Expr::create<Word>("compl") + Expr::create<Word>("not") + Expr::create<Word>("not_eq") + Expr::create<Word>("or") + Expr::create<Word>("or_eq") + Expr::create<Word>("xor") + Expr::create<Word>("xor_eq");
  _c_0 = Char::create_expr ("_");
  _c_1 = Char::create_expr ("?!");
  _c_2 = Char::create_expr ("a");
}

static AtStart init_registrator_ (&init_);

}

}
