#include <rf_core.hh>
#include <refal/Class.hh>
#include <refal/List.hh>
#include <refal/Convert.hh>

namespace refal
{

using namespace rfrt;

namespace Error
{

RF_DECL (Lib_m_Error);

RF_DECL (Not_m_Available);

static Expr _c_0;

static Expr _c_1;

RF_FUNC (Lib_m_Error, (RF_ARG _ve_fname, _ve_rror;;), RF_VOID)
  RF_ERROR ((_ve_fname + _ve_rror));
RF_END

RF_FUNC (Not_m_Available, (RF_ARG _ve_name;;), RF_VOID)
  Expr _ge_auxcall1;
  RF_CALL (List::Intersperse, (_c_0, _ve_name), _ge_auxcall1);
  Expr _gs_auxcall2;
  RF_CALL (Convert::To_m_Word, _ge_auxcall1, _gs_auxcall2);
  RF_ERROR ((_gs_auxcall2 + _c_1));
RF_END

}

namespace Error
{

static void init_ ()
{
  _c_0 = Char::create_expr (L".");
  _c_1 = Expr::create<Word>("Not available");
}

static AtStart init_registrator_ (&init_);

}

}
