#include <rf_core.hh>
#include "../Stream/IndexedStream.hh"
#include "Lexer.hh"
#include "../Stream/StreamErr.hh"
#include <refal/Box.hh>
#include <refal/Convert.hh>
#include <refal/Compare.hh>
#include <refal/Class.hh>
#include <refal/Arithm.hh>
#include "../Stream/Stream.hh"

namespace refal
{

using namespace rfrt;

namespace Lexer
{

Expr Case_m_Insensitive;

static Expr Collect_m_Errors_m_Box;

RF_DECL (Blank_q_);

RF_DECL (Var_m_Sym_q_);

RF_DECL (Uppercase_m_Letter_q_);

RF_DECL (Fun_m_Sym_q_);

RF_DECL (Scan_m_String_m_Rest);

static Expr Parenth_m_Level;

RF_DECL (Read_m_Term_m_Aux);

}

namespace Class
{

RF_DECL (Digit_q___0);

}

namespace Lexer
{

RF_DECL (Blank_q___0);

RF_DECL (Var_m_Sym_q___0);

RF_DECL (Fun_m_Sym_q___0);

}

namespace Class
{

RF_DECL (Letter_q___0);

}

namespace Lexer
{

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_28;

static Expr _c_26;

static Expr _c_27;

static Expr _c_29;

static Expr _c_30;

static Expr _c_31;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

static Expr _c_36;

static Expr _c_37;

static Expr _c_38;

static Expr _c_39;

static Expr _c_42;

static Expr _c_40;

static Expr _c_41;

static Expr _c_43;

static Expr _c_44;

static Expr _c_45;

static Expr _c_46;

static Expr _c_47;

static Expr _c_48;

static Expr _c_49;

static Expr _c_50;

static Expr _c_51;

static Expr _c_52;

static Expr _c_53;

static Expr _c_54;

static Expr _c_55;

static Expr _c_56;

static Expr _c_57;

static Expr _c_58;

static Expr _c_59;

static Expr _c_60;

static Expr _c_61;

static Expr _c_62;

static Expr _c_63;

static Expr _c_64;

static Expr _c_65;

static Expr _c_66;

static Expr _c_67;

static Expr _c_68;

static Expr _c_69;

static Expr _c_70;

static Expr _c_71;

static Expr _c_72;

static Expr _c_73;

static Expr _c_74;

static Expr _c_75;

static Expr _c_76;

static Expr _c_77;

static Expr _c_78;

static Expr _c_79;

static Expr _c_80;

static Expr _c_81;

static Expr _c_82;

static Expr _c_83;

static Expr _c_84;

static Expr _c_85;

RF_FUNC (Start_m_Collect_m_Errors, RF_VOID, RF_VOID)
  Expr _v__q_1;
  RF_CALL (Box::_q_, Collect_m_Errors_m_Box, _v__q_1);
  if ((_v__q_1.get_len () != 1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v__q_1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_num (_v__q_1, 0, 1);
  Expr _v__p_1;
  RF_CALL (Arithm::_p_, (_vs_num, _c_0), _v__p_1);
  RF_TAILCALL (Box::Store, (Collect_m_Errors_m_Box, _v__p_1), /*void*/);
RF_END

RF_FUNC (Stop_m_Collect_m_Errors, RF_VOID, RF_VOID)
  Expr _v__q_1;
  RF_CALL (Box::_q_, Collect_m_Errors_m_Box, _v__q_1);
  {
    {
      if ((_v__q_1.get_len () != 1))
      {
        goto _block1__branch1;
      }
      if (!_c_1.term_eq (_v__q_1, 0))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    if ((_v__q_1.get_len () != 1))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (!_v__q_1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_num (_v__q_1, 0, 1);
    Expr _v__m_1;
    RF_CALL (Arithm::_m_, (_vs_num, _c_0), _v__m_1);
    RF_TAILCALL (Box::Store, (Collect_m_Errors_m_Box, _v__m_1), /*void*/);
  }
_block1: {}
RF_END

RF_FUNC (Collecting_m_Errors_q_, RF_VOID, RF_VOID)
  {
    Expr _v__q_1;
    RF_CALL (Box::_q_, Collect_m_Errors_m_Box, _v__q_1);
    if ((_v__q_1.get_len () != 1))
    {
      goto _negation1;
    }
    if (!_c_1.term_eq (_v__q_1, 0))
    {
      goto _negation1;
    }
    RF_RETFAIL;
  }
_negation1: {}
RF_END

RF_FUNC (Blank_q_, (RF_ARG _v_arg1;;), RF_VOID)
  {
    {
      if (!_v_arg1.term_eq (_c_2, 0))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_v_arg1.term_eq (_c_3, 0))
      {
        goto _block1__branch2;
      }
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_v_arg1.term_eq (_c_4, 0))
      {
        goto _block1__branch3;
      }
      goto _block1;
    }
  _block1__branch3: {}
    if (!_v_arg1.term_eq (_c_5, 0))
    {
      RF_RETFAIL;
    }
  }
_block1: {}
RF_END

RF_FUNC (Skip_m_Blank_q_, (RF_ARG _vs_tream;;), RF_VOID)
  Expr _v_Get_m_While1;
  RF_CALL (Stream::Get_m_While, (_vs_tream, _c_6), _v_Get_m_While1);
  uintptr_t _v_len1 = _v_Get_m_While1.get_len ();
  uintptr_t _v_len2 = 0;
  if ((_v_len1 < (_v_len2 + 1)))
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len___e__e_tmp_m_Lexerrf_m_40_m_52 = (_v_len1 - _v_len2);
  Expr _vv__e__e_tmp_m_Lexerrf_m_40_m_52 (_v_Get_m_While1, 0, _v_len___e__e_tmp_m_Lexerrf_m_40_m_52);
RF_END

RF_FUNC (Skip_m_Comment_q_, (RF_ARG _vs_tream;;), RF_VOID)
  {
    {
      {
        if (!RF_CALL (Collecting_m_Errors_q_, /*void*/, /*void*/))
        {
          goto _negation1;
        }
        goto _block1__branch1;
      }
    _negation1: {}
      RF_CALL (StreamErr::Clear_m_Errors, /*void*/, /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
  }
_block1: {}
  Expr _v_Getc1;
  if (!RF_CALL (Stream::Getc, _vs_tream, _v_Getc1))
  {
    RF_RETFAIL;
  }
  {
    {
      if (!_v_Getc1.term_eq (_c_7, 0))
      {
        goto _block2__branch1;
      }
      Expr _v_Get_m_Line1;
      RF_CALL (Stream::Get_m_Line, _vs_tream, _v_Get_m_Line1);
      uintptr_t _v_len1 = _v_Get_m_Line1.get_len ();
      uintptr_t _v_len2 = 0;
      if ((_v_len1 < _v_len2))
      {
        RF_RETFAIL;
      }
      uintptr_t _v_len___e__e_tmp_m_Lexerrf_m_46_m_32 = (_v_len1 - _v_len2);
      Expr _ve__e__e_tmp_m_Lexerrf_m_46_m_32 (_v_Get_m_Line1, 0, _v_len___e__e_tmp_m_Lexerrf_m_46_m_32);
      goto _block2;
    }
  _block2__branch1: {}
    {
      if (!_v_Getc1.term_eq (_c_8, 0))
      {
        goto _block2__branch2;
      }
      Expr _vt_pos;
      RF_CALL (IndexedStream::Current_m_Pos, _vs_tream, _vt_pos);
      {
        {
          Expr _v_Getc2;
          if (!RF_CALL (Stream::Getc, _vs_tream, _v_Getc2))
          {
            goto _block3__branch1;
          }
          {
            {
              if (!_v_Getc2.term_eq (_c_8, 0))
              {
                goto _block4__branch1;
              }
              Expr _v_Get_m_Line2;
              RF_CALL (Stream::Get_m_Line, _vs_tream, _v_Get_m_Line2);
              uintptr_t _v_len3 = _v_Get_m_Line2.get_len ();
              uintptr_t _v_len4 = 0;
              if ((_v_len3 < _v_len4))
              {
                RF_RETFAIL;
              }
              uintptr_t _v_len___e__e_tmp_m_Lexerrf_m_51_m_38 = (_v_len3 - _v_len4);
              Expr _ve__e__e_tmp_m_Lexerrf_m_51_m_38 (_v_Get_m_Line2, 0, _v_len___e__e_tmp_m_Lexerrf_m_51_m_38);
              goto _block4;
            }
          _block4__branch1: {}
            {
              if (!_v_Getc2.term_eq (_c_7, 0))
              {
                goto _block4__branch2;
              }
              Expr _ve_stop_q_ (empty);
              for ( ; ; )
              {
                {
                  if ((_ve_stop_q_.get_len () != 1))
                  {
                    goto _iter1;
                  }
                  if (!_c_9.term_eq (_ve_stop_q_, 0))
                  {
                    goto _iter1;
                  }
                  goto _exit__iter1;
                }
              _iter1: {}
                {
                  {
                    Expr _v_Get_m_Delim1;
                    RF_CALL (Stream::Get_m_Delim, (_vs_tream, _c_7), _v_Get_m_Delim1);
                    uintptr_t _v_len5 = _v_Get_m_Delim1.get_len ();
                    uintptr_t _v_len6 = 0;
                    if ((_v_len5 < (_v_len6 + 1)))
                    {
                      goto _block5__branch1;
                    }
                    uintptr_t _v_len___e__e_tmp_m_Lexerrf_m_54_m_41 = (_v_len5 - _v_len6);
                    Expr _vv__e__e_tmp_m_Lexerrf_m_54_m_41 (_v_Get_m_Delim1, 0, _v_len___e__e_tmp_m_Lexerrf_m_54_m_41);
                    {
                      {
                        Expr _v_Getc3;
                        if (!RF_CALL (Stream::Getc, _vs_tream, _v_Getc3))
                        {
                          goto _block6__branch1;
                        }
                        {
                          {
                            if (!_v_Getc3.term_eq (_c_8, 0))
                            {
                              goto _block7__branch1;
                            }
                            _ve_stop_q_ = _c_9;
                            goto _block7;
                          }
                        _block7__branch1: {}
                          Expr _vt__e__e_tmp_m_Lexerrf_m_57_m_20 (_v_Getc3, 0, 1);
                          _ve_stop_q_ = empty;
                        }
                      _block7: {}
                        goto _block6;
                      }
                    _block6__branch1: {}
                      RF_CALL (StreamErr::Error_m_At, (_vt_pos, _c_10), /*void*/);
                      _ve_stop_q_ = _c_9;
                    }
                  _block6: {}
                    goto _block5;
                  }
                _block5__branch1: {}
                  RF_CALL (StreamErr::Error_m_At, (_vt_pos, _c_10), /*void*/);
                  _ve_stop_q_ = _c_9;
                }
              _block5: {}
              }
            _exit__iter1: {}
              goto _block4;
            }
          _block4__branch2: {}
            Expr _vt_1 (_v_Getc2, 0, 1);
            RF_CALL (StreamErr::Error, (_vs_tream, (_c_12 + _vt_1 + _c_11)), /*void*/);
            RF_RETFAIL;
          }
        _block4: {}
          goto _block3;
        }
      _block3__branch1: {}
        RF_CALL (StreamErr::Error_m_At, (_vt_pos, _c_13), /*void*/);
        RF_RETFAIL;
      }
    _block3: {}
      goto _block2;
    }
  _block2__branch2: {}
    Expr _vt_1 (_v_Getc1, 0, 1);
    RF_CALL (Stream::Ungets, (_vs_tream, _vt_1), /*void*/);
    RF_RETFAIL;
  }
_block2: {}
RF_END

RF_FUNC (Scan_m_Keyword_q_, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  Expr _v_Getc1;
  if (!RF_CALL (Stream::Getc, _vs_tream, _v_Getc1))
  {
    RF_RETFAIL;
  }
  {
    {
      if (!_v_Getc1.term_eq (_c_14, 0))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    Expr _vt_1 (_v_Getc1, 0, 1);
    RF_CALL (Stream::Ungets, (_vs_tream, _vt_1), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
  Expr _ve_ident;
  RF_CALL (Stream::Get_m_While, (_vs_tream, _c_15), _ve_ident);
  Expr _v_auxblock1;
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, Case_m_Insensitive, _v__q_1);
      if ((_v__q_1.get_len () != 1))
      {
        goto _block2__branch1;
      }
      if (!_c_0.term_eq (_v__q_1, 0))
      {
        goto _block2__branch1;
      }
      RF_CALL (Convert::To_m_Lower, _ve_ident, _v_auxblock1);
      goto _block2;
    }
  _block2__branch1: {}
    _v_auxblock1 = _ve_ident;
  }
_block2: {}
  {
    {
      if ((_v_auxblock1.get_len () != 3))
      {
        goto _block3__branch1;
      }
      if (!_c_16.eq (_v_auxblock1, 0))
      {
        goto _block3__branch1;
      }
      _v_res1 = _c_17;
      goto _block3;
    }
  _block3__branch1: {}
    {
      if ((_v_auxblock1.get_len () != 7))
      {
        goto _block3__branch2;
      }
      if (!_c_18.eq (_v_auxblock1, 0))
      {
        goto _block3__branch2;
      }
      _v_res1 = _c_19;
      goto _block3;
    }
  _block3__branch2: {}
    {
      if ((_v_auxblock1.get_len () != 5))
      {
        goto _block3__branch3;
      }
      if (!_c_20.eq (_v_auxblock1, 0))
      {
        goto _block3__branch3;
      }
      _v_res1 = _c_21;
      goto _block3;
    }
  _block3__branch3: {}
    {
      if ((_v_auxblock1.get_len () != 5))
      {
        goto _block3__branch4;
      }
      if (!_c_22.eq (_v_auxblock1, 0))
      {
        goto _block3__branch4;
      }
      _v_res1 = _c_23;
      goto _block3;
    }
  _block3__branch4: {}
    {
      if ((_v_auxblock1.get_len () != 4))
      {
        goto _block3__branch5;
      }
      if (!_c_24.eq (_v_auxblock1, 0))
      {
        goto _block3__branch5;
      }
      _v_res1 = _c_25;
      goto _block3;
    }
  _block3__branch5: {}
    {
      if ((_v_auxblock1.get_len () != 4))
      {
        goto _block3__branch6;
      }
      if (!_c_26.eq (_v_auxblock1, 0))
      {
        goto _block3__branch6;
      }
      _v_res1 = _c_27;
      goto _block3;
    }
  _block3__branch6: {}
    {
      if ((_v_auxblock1.get_len () != 5))
      {
        goto _block3__branch7;
      }
      if (!_c_28.eq (_v_auxblock1, 0))
      {
        goto _block3__branch7;
      }
      _v_res1 = _c_29;
      goto _block3;
    }
  _block3__branch7: {}
    {
      if ((_v_auxblock1.get_len () != 4))
      {
        goto _block3__branch8;
      }
      if (!_c_30.eq (_v_auxblock1, 0))
      {
        goto _block3__branch8;
      }
      _v_res1 = _c_31;
      goto _block3;
    }
  _block3__branch8: {}
    {
      if ((_v_auxblock1.get_len () != 1))
      {
        goto _block3__branch9;
      }
      if (!_c_32.term_eq (_v_auxblock1, 0))
      {
        goto _block3__branch9;
      }
      _v_res1 = _c_33;
      goto _block3;
    }
  _block3__branch9: {}
    {
      if ((_v_auxblock1.get_len () != 1))
      {
        goto _block3__branch10;
      }
      if (!_c_34.term_eq (_v_auxblock1, 0))
      {
        goto _block3__branch10;
      }
      _v_res1 = _c_35;
      goto _block3;
    }
  _block3__branch10: {}
    {
      if ((_v_auxblock1.get_len () != 6))
      {
        goto _block3__branch11;
      }
      if (!_c_36.eq (_v_auxblock1, 0))
      {
        goto _block3__branch11;
      }
      _v_res1 = _c_37;
      goto _block3;
    }
  _block3__branch11: {}
    {
      if ((_v_auxblock1.get_len () != 5))
      {
        goto _block3__branch12;
      }
      if (!_c_38.eq (_v_auxblock1, 0))
      {
        goto _block3__branch12;
      }
      _v_res1 = _c_39;
      goto _block3;
    }
  _block3__branch12: {}
    {
      if ((_v_auxblock1.get_len () != 5))
      {
        goto _block3__branch13;
      }
      if (!_c_40.eq (_v_auxblock1, 0))
      {
        goto _block3__branch13;
      }
      _v_res1 = _c_41;
      goto _block3;
    }
  _block3__branch13: {}
    {
      if ((_v_auxblock1.get_len () != 8))
      {
        goto _block3__branch14;
      }
      if (!_c_42.eq (_v_auxblock1, 0))
      {
        goto _block3__branch14;
      }
      _v_res1 = _c_43;
      goto _block3;
    }
  _block3__branch14: {}
    {
      if ((_v_auxblock1.get_len () != 4))
      {
        goto _block3__branch15;
      }
      if (!_c_44.eq (_v_auxblock1, 0))
      {
        goto _block3__branch15;
      }
      _v_res1 = _c_45;
      goto _block3;
    }
  _block3__branch15: {}
    {
      if ((_v_auxblock1.get_len () != 3))
      {
        goto _block3__branch16;
      }
      if (!_c_46.eq (_v_auxblock1, 0))
      {
        goto _block3__branch16;
      }
      _v_res1 = _c_47;
      goto _block3;
    }
  _block3__branch16: {}
    {
      if ((_v_auxblock1.get_len () != 6))
      {
        goto _block3__branch17;
      }
      if (!_c_48.eq (_v_auxblock1, 0))
      {
        goto _block3__branch17;
      }
      _v_res1 = _c_49;
      goto _block3;
    }
  _block3__branch17: {}
    {
      if ((_v_auxblock1.get_len () != 4))
      {
        goto _block3__branch18;
      }
      if (!_c_50.eq (_v_auxblock1, 0))
      {
        goto _block3__branch18;
      }
      _v_res1 = _c_51;
      goto _block3;
    }
  _block3__branch18: {}
    uintptr_t _v_len1 = _v_auxblock1.get_len ();
    uintptr_t _v_len2 = 0;
    if ((_v_len1 < _v_len2))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__1 = (_v_len1 - _v_len2);
    Expr _ve_1 (_v_auxblock1, 0, _v_len__1);
    RF_CALL (Stream::Ungets, (_vs_tream, (_c_14 + _ve_1)), /*void*/);
    RF_RETFAIL;
  }
_block3: {}
RF_END

RF_FUNC (Scan_m_Number_q_, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  Expr _v_Getc1;
  if (!RF_CALL (Stream::Getc, _vs_tream, _v_Getc1))
  {
    RF_RETFAIL;
  }
  if (!_v_Getc1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_first (_v_Getc1, 0, 1);
  {
    {
      if (!RF_CALL (Class::Digit_q_, _vs_first, /*void*/))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    {
      {
        {
          if (!_vs_first.term_eq (_c_52, 0))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        if (!_vs_first.term_eq (_c_53, 0))
        {
          goto _block1__branch2;
        }
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch2: {}
    RF_CALL (Stream::Ungets, (_vs_tream, _vs_first), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
  Expr _v_Get_m_While1;
  RF_CALL (Stream::Get_m_While, (_vs_tream, _c_54), _v_Get_m_While1);
  _v_res1 = (_c_55 + _vs_first + _v_Get_m_While1);
RF_END

RF_FUNC (Scan_m_Variable_q_, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  Expr _v_Getc1;
  if (!RF_CALL (Stream::Getc, _vs_tream, _v_Getc1))
  {
    RF_RETFAIL;
  }
  Expr _vs_type;
  {
    {
      if (!_v_Getc1.term_eq (_c_56, 0))
      {
        goto _block1__branch1;
      }
      _vs_type = _c_57;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_v_Getc1.term_eq (_c_58, 0))
      {
        goto _block1__branch2;
      }
      _vs_type = _c_59;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_v_Getc1.term_eq (_c_60, 0))
      {
        goto _block1__branch3;
      }
      _vs_type = _c_61;
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (!_v_Getc1.term_eq (_c_62, 0))
      {
        goto _block1__branch4;
      }
      _vs_type = _c_63;
      goto _block1;
    }
  _block1__branch4: {}
    Expr _vt_1 (_v_Getc1, 0, 1);
    RF_CALL (Stream::Ungets, (_vs_tream, _vt_1), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
  Expr _v_Getc2;
  if (!RF_CALL (Stream::Getc, _vs_tream, _v_Getc2))
  {
    RF_RETFAIL;
  }
  Expr _ve_name;
  {
    {
      if (!_v_Getc2.term_eq (_c_64, 0))
      {
        goto _block2__branch1;
      }
      RF_CALL (Stream::Get_m_While, (_vs_tream, _c_65), _ve_name);
      goto _block2;
    }
  _block2__branch1: {}
    {
      if (!_v_Getc2.symbol_at (0))
      {
        goto _block2__branch2;
      }
      Expr _vs_1 (_v_Getc2, 0, 1);
      if (!RF_CALL (Var_m_Sym_q_, _vs_1, /*void*/))
      {
        goto _block2__branch2;
      }
      Expr _v_Get_m_While1;
      RF_CALL (Stream::Get_m_While, (_vs_tream, _c_65), _v_Get_m_While1);
      _ve_name = (_vs_1 + _v_Get_m_While1);
      goto _block2;
    }
  _block2__branch2: {}
    Expr _vt_1 (_v_Getc2, 0, 1);
    RF_CALL (Stream::Ungets, (_vs_tream, _vt_1), /*void*/);
    _ve_name = empty;
  }
_block2: {}
  _v_res1 = (_vs_type + _ve_name);
RF_END

RF_FUNC (Var_m_Sym_q_, (RF_ARG _v_arg1;;), RF_VOID)
  if (!_v_arg1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_ym (_v_arg1, 0, 1);
  {
    {
      if (!RF_CALL (Class::Letter_q_, _vs_ym, /*void*/))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!RF_CALL (Class::Digit_q_, _vs_ym, /*void*/))
      {
        goto _block1__branch2;
      }
      goto _block1;
    }
  _block1__branch2: {}
    if (!_vs_ym.term_eq (_c_53, 0))
    {
      RF_RETFAIL;
    }
  }
_block1: {}
RF_END

RF_FUNC (Scan_m_Identifier_q_, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  Expr _v_Getc1;
  if (!RF_CALL (Stream::Getc, _vs_tream, _v_Getc1))
  {
    RF_RETFAIL;
  }
  if (!_v_Getc1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_first (_v_Getc1, 0, 1);
  {
    {
      if (!RF_CALL (Uppercase_m_Letter_q_, _vs_first, /*void*/))
      {
        goto _block1__branch1;
      }
      Expr _v_Get_m_While1;
      RF_CALL (Stream::Get_m_While, (_vs_tream, _c_66), _v_Get_m_While1);
      _v_res1 = (_c_67 + _vs_first + _v_Get_m_While1);
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Stream::Ungets, (_vs_tream, _vs_first), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
RF_END

RF_FUNC (Uppercase_m_Letter_q_, (RF_ARG _vs_letter;;), RF_VOID)
  if (!RF_CALL (Class::Letter_q_, _vs_letter, /*void*/))
  {
    RF_RETFAIL;
  }
  Expr _v_To_m_Upper1;
  RF_CALL (Convert::To_m_Upper, _vs_letter, _v_To_m_Upper1);
  RF_TAILCALL (Compare::_eq_, (_v_To_m_Upper1, _vs_letter), /*void*/);
RF_END

RF_FUNC (Fun_m_Sym_q_, (RF_ARG _v_arg1;;), RF_VOID)
  if (!_v_arg1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_ym (_v_arg1, 0, 1);
  {
    {
      if (!RF_CALL (Class::Letter_q_, _vs_ym, /*void*/))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!RF_CALL (Class::Digit_q_, _vs_ym, /*void*/))
      {
        goto _block1__branch2;
      }
      goto _block1;
    }
  _block1__branch2: {}
    {
      {
        if (!_vs_ym.term_eq (_c_53, 0))
        {
          goto _block2__branch1;
        }
        goto _block2;
      }
    _block2__branch1: {}
      if (!_vs_ym.term_eq (_c_64, 0))
      {
        RF_RETFAIL;
      }
    }
  _block2: {}
  }
_block1: {}
RF_END

RF_FUNC (Scan_m_Quoted_m_Word_q_, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  {
    {
      {
        if (!RF_CALL (Collecting_m_Errors_q_, /*void*/, /*void*/))
        {
          goto _negation1;
        }
        goto _block1__branch1;
      }
    _negation1: {}
      RF_CALL (StreamErr::Clear_m_Errors, /*void*/, /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
  }
_block1: {}
  Expr _vt_pos;
  RF_CALL (IndexedStream::Current_m_Pos, _vs_tream, _vt_pos);
  Expr _v_Getc1;
  if (!RF_CALL (Stream::Getc, _vs_tream, _v_Getc1))
  {
    RF_RETFAIL;
  }
  {
    {
      if (!_v_Getc1.term_eq (_c_68, 0))
      {
        goto _block2__branch1;
      }
      Expr _v_Scan_m_String_m_Rest1;
      RF_CALL (Scan_m_String_m_Rest, (_vt_pos, _c_69, _c_68, _vs_tream), _v_Scan_m_String_m_Rest1);
      _v_res1 = (_c_70 + _v_Scan_m_String_m_Rest1);
      goto _block2;
    }
  _block2__branch1: {}
    Expr _vt_1 (_v_Getc1, 0, 1);
    RF_CALL (Stream::Ungets, (_vs_tream, _vt_1), /*void*/);
    RF_RETFAIL;
  }
_block2: {}
RF_END

RF_FUNC (Scan_m_String_q_, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  {
    {
      {
        if (!RF_CALL (Collecting_m_Errors_q_, /*void*/, /*void*/))
        {
          goto _negation1;
        }
        goto _block1__branch1;
      }
    _negation1: {}
      RF_CALL (StreamErr::Clear_m_Errors, /*void*/, /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
  }
_block1: {}
  Expr _vt_pos;
  RF_CALL (IndexedStream::Current_m_Pos, _vs_tream, _vt_pos);
  Expr _v_Getc1;
  if (!RF_CALL (Stream::Getc, _vs_tream, _v_Getc1))
  {
    RF_RETFAIL;
  }
  {
    {
      if (!_v_Getc1.term_eq (_c_71, 0))
      {
        goto _block2__branch1;
      }
      Expr _v_Scan_m_String_m_Rest1;
      RF_CALL (Scan_m_String_m_Rest, (_vt_pos, _c_69, _c_71, _vs_tream), _v_Scan_m_String_m_Rest1);
      _v_res1 = (_c_72 + _v_Scan_m_String_m_Rest1);
      goto _block2;
    }
  _block2__branch1: {}
    Expr _vt_1 (_v_Getc1, 0, 1);
    RF_CALL (Stream::Ungets, (_vs_tream, _vt_1), /*void*/);
    RF_RETFAIL;
  }
_block2: {}
RF_END

RF_FUNC (Scan_m_Char_q_, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  {
    {
      {
        if (!RF_CALL (Collecting_m_Errors_q_, /*void*/, /*void*/))
        {
          goto _negation1;
        }
        goto _block1__branch1;
      }
    _negation1: {}
      RF_CALL (StreamErr::Clear_m_Errors, /*void*/, /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
  }
_block1: {}
  Expr _vt_pos;
  RF_CALL (IndexedStream::Current_m_Pos, _vs_tream, _vt_pos);
  Expr _v_Getc1;
  if (!RF_CALL (Stream::Getc, _vs_tream, _v_Getc1))
  {
    RF_RETFAIL;
  }
  {
    {
      if (!_v_Getc1.term_eq (_c_71, 0))
      {
        goto _block2__branch1;
      }
      Expr _v_Scan_m_String_m_Rest1;
      RF_CALL (Scan_m_String_m_Rest, (_vt_pos, _c_0, _c_71, _vs_tream), _v_Scan_m_String_m_Rest1);
      {
        {
          uintptr_t _v_len1 = _v_Scan_m_String_m_Rest1.get_len ();
          uintptr_t _v_len2 = 0;
          if ((_v_len1 < (_v_len2 + 1)))
          {
            goto _block3__branch1;
          }
          uintptr_t _v_len__str = (_v_len1 - _v_len2);
          Expr _vv_str (_v_Scan_m_String_m_Rest1, 0, _v_len__str);
          RF_CALL (Stream::Ungets, (_vs_tream, _c_71), /*void*/);
          _v_res1 = (_c_72 + _vv_str);
          goto _block3;
        }
      _block3__branch1: {}
        uintptr_t _v_len3 = _v_Scan_m_String_m_Rest1.get_len ();
        uintptr_t _v_len4 = 0;
        if ((_v_len3 < _v_len4))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len__mpty = (_v_len3 - _v_len4);
        Expr _ve_mpty (_v_Scan_m_String_m_Rest1, 0, _v_len__mpty);
        _v_res1 = _c_72;
      }
    _block3: {}
      goto _block2;
    }
  _block2__branch1: {}
    Expr _vt_1 (_v_Getc1, 0, 1);
    RF_CALL (Stream::Ungets, (_vs_tream, _vt_1), /*void*/);
    RF_RETFAIL;
  }
_block2: {}
RF_END

RF_FUNC (Scan_m_String_m_Rest, (RF_ARG _vt_pos, _vs_max, _vs_term, _vs_tream;;), (RF_RES _v_res1;;))
  Expr _ve_s (empty);
  Expr _v_max__1 (_vs_max);
  for ( ; ; )
  {
    {
      if (!_v_max__1.term_eq (_c_1, 0))
      {
        goto _iter1;
      }
      _v_res1 = _ve_s;
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        Expr _v_Getc1;
        if (!RF_CALL (Stream::Getc, _vs_tream, _v_Getc1))
        {
          goto _block1__branch1;
        }
        {
          {
            if (!_vs_term.term_eq (_v_Getc1, 0))
            {
              goto _block2__branch1;
            }
            _v_max__1 = _c_1;
            goto _block2;
          }
        _block2__branch1: {}
          {
            if (!_v_Getc1.term_eq (_c_73, 0))
            {
              goto _block2__branch2;
            }
            {
              {
                Expr _v_Getc2;
                if (!RF_CALL (Stream::Getc, _vs_tream, _v_Getc2))
                {
                  goto _block3__branch1;
                }
                {
                  {
                    if (!_v_Getc2.term_eq (_c_74, 0))
                    {
                      goto _block4__branch1;
                    }
                    RF_CALL (Arithm::_m_, (_v_max__1, _c_0), _v_max__1);
                    _ve_s = (_ve_s + _c_4);
                    goto _block4;
                  }
                _block4__branch1: {}
                  {
                    if (!_v_Getc2.term_eq (_c_62, 0))
                    {
                      goto _block4__branch2;
                    }
                    RF_CALL (Arithm::_m_, (_v_max__1, _c_0), _v_max__1);
                    _ve_s = (_ve_s + _c_3);
                    goto _block4;
                  }
                _block4__branch2: {}
                  {
                    if (!_v_Getc2.term_eq (_c_60, 0))
                    {
                      goto _block4__branch3;
                    }
                    RF_CALL (Arithm::_m_, (_v_max__1, _c_0), _v_max__1);
                    _ve_s = (_ve_s + _c_60);
                    goto _block4;
                  }
                _block4__branch3: {}
                  {
                    if (!_v_Getc2.term_eq (_c_75, 0))
                    {
                      goto _block4__branch4;
                    }
                    RF_CALL (Arithm::_m_, (_v_max__1, _c_0), _v_max__1);
                    _ve_s = (_ve_s + _c_75);
                    goto _block4;
                  }
                _block4__branch4: {}
                  {
                    if (!_v_Getc2.term_eq (_c_34, 0))
                    {
                      goto _block4__branch5;
                    }
                    RF_CALL (Arithm::_m_, (_v_max__1, _c_0), _v_max__1);
                    _ve_s = (_ve_s + _c_5);
                    goto _block4;
                  }
                _block4__branch5: {}
                  {
                    if (!_v_Getc2.term_eq (_c_76, 0))
                    {
                      goto _block4__branch6;
                    }
                    RF_CALL (Arithm::_m_, (_v_max__1, _c_0), _v_max__1);
                    _ve_s = (_ve_s + _c_76);
                    goto _block4;
                  }
                _block4__branch6: {}
                  {
                    if (!_v_Getc2.term_eq (_c_73, 0))
                    {
                      goto _block4__branch7;
                    }
                    RF_CALL (Arithm::_m_, (_v_max__1, _c_0), _v_max__1);
                    _ve_s = (_ve_s + _c_73);
                    goto _block4;
                  }
                _block4__branch7: {}
                  {
                    if (!_v_Getc2.term_eq (_c_71, 0))
                    {
                      goto _block4__branch8;
                    }
                    RF_CALL (Arithm::_m_, (_v_max__1, _c_0), _v_max__1);
                    _ve_s = (_ve_s + _c_71);
                    goto _block4;
                  }
                _block4__branch8: {}
                  {
                    if (!_v_Getc2.term_eq (_c_68, 0))
                    {
                      goto _block4__branch9;
                    }
                    RF_CALL (Arithm::_m_, (_v_max__1, _c_0), _v_max__1);
                    _ve_s = (_ve_s + _c_68);
                    goto _block4;
                  }
                _block4__branch9: {}
                  {
                    if (!_v_Getc2.term_eq (_c_4, 0))
                    {
                      goto _block4__branch10;
                    }
                    goto _block4;
                  }
                _block4__branch10: {}
                  {
                    if (!_v_Getc2.symbol_at (0))
                    {
                      goto _block4__branch11;
                    }
                    Expr _vs_1 (_v_Getc2, 0, 1);
                    RF_CALL (StreamErr::Error, (_vs_tream, (_c_77 + _vs_1 + _c_11)), /*void*/);
                    RF_CALL (Arithm::_m_, (_v_max__1, _c_0), _v_max__1);
                    _ve_s = (_ve_s + _vs_1);
                    goto _block4;
                  }
                _block4__branch11: {}
                  Expr _vt_1 (_v_Getc2, 0, 1);
                  RF_CALL (StreamErr::Error, (_vs_tream, (_c_78 + _vt_1 + _c_11)), /*void*/);
                }
              _block4: {}
                goto _block3;
              }
            _block3__branch1: {}
              RF_CALL (StreamErr::Error_m_At, (_vt_pos, _c_79), /*void*/);
              _v_max__1 = _c_1;
            }
          _block3: {}
            goto _block2;
          }
        _block2__branch2: {}
          {
            if (!_v_Getc1.term_eq (_c_4, 0))
            {
              goto _block2__branch3;
            }
            RF_CALL (Arithm::_m_, (_v_max__1, _c_0), _v_max__1);
            _ve_s = (_ve_s + _c_4);
            goto _block2;
          }
        _block2__branch3: {}
          {
            if (!_v_Getc1.symbol_at (0))
            {
              goto _block2__branch4;
            }
            Expr _vs_1 (_v_Getc1, 0, 1);
            RF_CALL (Arithm::_m_, (_v_max__1, _c_0), _v_max__1);
            _ve_s = (_ve_s + _vs_1);
            goto _block2;
          }
        _block2__branch4: {}
          Expr _vt_1 (_v_Getc1, 0, 1);
          RF_CALL (StreamErr::Error, (_vs_tream, (_c_12 + _vt_1 + _c_11)), /*void*/);
        }
      _block2: {}
        goto _block1;
      }
    _block1__branch1: {}
      RF_CALL (StreamErr::Error_m_At, (_vt_pos, _c_79), /*void*/);
      _v_max__1 = _c_1;
    }
  _block1: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Read_m_Term_q_, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  RF_CALL (Start_m_Collect_m_Errors, /*void*/, /*void*/);
  RF_CALL (Box::Store, (Parenth_m_Level, _c_1), /*void*/);
  {
    {
      Expr _vt_erm;
      if (!RF_CALL (Read_m_Term_m_Aux, _vs_tream, _vt_erm))
      {
        goto _block1__branch1;
      }
      RF_CALL (Stop_m_Collect_m_Errors, /*void*/, /*void*/);
      _v_res1 = _vt_erm;
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Stop_m_Collect_m_Errors, /*void*/, /*void*/);
    RF_RETFAIL;
  }
_block1: {}
RF_END

RF_FUNC (Read_m_Term_m_Aux, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  Expr _ve_stop_q_ (empty);
  for ( ; ; )
  {
    {
      if ((_ve_stop_q_.get_len () != 1))
      {
        goto _iter1;
      }
      if (!_c_9.term_eq (_ve_stop_q_, 0))
      {
        goto _iter1;
      }
      {
        {
          Expr _vt_pos;
          RF_CALL (IndexedStream::Current_m_Pos, _vs_tream, _vt_pos);
          Expr _v_Getc1;
          if (!RF_CALL (Stream::Getc, _vs_tream, _v_Getc1))
          {
            goto _block1__branch1;
          }
          {
            {
              if (!_v_Getc1.term_eq (_c_80, 0))
              {
                goto _block2__branch1;
              }
              Expr _v__q_1;
              RF_CALL (Box::_q_, Parenth_m_Level, _v__q_1);
              if ((_v__q_1.get_len () != 1))
              {
                RF_RETFAIL;
              }
              if (!_v__q_1.symbol_at (0))
              {
                RF_RETFAIL;
              }
              Expr _vs_level (_v__q_1, 0, 1);
              Expr _v__p_1;
              RF_CALL (Arithm::_p_, (_vs_level, _c_0), _v__p_1);
              RF_CALL (Box::Store, (Parenth_m_Level, _v__p_1), /*void*/);
              Expr _ve_terms (empty);
              Expr _ve_last (empty);
              for ( ; ; )
              {
                {
                  Expr _v__q_2;
                  RF_CALL (Box::_q_, Parenth_m_Level, _v__q_2);
                  if ((_v__q_2.get_len () != 1))
                  {
                    goto _iter2;
                  }
                  if (!_vs_level.term_eq (_v__q_2, 0))
                  {
                    goto _iter2;
                  }
                  _v_res1 = _ve_terms ();
                  goto _exit__iter2;
                }
              _iter2: {}
                {
                  {
                    Expr _v_Read_m_Term_m_Aux1;
                    if (!RF_CALL (Read_m_Term_m_Aux, _vs_tream, _v_Read_m_Term_m_Aux1))
                    {
                      goto _block3__branch1;
                    }
                    _ve_terms = (_ve_terms + _ve_last);
                    _ve_last = _v_Read_m_Term_m_Aux1;
                    goto _block3;
                  }
                _block3__branch1: {}
                  RF_CALL (StreamErr::Error_m_At, (_vt_pos, _c_81), /*void*/);
                  RF_RETFAIL;
                }
              _block3: {}
              }
            _exit__iter2: {}
              goto _block2;
            }
          _block2__branch1: {}
            {
              if (!_v_Getc1.term_eq (_c_82, 0))
              {
                goto _block2__branch2;
              }
              Expr _v__q_3;
              RF_CALL (Box::_q_, Parenth_m_Level, _v__q_3);
              if ((_v__q_3.get_len () != 1))
              {
                RF_RETFAIL;
              }
              if (!_v__q_3.symbol_at (0))
              {
                RF_RETFAIL;
              }
              Expr _vs_level (_v__q_3, 0, 1);
              {
                {
                  if (!RF_CALL (Compare::_gt_, (_vs_level, _c_1), /*void*/))
                  {
                    goto _block4__branch1;
                  }
                  Expr _v__m_1;
                  RF_CALL (Arithm::_m_, (_vs_level, _c_0), _v__m_1);
                  RF_CALL (Box::Store, (Parenth_m_Level, _v__m_1), /*void*/);
                  _v_res1 = _c_83;
                  goto _block4;
                }
              _block4__branch1: {}
                RF_CALL (StreamErr::Error, (_vs_tream, _c_84), /*void*/);
                RF_RETFAIL;
              }
            _block4: {}
              goto _block2;
            }
          _block2__branch2: {}
            Expr _vt_1 (_v_Getc1, 0, 1);
            RF_CALL (Stream::Ungets, (_vs_tream, _vt_1), /*void*/);
            goto _block1__branch1;
          }
        _block2: {}
          goto _block1;
        }
      _block1__branch1: {}
        {
          Expr _v_auxblock1;
          {
            {
              if (!RF_CALL (Scan_m_Identifier_q_, _vs_tream, _v_auxblock1))
              {
                goto _block5__branch1;
              }
              goto _block5;
            }
          _block5__branch1: {}
            {
              if (!RF_CALL (Scan_m_Quoted_m_Word_q_, _vs_tream, _v_auxblock1))
              {
                goto _block5__branch2;
              }
              goto _block5;
            }
          _block5__branch2: {}
            {
              if (!RF_CALL (Scan_m_Char_q_, _vs_tream, _v_auxblock1))
              {
                goto _block5__branch3;
              }
              goto _block5;
            }
          _block5__branch3: {}
            if (!RF_CALL (Scan_m_Number_q_, _vs_tream, _v_auxblock1))
            {
              goto _block1__branch2;
            }
          }
        _block5: {}
          uintptr_t _v_len1 = _v_auxblock1.get_len ();
          uintptr_t _v_len2 = 1;
          if ((_v_len1 < _v_len2))
          {
            goto _block1__branch2;
          }
          uintptr_t _v_len__value = (_v_len1 - _v_len2);
          if (!_v_auxblock1.symbol_at (0))
          {
            goto _block1__branch2;
          }
          Expr _vs_type (_v_auxblock1, 0, 1);
          Expr _ve_value (_v_auxblock1, 1, _v_len__value);
          {
            {
              if (!_vs_type.term_eq (_c_67, 0))
              {
                goto _block6__branch1;
              }
              {
                {
                  Expr _v__q_4;
                  RF_CALL (Box::_q_, Case_m_Insensitive, _v__q_4);
                  if ((_v__q_4.get_len () != 1))
                  {
                    goto _block7__branch1;
                  }
                  if (!_c_0.term_eq (_v__q_4, 0))
                  {
                    goto _block7__branch1;
                  }
                  Expr _v_To_m_Upper1;
                  RF_CALL (Convert::To_m_Upper, _ve_value, _v_To_m_Upper1);
                  RF_CALL (Convert::To_m_Word, _v_To_m_Upper1, _v_res1);
                  goto _block7;
                }
              _block7__branch1: {}
                RF_CALL (Convert::To_m_Word, _ve_value, _v_res1);
              }
            _block7: {}
              goto _block6;
            }
          _block6__branch1: {}
            {
              if (!_vs_type.term_eq (_c_70, 0))
              {
                goto _block6__branch2;
              }
              RF_CALL (Convert::To_m_Word, _ve_value, _v_res1);
              goto _block6;
            }
          _block6__branch2: {}
            {
              if (!_vs_type.term_eq (_c_72, 0))
              {
                goto _block6__branch3;
              }
              {
                {
                  if ((_v_len__value != 1))
                  {
                    goto _block8__branch1;
                  }
                  if (!_ve_value.symbol_at (0))
                  {
                    goto _block8__branch1;
                  }
                  Expr _vs_ymbol (_ve_value, 0, 1);
                  _v_res1 = _vs_ymbol;
                  goto _block8;
                }
              _block8__branch1: {}
                RF_TAILCALL (Read_m_Term_m_Aux, _vs_tream, _v_res1);
              }
            _block8: {}
              goto _block6;
            }
          _block6__branch3: {}
            if (!_vs_type.term_eq (_c_55, 0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            if (!RF_CALL (Convert::To_m_Int, _ve_value, _v_res1))
            {
              RF_RETFAIL;
            }
          }
        _block6: {}
          goto _block1;
        }
      _block1__branch2: {}
        Expr _v_Getc2;
        if (!RF_CALL (Stream::Getc, _vs_tream, _v_Getc2))
        {
          RF_RETFAIL;
        }
        Expr _vt_1 (_v_Getc2, 0, 1);
        RF_CALL (StreamErr::Error, (_vs_tream, (_c_12 + _vt_1 + _c_11)), /*void*/);
        RF_TAILCALL (Read_m_Term_m_Aux, _vs_tream, _v_res1);
      }
    _block1: {}
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        if (!RF_CALL (Skip_m_Blank_q_, _vs_tream, /*void*/))
        {
          goto _block9__branch1;
        }
        _ve_stop_q_ = empty;
        goto _block9;
      }
    _block9__branch1: {}
      {
        if (!RF_CALL (Skip_m_Comment_q_, _vs_tream, /*void*/))
        {
          goto _block9__branch2;
        }
        _ve_stop_q_ = empty;
        goto _block9;
      }
    _block9__branch2: {}
      _ve_stop_q_ = _c_9;
    }
  _block9: {}
  }
_exit__iter1: {}
RF_END

}

namespace Class
{

RF_FUNC (Digit_q___0, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = _v_arg1.get_len ();
  uintptr_t _v_len2 = 0;
  if ((_v_len1 < _v_len2))
  {
    RF_ERROR (Lexer::_c_85);
  }
  uintptr_t _v_len__stub1 = (_v_len1 - _v_len2);
  Expr _v_stub1 (_v_arg1, 0, _v_len__stub1);
  if (!RF_CALL (Digit_q_, _v_stub1, /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

}

namespace Lexer
{

RF_FUNC (Blank_q___0, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  if ((_v_arg1.get_len () != 1))
  {
    RF_ERROR (_c_85);
  }
  Expr _v_stub1 (_v_arg1, 0, 1);
  if (!RF_CALL (Blank_q_, _v_stub1, /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

RF_FUNC (Var_m_Sym_q___0, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  if ((_v_arg1.get_len () != 1))
  {
    RF_ERROR (_c_85);
  }
  Expr _v_stub1 (_v_arg1, 0, 1);
  if (!RF_CALL (Var_m_Sym_q_, _v_stub1, /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

RF_FUNC (Fun_m_Sym_q___0, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  if ((_v_arg1.get_len () != 1))
  {
    RF_ERROR (_c_85);
  }
  Expr _v_stub1 (_v_arg1, 0, 1);
  if (!RF_CALL (Fun_m_Sym_q_, _v_stub1, /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

}

namespace Class
{

RF_FUNC (Letter_q___0, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = _v_arg1.get_len ();
  uintptr_t _v_len2 = 0;
  if ((_v_len1 < _v_len2))
  {
    RF_ERROR (Lexer::_c_85);
  }
  uintptr_t _v_len__stub1 = (_v_len1 - _v_len2);
  Expr _v_stub1 (_v_arg1, 0, _v_len__stub1);
  if (!RF_CALL (Letter_q_, _v_stub1, /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

}

namespace Lexer
{

static void init_ ()
{
  Case_m_Insensitive = Expr::create_sym< NamedObject<BoxContents> >(L"Case-Insensitive");
//  Collect_m_Errors_m_Box = Expr::create_sym< NamedObject<BoxContents> >(L"Collect-Errors-Box");
  Parenth_m_Level = Expr::create_sym< NamedObject<BoxContents> >(L"Parenth-Level");
  _c_0 = Expr::create<Integer>("1");
  _c_1 = Expr::create<Integer>("0");
  Collect_m_Errors_m_Box = Expr::create_sym<BoxContents>(_c_1);
  _c_2 = Char::create_expr (" ");
  _c_3 = Char::create_expr ("\t");
  _c_4 = Char::create_expr ("\n");
  _c_5 = Char::create_expr ("\r");
  _c_6 = Expr::create_sym<Func> (Blank_q___0);
  _c_7 = Char::create_expr ("*");
  _c_8 = Char::create_expr ("/");
  _c_9 = Expr::create<Word>("Stop");
  _c_10 = Expr::create<Word>("Unclosed comment");
  _c_11 = Expr::create<Word>("'");
  _c_12 = Expr::create<Word>("Invalid character '");
  _c_13 = Expr::create<Word>("Unexpected end of file");
  _c_14 = Char::create_expr ("$");
  _c_15 = Expr::create_sym<Func> (Class::Letter_q___0);
  _c_16 = Char::create_expr ("box");
  _c_17 = Expr::create<Word>("BOX");
  _c_18 = Char::create_expr ("channel");
  _c_19 = Expr::create<Word>("CHANNEL");
  _c_20 = Char::create_expr ("const");
  _c_21 = Expr::create<Word>("CONST");
  _c_22 = Char::create_expr ("error");
  _c_23 = Expr::create<Word>("ERROR");
  _c_24 = Char::create_expr ("fail");
  _c_25 = Expr::create<Word>("FAIL");
  _c_28 = Char::create_expr ("func?");
  _c_26 = Expr (_c_28, 0, 4);
  _c_27 = Expr::create<Word>("FUNC");
  _c_29 = Expr::create<Word>("FUNC?");
  _c_30 = Char::create_expr ("iter");
  _c_31 = Expr::create<Word>("ITER");
  _c_32 = Expr (_c_24, 3, 1);
  _c_33 = Expr::create<Word>("L");
  _c_34 = Expr (_c_30, 3, 1);
  _c_35 = Expr::create<Word>("R");
  _c_36 = Char::create_expr ("string");
  _c_37 = Expr::create<Word>("STRING");
  _c_38 = Char::create_expr ("table");
  _c_39 = Expr::create<Word>("TABLE");
  _c_42 = Char::create_expr ("traceall");
  _c_40 = Expr (_c_42, 0, 5);
  _c_41 = Expr::create<Word>("TRACE");
  _c_43 = Expr::create<Word>("TRACEALL");
  _c_44 = Char::create_expr ("trap");
  _c_45 = Expr::create<Word>("TRAP");
  _c_46 = Char::create_expr ("use");
  _c_47 = Expr::create<Word>("USE");
  _c_48 = Char::create_expr ("vector");
  _c_49 = Expr::create<Word>("VECTOR");
  _c_50 = Char::create_expr ("with");
  _c_51 = Expr::create<Word>("WITH");
  _c_52 = Char::create_expr ("+");
  _c_53 = Char::create_expr ("-");
  _c_54 = Expr::create_sym<Func> (Class::Digit_q___0);
  _c_55 = Expr::create<Word>("NUMBER");
  _c_56 = Expr (_c_46, 1, 1);
  _c_57 = Expr::create<Word>("SVAR");
  _c_58 = Expr (_c_46, 2, 1);
  _c_59 = Expr::create<Word>("EVAR");
  _c_60 = Expr (_c_48, 0, 1);
  _c_61 = Expr::create<Word>("VVAR");
  _c_62 = Expr (_c_30, 1, 1);
  _c_63 = Expr::create<Word>("TVAR");
  _c_64 = Char::create_expr (".");
  _c_65 = Expr::create_sym<Func> (Var_m_Sym_q___0);
  _c_66 = Expr::create_sym<Func> (Fun_m_Sym_q___0);
  _c_67 = Expr::create<Word>("WORD");
  _c_68 = Char::create_expr ("\"");
  _c_69 = Expr::create<Integer>("-1");
  _c_70 = Expr::create<Word>("QWORD");
  _c_71 = Char::create_expr ("'");
  _c_72 = Expr::create<Word>("SYMBOLS");
  _c_73 = Char::create_expr ("\\");
  _c_74 = Expr (_c_20, 2, 1);
  _c_75 = Expr (_c_16, 0, 1);
  _c_76 = Expr (_c_24, 0, 1);
  _c_77 = Expr::create<Word>("Unknown control sequence '\\");
  _c_78 = Expr::create<Word>("Bad symbol '");
  _c_79 = Expr::create<Word>("Unclosed quotes");
  _c_80 = Char::create_expr ("(");
  _c_81 = Expr::create<Word>("Unclosed parentheses");
  _c_82 = Char::create_expr (")");
  _c_83 = (Expr::create<Word>("Time-To-Close-Parentheses")) ();
  _c_84 = Expr::create<Word>("Unexpected right parenthesis");
  _c_85 = Expr::create<Word>("Apply") + Expr::create<Word>("Apply") + Expr::create<Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}
