#include <rf_core.hh>

using namespace rfrt;

namespace refal
{

namespace StdIO
{

RF_DECL(Print);
RF_DECL(PrintLN);

RF_FUNC (Print, (RF_ARG _expr;;), RF_VOID)
  if (!_expr.print(stdout)) {
    throw Word::create_expr(L"Print") +
      Word::create_expr(L"Expr::print() failed");
  }
RF_END

RF_FUNC (PrintLN, (RF_ARG _expr;;), RF_VOID)
  if (!_expr.println(stdout)) {
    throw Word::create_expr(L"PrintLN") +
      Word::create_expr(L"Expr::println() failed");
  }
RF_END

}
}
