#ifndef __Stream_hh__
#define __Stream_hh__

#include <rf_core.hh>

namespace refal
{

using namespace rfrt;

namespace Stream
{

RF_DECL (Stream);

RF_DECL (Expr_m_Open);

RF_DECL (File_m_Open);

RF_DECL (File_m_Close);

RF_DECL (StdIStream);

RF_DECL (Getc);

RF_DECL (Gets);

RF_DECL (Ungets);

RF_DECL (Scanc);

RF_DECL (Get_m_Delim);

RF_DECL (Get_m_Line);

RF_DECL (Get_m_While);

RF_DECL (End_m_of_m_Stream_q_);

}

}

#endif // __Stream_hh__
