#include <rf_core.hh>
#include <refal/Arithm.hh>
#include <refal/StdIO.hh>
#include <refal/Box.hh>
#include "StreamErr.hh"

namespace refal
{

using namespace rfrt;

namespace StreamErr
{

static Expr Error_m_Box;

static Expr _c_4;

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

RF_FUNC (Errors, RF_VOID, (RF_RES _v_res1;;))
  RF_TAILCALL (Box::_q_, Error_m_Box, _v_res1);
RF_END

RF_FUNC (Clear_m_Errors, RF_VOID, RF_VOID)
  RF_TAILCALL (Box::Store, (Error_m_Box, empty), /*void*/);
RF_END

RF_FUNC (Error, (RF_ARG _vs_tream, _ve_message;;), RF_VOID)
  RF_TAILCALL (Box::Put, (Error_m_Box, (_c_0 + _ve_message ()) ()), /*void*/);
RF_END

RF_FUNC (Error_m_At, (RF_ARG _vt_pos, _ve_message;;), RF_VOID)
  RF_TAILCALL (Box::Put, (Error_m_Box, (_c_0 + _ve_message ()) ()), /*void*/);
RF_END

RF_FUNC (Print_m_Errors, RF_VOID, RF_VOID)
  {
    Expr _v_Errors1;
    RF_CALL (Errors, /*void*/, _v_Errors1);
    if ((_v_Errors1.get_len () < 1))
    {
      goto _block1__branch1;
    }
    RF_lsplit (_v_Errors1, 0, _ve__e__e_tmp_m_StreamErrrf_m_38_m_15, _v_lsplit__Errors1);
    for ( ; ; RF_iter(_v_Errors1)++)
    {
      {
        if (!RF_iter(_v_Errors1))
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len1 = _v_lsplit__Errors1.get_len ();
        uintptr_t _v_len2 = 1;
        if ((_v_len1 < _v_len2))
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_StreamErrrf_m_38_m_54 = (_v_len1 - _v_len2);
        if (_v_lsplit__Errors1.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__lsplit__Errors1 (_v_lsplit__Errors1, 0);
        if ((_v_deref__lsplit__Errors1.get_len () != 3))
        {
          goto _continue1;
        }
        if (_v_deref__lsplit__Errors1.symbol_at (0))
        {
          goto _continue1;
        }
        if (_v_deref__lsplit__Errors1.symbol_at (1))
        {
          goto _continue1;
        }
        if (_v_deref__lsplit__Errors1.symbol_at (2))
        {
          goto _continue1;
        }
        Expr _v_deref__deref__lsplit__Errors1 (_v_deref__lsplit__Errors1, 0);
        Expr _v_deref__deref__lsplit__Errors12 (_v_deref__lsplit__Errors1, 1);
        Expr _v_deref__deref__lsplit__Errors13 (_v_deref__lsplit__Errors1, 2);
        if ((_v_deref__deref__lsplit__Errors12.get_len () != 2))
        {
          goto _continue1;
        }
        uintptr_t _v_len3 = _v_deref__deref__lsplit__Errors13.get_len ();
        uintptr_t _v_len4 = 0;
        if ((_v_len3 < _v_len4))
        {
          goto _continue1;
        }
        uintptr_t _v_len__message = (_v_len3 - _v_len4);
        uintptr_t _v_len5 = _v_deref__deref__lsplit__Errors1.get_len ();
        uintptr_t _v_len6 = 0;
        if ((_v_len5 < _v_len6))
        {
          goto _continue1;
        }
        uintptr_t _v_len__name = (_v_len5 - _v_len6);
        if (!_v_deref__deref__lsplit__Errors12.symbol_at (0))
        {
          goto _continue1;
        }
        if (!_v_deref__deref__lsplit__Errors12.symbol_at (1))
        {
          goto _continue1;
        }
        Expr _ve__e__e_tmp_m_StreamErrrf_m_38_m_54 (_v_lsplit__Errors1, 1, _v_len___e__e_tmp_m_StreamErrrf_m_38_m_54);
        Expr _ve_name (_v_deref__deref__lsplit__Errors1, 0, _v_len__name);
        Expr _vs_row (_v_deref__deref__lsplit__Errors12, 0, 1);
        Expr _vs_col (_v_deref__deref__lsplit__Errors12, 1, 1);
        Expr _ve_message (_v_deref__deref__lsplit__Errors13, 0, _v_len__message);
        RF_CALL (StdIO::PrintLN, (_ve_name + _c_3 + _vs_row + _c_2 + _vs_col + _c_1 + _ve_message), /*void*/);
        goto _continue1;
      }
  _continue1: {}
    }
  }
_block1__branch1: {}
RF_END

}

namespace StreamErr
{

static void init_ ()
{
  Error_m_Box = Expr::create_sym<BoxContents> ();
  _c_4 = Integer::create_expr ("0") + Integer::create_expr ("0");
  _c_0 = (empty) () + (_c_4) ();
  _c_1 = Word::create_expr (" --- Error: ");
  _c_2 = Word::create_expr (", ");
  _c_3 = Word::create_expr (": ");
}

static AtStart init_registrator_ (&init_);

}

}
