#include <rf_core.hh>
#include <refal/Arithm.hh>
#include <refal/Apply.hh>
#include <refal/Class.hh>
#include <refal/Convert.hh>
#include <refal/CppMangle.hh>
#include <refal/Compare.hh>
#include <refal/Box.hh>
#include <refal/StdIO.hh>
#include "rfp_compile.hh"
#include <refal/Table.hh>
#include "rfpc.hh"
#include "rfp_helper.hh"
#include <refal/List.hh>

namespace refal
{

using namespace rfrt;

namespace rfp__asail__tpp
{

static Expr Int;

static Expr Module_m_Name;

static Expr Current_m_Namespace;

static Expr Current_m_Func;

static Expr Entry;

static Expr Entry_m_Name;

static Expr Const_m_Exprs;

static Expr Const_m_Local;

static Expr Param;

RF_DECL (RFP_m_ASAIL_m_To_m_TPP);

RF_DECL (ASAIL_m_To_m_TPP);

RF_DECL (Expr_m_To_m_TPP);

RF_DECL (Expr_m_Ref_m_To_m_TPP);

RF_DECL (Term_m_Ref_m_To_m_TPP);

RF_DECL (Expr_m_Int_m_To_m_TPP);

RF_DECL (Cond_m_To_m_TPP);

RF_DECL (Infix_m_To_m_TPP);

RF_DECL (Op_m_Arg_m_To_m_TPP);

RF_DECL (Step_m_To_m_TPP);

RF_DECL (Const_m_Expr_m_To_m_TPP);

RF_DECL (Const_m_Expr_m_Aux);

RF_DECL (Symbol_m_To_m_TPP);

RF_DECL (Args_m_To_m_TPP);

RF_DECL (Name_m_To_m_TPP);

RF_DECL (TPP_m_Param);

RF_DECL (Add);

RF_DECL (Func_m_Const);

RF_DECL (Punct);

RF_DECL (Func_m_Prototype);

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_20;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_161;

static Expr _c_7;

static Expr _c_8;

static Expr _c_156;

static Expr _c_9;

static Expr _c_154;

static Expr _c_10;

static Expr _c_157;

static Expr _c_11;

static Expr _c_41;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_162;

static Expr _c_15;

static Expr _c_26;

static Expr _c_16;

static Expr _c_17;

static Expr _c_163;

static Expr _c_18;

static Expr _c_28;

static Expr _c_19;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_27;

static Expr _c_29;

static Expr _c_30;

static Expr _c_31;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

static Expr _c_36;

static Expr _c_37;

static Expr _c_38;

static Expr _c_39;

static Expr _c_40;

static Expr _c_42;

static Expr _c_43;

static Expr _c_44;

static Expr _c_45;

static Expr _c_46;

static Expr _c_47;

static Expr _c_48;

static Expr _c_49;

static Expr _c_50;

static Expr _c_51;

static Expr _c_52;

static Expr _c_53;

static Expr _c_54;

static Expr _c_55;

static Expr _c_56;

static Expr _c_57;

static Expr _c_58;

static Expr _c_59;

static Expr _c_60;

static Expr _c_61;

static Expr _c_62;

static Expr _c_63;

static Expr _c_64;

static Expr _c_65;

static Expr _c_66;

static Expr _c_67;

static Expr _c_68;

static Expr _c_69;

static Expr _c_70;

static Expr _c_71;

static Expr _c_72;

static Expr _c_73;

static Expr _c_74;

static Expr _c_75;

static Expr _c_76;

static Expr _c_77;

static Expr _c_158;

static Expr _c_78;

static Expr _c_79;

static Expr _c_80;

static Expr _c_81;

static Expr _c_82;

static Expr _c_83;

static Expr _c_84;

static Expr _c_85;

static Expr _c_86;

static Expr _c_87;

static Expr _c_88;

static Expr _c_89;

static Expr _c_90;

static Expr _c_91;

static Expr _c_92;

static Expr _c_93;

static Expr _c_94;

static Expr _c_95;

static Expr _c_96;

static Expr _c_97;

static Expr _c_98;

static Expr _c_99;

static Expr _c_100;

static Expr _c_101;

static Expr _c_102;

static Expr _c_103;

static Expr _c_104;

static Expr _c_105;

static Expr _c_106;

static Expr _c_107;

static Expr _c_108;

static Expr _c_109;

static Expr _c_110;

static Expr _c_111;

static Expr _c_112;

static Expr _c_113;

static Expr _c_114;

static Expr _c_115;

static Expr _c_116;

static Expr _c_117;

static Expr _c_118;

static Expr _c_119;

static Expr _c_120;

static Expr _c_121;

static Expr _c_122;

static Expr _c_123;

static Expr _c_124;

static Expr _c_125;

static Expr _c_126;

static Expr _c_127;

static Expr _c_128;

static Expr _c_129;

static Expr _c_130;

static Expr _c_131;

static Expr _c_132;

static Expr _c_133;

static Expr _c_134;

static Expr _c_136;

static Expr _c_135;

static Expr _c_137;

static Expr _c_138;

static Expr _c_139;

static Expr _c_140;

static Expr _c_142;

static Expr _c_141;

static Expr _c_144;

static Expr _c_143;

static Expr _c_145;

static Expr _c_146;

static Expr _c_147;

static Expr _c_148;

static Expr _c_149;

static Expr _c_150;

static Expr _c_151;

static Expr _c_152;

static Expr _c_153;

static Expr _c_155;

static Expr _c_159;

static Expr _c_160;

RF_FUNC (RFP_m_ASAIL_m_To_m_TPP, (RF_ARG _gt_arg1, _ge_arg2;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = (_ge_arg2.get_len () + 1);
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__asail = (_v_len1 - _v_len2);
  Expr _v_compose1 ((_gt_arg1 + _ge_arg2));
  if (_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (_v_compose1, 0);
  uintptr_t _v_len3 = _v_deref__compose1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__ModuleName = (_v_len3 - _v_len4);
  Expr _ve_asail (_v_compose1, (0 + 1), _v_len__asail);
  Expr _ve_ModuleName (_v_deref__compose1, 0, _v_len__ModuleName);
  {
    {
      Expr _ge_auxcall1;
      if (!RF_CALL (Table::Lookup, (rfp__helper::RFP_m_Options, _c_0), _ge_auxcall1))
      {
        goto _block1__branch1;
      }
      RF_CALL (Box::Store, (Int, _ge_auxcall1), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Box::Store, (Int, _c_1), /*void*/);
  }
_block1: {}
  RF_CALL (Box::Store, (Module_m_Name, _ve_ModuleName), /*void*/);
  RF_CALL (Box::Store, (Entry, (_ve_ModuleName + _c_2) ()), /*void*/);
  RF_CALL (Box::Store, (Entry_m_Name, empty), /*void*/);
  RF_CALL (Box::Store, (Const_m_Exprs, empty), /*void*/);
  {
    {
      Expr _v_ASAIL_m_To_m_TPP1;
      RF_CALL (ASAIL_m_To_m_TPP, _ve_asail, _v_ASAIL_m_To_m_TPP1);
      uintptr_t _v_len5 = _v_ASAIL_m_To_m_TPP1.get_len ();
      uintptr_t _v_len6 = 0;
      if (_v_len5 < (_v_len6 + 1))
      {
        goto _block2__branch1;
      }
      uintptr_t _v_len__cpp = (_v_len5 - _v_len6);
      Expr _vv_cpp (_v_ASAIL_m_To_m_TPP1, 0, _v_len__cpp);
      _v_res1 = _vv_cpp;
      goto _block2;
    }
  _block2__branch1: {}
    _v_res1 = empty;
  }
_block2: {}
RF_END

RF_FUNC (ASAIL_m_To_m_TPP, (RF_ARG _ve_asail;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ve_asail.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__end = (_v_len1 - _v_len2);
      Expr _vt_item (_ve_asail, 0, 1);
      Expr _ve_end (_ve_asail, (0 + 1), _v_len__end);
      Expr _ve_cpp_m_item;
      {
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__item (_vt_item, 0);
          uintptr_t _v_len3 = _v_deref__item.get_len ();
          uintptr_t _v_len4 = 4;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__body = (_v_len3 - _v_len4);
          if (_v_deref__item.symbol_at ((0 + 1 + 1)))
          {
            goto _block2__branch1;
          }
          if (_v_deref__item.symbol_at ((0 + 1 + 1 + 1)))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__deref__item (_v_deref__item, (0 + 1 + 1));
          Expr _v_deref__deref__item2 (_v_deref__item, (0 + 1 + 1 + 1));
          uintptr_t _v_len5 = _v_deref__deref__item2.get_len ();
          uintptr_t _v_len6 = 0;
          if (_v_len5 < _v_len6)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__ress = (_v_len5 - _v_len6);
          uintptr_t _v_len7 = _v_deref__deref__item.get_len ();
          uintptr_t _v_len8 = 0;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__args = (_v_len7 - _v_len8);
          if (!_v_deref__item.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _vs_tag (_v_deref__item, 0, 1);
          Expr _vt_name (_v_deref__item, (0 + 1), 1);
          Expr _ve_body (_v_deref__item, (0 + 1 + 1 + 1 + 1), _v_len__body);
          Expr _ve_args (_v_deref__deref__item, 0, _v_len__args);
          Expr _ve_ress (_v_deref__deref__item2, 0, _v_len__ress);
          Expr _ve_return_m_type;
          Expr _ve_return;
          {
            {
              if (!_vs_tag.term_eq (_c_3, 0))
              {
                goto _block3__branch1;
              }
              _ve_return_m_type = _c_4;
              _ve_return = empty;
              goto _block3;
            }
          _block3__branch1: {}
            {
              if (!_vs_tag.term_eq (_c_5, 0))
              {
                goto _block3__branch2;
              }
              _ve_return_m_type = _c_6;
              _ve_return = _c_7;
              goto _block3;
            }
          _block3__branch2: {}
            if (!_vs_tag.term_eq (_c_8, 0))
            {
              goto _block2__branch1;
            }
            _ve_return_m_type = _c_4;
            _ve_return = empty;
          }
        _block3: {}
          RF_CALL (Box::Store, (Current_m_Func, _vt_name), /*void*/);
          {
            {
              Expr _v__q_1;
              RF_CALL (Box::_q_, Entry, _v__q_1);
              if (_v__q_1.get_len () != 1)
              {
                goto _block4__branch1;
              }
              if (!_vt_name.term_eq (_v__q_1, 0))
              {
                goto _block4__branch1;
              }
              Expr _ge_auxcall1;
              RF_CALL (CppMangle::Rfp2Cpp, _vt_name, _ge_auxcall1);
              RF_CALL (Box::Store, (Entry_m_Name, _ge_auxcall1), /*void*/);
              goto _block4;
            }
          _block4__branch1: {}
          }
        _block4: {}
          Expr _ve_qualifiers;
          Expr _ge_name__5;
          RF_CALL (rfp__helper::RFP_m_Extract_m_Qualifiers, _vt_name, (_ve_qualifiers, _ge_name__5));
          Expr _ge_auxcall2;
          RF_CALL (Args_m_To_m_TPP, (_c_9, _c_10, _ve_args), _ge_auxcall2);
          Expr _ve_tval;
          RF_CALL (TPP_m_Param, _ge_auxcall2, _ve_tval);
          Expr _ge_auxcall3;
          RF_CALL (Args_m_To_m_TPP, (_c_11, _c_10, _ve_ress), _ge_auxcall3);
          Expr _ve_tout;
          RF_CALL (TPP_m_Param, _ge_auxcall3, _ve_tout);
          Expr _ve_tparam;
          {
            {
              if (_ve_tval.get_len () != 0)
              {
                goto _block5__branch1;
              }
              _ve_tparam = _ve_tout;
              goto _block5;
            }
          _block5__branch1: {}
            {
              if (_ve_tout.get_len () != 0)
              {
                goto _block5__branch2;
              }
              _ve_tparam = _ve_tval;
              goto _block5;
            }
          _block5__branch2: {}
            _ve_tparam = (_ve_tval + _c_12 + _ve_tout);
          }
        _block5: {}
          RF_CALL (Box::Store, (Const_m_Local, empty), /*void*/);
          Expr _ge_body__6;
          RF_CALL (ASAIL_m_To_m_TPP, _ve_body, _ge_body__6);
          Expr _ge_auxcall4;
          RF_CALL (Box::_q_, Const_m_Exprs, _ge_auxcall4);
          Expr _ge_auxcall5;
          RF_CALL (Box::_q_, Const_m_Local, _ge_auxcall5);
          Expr _ve_const;
          RF_CALL (Func_m_Const, (_ge_auxcall4, _ge_auxcall5), _ve_const);
          Expr _ge_const__7;
          Expr _ve_init_m_consts (empty);
          Expr _ve_result (_ve_const);
          for ( ; ; )
          {
            {
              if (_ve_result.get_len () != 0)
              {
                goto _iter1;
              }
              _ge_const__7 = _ve_init_m_consts;
              goto _exit__iter1;
            }
          _iter1: {}
            uintptr_t _v_len9 = _ve_result.get_len ();
            uintptr_t _v_len10 = 1;
            if (_v_len9 < _v_len10)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            uintptr_t _v_len__rest = (_v_len9 - _v_len10);
            if (_ve_result.symbol_at (0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _v_deref__result (_ve_result, 0);
            uintptr_t _v_len11 = _v_deref__result.get_len ();
            uintptr_t _v_len12 = 1;
            if (_v_len11 < _v_len12)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            uintptr_t _v_len__cpp_m_name = (_v_len11 - _v_len12);
            if (_v_deref__result.symbol_at ((0 + _v_len__cpp_m_name)))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _v_deref__deref__result (_v_deref__result, (0 + _v_len__cpp_m_name));
            uintptr_t _v_len13 = _v_deref__deref__result.get_len ();
            uintptr_t _v_len14 = 0;
            if (_v_len13 < _v_len14)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            uintptr_t _v_len__value = (_v_len13 - _v_len14);
            Expr _ve_rest (_ve_result, (0 + 1), _v_len__rest);
            Expr _ve_cpp_m_name (_v_deref__result, 0, _v_len__cpp_m_name);
            Expr _ve_value (_v_deref__deref__result, 0, _v_len__value);
            _ve_init_m_consts = (_ve_init_m_consts + (_c_15 + _ve_cpp_m_name + _c_14 + _ve_value + _c_13) ());
            _ve_result = _ve_rest;
          }
        _exit__iter1: {}
          Expr _ge_auxcall6;
          RF_CALL (CppMangle::Rfp2Cpp, _ge_name__5, _ge_auxcall6);
          _ve_cpp_m_item = (_c_20 + _ge_auxcall6 + _c_19 + _ve_tparam + _c_18 + (_c_17 + _ge_const__7 () + _ge_body__6 () + _c_16) ()) ();
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__item2 (_vt_item, 0);
          uintptr_t _v_len15 = _v_deref__item2.get_len ();
          uintptr_t _v_len16 = 2;
          if (_v_len15 < _v_len16)
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len__body2 = (_v_len15 - _v_len16);
          if (_v_deref__item2.symbol_at ((0 + 1)))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__deref__item22 (_v_deref__item2, (0 + 1));
          uintptr_t _v_len17 = _v_deref__deref__item22.get_len ();
          uintptr_t _v_len18 = 0;
          if (_v_len17 < _v_len18)
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len__cond = (_v_len17 - _v_len18);
          if (!_c_21.term_eq (_v_deref__item2, 0))
          {
            goto _block2__branch2;
          }
          Expr _ve_body (_v_deref__item2, (0 + 1 + 1), _v_len__body2);
          Expr _ve_cond (_v_deref__deref__item22, 0, _v_len__cond);
          Expr _ge_auxcall7;
          RF_CALL (Cond_m_To_m_TPP, _ve_cond, _ge_auxcall7);
          Expr _ge_auxcall8;
          RF_CALL (ASAIL_m_To_m_TPP, _ve_body, _ge_auxcall8);
          _ve_cpp_m_item = ((_c_22 + _ge_auxcall7 + _c_18) () + (_c_23 + _ge_auxcall8 () + _c_16) ());
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__item3 (_vt_item, 0);
          uintptr_t _v_len19 = _v_deref__item3.get_len ();
          uintptr_t _v_len20 = 5;
          if (_v_len19 < _v_len20)
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len__body3 = (_v_len19 - _v_len20);
          if (_v_deref__item3.symbol_at ((0 + 1)))
          {
            goto _block2__branch3;
          }
          if (_v_deref__item3.symbol_at ((0 + 1 + 1)))
          {
            goto _block2__branch3;
          }
          if (_v_deref__item3.symbol_at ((0 + 1 + 1 + 1)))
          {
            goto _block2__branch3;
          }
          if (_v_deref__item3.symbol_at ((0 + 1 + 1 + 1 + 1)))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__deref__item3 (_v_deref__item3, (0 + 1));
          Expr _v_deref__deref__item32 (_v_deref__item3, (0 + 1 + 1));
          Expr _v_deref__deref__item33 (_v_deref__item3, (0 + 1 + 1 + 1));
          Expr _v_deref__deref__item34 (_v_deref__item3, (0 + 1 + 1 + 1 + 1));
          uintptr_t _v_len21 = _v_deref__deref__item3.get_len ();
          uintptr_t _v_len22 = 0;
          if (_v_len21 < _v_len22)
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len__cont_m_label = (_v_len21 - _v_len22);
          uintptr_t _v_len23 = _v_deref__deref__item32.get_len ();
          uintptr_t _v_len24 = 0;
          if (_v_len23 < _v_len24)
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len__break_m_label = (_v_len23 - _v_len24);
          uintptr_t _v_len25 = _v_deref__deref__item34.get_len ();
          uintptr_t _v_len26 = 0;
          if (_v_len25 < _v_len26)
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len__step = (_v_len25 - _v_len26);
          uintptr_t _v_len27 = _v_deref__deref__item33.get_len ();
          uintptr_t _v_len28 = 0;
          if (_v_len27 < _v_len28)
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len__cond2 = (_v_len27 - _v_len28);
          if (!_c_24.term_eq (_v_deref__item3, 0))
          {
            goto _block2__branch3;
          }
          Expr _ve_body (_v_deref__item3, (0 + 1 + 1 + 1 + 1 + 1), _v_len__body3);
          Expr _ve_cont_m_label (_v_deref__deref__item3, 0, _v_len__cont_m_label);
          Expr _ve_break_m_label (_v_deref__deref__item32, 0, _v_len__break_m_label);
          Expr _ve_cond (_v_deref__deref__item33, 0, _v_len__cond2);
          Expr _ve_step (_v_deref__deref__item34, 0, _v_len__step);
          Expr _ge_body__5;
          {
            {
              if (_v_len__cont_m_label != 1)
              {
                goto _block8__branch1;
              }
              Expr _vt__e__e_tmp_m_rfp__asail__tpprf_m_144_m_25 (_ve_cont_m_label, 0, 1);
              Expr _ge_auxcall9;
              RF_CALL (ASAIL_m_To_m_TPP, _ve_body, _ge_auxcall9);
              Expr _ge_auxcall10;
              RF_CALL (CppMangle::Rfp2Cpp, (_c_25 + _ve_cont_m_label) (), _ge_auxcall10);
              _ge_body__5 = (_c_23 + (_c_23 + _ge_auxcall9 () + _c_16) () + (_c_25 + _ge_auxcall10 + _c_26) () + _c_16) ();
              goto _block8;
            }
          _block8__branch1: {}
            Expr _ge_auxcall11;
            RF_CALL (ASAIL_m_To_m_TPP, _ve_body, _ge_auxcall11);
            _ge_body__5 = (_c_23 + _ge_auxcall11 () + _c_16) ();
          }
        _block8: {}
          Expr _ve_break;
          {
            {
              if (_v_len__break_m_label != 1)
              {
                goto _block9__branch1;
              }
              Expr _vt__e__e_tmp_m_rfp__asail__tpprf_m_152_m_26 (_ve_break_m_label, 0, 1);
              Expr _ge_auxcall12;
              RF_CALL (CppMangle::Rfp2Cpp, (_c_25 + _ve_break_m_label) (), _ge_auxcall12);
              _ve_break = (_c_25 + _ge_auxcall12 + _c_26) ();
              goto _block9;
            }
          _block9__branch1: {}
            _ve_break = empty;
          }
        _block9: {}
          Expr _ge_auxcall13;
          RF_CALL (Cond_m_To_m_TPP, _ve_cond, _ge_auxcall13);
          Expr _ge_auxcall14;
          RF_CALL (Step_m_To_m_TPP, _ve_step, _ge_auxcall14);
          _ve_cpp_m_item = ((_c_28 + _ge_auxcall13 + _c_27 + _ge_auxcall14 + _c_18) () + _ge_body__5 + _ve_break);
          goto _block2;
        }
      _block2__branch3: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__item4 (_vt_item, 0);
          uintptr_t _v_len29 = _v_deref__item4.get_len ();
          uintptr_t _v_len30 = 2;
          if (_v_len29 < _v_len30)
          {
            goto _block2__branch4;
          }
          uintptr_t _v_len__body4 = (_v_len29 - _v_len30);
          if (_v_deref__item4.symbol_at ((0 + 1)))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__deref__item4 (_v_deref__item4, (0 + 1));
          uintptr_t _v_len31 = _v_deref__deref__item4.get_len ();
          uintptr_t _v_len32 = 0;
          if (_v_len31 < _v_len32)
          {
            goto _block2__branch4;
          }
          uintptr_t _v_len__label = (_v_len31 - _v_len32);
          if (!_c_25.term_eq (_v_deref__item4, 0))
          {
            goto _block2__branch4;
          }
          Expr _ve_body (_v_deref__item4, (0 + 1 + 1), _v_len__body4);
          Expr _ve_label (_v_deref__deref__item4, 0, _v_len__label);
          Expr _ge_auxcall15;
          RF_CALL (ASAIL_m_To_m_TPP, _ve_body, _ge_auxcall15);
          Expr _ge_auxcall16;
          RF_CALL (CppMangle::Rfp2Cpp, (_c_25 + _ve_label) (), _ge_auxcall16);
          _ve_cpp_m_item = ((_c_23 + _ge_auxcall15 () + _c_16) () + (_c_25 + _ge_auxcall16 + _c_26) ());
          goto _block2;
        }
      _block2__branch4: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch5;
          }
          Expr _v_deref__item5 (_vt_item, 0);
          uintptr_t _v_len33 = _v_deref__item5.get_len ();
          uintptr_t _v_len34 = 1;
          if (_v_len33 < _v_len34)
          {
            goto _block2__branch5;
          }
          uintptr_t _v_len__body5 = (_v_len33 - _v_len34);
          if (!_c_29.term_eq (_v_deref__item5, 0))
          {
            goto _block2__branch5;
          }
          Expr _ve_body (_v_deref__item5, (0 + 1), _v_len__body5);
          Expr _ge_auxcall17;
          RF_CALL (ASAIL_m_To_m_TPP, _ve_body, _ge_auxcall17);
          _ve_cpp_m_item = (_c_30 + (_c_23 + _ge_auxcall17 () + _c_16) ());
          goto _block2;
        }
      _block2__branch5: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch6;
          }
          Expr _v_deref__item6 (_vt_item, 0);
          uintptr_t _v_len35 = _v_deref__item6.get_len ();
          uintptr_t _v_len36 = 1;
          if (_v_len35 < _v_len36)
          {
            goto _block2__branch6;
          }
          uintptr_t _v_len__body6 = (_v_len35 - _v_len36);
          if (!_c_31.term_eq (_v_deref__item6, 0))
          {
            goto _block2__branch6;
          }
          Expr _ve_body (_v_deref__item6, (0 + 1), _v_len__body6);
          Expr _ge_auxcall18;
          RF_CALL (ASAIL_m_To_m_TPP, _ve_body, _ge_auxcall18);
          _ve_cpp_m_item = (_c_33 + (_c_23 + (_c_32 + _ge_auxcall18) () + _c_16) ());
          goto _block2;
        }
      _block2__branch6: {}
        {
          if (!_vt_item.term_eq (_c_34, 0))
          {
            goto _block2__branch7;
          }
          _ve_cpp_m_item = _c_7;
          goto _block2;
        }
      _block2__branch7: {}
        {
          if (!_vt_item.term_eq (_c_35, 0))
          {
            goto _block2__branch8;
          }
          _ve_cpp_m_item = _c_36;
          goto _block2;
        }
      _block2__branch8: {}
        {
          if (!_vt_item.term_eq (_c_37, 0))
          {
            goto _block2__branch9;
          }
          _ve_cpp_m_item = _c_38;
          goto _block2;
        }
      _block2__branch9: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch10;
          }
          Expr _v_deref__item7 (_vt_item, 0);
          uintptr_t _v_len37 = _v_deref__item7.get_len ();
          uintptr_t _v_len38 = 4;
          if (_v_len37 < _v_len38)
          {
            goto _block2__branch10;
          }
          uintptr_t _v_len__expr = (_v_len37 - _v_len38);
          if (_v_deref__item7.symbol_at ((0 + 1 + _v_len__expr)))
          {
            goto _block2__branch10;
          }
          Expr _v_deref__deref__item7 (_v_deref__item7, (0 + 1 + _v_len__expr));
          uintptr_t _v_len39 = _v_deref__deref__item7.get_len ();
          uintptr_t _v_len40 = 0;
          if (_v_len39 < _v_len40)
          {
            goto _block2__branch10;
          }
          uintptr_t _v_len__min = (_v_len39 - _v_len40);
          if (!_c_39.term_eq (_v_deref__item7, 0))
          {
            goto _block2__branch10;
          }
          Expr _ve_expr (_v_deref__item7, (0 + 1), _v_len__expr);
          Expr _vt_var1 (_v_deref__item7, (0 + 1 + _v_len__expr + 1), 1);
          Expr _vt_var2 (_v_deref__item7, (0 + 1 + _v_len__expr + 1 + 1), 1);
          Expr _ve_min (_v_deref__deref__item7, 0, _v_len__min);
          Expr _ge_auxcall19;
          RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr, _ge_auxcall19);
          Expr _ge_auxcall20;
          RF_CALL (Expr_m_Int_m_To_m_TPP, _ve_min, _ge_auxcall20);
          Expr _ge_auxcall21;
          RF_CALL (CppMangle::Rfp2Cpp, _vt_var1, _ge_auxcall21);
          Expr _ge_auxcall22;
          RF_CALL (CppMangle::Rfp2Cpp, _vt_var2, _ge_auxcall22);
          _ve_cpp_m_item = (_c_43 + _ge_auxcall19 + _c_12 + _ge_auxcall20 + _c_42 + _ge_auxcall21 + _c_41 + _ge_auxcall22 + _c_40) ();
          goto _block2;
        }
      _block2__branch10: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch11;
          }
          Expr _v_deref__item8 (_vt_item, 0);
          uintptr_t _v_len41 = _v_deref__item8.get_len ();
          uintptr_t _v_len42 = 4;
          if (_v_len41 < _v_len42)
          {
            goto _block2__branch11;
          }
          uintptr_t _v_len__expr2 = (_v_len41 - _v_len42);
          if (_v_deref__item8.symbol_at ((0 + 1 + _v_len__expr2)))
          {
            goto _block2__branch11;
          }
          Expr _v_deref__deref__item8 (_v_deref__item8, (0 + 1 + _v_len__expr2));
          uintptr_t _v_len43 = _v_deref__deref__item8.get_len ();
          uintptr_t _v_len44 = 0;
          if (_v_len43 < _v_len44)
          {
            goto _block2__branch11;
          }
          uintptr_t _v_len__min2 = (_v_len43 - _v_len44);
          if (!_c_44.term_eq (_v_deref__item8, 0))
          {
            goto _block2__branch11;
          }
          Expr _ve_expr (_v_deref__item8, (0 + 1), _v_len__expr2);
          Expr _vt_var1 (_v_deref__item8, (0 + 1 + _v_len__expr2 + 1), 1);
          Expr _vt_var2 (_v_deref__item8, (0 + 1 + _v_len__expr2 + 1 + 1), 1);
          Expr _ve_min (_v_deref__deref__item8, 0, _v_len__min2);
          Expr _ge_auxcall23;
          RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr, _ge_auxcall23);
          Expr _ge_auxcall24;
          RF_CALL (Expr_m_Int_m_To_m_TPP, _ve_min, _ge_auxcall24);
          Expr _ge_auxcall25;
          RF_CALL (CppMangle::Rfp2Cpp, _vt_var1, _ge_auxcall25);
          Expr _ge_auxcall26;
          RF_CALL (CppMangle::Rfp2Cpp, _vt_var2, _ge_auxcall26);
          _ve_cpp_m_item = (_c_46 + _ge_auxcall23 + _c_12 + _ge_auxcall24 + _c_42 + _ge_auxcall25 + _c_45 + _ge_auxcall26 + _c_40) ();
          goto _block2;
        }
      _block2__branch11: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch12;
          }
          Expr _v_deref__item9 (_vt_item, 0);
          uintptr_t _v_len45 = _v_deref__item9.get_len ();
          uintptr_t _v_len46 = 2;
          if (_v_len45 < _v_len46)
          {
            goto _block2__branch12;
          }
          uintptr_t _v_len__expr3 = (_v_len45 - _v_len46);
          if (!_c_47.term_eq (_v_deref__item9, 0))
          {
            goto _block2__branch12;
          }
          Expr _vt_var (_v_deref__item9, (0 + 1), 1);
          Expr _ve_expr (_v_deref__item9, (0 + 1 + 1), _v_len__expr3);
          Expr _ge_auxcall27;
          RF_CALL (CppMangle::Rfp2Cpp, _vt_var, _ge_auxcall27);
          Expr _ge_auxcall28;
          RF_CALL (Expr_m_To_m_TPP, (empty, _ve_expr), _ge_auxcall28);
          _ve_cpp_m_item = (_ge_auxcall27 + _c_14 + _ge_auxcall28 + _c_13) ();
          goto _block2;
        }
      _block2__branch12: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch13;
          }
          Expr _v_deref__item10 (_vt_item, 0);
          if (_v_deref__item10.get_len () != 3)
          {
            goto _block2__branch13;
          }
          if (!_c_48.term_eq (_v_deref__item10, 0))
          {
            goto _block2__branch13;
          }
          if (!_v_deref__item10.symbol_at ((0 + 1)))
          {
            goto _block2__branch13;
          }
          Expr _vs_type (_v_deref__item10, (0 + 1), 1);
          Expr _vt_var (_v_deref__item10, (0 + 1 + 1), 1);
          Expr _ge_auxcall29;
          RF_CALL (CppMangle::Rfp2Cpp, _vt_var, _ge_auxcall29);
          _ve_cpp_m_item = (_c_15 + _ge_auxcall29 + _c_13) ();
          goto _block2;
        }
      _block2__branch13: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch14;
          }
          Expr _v_deref__item11 (_vt_item, 0);
          uintptr_t _v_len47 = _v_deref__item11.get_len ();
          uintptr_t _v_len48 = 2;
          if (_v_len47 < _v_len48)
          {
            goto _block2__branch14;
          }
          uintptr_t _v_len__expr4 = (_v_len47 - _v_len48);
          if (!_c_0.term_eq (_v_deref__item11, 0))
          {
            goto _block2__branch14;
          }
          Expr _vt_var (_v_deref__item11, (0 + 1), 1);
          Expr _ve_expr (_v_deref__item11, (0 + 1 + 1), _v_len__expr4);
          Expr _ge_auxcall30;
          RF_CALL (CppMangle::Rfp2Cpp, _vt_var, _ge_auxcall30);
          Expr _ge_auxcall31;
          RF_CALL (Expr_m_Int_m_To_m_TPP, _ve_expr, _ge_auxcall31);
          _ve_cpp_m_item = (_c_15 + _ge_auxcall30 + _c_14 + _ge_auxcall31 + _c_13) ();
          goto _block2;
        }
      _block2__branch14: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch15;
          }
          Expr _v_deref__item12 (_vt_item, 0);
          uintptr_t _v_len49 = _v_deref__item12.get_len ();
          uintptr_t _v_len50 = 2;
          if (_v_len49 < _v_len50)
          {
            goto _block2__branch15;
          }
          uintptr_t _v_len__expr5 = (_v_len49 - _v_len50);
          if (!_c_49.term_eq (_v_deref__item12, 0))
          {
            goto _block2__branch15;
          }
          Expr _vt_var (_v_deref__item12, (0 + 1), 1);
          Expr _ve_expr (_v_deref__item12, (0 + 1 + 1), _v_len__expr5);
          Expr _ge_auxcall32;
          RF_CALL (CppMangle::Rfp2Cpp, _vt_var, _ge_auxcall32);
          Expr _ge_auxcall33;
          RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr, _ge_auxcall33);
          _ve_cpp_m_item = (_c_15 + _ge_auxcall32 + _c_50 + _ge_auxcall33 + _c_40) ();
          goto _block2;
        }
      _block2__branch15: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch16;
          }
          Expr _v_deref__item13 (_vt_item, 0);
          uintptr_t _v_len51 = _v_deref__item13.get_len ();
          uintptr_t _v_len52 = 3;
          if (_v_len51 < _v_len52)
          {
            goto _block2__branch16;
          }
          uintptr_t _v_len__expr6 = (_v_len51 - _v_len52);
          if (_v_deref__item13.symbol_at ((0 + 1 + 1 + _v_len__expr6)))
          {
            goto _block2__branch16;
          }
          Expr _v_deref__deref__item13 (_v_deref__item13, (0 + 1 + 1 + _v_len__expr6));
          uintptr_t _v_len53 = _v_deref__deref__item13.get_len ();
          uintptr_t _v_len54 = 0;
          if (_v_len53 < _v_len54)
          {
            goto _block2__branch16;
          }
          uintptr_t _v_len__pos = (_v_len53 - _v_len54);
          if (!_c_51.term_eq (_v_deref__item13, 0))
          {
            goto _block2__branch16;
          }
          Expr _vt_var (_v_deref__item13, (0 + 1), 1);
          Expr _ve_expr (_v_deref__item13, (0 + 1 + 1), _v_len__expr6);
          Expr _ve_pos (_v_deref__deref__item13, 0, _v_len__pos);
          Expr _ge_auxcall34;
          RF_CALL (CppMangle::Rfp2Cpp, _vt_var, _ge_auxcall34);
          Expr _ge_auxcall35;
          RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr, _ge_auxcall35);
          Expr _ge_auxcall36;
          RF_CALL (Expr_m_Int_m_To_m_TPP, _ve_pos, _ge_auxcall36);
          _ve_cpp_m_item = (_c_15 + _ge_auxcall34 + _c_50 + _ge_auxcall35 + _c_52 + _ge_auxcall36 + _c_40) ();
          goto _block2;
        }
      _block2__branch16: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch17;
          }
          Expr _v_deref__item14 (_vt_item, 0);
          uintptr_t _v_len55 = _v_deref__item14.get_len ();
          uintptr_t _v_len56 = 4;
          if (_v_len55 < _v_len56)
          {
            goto _block2__branch17;
          }
          uintptr_t _v_len__expr7 = (_v_len55 - _v_len56);
          if (_v_deref__item14.symbol_at ((0 + 1 + 1 + _v_len__expr7)))
          {
            goto _block2__branch17;
          }
          if (_v_deref__item14.symbol_at ((0 + 1 + 1 + _v_len__expr7 + 1)))
          {
            goto _block2__branch17;
          }
          Expr _v_deref__deref__item14 (_v_deref__item14, (0 + 1 + 1 + _v_len__expr7));
          Expr _v_deref__deref__item142 (_v_deref__item14, (0 + 1 + 1 + _v_len__expr7 + 1));
          uintptr_t _v_len57 = _v_deref__deref__item142.get_len ();
          uintptr_t _v_len58 = 0;
          if (_v_len57 < _v_len58)
          {
            goto _block2__branch17;
          }
          uintptr_t _v_len__len = (_v_len57 - _v_len58);
          uintptr_t _v_len59 = _v_deref__deref__item14.get_len ();
          uintptr_t _v_len60 = 0;
          if (_v_len59 < _v_len60)
          {
            goto _block2__branch17;
          }
          uintptr_t _v_len__pos2 = (_v_len59 - _v_len60);
          if (!_c_53.term_eq (_v_deref__item14, 0))
          {
            goto _block2__branch17;
          }
          Expr _vt_var (_v_deref__item14, (0 + 1), 1);
          Expr _ve_expr (_v_deref__item14, (0 + 1 + 1), _v_len__expr7);
          Expr _ve_pos (_v_deref__deref__item14, 0, _v_len__pos2);
          Expr _ve_len (_v_deref__deref__item142, 0, _v_len__len);
          Expr _ge_auxcall37;
          RF_CALL (CppMangle::Rfp2Cpp, _vt_var, _ge_auxcall37);
          Expr _ge_auxcall38;
          RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr, _ge_auxcall38);
          Expr _ge_auxcall39;
          RF_CALL (Expr_m_Int_m_To_m_TPP, _ve_pos, _ge_auxcall39);
          Expr _ge_auxcall40;
          RF_CALL (Expr_m_Int_m_To_m_TPP, _ve_len, _ge_auxcall40);
          _ve_cpp_m_item = (_c_15 + _ge_auxcall37 + _c_50 + _ge_auxcall38 + _c_52 + _ge_auxcall39 + _c_52 + _ge_auxcall40 + _c_40) ();
          goto _block2;
        }
      _block2__branch17: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch18;
          }
          Expr _v_deref__item15 (_vt_item, 0);
          if (_v_deref__item15.get_len () != 2)
          {
            goto _block2__branch18;
          }
          if (!_c_54.term_eq (_v_deref__item15, 0))
          {
            goto _block2__branch18;
          }
          Expr _vt_var (_v_deref__item15, (0 + 1), 1);
          Expr _ge_auxcall41;
          RF_CALL (CppMangle::Rfp2Cpp, _vt_var, _ge_auxcall41);
          _ve_cpp_m_item = (_c_56 + _ge_auxcall41 + _c_55) ();
          goto _block2;
        }
      _block2__branch18: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch19;
          }
          Expr _v_deref__item16 (_vt_item, 0);
          if (_v_deref__item16.get_len () != 2)
          {
            goto _block2__branch19;
          }
          if (!_c_57.term_eq (_v_deref__item16, 0))
          {
            goto _block2__branch19;
          }
          Expr _vt_label (_v_deref__item16, (0 + 1), 1);
          Expr _ge_auxcall42;
          RF_CALL (CppMangle::Rfp2Cpp, (_c_25 + _vt_label) (), _ge_auxcall42);
          _ve_cpp_m_item = (_c_58 + _ge_auxcall42 + _c_13) ();
          goto _block2;
        }
      _block2__branch19: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch20;
          }
          Expr _v_deref__item17 (_vt_item, 0);
          if (_v_deref__item17.get_len () != 2)
          {
            goto _block2__branch20;
          }
          if (!_c_59.term_eq (_v_deref__item17, 0))
          {
            goto _block2__branch20;
          }
          Expr _vt_label (_v_deref__item17, (0 + 1), 1);
          Expr _ge_auxcall43;
          RF_CALL (CppMangle::Rfp2Cpp, (_c_25 + _vt_label) (), _ge_auxcall43);
          _ve_cpp_m_item = (_c_58 + _ge_auxcall43 + _c_13) ();
          goto _block2;
        }
      _block2__branch20: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch21;
          }
          Expr _v_deref__item18 (_vt_item, 0);
          uintptr_t _v_len61 = _v_deref__item18.get_len ();
          uintptr_t _v_len62 = 1;
          if (_v_len61 < _v_len62)
          {
            goto _block2__branch21;
          }
          uintptr_t _v_len__expr8 = (_v_len61 - _v_len62);
          if (!_c_60.term_eq (_v_deref__item18, 0))
          {
            goto _block2__branch21;
          }
          Expr _ve_expr (_v_deref__item18, (0 + 1), _v_len__expr8);
          Expr _ge_auxcall44;
          RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr, _ge_auxcall44);
          _ve_cpp_m_item = (_c_61 + _ge_auxcall44 + _c_40) ();
          goto _block2;
        }
      _block2__branch21: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch22;
          }
          Expr _v_deref__item19 (_vt_item, 0);
          uintptr_t _v_len63 = _v_deref__item19.get_len ();
          uintptr_t _v_len64 = 4;
          if (_v_len63 < _v_len64)
          {
            goto _block2__branch22;
          }
          uintptr_t _v_len__expr9 = (_v_len63 - _v_len64);
          if (_v_deref__item19.symbol_at ((0 + 1 + 1 + 1)))
          {
            goto _block2__branch22;
          }
          Expr _v_deref__deref__item19 (_v_deref__item19, (0 + 1 + 1 + 1));
          uintptr_t _v_len65 = _v_deref__deref__item19.get_len ();
          uintptr_t _v_len66 = 0;
          if (_v_len65 < _v_len66)
          {
            goto _block2__branch22;
          }
          uintptr_t _v_len__comment = (_v_len65 - _v_len66);
          if (!_c_62.term_eq (_v_deref__item19, 0))
          {
            goto _block2__branch22;
          }
          if (!_v_deref__item19.symbol_at ((0 + 1)))
          {
            goto _block2__branch22;
          }
          Expr _vs_linkage (_v_deref__item19, (0 + 1), 1);
          Expr _vt_name (_v_deref__item19, (0 + 1 + 1), 1);
          Expr _ve_expr (_v_deref__item19, (0 + 1 + 1 + 1 + 1), _v_len__expr9);
          Expr _ve_comment (_v_deref__deref__item19, 0, _v_len__comment);
          Expr _ve_qualifiers;
          Expr _ge_name__5;
          {
            {
              if (_vt_name.symbol_at (0))
              {
                goto _block10__branch1;
              }
              Expr _v_deref__name (_vt_name, 0);
              uintptr_t _v_len67 = _v_deref__name.get_len ();
              uintptr_t _v_len68 = 1;
              if (_v_len67 < _v_len68)
              {
                goto _block10__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__asail__tpprf_m_203_m_27 = (_v_len67 - _v_len68);
              if (!_c_63.term_eq (_v_deref__name, 0))
              {
                goto _block10__branch1;
              }
              Expr _ve__e__e_tmp_m_rfp__asail__tpprf_m_203_m_27 (_v_deref__name, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__tpprf_m_203_m_27);
              Expr _ge_auxcall45;
              RF_CALL (Box::_q_, Module_m_Name, _ge_auxcall45);
              _ve_qualifiers = _ge_auxcall45;
              _ge_name__5 = _vt_name;
              goto _block10;
            }
          _block10__branch1: {}
            RF_CALL (rfp__helper::RFP_m_Extract_m_Qualifiers, _vt_name, (_ve_qualifiers, _ge_name__5));
          }
        _block10: {}
          Expr _ve_cpp_m_name;
          RF_CALL (CppMangle::Rfp2Cpp, _ge_name__5, _ve_cpp_m_name);
          Expr _ge_auxcall46;
          RF_CALL (Const_m_Expr_m_To_m_TPP, _ve_expr, _ge_auxcall46);
          RF_CALL (Box::Put, (Const_m_Exprs, (_ve_cpp_m_name + _ge_auxcall46 ()) ()), /*void*/);
          _ve_cpp_m_item = empty;
          goto _block2;
        }
      _block2__branch22: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch23;
          }
          Expr _v_deref__item20 (_vt_item, 0);
          if (_v_deref__item20.get_len () != 4)
          {
            goto _block2__branch23;
          }
          if (!_c_64.term_eq (_v_deref__item20, 0))
          {
            goto _block2__branch23;
          }
          if (!_v_deref__item20.symbol_at ((0 + 1)))
          {
            goto _block2__branch23;
          }
          if (!_v_deref__item20.symbol_at ((0 + 1 + 1)))
          {
            goto _block2__branch23;
          }
          Expr _vs_linkage (_v_deref__item20, (0 + 1), 1);
          Expr _vs_tag (_v_deref__item20, (0 + 1 + 1), 1);
          Expr _vt_name (_v_deref__item20, (0 + 1 + 1 + 1), 1);
          Expr _ge_linkage__5;
          {
            {
              if (!_vs_linkage.term_eq (_c_65, 0))
              {
                goto _block11__branch1;
              }
              _ge_linkage__5 = _c_66;
              goto _block11;
            }
          _block11__branch1: {}
            _ge_linkage__5 = empty;
          }
        _block11: {}
          Expr _v_To_m_Chars1;
          RF_CALL (Convert::To_m_Chars, _vs_tag, _v_To_m_Chars1);
          uintptr_t _v_len69 = _v_To_m_Chars1.get_len ();
          uintptr_t _v_len70 = 1;
          if (_v_len69 < _v_len70)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len__2 = (_v_len69 - _v_len70);
          if (!_v_To_m_Chars1.symbol_at (0))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _vs_1 (_v_To_m_Chars1, 0, 1);
          Expr _ve_2 (_v_To_m_Chars1, (0 + 1), _v_len__2);
          Expr _ve_qualifiers;
          Expr _ge_name__5;
          RF_CALL (rfp__helper::RFP_m_Extract_m_Qualifiers, _vt_name, (_ve_qualifiers, _ge_name__5));
          Expr _ve_cpp_m_name;
          RF_CALL (CppMangle::Rfp2Cpp, _ge_name__5, _ve_cpp_m_name);
          {
            {
              if (!_vs_tag.term_eq (_c_67, 0))
              {
                goto _block12__branch1;
              }
              RF_CALL (Box::Put, (Const_m_Exprs, (_ve_cpp_m_name + (_c_69 + _ge_name__5 + _c_68) ()) ()), /*void*/);
              goto _block12;
            }
          _block12__branch1: {}
            Expr _ge_auxcall47;
            RF_CALL (Convert::To_m_Lower, _ve_2, _ge_auxcall47);
            RF_CALL (Box::Put, (Const_m_Exprs, (_ve_cpp_m_name + (_c_71 + _vs_1 + _ge_auxcall47 + _c_70 + _ge_name__5 + _c_68) ()) ()), /*void*/);
          }
        _block12: {}
          _ve_cpp_m_item = (_ge_linkage__5 + _c_72 + _ve_cpp_m_name + _c_13) ();
          goto _block2;
        }
      _block2__branch23: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch24;
          }
          Expr _v_deref__item21 (_vt_item, 0);
          if (_v_deref__item21.get_len () != 2)
          {
            goto _block2__branch24;
          }
          if (!_c_73.term_eq (_v_deref__item21, 0))
          {
            goto _block2__branch24;
          }
          Expr _vt_name (_v_deref__item21, (0 + 1), 1);
          Expr _ve_qualifiers;
          Expr _ve_name;
          RF_CALL (rfp__helper::RFP_m_Extract_m_Qualifiers, _vt_name, (_ve_qualifiers, _ve_name));
          Expr _ge_auxcall48;
          RF_CALL (CppMangle::Rfp2Cpp, _ve_name, _ge_auxcall48);
          _ve_cpp_m_item = (_c_74 + _ge_auxcall48 + _c_13) ();
          goto _block2;
        }
      _block2__branch24: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch25;
          }
          Expr _v_deref__item22 (_vt_item, 0);
          if (_v_deref__item22.get_len () != 2)
          {
            goto _block2__branch25;
          }
          if (!_c_75.term_eq (_v_deref__item22, 0))
          {
            goto _block2__branch25;
          }
          Expr _vt_fname (_v_deref__item22, (0 + 1), 1);
          Expr _ve_qualifiers;
          Expr _ve_name;
          RF_CALL (rfp__helper::RFP_m_Extract_m_Qualifiers, _vt_fname, (_ve_qualifiers, _ve_name));
          RF_CALL (Box::Store, (Param, _c_76), /*void*/);
          Expr _v_Lookup_m_Func1;
          Expr _v_Lookup_m_Func2;
          Expr _v_Lookup_m_Func3;
          Expr _v_Lookup_m_Func4;
          Expr _v_Lookup_m_Func5;
          if (!RF_CALL (rfp__compile::Lookup_m_Func, _vt_fname, (_v_Lookup_m_Func1, _v_Lookup_m_Func2, _v_Lookup_m_Func3, _v_Lookup_m_Func4, _v_Lookup_m_Func5)))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len71 = 5;
          uintptr_t _v_len72 = 2;
          if (_v_len71 < _v_len72)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len__expr10 = (_v_len71 - _v_len72);
          Expr _v_compose1 ((_v_Lookup_m_Func1 + _v_Lookup_m_Func2 + _v_Lookup_m_Func3 + _v_Lookup_m_Func4 () + _v_Lookup_m_Func5 ()));
          if (_v_compose1.symbol_at ((0 + _v_len__expr10)))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          if (_v_compose1.symbol_at ((0 + _v_len__expr10 + 1)))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _v_deref__compose1 (_v_compose1, (0 + _v_len__expr10));
          Expr _v_deref__compose12 (_v_compose1, (0 + _v_len__expr10 + 1));
          uintptr_t _v_len73 = _v_deref__compose12.get_len ();
          uintptr_t _v_len74 = 0;
          if (_v_len73 < _v_len74)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len__Fout = (_v_len73 - _v_len74);
          uintptr_t _v_len75 = _v_deref__compose1.get_len ();
          uintptr_t _v_len76 = 0;
          if (_v_len75 < _v_len76)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len__Fin = (_v_len75 - _v_len76);
          Expr _ve_expr (_v_compose1, 0, _v_len__expr10);
          Expr _ve_Fin (_v_deref__compose1, 0, _v_len__Fin);
          Expr _ve_Fout (_v_deref__compose12, 0, _v_len__Fout);
          Expr _ve_fin;
          RF_CALL (Func_m_Prototype, (_c_77, _ve_Fin), _ve_fin);
          Expr _ve_fout;
          RF_CALL (Func_m_Prototype, (_c_78, _ve_Fout), _ve_fout);
          Expr _ve_param;
          RF_CALL (Punct, (_ve_fin + _ve_fout), _ve_param);
          Expr _ge_auxcall49;
          RF_CALL (CppMangle::Rfp2Cpp, _ve_name, _ge_auxcall49);
          _ve_cpp_m_item = (_c_20 + _ge_auxcall49 + _c_50 + _ve_param + _c_40) ();
          goto _block2;
        }
      _block2__branch25: {}
        if (_vt_item.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__item23 (_vt_item, 0);
        if (_v_deref__item23.get_len () != 4)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        if (_v_deref__item23.symbol_at ((0 + 1 + 1)))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        if (_v_deref__item23.symbol_at ((0 + 1 + 1 + 1)))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__deref__item23 (_v_deref__item23, (0 + 1 + 1));
        Expr _v_deref__deref__item232 (_v_deref__item23, (0 + 1 + 1 + 1));
        uintptr_t _v_len77 = _v_deref__deref__item232.get_len ();
        uintptr_t _v_len78 = 0;
        if (_v_len77 < _v_len78)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len__ress2 = (_v_len77 - _v_len78);
        uintptr_t _v_len79 = _v_deref__deref__item23.get_len ();
        uintptr_t _v_len80 = 0;
        if (_v_len79 < _v_len80)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len__exprs = (_v_len79 - _v_len80);
        if (!_v_deref__item23.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _vs_call (_v_deref__item23, 0, 1);
        Expr _vt_name (_v_deref__item23, (0 + 1), 1);
        Expr _ve_exprs (_v_deref__deref__item23, 0, _v_len__exprs);
        Expr _ve_ress (_v_deref__deref__item232, 0, _v_len__ress2);
        Expr _ve_tval;
        RF_CALL (Args_m_To_m_TPP, (empty, _c_79, _ve_exprs), _ve_tval);
        Expr _ve_tout;
        RF_CALL (Args_m_To_m_TPP, (empty, _c_10, _ve_ress), _ve_tout);
        Expr _ve_tparam;
        {
          {
            if (_ve_tval.get_len () != 0)
            {
              goto _block13__branch1;
            }
            _ve_tparam = _ve_tout;
            goto _block13;
          }
        _block13__branch1: {}
          {
            if (_ve_tout.get_len () != 0)
            {
              goto _block13__branch2;
            }
            _ve_tparam = _ve_tval;
            goto _block13;
          }
        _block13__branch2: {}
          _ve_tparam = (_ve_tval + _c_12 + _ve_tout);
        }
      _block13: {}
        Expr _ge_auxcall50;
        RF_CALL (Name_m_To_m_TPP, _vt_name, _ge_auxcall50);
        _ve_cpp_m_item = (_ge_auxcall50 + _c_80 + _ve_tparam + _c_40) ();
      }
    _block2: {}
      Expr _v_ASAIL_m_To_m_TPP1;
      RF_CALL (ASAIL_m_To_m_TPP, _ve_end, _v_ASAIL_m_To_m_TPP1);
      _v_res1 = (_ve_cpp_m_item + _v_ASAIL_m_To_m_TPP1);
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Expr_m_To_m_TPP, (RF_ARG _ve_init, _ve_expr_m_all;;), (RF_RES _v_res1;;))
  {
    {
      if (_ve_expr_m_all.get_len () != 0)
      {
        goto _block1__branch1;
      }
      RF_TAILCALL (Expr_m_Ref_m_To_m_TPP, _ve_init, _v_res1);
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len1 = _ve_expr_m_all.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      if (_ve_expr_m_all.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__expr_m_all (_ve_expr_m_all, 0);
      uintptr_t _v_len3 = _v_deref__expr_m_all.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__expr = (_v_len3 - _v_len4);
      if (!_c_81.term_eq (_v_deref__expr_m_all, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest);
      Expr _ve_expr (_v_deref__expr_m_all, (0 + 1), _v_len__expr);
      RF_TAILCALL (Expr_m_Ref_m_To_m_TPP, (_ve_init + _ve_expr_m_all), _v_res1);
      goto _block1;
    }
  _block1__branch2: {}
    {
      uintptr_t _v_len5 = _ve_expr_m_all.get_len ();
      uintptr_t _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__rest2 = (_v_len5 - _v_len6);
      if (_ve_expr_m_all.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__expr_m_all2 (_ve_expr_m_all, 0);
      uintptr_t _v_len7 = _v_deref__expr_m_all2.get_len ();
      uintptr_t _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__expr2 = (_v_len7 - _v_len8);
      if (!_c_49.term_eq (_v_deref__expr_m_all2, 0))
      {
        goto _block1__branch3;
      }
      Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest2);
      Expr _ve_expr (_v_deref__expr_m_all2, (0 + 1), _v_len__expr2);
      RF_TAILCALL (Expr_m_Ref_m_To_m_TPP, (_ve_init + _ve_expr_m_all), _v_res1);
      goto _block1;
    }
  _block1__branch3: {}
    {
      uintptr_t _v_len9 = _ve_expr_m_all.get_len ();
      uintptr_t _v_len10 = 1;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__rest3 = (_v_len9 - _v_len10);
      if (_ve_expr_m_all.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__expr_m_all3 (_ve_expr_m_all, 0);
      uintptr_t _v_len11 = _v_deref__expr_m_all3.get_len ();
      uintptr_t _v_len12 = 1;
      if (_v_len11 < _v_len12)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__expr3 = (_v_len11 - _v_len12);
      if (!_c_51.term_eq (_v_deref__expr_m_all3, 0))
      {
        goto _block1__branch4;
      }
      Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest3);
      Expr _ve_expr (_v_deref__expr_m_all3, (0 + 1), _v_len__expr3);
      RF_TAILCALL (Expr_m_Ref_m_To_m_TPP, (_ve_init + _ve_expr_m_all), _v_res1);
      goto _block1;
    }
  _block1__branch4: {}
    {
      uintptr_t _v_len13 = _ve_expr_m_all.get_len ();
      uintptr_t _v_len14 = 1;
      if (_v_len13 < _v_len14)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__rest4 = (_v_len13 - _v_len14);
      if (_ve_expr_m_all.symbol_at (0))
      {
        goto _block1__branch5;
      }
      Expr _v_deref__expr_m_all4 (_ve_expr_m_all, 0);
      uintptr_t _v_len15 = _v_deref__expr_m_all4.get_len ();
      uintptr_t _v_len16 = 1;
      if (_v_len15 < _v_len16)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__expr4 = (_v_len15 - _v_len16);
      if (!_c_53.term_eq (_v_deref__expr_m_all4, 0))
      {
        goto _block1__branch5;
      }
      Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest4);
      Expr _ve_expr (_v_deref__expr_m_all4, (0 + 1), _v_len__expr4);
      RF_TAILCALL (Expr_m_Ref_m_To_m_TPP, (_ve_init + _ve_expr_m_all), _v_res1);
      goto _block1;
    }
  _block1__branch5: {}
    {
      uintptr_t _v_len17 = _ve_expr_m_all.get_len ();
      uintptr_t _v_len18 = 1;
      if (_v_len17 < _v_len18)
      {
        goto _block1__branch6;
      }
      uintptr_t _v_len__rest5 = (_v_len17 - _v_len18);
      if (_ve_expr_m_all.symbol_at (0))
      {
        goto _block1__branch6;
      }
      Expr _v_deref__expr_m_all5 (_ve_expr_m_all, 0);
      uintptr_t _v_len19 = _v_deref__expr_m_all5.get_len ();
      uintptr_t _v_len20 = 1;
      if (_v_len19 < _v_len20)
      {
        goto _block1__branch6;
      }
      uintptr_t _v_len__expr5 = (_v_len19 - _v_len20);
      if (!_c_82.term_eq (_v_deref__expr_m_all5, 0))
      {
        goto _block1__branch6;
      }
      Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest5);
      Expr _ve_expr (_v_deref__expr_m_all5, (0 + 1), _v_len__expr5);
      RF_TAILCALL (Expr_m_Int_m_To_m_TPP, (_ve_init + _ve_expr_m_all), _v_res1);
      goto _block1;
    }
  _block1__branch6: {}
    {
      uintptr_t _v_len21 = _ve_expr_m_all.get_len ();
      uintptr_t _v_len22 = 1;
      if (_v_len21 < _v_len22)
      {
        goto _block1__branch7;
      }
      uintptr_t _v_len__rest6 = (_v_len21 - _v_len22);
      if (_ve_expr_m_all.symbol_at (0))
      {
        goto _block1__branch7;
      }
      Expr _v_deref__expr_m_all6 (_ve_expr_m_all, 0);
      uintptr_t _v_len23 = _v_deref__expr_m_all6.get_len ();
      uintptr_t _v_len24 = 1;
      if (_v_len23 < _v_len24)
      {
        goto _block1__branch7;
      }
      uintptr_t _v_len__args = (_v_len23 - _v_len24);
      if (!_c_83.term_eq (_v_deref__expr_m_all6, 0))
      {
        goto _block1__branch7;
      }
      Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest6);
      Expr _ve_args (_v_deref__expr_m_all6, (0 + 1), _v_len__args);
      RF_TAILCALL (Expr_m_Int_m_To_m_TPP, (_ve_init + _ve_expr_m_all), _v_res1);
      goto _block1;
    }
  _block1__branch7: {}
    {
      uintptr_t _v_len25 = _ve_expr_m_all.get_len ();
      uintptr_t _v_len26 = 1;
      if (_v_len25 < _v_len26)
      {
        goto _block1__branch8;
      }
      uintptr_t _v_len__rest7 = (_v_len25 - _v_len26);
      if (_ve_expr_m_all.symbol_at (0))
      {
        goto _block1__branch8;
      }
      Expr _v_deref__expr_m_all7 (_ve_expr_m_all, 0);
      uintptr_t _v_len27 = _v_deref__expr_m_all7.get_len ();
      uintptr_t _v_len28 = 1;
      if (_v_len27 < _v_len28)
      {
        goto _block1__branch8;
      }
      uintptr_t _v_len__args2 = (_v_len27 - _v_len28);
      if (!_c_84.term_eq (_v_deref__expr_m_all7, 0))
      {
        goto _block1__branch8;
      }
      Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest7);
      Expr _ve_args (_v_deref__expr_m_all7, (0 + 1), _v_len__args2);
      RF_TAILCALL (Expr_m_Int_m_To_m_TPP, (_ve_init + _ve_expr_m_all), _v_res1);
      goto _block1;
    }
  _block1__branch8: {}
    {
      uintptr_t _v_len29 = _ve_expr_m_all.get_len ();
      uintptr_t _v_len30 = 1;
      if (_v_len29 < _v_len30)
      {
        goto _block1__branch9;
      }
      uintptr_t _v_len__rest8 = (_v_len29 - _v_len30);
      if (_ve_expr_m_all.symbol_at (0))
      {
        goto _block1__branch9;
      }
      Expr _v_deref__expr_m_all8 (_ve_expr_m_all, 0);
      uintptr_t _v_len31 = _v_deref__expr_m_all8.get_len ();
      uintptr_t _v_len32 = 2;
      if (_v_len31 < _v_len32)
      {
        goto _block1__branch9;
      }
      uintptr_t _v_len__args3 = (_v_len31 - _v_len32);
      if (!_c_85.term_eq (_v_deref__expr_m_all8, 0))
      {
        goto _block1__branch9;
      }
      if (!_v_deref__expr_m_all8.symbol_at ((0 + 1)))
      {
        goto _block1__branch9;
      }
      Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest8);
      Expr _vs_op (_v_deref__expr_m_all8, (0 + 1), 1);
      Expr _ve_args (_v_deref__expr_m_all8, (0 + 1 + 1), _v_len__args3);
      RF_TAILCALL (Expr_m_Int_m_To_m_TPP, (_ve_init + _ve_expr_m_all), _v_res1);
      goto _block1;
    }
  _block1__branch9: {}
    uintptr_t _v_len33 = _ve_expr_m_all.get_len ();
    uintptr_t _v_len34 = 1;
    if (_v_len33 < _v_len34)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__rest9 = (_v_len33 - _v_len34);
    if (_ve_expr_m_all.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__expr_m_all9 (_ve_expr_m_all, 0);
    if (_v_deref__expr_m_all9.get_len () != 2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_v_deref__expr_m_all9.symbol_at ((0 + 1)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__deref__expr_m_all9 (_v_deref__expr_m_all9, (0 + 1));
    uintptr_t _v_len35 = _v_deref__deref__expr_m_all9.get_len ();
    uintptr_t _v_len36 = 0;
    if (_v_len35 < _v_len36)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__QualifiedName = (_v_len35 - _v_len36);
    if (!_v_deref__expr_m_all9.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_rest (_ve_expr_m_all, (0 + 1), _v_len__rest9);
    Expr _vs_var_m_tag (_v_deref__expr_m_all9, 0, 1);
    Expr _ve_QualifiedName (_v_deref__deref__expr_m_all9, 0, _v_len__QualifiedName);
    RF_TAILCALL (Expr_m_To_m_TPP, ((_ve_init + (_vs_var_m_tag + _ve_QualifiedName ()) ()), _ve_rest), _v_res1);
  }
_block1: {}
RF_END

RF_FUNC (Expr_m_Ref_m_To_m_TPP, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () != 0)
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      Expr _vt_erm (_ge_arg1, 0, 1);
      RF_TAILCALL (Term_m_Ref_m_To_m_TPP, _vt_erm, _v_res1);
      goto _block1;
    }
  _block1__branch2: {}
    Expr _ge_auxcall1;
    RF_CALL (List::Paren, _ge_arg1, _ge_auxcall1);
    Expr _ge_auxcall2;
    RF_CALL (Infix_m_To_m_TPP, (_c_86, _c_87, _ge_auxcall1), _ge_auxcall2);
    _v_res1 = (_c_88 + _ge_auxcall2 + _c_18);
  }
_block1: {}
RF_END

RF_FUNC (Term_m_Ref_m_To_m_TPP, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (_ge_arg1, 0);
      uintptr_t _v_len1 = _v_deref__arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__expr = (_v_len1 - _v_len2);
      if (!_c_81.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve_expr (_v_deref__arg1, (0 + 1), _v_len__expr);
      Expr _ge_auxcall1;
      RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr, _ge_auxcall1);
      _v_res1 = (_c_15 + _ge_auxcall1 + _c_89);
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg12 (_ge_arg1, 0);
      uintptr_t _v_len3 = _v_deref__arg12.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__expr2 = (_v_len3 - _v_len4);
      if (!_c_49.term_eq (_v_deref__arg12, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_expr (_v_deref__arg12, (0 + 1), _v_len__expr2);
      Expr _ge_auxcall2;
      RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr, _ge_auxcall2);
      _v_res1 = (_c_90 + _ge_auxcall2 + _c_18);
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch3;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__arg13 (_ge_arg1, 0);
      uintptr_t _v_len5 = _v_deref__arg13.get_len ();
      uintptr_t _v_len6 = 2;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__expr3 = (_v_len5 - _v_len6);
      if (_v_deref__arg13.symbol_at ((0 + 1 + _v_len__expr3)))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__deref__arg13 (_v_deref__arg13, (0 + 1 + _v_len__expr3));
      uintptr_t _v_len7 = _v_deref__deref__arg13.get_len ();
      uintptr_t _v_len8 = 0;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__pos = (_v_len7 - _v_len8);
      if (!_c_51.term_eq (_v_deref__arg13, 0))
      {
        goto _block1__branch3;
      }
      Expr _ve_expr (_v_deref__arg13, (0 + 1), _v_len__expr3);
      Expr _ve_pos (_v_deref__deref__arg13, 0, _v_len__pos);
      Expr _ge_auxcall3;
      RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr, _ge_auxcall3);
      Expr _ge_auxcall4;
      RF_CALL (Expr_m_Int_m_To_m_TPP, _ve_pos, _ge_auxcall4);
      _v_res1 = (_c_91 + _ge_auxcall3 + _c_52 + _ge_auxcall4 + _c_18);
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch4;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__arg14 (_ge_arg1, 0);
      uintptr_t _v_len9 = _v_deref__arg14.get_len ();
      uintptr_t _v_len10 = 3;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__expr4 = (_v_len9 - _v_len10);
      if (_v_deref__arg14.symbol_at ((0 + 1 + _v_len__expr4)))
      {
        goto _block1__branch4;
      }
      if (_v_deref__arg14.symbol_at ((0 + 1 + _v_len__expr4 + 1)))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__deref__arg14 (_v_deref__arg14, (0 + 1 + _v_len__expr4));
      Expr _v_deref__deref__arg142 (_v_deref__arg14, (0 + 1 + _v_len__expr4 + 1));
      uintptr_t _v_len11 = _v_deref__deref__arg142.get_len ();
      uintptr_t _v_len12 = 0;
      if (_v_len11 < _v_len12)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__len = (_v_len11 - _v_len12);
      uintptr_t _v_len13 = _v_deref__deref__arg14.get_len ();
      uintptr_t _v_len14 = 0;
      if (_v_len13 < _v_len14)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__pos2 = (_v_len13 - _v_len14);
      if (!_c_53.term_eq (_v_deref__arg14, 0))
      {
        goto _block1__branch4;
      }
      Expr _ve_expr (_v_deref__arg14, (0 + 1), _v_len__expr4);
      Expr _ve_pos (_v_deref__deref__arg14, 0, _v_len__pos2);
      Expr _ve_len (_v_deref__deref__arg142, 0, _v_len__len);
      Expr _ge_auxcall5;
      RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr, _ge_auxcall5);
      Expr _ge_auxcall6;
      RF_CALL (Expr_m_Int_m_To_m_TPP, _ve_pos, _ge_auxcall6);
      Expr _ge_auxcall7;
      RF_CALL (Expr_m_Int_m_To_m_TPP, _ve_len, _ge_auxcall7);
      _v_res1 = (_c_91 + _ge_auxcall5 + _c_52 + _ge_auxcall6 + _c_52 + _ge_auxcall7 + _c_18);
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch5;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch5;
      }
      Expr _v_deref__arg15 (_ge_arg1, 0);
      if (_v_deref__arg15.get_len () != 2)
      {
        goto _block1__branch5;
      }
      if (!_c_92.term_eq (_v_deref__arg15, 0))
      {
        goto _block1__branch5;
      }
      Expr _vt_name (_v_deref__arg15, (0 + 1), 1);
      RF_TAILCALL (Name_m_To_m_TPP, _vt_name, _v_res1);
      goto _block1;
    }
  _block1__branch5: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch6;
      }
      if (!_c_93.term_eq (_ge_arg1, 0))
      {
        goto _block1__branch6;
      }
      _v_res1 = _c_94;
      goto _block1;
    }
  _block1__branch6: {}
    if (_ge_arg1.get_len () != 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_ge_arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__arg16 (_ge_arg1, 0);
    if (_v_deref__arg16.get_len () != 2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (!_v_deref__arg16.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_var_m_tag (_v_deref__arg16, 0, 1);
    Expr _vt_name (_v_deref__arg16, (0 + 1), 1);
    {
      {
        if (!_vs_var_m_tag.term_eq (_c_63, 0))
        {
          goto _block2__branch1;
        }
        Expr _ve_var;
        RF_CALL (CppMangle::Rfp2Cpp, (_vs_var_m_tag + _vt_name) (), _ve_var);
        Expr _ge_auxcall8;
        RF_CALL (Box::_q_, Const_m_Local, _ge_auxcall8);
        RF_CALL (Add, (Const_m_Local, (_ve_var () + _ge_auxcall8)), /*void*/);
        _v_res1 = _ve_var;
        goto _block2;
      }
    _block2__branch1: {}
      RF_TAILCALL (CppMangle::Rfp2Cpp, (_vs_var_m_tag + _vt_name) (), _v_res1);
    }
  _block2: {}
  }
_block1: {}
RF_END

RF_FUNC (Expr_m_Int_m_To_m_TPP, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () != 0)
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      if (!_ge_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _vs_ObjectSymbol (_ge_arg1, 0, 1);
      {
        {
          if (!RF_CALL (Class::Int_q_, _vs_ObjectSymbol, /*void*/))
          {
            goto _block2__branch1;
          }
          _v_res1 = _vs_ObjectSymbol;
          goto _block2;
        }
      _block2__branch1: {}
        RF_ERROR ((_c_95 + _vs_ObjectSymbol) ());
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch3;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__arg1 (_ge_arg1, 0);
      uintptr_t _v_len1 = _v_deref__arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__expr = (_v_len1 - _v_len2);
      if (!_c_82.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch3;
      }
      Expr _ve_expr (_v_deref__arg1, (0 + 1), _v_len__expr);
      Expr _ge_auxcall1;
      RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr, _ge_auxcall1);
      _v_res1 = (_c_56 + _ge_auxcall1 + _c_96);
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch4;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__arg12 (_ge_arg1, 0);
      uintptr_t _v_len3 = _v_deref__arg12.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__args = (_v_len3 - _v_len4);
      if (!_c_83.term_eq (_v_deref__arg12, 0))
      {
        goto _block1__branch4;
      }
      Expr _ve_args (_v_deref__arg12, (0 + 1), _v_len__args);
      Expr _ge_auxcall2;
      RF_CALL (Args_m_To_m_TPP, (empty, _c_97, _ve_args), _ge_auxcall2);
      _v_res1 = (_c_98 + _ge_auxcall2 + _c_18);
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch5;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch5;
      }
      Expr _v_deref__arg13 (_ge_arg1, 0);
      uintptr_t _v_len5 = _v_deref__arg13.get_len ();
      uintptr_t _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__args2 = (_v_len5 - _v_len6);
      if (!_c_84.term_eq (_v_deref__arg13, 0))
      {
        goto _block1__branch5;
      }
      Expr _ve_args (_v_deref__arg13, (0 + 1), _v_len__args2);
      Expr _ge_auxcall3;
      RF_CALL (Args_m_To_m_TPP, (empty, _c_97, _ve_args), _ge_auxcall3);
      _v_res1 = (_c_99 + _ge_auxcall3 + _c_18);
      goto _block1;
    }
  _block1__branch5: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch6;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch6;
      }
      Expr _v_deref__arg14 (_ge_arg1, 0);
      uintptr_t _v_len7 = _v_deref__arg14.get_len ();
      uintptr_t _v_len8 = 2;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch6;
      }
      uintptr_t _v_len__args3 = (_v_len7 - _v_len8);
      if (!_c_85.term_eq (_v_deref__arg14, 0))
      {
        goto _block1__branch6;
      }
      if (!_v_deref__arg14.symbol_at ((0 + 1)))
      {
        goto _block1__branch6;
      }
      Expr _vs_op (_v_deref__arg14, (0 + 1), 1);
      Expr _ve_args (_v_deref__arg14, (0 + 1 + 1), _v_len__args3);
      Expr _ge_auxcall4;
      RF_CALL (Infix_m_To_m_TPP, (_c_100, _vs_op, _ve_args), _ge_auxcall4);
      _v_res1 = (_c_80 + _ge_auxcall4 + _c_18);
      goto _block1;
    }
  _block1__branch6: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch7;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch7;
      }
      Expr _v_deref__arg15 (_ge_arg1, 0);
      if (_v_deref__arg15.get_len () != 2)
      {
        goto _block1__branch7;
      }
      if (!_c_92.term_eq (_v_deref__arg15, 0))
      {
        goto _block1__branch7;
      }
      Expr _vt_name (_v_deref__arg15, (0 + 1), 1);
      RF_TAILCALL (Name_m_To_m_TPP, _vt_name, _v_res1);
      goto _block1;
    }
  _block1__branch7: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch8;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch8;
      }
      Expr _v_deref__arg16 (_ge_arg1, 0);
      if (_v_deref__arg16.get_len () != 2)
      {
        goto _block1__branch8;
      }
      if (!_v_deref__arg16.symbol_at (0))
      {
        goto _block1__branch8;
      }
      Expr _vs_var_m_tag (_v_deref__arg16, 0, 1);
      Expr _vt_name (_v_deref__arg16, (0 + 1), 1);
      {
        {
          if (!_vs_var_m_tag.term_eq (_c_63, 0))
          {
            goto _block3__branch1;
          }
          Expr _ve_var;
          RF_CALL (CppMangle::Rfp2Cpp, (_vs_var_m_tag + _vt_name) (), _ve_var);
          Expr _ge_auxcall5;
          RF_CALL (Box::_q_, Const_m_Local, _ge_auxcall5);
          RF_CALL (Add, (Const_m_Local, (_ve_var () + _ge_auxcall5)), /*void*/);
          _v_res1 = _ve_var;
          goto _block3;
        }
      _block3__branch1: {}
        RF_TAILCALL (CppMangle::Rfp2Cpp, (_vs_var_m_tag + _vt_name) (), _v_res1);
      }
    _block3: {}
      goto _block1;
    }
  _block1__branch8: {}
    Expr _ge_auxcall6;
    RF_CALL (List::Paren, _ge_arg1, _ge_auxcall6);
    Expr _ge_auxcall7;
    RF_CALL (Infix_m_To_m_TPP, (_c_100, _c_87, _ge_auxcall6), _ge_auxcall7);
    _v_res1 = (_c_80 + _ge_auxcall7 + _c_18);
  }
_block1: {}
RF_END

RF_FUNC (Cond_m_To_m_TPP, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () != 0)
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg1 (_ge_arg1, 0);
      if (_v_deref__arg1.get_len () != 4)
      {
        goto _block1__branch2;
      }
      if (_v_deref__arg1.symbol_at ((0 + 1 + 1)))
      {
        goto _block1__branch2;
      }
      if (_v_deref__arg1.symbol_at ((0 + 1 + 1 + 1)))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__deref__arg1 (_v_deref__arg1, (0 + 1 + 1));
      Expr _v_deref__deref__arg12 (_v_deref__arg1, (0 + 1 + 1 + 1));
      uintptr_t _v_len1 = _v_deref__deref__arg12.get_len ();
      uintptr_t _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__ress = (_v_len1 - _v_len2);
      uintptr_t _v_len3 = _v_deref__deref__arg1.get_len ();
      uintptr_t _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__exprs = (_v_len3 - _v_len4);
      if (!_c_101.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch2;
      }
      Expr _vt_name (_v_deref__arg1, (0 + 1), 1);
      Expr _ve_exprs (_v_deref__deref__arg1, 0, _v_len__exprs);
      Expr _ve_ress (_v_deref__deref__arg12, 0, _v_len__ress);
      Expr _ve_tval;
      RF_CALL (Args_m_To_m_TPP, (empty, _c_79, _ve_exprs), _ve_tval);
      Expr _ve_tout;
      RF_CALL (Args_m_To_m_TPP, (empty, _c_10, _ve_ress), _ve_tout);
      Expr _ve_tparam;
      {
        {
          if (_ve_tval.get_len () != 0)
          {
            goto _block2__branch1;
          }
          _ve_tparam = _ve_tout;
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_ve_tout.get_len () != 0)
          {
            goto _block2__branch2;
          }
          _ve_tparam = _ve_tval;
          goto _block2;
        }
      _block2__branch2: {}
        _ve_tparam = (_ve_tval + _c_12 + _ve_tout);
      }
    _block2: {}
      Expr _ge_auxcall1;
      RF_CALL (Name_m_To_m_TPP, _vt_name, _ge_auxcall1);
      _v_res1 = (_ge_auxcall1 + _c_80 + _ve_tparam + _c_18);
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch3;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__arg12 (_ge_arg1, 0);
      uintptr_t _v_len5 = _v_deref__arg12.get_len ();
      uintptr_t _v_len6 = 2;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__expr = (_v_len5 - _v_len6);
      if (_v_deref__arg12.symbol_at ((0 + 1 + _v_len__expr)))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__deref__arg122 (_v_deref__arg12, (0 + 1 + _v_len__expr));
      uintptr_t _v_len7 = _v_deref__deref__arg122.get_len ();
      uintptr_t _v_len8 = 0;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__pos = (_v_len7 - _v_len8);
      if (!_c_102.term_eq (_v_deref__arg12, 0))
      {
        goto _block1__branch3;
      }
      Expr _ve_expr (_v_deref__arg12, (0 + 1), _v_len__expr);
      Expr _ve_pos (_v_deref__deref__arg122, 0, _v_len__pos);
      Expr _ge_auxcall2;
      RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr, _ge_auxcall2);
      Expr _ge_auxcall3;
      RF_CALL (Expr_m_Int_m_To_m_TPP, _ve_pos, _ge_auxcall3);
      _v_res1 = (_c_56 + _ge_auxcall2 + _c_103 + _ge_auxcall3 + _c_18);
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch4;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__arg13 (_ge_arg1, 0);
      uintptr_t _v_len9 = _v_deref__arg13.get_len ();
      uintptr_t _v_len10 = 3;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__expr2 = (_v_len9 - _v_len10);
      if (_v_deref__arg13.symbol_at ((0 + 1 + _v_len__expr2)))
      {
        goto _block1__branch4;
      }
      if (_v_deref__arg13.symbol_at ((0 + 1 + _v_len__expr2 + 1)))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__deref__arg13 (_v_deref__arg13, (0 + 1 + _v_len__expr2));
      Expr _v_deref__deref__arg132 (_v_deref__arg13, (0 + 1 + _v_len__expr2 + 1));
      uintptr_t _v_len11 = _v_deref__deref__arg132.get_len ();
      uintptr_t _v_len12 = 0;
      if (_v_len11 < _v_len12)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__len = (_v_len11 - _v_len12);
      uintptr_t _v_len13 = _v_deref__deref__arg13.get_len ();
      uintptr_t _v_len14 = 0;
      if (_v_len13 < _v_len14)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__pos2 = (_v_len13 - _v_len14);
      if (!_c_104.term_eq (_v_deref__arg13, 0))
      {
        goto _block1__branch4;
      }
      Expr _ve_expr (_v_deref__arg13, (0 + 1), _v_len__expr2);
      Expr _ve_pos (_v_deref__deref__arg13, 0, _v_len__pos2);
      Expr _ve_len (_v_deref__deref__arg132, 0, _v_len__len);
      Expr _ge_auxcall4;
      RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr, _ge_auxcall4);
      Expr _ge_auxcall5;
      RF_CALL (Expr_m_Int_m_To_m_TPP, _ve_pos, _ge_auxcall5);
      Expr _ge_auxcall6;
      RF_CALL (Expr_m_Int_m_To_m_TPP, _ve_len, _ge_auxcall6);
      _v_res1 = (_c_56 + _ge_auxcall4 + _c_105 + _ge_auxcall5 + _c_52 + _ge_auxcall6 + _c_18);
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch5;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch5;
      }
      Expr _v_deref__arg14 (_ge_arg1, 0);
      uintptr_t _v_len15 = _v_deref__arg14.get_len ();
      uintptr_t _v_len16 = 1;
      if (_v_len15 < _v_len16)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__expr3 = (_v_len15 - _v_len16);
      if (!_c_106.term_eq (_v_deref__arg14, 0))
      {
        goto _block1__branch5;
      }
      Expr _ve_expr (_v_deref__arg14, (0 + 1), _v_len__expr3);
      Expr _ge_auxcall7;
      RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr, _ge_auxcall7);
      _v_res1 = (_c_107 + _ge_auxcall7 + _c_18);
      goto _block1;
    }
  _block1__branch5: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch6;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch6;
      }
      Expr _v_deref__arg15 (_ge_arg1, 0);
      uintptr_t _v_len17 = _v_deref__arg15.get_len ();
      uintptr_t _v_len18 = 3;
      if (_v_len17 < _v_len18)
      {
        goto _block1__branch6;
      }
      uintptr_t _v_len__expr1 = (_v_len17 - _v_len18);
      if (_v_deref__arg15.symbol_at ((0 + 1 + _v_len__expr1)))
      {
        goto _block1__branch6;
      }
      if (_v_deref__arg15.symbol_at ((0 + 1 + _v_len__expr1 + 1)))
      {
        goto _block1__branch6;
      }
      Expr _v_deref__deref__arg15 (_v_deref__arg15, (0 + 1 + _v_len__expr1));
      Expr _v_deref__deref__arg152 (_v_deref__arg15, (0 + 1 + _v_len__expr1 + 1));
      uintptr_t _v_len19 = _v_deref__deref__arg152.get_len ();
      uintptr_t _v_len20 = 0;
      if (_v_len19 < _v_len20)
      {
        goto _block1__branch6;
      }
      uintptr_t _v_len__pos3 = (_v_len19 - _v_len20);
      uintptr_t _v_len21 = _v_deref__deref__arg15.get_len ();
      uintptr_t _v_len22 = 0;
      if (_v_len21 < _v_len22)
      {
        goto _block1__branch6;
      }
      uintptr_t _v_len__expr22 = (_v_len21 - _v_len22);
      if (!_c_108.term_eq (_v_deref__arg15, 0))
      {
        goto _block1__branch6;
      }
      Expr _ve_expr1 (_v_deref__arg15, (0 + 1), _v_len__expr1);
      Expr _ve_expr2 (_v_deref__deref__arg15, 0, _v_len__expr22);
      Expr _ve_pos (_v_deref__deref__arg152, 0, _v_len__pos3);
      Expr _ge_auxcall8;
      RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr1, _ge_auxcall8);
      Expr _ge_auxcall9;
      RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr2, _ge_auxcall9);
      Expr _ge_auxcall10;
      RF_CALL (Expr_m_Int_m_To_m_TPP, _ve_pos, _ge_auxcall10);
      _v_res1 = (_c_56 + _ge_auxcall8 + _c_109 + _ge_auxcall9 + _c_52 + _ge_auxcall10 + _c_18);
      goto _block1;
    }
  _block1__branch6: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch7;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch7;
      }
      Expr _v_deref__arg16 (_ge_arg1, 0);
      uintptr_t _v_len23 = _v_deref__arg16.get_len ();
      uintptr_t _v_len24 = 3;
      if (_v_len23 < _v_len24)
      {
        goto _block1__branch7;
      }
      uintptr_t _v_len__expr12 = (_v_len23 - _v_len24);
      if (_v_deref__arg16.symbol_at ((0 + 1 + _v_len__expr12)))
      {
        goto _block1__branch7;
      }
      if (_v_deref__arg16.symbol_at ((0 + 1 + _v_len__expr12 + 1)))
      {
        goto _block1__branch7;
      }
      Expr _v_deref__deref__arg16 (_v_deref__arg16, (0 + 1 + _v_len__expr12));
      Expr _v_deref__deref__arg162 (_v_deref__arg16, (0 + 1 + _v_len__expr12 + 1));
      uintptr_t _v_len25 = _v_deref__deref__arg162.get_len ();
      uintptr_t _v_len26 = 0;
      if (_v_len25 < _v_len26)
      {
        goto _block1__branch7;
      }
      uintptr_t _v_len__pos4 = (_v_len25 - _v_len26);
      uintptr_t _v_len27 = _v_deref__deref__arg16.get_len ();
      uintptr_t _v_len28 = 0;
      if (_v_len27 < _v_len28)
      {
        goto _block1__branch7;
      }
      uintptr_t _v_len__expr23 = (_v_len27 - _v_len28);
      if (!_c_110.term_eq (_v_deref__arg16, 0))
      {
        goto _block1__branch7;
      }
      Expr _ve_expr1 (_v_deref__arg16, (0 + 1), _v_len__expr12);
      Expr _ve_expr2 (_v_deref__deref__arg16, 0, _v_len__expr23);
      Expr _ve_pos (_v_deref__deref__arg162, 0, _v_len__pos4);
      Expr _ge_auxcall11;
      RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr1, _ge_auxcall11);
      Expr _ge_auxcall12;
      RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr2, _ge_auxcall12);
      Expr _ge_auxcall13;
      RF_CALL (Expr_m_Int_m_To_m_TPP, _ve_pos, _ge_auxcall13);
      _v_res1 = (_c_56 + _ge_auxcall11 + _c_111 + _ge_auxcall12 + _c_52 + _ge_auxcall13 + _c_18);
      goto _block1;
    }
  _block1__branch7: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch8;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch8;
      }
      Expr _v_deref__arg17 (_ge_arg1, 0);
      uintptr_t _v_len29 = _v_deref__arg17.get_len ();
      uintptr_t _v_len30 = 1;
      if (_v_len29 < _v_len30)
      {
        goto _block1__branch8;
      }
      uintptr_t _v_len__cond = (_v_len29 - _v_len30);
      if (!_c_112.term_eq (_v_deref__arg17, 0))
      {
        goto _block1__branch8;
      }
      Expr _ve_cond (_v_deref__arg17, (0 + 1), _v_len__cond);
      Expr _v_Cond_m_To_m_TPP1;
      RF_CALL (Cond_m_To_m_TPP, _ve_cond, _v_Cond_m_To_m_TPP1);
      _v_res1 = (_c_113 + _v_Cond_m_To_m_TPP1);
      goto _block1;
    }
  _block1__branch8: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch9;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch9;
      }
      Expr _v_deref__arg18 (_ge_arg1, 0);
      uintptr_t _v_len31 = _v_deref__arg18.get_len ();
      uintptr_t _v_len32 = 2;
      if (_v_len31 < _v_len32)
      {
        goto _block1__branch9;
      }
      uintptr_t _v_len__args = (_v_len31 - _v_len32);
      if (!_c_85.term_eq (_v_deref__arg18, 0))
      {
        goto _block1__branch9;
      }
      if (!_v_deref__arg18.symbol_at ((0 + 1)))
      {
        goto _block1__branch9;
      }
      Expr _vs_op (_v_deref__arg18, (0 + 1), 1);
      Expr _ve_args (_v_deref__arg18, (0 + 1 + 1), _v_len__args);
      Expr _gs_auxcall14;
      RF_CALL (Op_m_Arg_m_To_m_TPP, _vs_op, _gs_auxcall14);
      Expr _ge_auxcall15;
      RF_CALL (Infix_m_To_m_TPP, (_gs_auxcall14, _vs_op, _ve_args), _ge_auxcall15);
      _v_res1 = (_c_80 + _ge_auxcall15 + _c_18);
      goto _block1;
    }
  _block1__branch9: {}
    Expr _ge_auxcall16;
    RF_CALL (List::Paren, _ge_arg1, _ge_auxcall16);
    Expr _ge_auxcall17;
    RF_CALL (Infix_m_To_m_TPP, (_c_114, _c_115, _ge_auxcall16), _ge_auxcall17);
    _v_res1 = (_c_80 + _ge_auxcall17 + _c_18);
  }
_block1: {}
RF_END

RF_FUNC (Infix_m_To_m_TPP, (RF_ARG _vs_arg2cpp, _vs_op, _ve_args;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ve_args.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      if (_ve_args.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__args (_ve_args, 0);
      uintptr_t _v_len3 = _v_deref__args.get_len ();
      uintptr_t _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__arg = (_v_len3 - _v_len4);
      Expr _ve_rest (_ve_args, (0 + 1), _v_len__rest);
      Expr _ve_arg (_v_deref__args, 0, _v_len__arg);
      if (!RF_CALL (Apply::Apply, (_vs_arg2cpp, _ve_arg), _ve_arg))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      RF_CALL (Infix_m_To_m_TPP, (_vs_arg2cpp, _vs_op, _ve_rest), _ve_rest);
      {
        {
          uintptr_t _v_len5 = _ve_rest.get_len ();
          uintptr_t _v_len6 = 0;
          if (_v_len5 < (_v_len6 + 1))
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__asail__tpprf_m_386_m_28 = (_v_len5 - _v_len6);
          uintptr_t _v_len7 = _ve_arg.get_len ();
          uintptr_t _v_len8 = 0;
          if (_v_len7 < (_v_len8 + 1))
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__asail__tpprf_m_386_m_16 = (_v_len7 - _v_len8);
          Expr _vv__e__e_tmp_m_rfp__asail__tpprf_m_386_m_16 (_ve_arg, 0, _v_len___e__e_tmp_m_rfp__asail__tpprf_m_386_m_16);
          Expr _vv__e__e_tmp_m_rfp__asail__tpprf_m_386_m_28 (_ve_rest, 0, _v_len___e__e_tmp_m_rfp__asail__tpprf_m_386_m_28);
          {
            {
              if (!_vs_op.term_eq (_c_87, 0))
              {
                goto _block3__branch1;
              }
              _v_res1 = (_c_88 + _ve_arg + _c_12 + _ve_rest + _c_18);
              goto _block3;
            }
          _block3__branch1: {}
            _v_res1 = (_ve_arg + _c_116 + _vs_op + _c_116 + _ve_rest);
          }
        _block3: {}
          goto _block2;
        }
      _block2__branch1: {}
        _v_res1 = (_ve_arg + _ve_rest);
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Op_m_Arg_m_To_m_TPP, (RF_ARG _vs_op;;), (RF_RES _v_res1;;))
  {
    {
      {
        {
          if (!_vs_op.term_eq (_c_115, 0))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        if (!_vs_op.term_eq (_c_117, 0))
        {
          goto _block1__branch1;
        }
      }
    _block2: {}
      _v_res1 = _c_114;
      goto _block1;
    }
  _block1__branch1: {}
    {
      {
        if (!_vs_op.term_eq (_c_118, 0))
        {
          goto _block3__branch1;
        }
        goto _block3;
      }
    _block3__branch1: {}
      {
        if (!_vs_op.term_eq (_c_119, 0))
        {
          goto _block3__branch2;
        }
        goto _block3;
      }
    _block3__branch2: {}
      {
        if (!_vs_op.term_eq (_c_120, 0))
        {
          goto _block3__branch3;
        }
        goto _block3;
      }
    _block3__branch3: {}
      {
        if (!_vs_op.term_eq (_c_121, 0))
        {
          goto _block3__branch4;
        }
        goto _block3;
      }
    _block3__branch4: {}
      {
        if (!_vs_op.term_eq (_c_122, 0))
        {
          goto _block3__branch5;
        }
        goto _block3;
      }
    _block3__branch5: {}
      {
        if (!_vs_op.term_eq (_c_123, 0))
        {
          goto _block3__branch6;
        }
        goto _block3;
      }
    _block3__branch6: {}
      {
        if (!_vs_op.term_eq (_c_87, 0))
        {
          goto _block3__branch7;
        }
        goto _block3;
      }
    _block3__branch7: {}
      {
        if (!_vs_op.term_eq (_c_124, 0))
        {
          goto _block3__branch8;
        }
        goto _block3;
      }
    _block3__branch8: {}
      {
        if (!_vs_op.term_eq (_c_125, 0))
        {
          goto _block3__branch9;
        }
        goto _block3;
      }
    _block3__branch9: {}
      {
        if (!_vs_op.term_eq (_c_126, 0))
        {
          goto _block3__branch10;
        }
        goto _block3;
      }
    _block3__branch10: {}
      if (!_vs_op.term_eq (_c_127, 0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
    }
  _block3: {}
    _v_res1 = _c_100;
  }
_block1: {}
RF_END

RF_FUNC (Step_m_To_m_TPP, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () != 0)
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg1 (_ge_arg1, 0);
      uintptr_t _v_len1 = _v_deref__arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__expr = (_v_len1 - _v_len2);
      if (!_c_128.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_expr (_v_deref__arg1, (0 + 1), _v_len__expr);
      Expr _ge_auxcall1;
      RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr, _ge_auxcall1);
      _v_res1 = (_c_107 + _ge_auxcall1 + _c_129);
      goto _block1;
    }
  _block1__branch2: {}
    if (_ge_arg1.get_len () != 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_ge_arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__arg12 (_ge_arg1, 0);
    uintptr_t _v_len3 = _v_deref__arg12.get_len ();
    uintptr_t _v_len4 = 1;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__expr2 = (_v_len3 - _v_len4);
    if (!_c_130.term_eq (_v_deref__arg12, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_expr (_v_deref__arg12, (0 + 1), _v_len__expr2);
    Expr _ge_auxcall2;
    RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_expr, _ge_auxcall2);
    _v_res1 = (_c_107 + _ge_auxcall2 + _c_131);
  }
_block1: {}
RF_END

RF_FUNC (Const_m_Expr_m_To_m_TPP, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () != 0)
      {
        goto _block1__branch1;
      }
      _v_res1 = _c_132;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg1 (_ge_arg1, 0);
      if (_v_deref__arg1.get_len () != 4)
      {
        goto _block1__branch2;
      }
      if (!_c_53.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch2;
      }
      if (!_v_deref__arg1.symbol_at ((0 + 1 + 1)))
      {
        goto _block1__branch2;
      }
      if (!_v_deref__arg1.symbol_at ((0 + 1 + 1 + 1)))
      {
        goto _block1__branch2;
      }
      Expr _vt_name (_v_deref__arg1, (0 + 1), 1);
      Expr _vs_pos (_v_deref__arg1, (0 + 1 + 1), 1);
      Expr _vs_len (_v_deref__arg1, (0 + 1 + 1 + 1), 1);
      Expr _ge_auxcall1;
      RF_CALL (CppMangle::Rfp2Cpp, _vt_name, _ge_auxcall1);
      _v_res1 = (_c_133 + _ge_auxcall1 + _c_52 + _vs_pos + _c_52 + _vs_len + _c_18);
      goto _block1;
    }
  _block1__branch2: {}
    Expr _v_Const_m_Expr_m_Aux1;
    RF_CALL (Const_m_Expr_m_Aux, (_c_134 + _ge_arg1), _v_Const_m_Expr_m_Aux1);
    {
      {
        uintptr_t _v_len1 = _v_Const_m_Expr_m_Aux1.get_len ();
        uintptr_t _v_len2 = 3;
        if (_v_len1 < _v_len2)
        {
          goto _block2__branch1;
        }
        uintptr_t _v_len__cpp_m_expr = (_v_len1 - _v_len2);
        if (!_c_135.eq (_v_Const_m_Expr_m_Aux1, 0))
        {
          goto _block2__branch1;
        }
        Expr _ve_cpp_m_expr (_v_Const_m_Expr_m_Aux1, (0 + 1 + 1 + 1), _v_len__cpp_m_expr);
        _v_res1 = _ve_cpp_m_expr;
        goto _block2;
      }
    _block2__branch1: {}
      uintptr_t _v_len3 = _v_Const_m_Expr_m_Aux1.get_len ();
      uintptr_t _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__cpp_m_expr2 = (_v_len3 - _v_len4);
      Expr _ve_cpp_m_expr (_v_Const_m_Expr_m_Aux1, 0, _v_len__cpp_m_expr2);
      _v_res1 = _ve_cpp_m_expr;
    }
  _block2: {}
  }
_block1: {}
RF_END

RF_FUNC (Const_m_Expr_m_Aux, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = _ge_arg1.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__expr = (_v_len1 - _v_len2);
  if (_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (_ge_arg1, 0);
  uintptr_t _v_len3 = _v_deref__arg1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__accum = (_v_len3 - _v_len4);
  Expr _ve_expr (_ge_arg1, (0 + 1), _v_len__expr);
  Expr _ve_accum (_v_deref__arg1, 0, _v_len__accum);
  {
    {
      uintptr_t _v_len5 = _v_len__expr;
      uintptr_t _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len5 - _v_len6);
      if (!_ve_expr.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_sym (_ve_expr, 0, 1);
      Expr _ve_rest (_ve_expr, (0 + 1), _v_len__rest);
      if (!RF_CALL (Class::Char_q_, _vs_sym, /*void*/))
      {
        goto _block1__branch1;
      }
      Expr _ge_auxcall1;
      RF_CALL (Symbol_m_To_m_TPP, _vs_sym, _ge_auxcall1);
      RF_TAILCALL (Const_m_Expr_m_Aux, ((_ve_accum + _ge_auxcall1) () + _ve_rest), _v_res1);
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len7 = _v_len__accum;
      uintptr_t _v_len8 = 0;
      if (_v_len7 < (_v_len8 + 1))
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__asail__tpprf_m_427_m_14 = (_v_len7 - _v_len8);
      Expr _vv__e__e_tmp_m_rfp__asail__tpprf_m_427_m_14 (_ve_accum, 0, _v_len___e__e_tmp_m_rfp__asail__tpprf_m_427_m_14);
      Expr _v_Const_m_Expr_m_Aux1;
      RF_CALL (Const_m_Expr_m_Aux, (_c_134 + _ve_expr), _v_Const_m_Expr_m_Aux1);
      _v_res1 = (_c_136 + _ve_accum + _c_68 + _v_Const_m_Expr_m_Aux1);
      goto _block1;
    }
  _block1__branch2: {}
    {
      uintptr_t _v_len9 = _v_len__expr;
      uintptr_t _v_len10 = 1;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__rest2 = (_v_len9 - _v_len10);
      Expr _vt_item (_ve_expr, 0, 1);
      Expr _ve_rest (_ve_expr, (0 + 1), _v_len__rest2);
      Expr _ve_cpp_m_item;
      {
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__item (_vt_item, 0);
          uintptr_t _v_len11 = _v_deref__item.get_len ();
          uintptr_t _v_len12 = 1;
          if (_v_len11 < _v_len12)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__paren_m_expr = (_v_len11 - _v_len12);
          if (!_c_81.term_eq (_v_deref__item, 0))
          {
            goto _block2__branch1;
          }
          Expr _ve_paren_m_expr (_v_deref__item, (0 + 1), _v_len__paren_m_expr);
          Expr _ge_auxcall2;
          RF_CALL (Const_m_Expr_m_To_m_TPP, _ve_paren_m_expr, _ge_auxcall2);
          _ve_cpp_m_item = (_c_138 + _ge_auxcall2 + _c_137);
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__item2 (_vt_item, 0);
          if (_v_deref__item2.get_len () != 2)
          {
            goto _block2__branch2;
          }
          if (!_c_92.term_eq (_v_deref__item2, 0))
          {
            goto _block2__branch2;
          }
          Expr _vt_name (_v_deref__item2, (0 + 1), 1);
          Expr _v_Name_m_To_m_TPP1;
          RF_CALL (Name_m_To_m_TPP, _vt_name, _v_Name_m_To_m_TPP1);
          _ve_cpp_m_item = (_c_135 + _v_Name_m_To_m_TPP1);
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__item3 (_vt_item, 0);
          uintptr_t _v_len13 = _v_deref__item3.get_len ();
          uintptr_t _v_len14 = 1;
          if (_v_len13 < _v_len14)
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__asail__tpprf_m_435_m_14 = (_v_len13 - _v_len14);
          if (!_c_63.term_eq (_v_deref__item3, 0))
          {
            goto _block2__branch3;
          }
          Expr _ve__e__e_tmp_m_rfp__asail__tpprf_m_435_m_14 (_v_deref__item3, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__tpprf_m_435_m_14);
          Expr _ve_const;
          RF_CALL (CppMangle::Rfp2Cpp, _vt_item, _ve_const);
          Expr _ge_auxcall3;
          RF_CALL (Box::_q_, Const_m_Local, _ge_auxcall3);
          RF_CALL (Add, (Const_m_Local, (_ve_const () + _ge_auxcall3)), /*void*/);
          _ve_cpp_m_item = (_c_135 + _ve_const);
          goto _block2;
        }
      _block2__branch3: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__item4 (_vt_item, 0);
          if (_v_deref__item4.get_len () != 2)
          {
            goto _block2__branch4;
          }
          if (!_c_3.term_eq (_v_deref__item4, 0))
          {
            goto _block2__branch4;
          }
          Expr _vt_name (_v_deref__item4, (0 + 1), 1);
          Expr _ge_auxcall4;
          RF_CALL (Name_m_To_m_TPP, _vt_name, _ge_auxcall4);
          _ve_cpp_m_item = (_c_139 + _ge_auxcall4 + _c_18);
          goto _block2;
        }
      _block2__branch4: {}
        if (!_vt_item.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _vs_sym (_vt_item, 0, 1);
        {
          {
            if (!RF_CALL (Class::Int_q_, _vs_sym, /*void*/))
            {
              goto _block3__branch1;
            }
            Expr _ge_auxcall5;
            RF_CALL (Box::_q_, Int, _ge_auxcall5);
            _ve_cpp_m_item = (_c_141 + _ge_auxcall5 + _c_140 + _vs_sym + _c_68);
            goto _block3;
          }
        _block3__branch1: {}
          if (!RF_CALL (Class::Word_q_, _vs_sym, /*void*/))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _ge_auxcall6;
          RF_CALL (Symbol_m_To_m_TPP, _vs_sym, _ge_auxcall6);
          _ve_cpp_m_item = (_c_142 + _ge_auxcall6 + _c_68);
        }
      _block3: {}
      }
    _block2: {}
      Expr _v_Const_m_Expr_m_Aux2;
      RF_CALL (Const_m_Expr_m_Aux, (_c_134 + _ve_rest), _v_Const_m_Expr_m_Aux2);
      _v_res1 = (_ve_cpp_m_item + _v_Const_m_Expr_m_Aux2);
      goto _block1;
    }
  _block1__branch3: {}
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Symbol_m_To_m_TPP, (RF_ARG _vs_ObjectSymbol;;), (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  RF_CALL (Convert::To_m_Chars, _vs_ObjectSymbol, _ge_auxcall1);
  Expr _ve_symbol (_ge_auxcall1);
  Expr _ve_cpp_m_symbol (empty);
  for ( ; ; )
  {
    {
      if (_ve_symbol.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_cpp_m_symbol;
      goto _exit__iter1;
    }
  _iter1: {}
    uintptr_t _v_len1 = _ve_symbol.get_len ();
    uintptr_t _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__rest = (_v_len1 - _v_len2);
    if (!_ve_symbol.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_char (_ve_symbol, 0, 1);
    Expr _ve_rest (_ve_symbol, (0 + 1), _v_len__rest);
    Expr _ve_cpp_m_char;
    {
      {
        if (!_vs_char.term_eq (_c_143, 0))
        {
          goto _block3__branch1;
        }
        _ve_cpp_m_char = _c_144;
        goto _block3;
      }
    _block3__branch1: {}
      {
        if (!_vs_char.term_eq (_c_145, 0))
        {
          goto _block3__branch2;
        }
        _ve_cpp_m_char = _c_146;
        goto _block3;
      }
    _block3__branch2: {}
      {
        if (!_vs_char.term_eq (_c_147, 0))
        {
          goto _block3__branch3;
        }
        _ve_cpp_m_char = _c_148;
        goto _block3;
      }
    _block3__branch3: {}
      {
        if (!_vs_char.term_eq (_c_149, 0))
        {
          goto _block3__branch4;
        }
        _ve_cpp_m_char = _c_150;
        goto _block3;
      }
    _block3__branch4: {}
      {
        if (!_vs_char.term_eq (_c_151, 0))
        {
          goto _block3__branch5;
        }
        _ve_cpp_m_char = _c_152;
        goto _block3;
      }
    _block3__branch5: {}
      if (!_vs_char.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _vs__e__e_tmp_m_rfp__asail__tpprf_m_463_m_8 (_vs_char, 0, 1);
      _ve_cpp_m_char = _vs_char;
    }
  _block3: {}
    _ve_symbol = _ve_rest;
    _ve_cpp_m_symbol = (_ve_cpp_m_symbol + _ve_cpp_m_char);
  }
_exit__iter1: {}
RF_END

RF_FUNC (Args_m_To_m_TPP, (RF_ARG _ge_arg1, _gs_arg2, _ge_arg3;;), (RF_RES _v_res1;;))
  {
    {
      if ((_ge_arg3.get_len () + 2) != 2)
      {
        goto _block1__branch1;
      }
      Expr _v_compose1 ((_ge_arg1 () + _gs_arg2 + _ge_arg3));
      if (_v_compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__compose1 (_v_compose1, 0);
      uintptr_t _v_len1 = _v_deref__compose1.get_len ();
      uintptr_t _v_len2 = 0;
      if (_v_len1 < (_v_len2 + 1))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__prefix = (_v_len1 - _v_len2);
      if (!_c_10.term_eq (_v_compose1, (0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _vv_prefix (_v_deref__compose1, 0, _v_len__prefix);
      _v_res1 = _c_153;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if ((_ge_arg3.get_len () + 2) != 2)
      {
        goto _block1__branch2;
      }
      Expr _v_compose2 ((_ge_arg1 () + _gs_arg2 + _ge_arg3));
      if (!_c_154.eq (_v_compose2, 0))
      {
        goto _block1__branch2;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if ((_ge_arg3.get_len () + 2) != 3)
      {
        goto _block1__branch3;
      }
      Expr _v_compose3 ((_ge_arg1 () + _gs_arg2 + _ge_arg3));
      if (_v_compose3.symbol_at ((0 + 1 + 1)))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__compose3 (_v_compose3, (0 + 1 + 1));
      uintptr_t _v_len3 = _v_deref__compose3.get_len ();
      uintptr_t _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__arg = (_v_len3 - _v_len4);
      if (!_c_154.eq (_v_compose3, 0))
      {
        goto _block1__branch3;
      }
      Expr _ve_arg (_v_deref__compose3, 0, _v_len__arg);
      RF_TAILCALL (CppMangle::Rfp2Cpp, _ve_arg (), _v_res1);
      goto _block1;
    }
  _block1__branch3: {}
    {
      if ((_ge_arg3.get_len () + 2) != 2)
      {
        goto _block1__branch4;
      }
      Expr _v_compose4 ((_ge_arg1 () + _gs_arg2 + _ge_arg3));
      if (_v_compose4.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__compose4 (_v_compose4, 0);
      uintptr_t _v_len5 = _v_deref__compose4.get_len ();
      uintptr_t _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__prefix2 = (_v_len5 - _v_len6);
      if (!_c_79.term_eq (_v_compose4, (0 + 1)))
      {
        goto _block1__branch4;
      }
      Expr _ve_prefix (_v_deref__compose4, 0, _v_len__prefix2);
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch4: {}
    {
      if ((_ge_arg3.get_len () + 2) != 3)
      {
        goto _block1__branch5;
      }
      Expr _v_compose5 ((_ge_arg1 () + _gs_arg2 + _ge_arg3));
      if (_v_compose5.symbol_at (0))
      {
        goto _block1__branch5;
      }
      if (_v_compose5.symbol_at ((0 + 1 + 1)))
      {
        goto _block1__branch5;
      }
      Expr _v_deref__compose5 (_v_compose5, 0);
      Expr _v_deref__compose52 (_v_compose5, (0 + 1 + 1));
      uintptr_t _v_len7 = _v_deref__compose52.get_len ();
      uintptr_t _v_len8 = 0;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__arg2 = (_v_len7 - _v_len8);
      uintptr_t _v_len9 = _v_deref__compose5.get_len ();
      uintptr_t _v_len10 = 0;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__prefix3 = (_v_len9 - _v_len10);
      if (!_c_79.term_eq (_v_compose5, (0 + 1)))
      {
        goto _block1__branch5;
      }
      Expr _ve_prefix (_v_deref__compose5, 0, _v_len__prefix3);
      Expr _ve_arg (_v_deref__compose52, 0, _v_len__arg2);
      RF_TAILCALL (Expr_m_Ref_m_To_m_TPP, _ve_arg, _v_res1);
      goto _block1;
    }
  _block1__branch5: {}
    Expr _ge_arg3__2 (_ge_arg3);
    Expr _ve_cpp_m_args (empty);
    for ( ; ; )
    {
      {
        if (_ge_arg3__2.get_len () != 0)
        {
          goto _iter1;
        }
        {
          {
            Expr _v_compose6 ((_ge_arg1 () + _gs_arg2));
            if (!_c_79.term_eq (_v_compose6, (0 + 1)))
            {
              goto _block2__branch1;
            }
            Expr _vt__e__e_tmp_m_rfp__asail__tpprf_m_494_m_8 (_v_compose6, 0, 1);
            _v_res1 = (_c_80 + _ve_cpp_m_args + _c_18);
            goto _block2;
          }
        _block2__branch1: {}
          {
            Expr _v_compose7 ((_ge_arg1 () + _gs_arg2));
            if (!_c_154.eq (_v_compose7, 0))
            {
              goto _block2__branch2;
            }
            _v_res1 = (_c_80 + _ve_cpp_m_args + _c_18);
            goto _block2;
          }
        _block2__branch2: {}
          {
            Expr _v_compose8 ((_ge_arg1 () + _gs_arg2));
            if (_v_compose8.symbol_at (0))
            {
              goto _block2__branch3;
            }
            Expr _v_deref__compose8 (_v_compose8, 0);
            uintptr_t _v_len11 = _v_deref__compose8.get_len ();
            uintptr_t _v_len12 = 0;
            if (_v_len11 < (_v_len12 + 1))
            {
              goto _block2__branch3;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__asail__tpprf_m_496_m_9 = (_v_len11 - _v_len12);
            if (!_c_10.term_eq (_v_compose8, (0 + 1)))
            {
              goto _block2__branch3;
            }
            Expr _vv__e__e_tmp_m_rfp__asail__tpprf_m_496_m_9 (_v_deref__compose8, 0, _v_len___e__e_tmp_m_rfp__asail__tpprf_m_496_m_9);
            _v_res1 = (_c_80 + _ge_arg1 + _ve_cpp_m_args + _c_155);
            goto _block2;
          }
        _block2__branch3: {}
          uintptr_t _v_len13 = 2;
          uintptr_t _v_len14 = 0;
          if (_v_len13 < _v_len14)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__asail__tpprf_m_497_m_8 = (_v_len13 - _v_len14);
          Expr _v_compose9 ((_ge_arg1 () + _gs_arg2));
          Expr _ve__e__e_tmp_m_rfp__asail__tpprf_m_497_m_8 (_v_compose9, 0, _v_len___e__e_tmp_m_rfp__asail__tpprf_m_497_m_8);
          _v_res1 = (_ge_arg1 + _ve_cpp_m_args);
        }
      _block2: {}
        goto _exit__iter1;
      }
    _iter1: {}
      uintptr_t _v_len15 = _ge_arg3__2.get_len ();
      uintptr_t _v_len16 = 1;
      if (_v_len15 < _v_len16)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__rest = (_v_len15 - _v_len16);
      if (_ge_arg3__2.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__arg3__2 (_ge_arg3__2, 0);
      uintptr_t _v_len17 = _v_deref__arg3__2.get_len ();
      uintptr_t _v_len18 = 0;
      if (_v_len17 < _v_len18)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__arg3 = (_v_len17 - _v_len18);
      Expr _ve_rest (_ge_arg3__2, (0 + 1), _v_len__rest);
      Expr _ve_arg (_v_deref__arg3__2, 0, _v_len__arg3);
      Expr _ve_comma;
      {
        {
          uintptr_t _v_len19 = _v_len__rest;
          uintptr_t _v_len20 = 0;
          if (_v_len19 < (_v_len20 + 1))
          {
            goto _block4__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__asail__tpprf_m_483_m_21 = (_v_len19 - _v_len20);
          Expr _vv__e__e_tmp_m_rfp__asail__tpprf_m_483_m_21 (_ve_rest, 0, _v_len___e__e_tmp_m_rfp__asail__tpprf_m_483_m_21);
          _ve_comma = _c_52;
          goto _block4;
        }
      _block4__branch1: {}
        _ve_comma = empty;
      }
    _block4: {}
      {
        {
          if (!_gs_arg2.term_eq (_c_10, 0))
          {
            goto _block5__branch1;
          }
          Expr _ge_auxcall1;
          RF_CALL (CppMangle::Rfp2Cpp, _ve_arg (), _ge_auxcall1);
          _ge_arg3__2 = _ve_rest;
          _ve_cpp_m_args = (_ve_cpp_m_args + _ge_auxcall1 + _ve_comma);
          goto _block5;
        }
      _block5__branch1: {}
        {
          if (!_gs_arg2.term_eq (_c_79, 0))
          {
            goto _block5__branch2;
          }
          Expr _ge_auxcall2;
          RF_CALL (Expr_m_Ref_m_To_m_TPP, _ve_arg, _ge_auxcall2);
          _ge_arg3__2 = _ve_rest;
          _ve_cpp_m_args = (_ve_cpp_m_args + _ge_auxcall2 + _ve_comma);
          goto _block5;
        }
      _block5__branch2: {}
        if (!_gs_arg2.term_eq (_c_97, 0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _ge_auxcall3;
        RF_CALL (Expr_m_Int_m_To_m_TPP, _ve_arg, _ge_auxcall3);
        _ge_arg3__2 = _ve_rest;
        _ve_cpp_m_args = (_ve_cpp_m_args + _ge_auxcall3 + _ve_comma);
      }
    _block5: {}
    }
  _exit__iter1: {}
  }
_block1: {}
RF_END

RF_FUNC (Name_m_To_m_TPP, (RF_ARG _vt_obj_m_name;;), (RF_RES _v_res1;;))
  Expr _ve_qualifiers;
  Expr _ve_name;
  RF_CALL (rfp__helper::RFP_m_Extract_m_Qualifiers, _vt_obj_m_name, (_ve_qualifiers, _ve_name));
  Expr _ve_namespace;
  RF_CALL (Box::_q_, Current_m_Namespace, _ve_namespace);
  {
    {
      uintptr_t _v_len1 = _ve_qualifiers.get_len ();
      uintptr_t _v_len2 = _ve_namespace.get_len ();
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__cont = (_v_len1 - _v_len2);
      if (!_ve_namespace.eq (_ve_qualifiers, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve_cont (_ve_qualifiers, (0 + _ve_namespace.get_len ()), _v_len__cont);
      RF_TAILCALL (CppMangle::Rfp2Cpp, (_ve_cont + _ve_name), _v_res1);
      goto _block1;
    }
  _block1__branch1: {}
    RF_TAILCALL (CppMangle::Rfp2Cpp, (_ve_qualifiers + _ve_name) (), _v_res1);
  }
_block1: {}
RF_END

RF_FUNC (TPP_m_Param, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () != 7)
      {
        goto _block1__branch1;
      }
      if (!_c_153.eq (_ge_arg1, 0))
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () < 8)
      {
        goto _block1__branch2;
      }
      if (!_c_156.eq (_ge_arg1, 0))
      {
        goto _block1__branch2;
      }
      Expr _v_subexpr__arg1 (_ge_arg1, (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1), (_ge_arg1.get_len () - (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 0)));
      RF_lsplit (_v_subexpr__arg1, 0, _ve_x, _v_lsplit__arg1);
      for ( ; ; RF_iter(_v_subexpr__arg1)++)
      {
        {
          if (!RF_iter(_v_subexpr__arg1))
          {
            goto _block1__branch2;
          }
          uintptr_t _v_len1 = _v_lsplit__arg1.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch2;
          }
          uintptr_t _v_len__y = (_v_len1 - _v_len2);
          if (!_c_12.term_eq (_v_lsplit__arg1, 0))
          {
            goto _continue1;
          }
          Expr _ve_y (_v_lsplit__arg1, (0 + 1), _v_len__y);
          Expr _v_TPP_m_Param1;
          RF_CALL (TPP_m_Param, (_c_156 + _ve_y), _v_TPP_m_Param1);
          _v_res1 = (_c_15 + _ve_x + _v_TPP_m_Param1);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch2: {}
    {
      uintptr_t _v_len3 = _ge_arg1.get_len ();
      uintptr_t _v_len4 = 10;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__x = (_v_len3 - _v_len4);
      if (!_c_156.eq (_ge_arg1, 0))
      {
        goto _block1__branch3;
      }
      if (!_c_155.eq (_ge_arg1, (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + _v_len__x)))
      {
        goto _block1__branch3;
      }
      Expr _ve_x (_ge_arg1, (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1), _v_len__x);
      _v_res1 = (_c_15 + _ve_x);
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (_ge_arg1.get_len () < 8)
      {
        goto _block1__branch4;
      }
      if (!_c_157.eq (_ge_arg1, 0))
      {
        goto _block1__branch4;
      }
      Expr _v_subexpr__arg12 (_ge_arg1, (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1), (_ge_arg1.get_len () - (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 0)));
      RF_lsplit (_v_subexpr__arg12, 0, _ve_x, _v_lsplit__arg12);
      for ( ; ; RF_iter(_v_subexpr__arg12)++)
      {
        {
          if (!RF_iter(_v_subexpr__arg12))
          {
            goto _block1__branch4;
          }
          uintptr_t _v_len5 = _v_lsplit__arg12.get_len ();
          uintptr_t _v_len6 = 1;
          if (_v_len5 < _v_len6)
          {
            goto _block1__branch4;
          }
          uintptr_t _v_len__y2 = (_v_len5 - _v_len6);
          if (!_c_12.term_eq (_v_lsplit__arg12, 0))
          {
            goto _continue2;
          }
          Expr _ve_y (_v_lsplit__arg12, (0 + 1), _v_len__y2);
          Expr _v_TPP_m_Param2;
          RF_CALL (TPP_m_Param, (_c_157 + _ve_y), _v_TPP_m_Param2);
          _v_res1 = (_c_158 + _ve_x + _v_TPP_m_Param2);
          goto _exit2;
        }
    _continue2: {}
      }
    _exit2: {}
      goto _block1;
    }
  _block1__branch4: {}
    uintptr_t _v_len7 = _ge_arg1.get_len ();
    uintptr_t _v_len8 = 10;
    if (_v_len7 < _v_len8)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__x2 = (_v_len7 - _v_len8);
    if (!_c_157.eq (_ge_arg1, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (!_c_155.eq (_ge_arg1, (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + _v_len__x2)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_x (_ge_arg1, (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1), _v_len__x2);
    _v_res1 = (_c_158 + _ve_x);
  }
_block1: {}
RF_END

RF_FUNC (Add, (RF_ARG _gs_arg1, _ge_arg2;;), RF_VOID)
  uintptr_t _v_len1 = (_ge_arg2.get_len () + 1);
  uintptr_t _v_len2 = 2;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__expr = (_v_len1 - _v_len2);
  Expr _v_compose1 ((_gs_arg1 + _ge_arg2));
  if (_v_compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (_v_compose1, (0 + 1));
  uintptr_t _v_len3 = _v_deref__compose1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__const = (_v_len3 - _v_len4);
  if (!_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_box (_v_compose1, 0, 1);
  Expr _ve_expr (_v_compose1, (0 + 1 + 1), _v_len__expr);
  Expr _ve_const (_v_deref__compose1, 0, _v_len__const);
  {
    {
      if (_v_len__expr < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ve_expr, 0, _ve_1, _v_lsplit__expr);
      for ( ; ; RF_iter(_ve_expr)++)
      {
        {
          if (!RF_iter(_ve_expr))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len5 = _v_lsplit__expr.get_len ();
          uintptr_t _v_len6 = 1;
          if (_v_len5 < _v_len6)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__2 = (_v_len5 - _v_len6);
          if (_v_lsplit__expr.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _v_deref__lsplit__expr (_v_lsplit__expr, 0);
          if (_v_deref__lsplit__expr.get_len () != _v_len__const)
          {
            goto _continue1;
          }
          if (!_ve_const.eq (_v_deref__lsplit__expr, 0))
          {
            goto _continue1;
          }
          Expr _ve_2 (_v_lsplit__expr, (0 + 1), _v_len__2);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    RF_TAILCALL (Box::Store, (_vs_box, (_ve_const () + _ve_expr)), /*void*/);
  }
_block1: {}
RF_END

RF_FUNC (Func_m_Const, (RF_ARG _ve_all_m_const, _ve_local_m_const;;), (RF_RES _v_res1;;))
  Expr _ve_res (empty);
  Expr _ve_all (_ve_all_m_const);
  Expr _ve_local (_ve_local_m_const);
  for ( ; ; )
  {
    {
      if (_ve_local.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_res;
      goto _exit__iter1;
    }
  _iter1: {}
    uintptr_t _v_len1 = _ve_local.get_len ();
    uintptr_t _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__rest = (_v_len1 - _v_len2);
    if (_ve_all.get_len () < 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_ve_local.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__local (_ve_local, 0);
    uintptr_t _v_len3 = _v_deref__local.get_len ();
    uintptr_t _v_len4 = 0;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__name = (_v_len3 - _v_len4);
    Expr _ve_rest (_ve_local, (0 + 1), _v_len__rest);
    Expr _ve_name (_v_deref__local, 0, _v_len__name);
    RF_lsplit (_ve_all, 0, _ve_1, _v_lsplit__all);
    for ( ; ; RF_iter(_ve_all)++)
    {
      {
        if (!RF_iter(_ve_all))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len5 = _v_lsplit__all.get_len ();
        uintptr_t _v_len6 = 1;
        if (_v_len5 < _v_len6)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len__2 = (_v_len5 - _v_len6);
        if (_v_lsplit__all.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__lsplit__all (_v_lsplit__all, 0);
        if (_v_deref__lsplit__all.get_len () != (_v_len__name + 1))
        {
          goto _continue1;
        }
        if (_v_deref__lsplit__all.symbol_at ((0 + _v_len__name)))
        {
          goto _continue1;
        }
        Expr _v_deref__deref__lsplit__all (_v_deref__lsplit__all, (0 + _v_len__name));
        uintptr_t _v_len7 = _v_deref__deref__lsplit__all.get_len ();
        uintptr_t _v_len8 = 0;
        if (_v_len7 < _v_len8)
        {
          goto _continue1;
        }
        uintptr_t _v_len__value = (_v_len7 - _v_len8);
        if (!_ve_name.eq (_v_deref__lsplit__all, 0))
        {
          goto _continue1;
        }
        Expr _ve_2 (_v_lsplit__all, (0 + 1), _v_len__2);
        Expr _ve_value (_v_deref__deref__lsplit__all, 0, _v_len__value);
        _ve_res = (_ve_res + (_ve_name + _ve_value ()) ());
        _ve_all = (_ve_1 + _ve_2);
        _ve_local = _ve_rest;
        goto _exit1;
      }
  _continue1: {}
    }
  _exit1: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Punct, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () != 0)
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg1 (_ge_arg1, 0);
      uintptr_t _v_len1 = _v_deref__arg1.get_len ();
      uintptr_t _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__1 = (_v_len1 - _v_len2);
      Expr _ve_1 (_v_deref__arg1, 0, _v_len__1);
      _v_res1 = _ve_1;
      goto _block1;
    }
  _block1__branch2: {}
    uintptr_t _v_len3 = _ge_arg1.get_len ();
    uintptr_t _v_len4 = 1;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__2 = (_v_len3 - _v_len4);
    if (_ge_arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__arg12 (_ge_arg1, 0);
    uintptr_t _v_len5 = _v_deref__arg12.get_len ();
    uintptr_t _v_len6 = 0;
    if (_v_len5 < _v_len6)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__12 = (_v_len5 - _v_len6);
    Expr _ve_2 (_ge_arg1, (0 + 1), _v_len__2);
    Expr _ve_1 (_v_deref__arg12, 0, _v_len__12);
    Expr _v_Punct1;
    RF_CALL (Punct, _ve_2, _v_Punct1);
    _v_res1 = (_ve_1 + _c_12 + _v_Punct1);
  }
_block1: {}
RF_END

RF_FUNC (Func_m_Prototype, (RF_ARG _ve_type, _ve_param;;), (RF_RES _v_res1;;))
  Expr _ve_init (empty);
  Expr _ve_list (_ve_param);
  for ( ; ; )
  {
    {
      if (_ve_list.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_init;
      goto _exit__iter1;
    }
  _iter1: {}
    uintptr_t _v_len1 = _ve_list.get_len ();
    uintptr_t _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__2 = (_v_len1 - _v_len2);
    if (_ve_list.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__list (_ve_list, 0);
    uintptr_t _v_len3 = _v_deref__list.get_len ();
    uintptr_t _v_len4 = 0;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__1 = (_v_len3 - _v_len4);
    Expr _ve_2 (_ve_list, (0 + 1), _v_len__2);
    Expr _ve_1 (_v_deref__list, 0, _v_len__1);
    Expr _v__q_1;
    RF_CALL (Box::_q_, Param, _v__q_1);
    if (_v__q_1.get_len () != 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (!_v__q_1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_numb (_v__q_1, 0, 1);
    Expr _gs_auxcall1;
    RF_CALL (Arithm::_p_, (_vs_numb, _c_159), _gs_auxcall1);
    RF_CALL (Box::Store, (Param, _gs_auxcall1), /*void*/);
    Expr _ge_auxcall2;
    RF_CALL (Box::_q_, Param, _ge_auxcall2);
    _ve_init = (_ve_init + (_ve_type + _c_160 + _ge_auxcall2) ());
    _ve_list = _ve_2;
  }
_exit__iter1: {}
RF_END

}

namespace rfp__asail__tpp
{

static void init_ ()
{
  Int = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Int");
  Module_m_Name = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Module-Name");
  Current_m_Namespace = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Current-Namespace");
  Current_m_Func = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Current-Func");
  Entry = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Entry");
  Entry_m_Name = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Entry-Name");
  Const_m_Exprs = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Const-Exprs");
  Const_m_Local = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Const-Local");
  Param = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Param");
  _c_0 = Expr::create<rftype::Word>("INT");
  _c_1 = Expr::create<rftype::Word>("Integer");
  _c_2 = Expr::create<rftype::Word>("Main");
  _c_3 = Expr::create<rftype::Word>("FUNC");
  _c_20 = rftype::Char::create_expr (L"tfun int ");
  _c_4 = Expr (_c_20, 0, 8);
  _c_5 = Expr::create<rftype::Word>("FUNC?");
  _c_6 = rftype::Char::create_expr (L"boolean");
  _c_161 = rftype::Char::create_expr (L"return true;");
  _c_7 = (_c_161) ();
  _c_8 = Expr::create<rftype::Word>("TFUNC");
  _c_156 = rftype::Char::create_expr (L"(RF_ARG");
  _c_9 = Expr (_c_156, 1, 6);
  _c_154 = (empty) () + Expr::create<rftype::Word>("Vars");
  _c_10 = Expr (_c_154, 1, 1);
  _c_157 = rftype::Char::create_expr (L"(RF_Res");
  _c_11 = Expr (_c_157, 1, 6);
  _c_41 = rftype::Char::create_expr (L",(Expr&) ");
  _c_12 = Expr (_c_41, 0, 1);
  _c_13 = Expr (_c_161, 11, 1);
  _c_14 = rftype::Char::create_expr (L" = ");
  _c_162 = rftype::Char::create_expr (L"tval Expr empty;");
  _c_15 = Expr (_c_162, 0, 10);
  _c_26 = rftype::Char::create_expr (L": {}");
  _c_16 = Expr (_c_26, 3, 1);
  _c_17 = rftype::Char::create_expr (L"{") + (_c_162) ();
  _c_163 = rftype::Char::create_expr (L"RF_FUNC_ERROR (unexpected_fail);");
  _c_18 = Expr (_c_163, 30, 1);
  _c_28 = rftype::Char::create_expr (L"for ( ; ");
  _c_19 = Expr (_c_28, 4, 2);
  _c_21 = Expr::create<rftype::Word>("IF");
  _c_22 = rftype::Char::create_expr (L"if (");
  _c_23 = Expr (_c_17, 0, 1);
  _c_24 = Expr::create<rftype::Word>("FOR");
  _c_25 = Expr::create<rftype::Word>("LABEL");
  _c_27 = Expr (_c_28, 6, 2);
  _c_29 = Expr::create<rftype::Word>("TRY");
  _c_30 = (rftype::Char::create_expr (L"RF_TRAP")) ();
  _c_31 = Expr::create<rftype::Word>("CATCH-ERROR");
  _c_32 = (rftype::Char::create_expr (L"RF_CLEANUP;")) ();
  _c_33 = (rftype::Char::create_expr (L"RF_WITH")) ();
  _c_34 = Expr::create<rftype::Word>("RETURN");
  _c_35 = Expr::create<rftype::Word>("RETFAIL");
  _c_36 = (rftype::Char::create_expr (L"RF_RETFAIL;")) ();
  _c_37 = Expr::create<rftype::Word>("FATAL");
  _c_38 = (_c_163) ();
  _c_39 = Expr::create<rftype::Word>("LSPLIT");
  _c_40 = Expr (_c_163, 30, 2);
  _c_42 = rftype::Char::create_expr (L", (Expr&) ");
  _c_43 = rftype::Char::create_expr (L"lsplit (");
  _c_44 = Expr::create<rftype::Word>("RSPLIT");
  _c_45 = Expr (_c_41, 0, 8);
  _c_46 = rftype::Char::create_expr (L"rsplit (");
  _c_47 = Expr::create<rftype::Word>("ASSIGN");
  _c_48 = Expr::create<rftype::Word>("DECL");
  _c_49 = Expr::create<rftype::Word>("EXPR");
  _c_50 = Expr (_c_22, 2, 2);
  _c_51 = Expr::create<rftype::Word>("DEREF");
  _c_52 = Expr (_c_42, 0, 2);
  _c_53 = Expr::create<rftype::Word>("SUBEXPR");
  _c_54 = Expr::create<rftype::Word>("DROP");
  _c_55 = rftype::Char::create_expr (L").drop ();");
  _c_56 = rftype::Char::create_expr (L"((Expr&)");
  _c_57 = Expr::create<rftype::Word>("CONTINUE");
  _c_58 = rftype::Char::create_expr (L"goto ");
  _c_59 = Expr::create<rftype::Word>("BREAK");
  _c_60 = Expr::create<rftype::Word>("ERROR");
  _c_61 = rftype::Char::create_expr (L"RF_ERROR (");
  _c_62 = Expr::create<rftype::Word>("CONSTEXPR");
  _c_63 = Expr::create<rftype::Word>("STATIC");
  _c_64 = Expr::create<rftype::Word>("OBJ");
  _c_65 = Expr::create<rftype::Word>("LOCAL");
  _c_66 = rftype::Char::create_expr (L"static ");
  _c_67 = Expr::create<rftype::Word>("BOX");
  _c_68 = rftype::Char::create_expr (L"\")");
  _c_69 = rftype::Char::create_expr (L"Expr::create_sym< NamedObject<BoxContents> >(L\"");
  _c_70 = Expr (_c_69, 43, 4);
  _c_71 = rftype::Char::create_expr (L"new rftype::StaticObject<rftype::");
  _c_72 = Expr (_c_162, 5, 5);
  _c_73 = Expr::create<rftype::Word>("DECL-OBJ");
  _c_74 = rftype::Char::create_expr (L"extern Expr ");
  _c_75 = Expr::create<rftype::Word>("DECL-FUNC");
  _c_76 = Expr::create<rftype::Integer>("0");
  _c_77 = Expr (_c_162, 0, 5);
  _c_158 = rftype::Char::create_expr (L"tout Expr ");
  _c_78 = Expr (_c_158, 0, 5);
  _c_79 = Expr::create<rftype::Word>("Exprs");
  _c_80 = Expr (_c_50, 1, 1);
  _c_81 = Expr::create<rftype::Word>("PAREN");
  _c_82 = Expr::create<rftype::Word>("LENGTH");
  _c_83 = Expr::create<rftype::Word>("MAX");
  _c_84 = Expr::create<rftype::Word>("MIN");
  _c_85 = Expr::create<rftype::Word>("INFIX");
  _c_86 = Expr::create_sym<rftype::Func> (Term_m_Ref_m_To_m_TPP);
  _c_87 = Expr::create<rftype::Word>("+");
  _c_88 = rftype::Char::create_expr (L" concat(");
  _c_89 = Expr (_c_55, 6, 3);
  _c_90 = rftype::Char::create_expr (L" tval Expr(");
  _c_91 = Expr (_c_90, 1, 10);
  _c_92 = Expr::create<rftype::Word>("REF");
  _c_93 = Expr::create<rftype::Word>("ERROR-EXPR");
  _c_94 = rftype::Char::create_expr (L"err");
  _c_95 = Expr::create<rftype::Word>("Illegal type int-symbol: ");
  _c_96 = rftype::Char::create_expr (L").get_len ()");
  _c_97 = Expr::create<rftype::Word>("Ints");
  _c_98 = rftype::Char::create_expr (L"pxx_max (");
  _c_99 = rftype::Char::create_expr (L"pxx_min (");
  _c_100 = Expr::create_sym<rftype::Func> (Expr_m_Int_m_To_m_TPP);
  _c_101 = Expr::create<rftype::Word>("CALL");
  _c_102 = Expr::create<rftype::Word>("SYMBOL?");
  _c_103 = rftype::Char::create_expr (L").symbol_at (");
  _c_104 = Expr::create<rftype::Word>("FLAT-SUBEXPR?");
  _c_105 = rftype::Char::create_expr (L").flat_at (");
  _c_106 = Expr::create<rftype::Word>("CHECK-ITER");
  _c_107 = rftype::Char::create_expr (L"iter(");
  _c_108 = Expr::create<rftype::Word>("EQ");
  _c_109 = rftype::Char::create_expr (L").eq (");
  _c_110 = Expr::create<rftype::Word>("TERM-EQ");
  _c_111 = rftype::Char::create_expr (L").term_eq (");
  _c_112 = Expr::create<rftype::Word>("NOT");
  _c_113 = rftype::Char::create_expr (L"!");
  _c_114 = Expr::create_sym<rftype::Func> (Cond_m_To_m_TPP);
  _c_115 = Expr::create<rftype::Word>("&&");
  _c_116 = Expr (_c_50, 0, 1);
  _c_117 = Expr::create<rftype::Word>("||");
  _c_118 = Expr::create<rftype::Word>("<");
  _c_119 = Expr::create<rftype::Word>(">");
  _c_120 = Expr::create<rftype::Word>("<=");
  _c_121 = Expr::create<rftype::Word>(">=");
  _c_122 = Expr::create<rftype::Word>("==");
  _c_123 = Expr::create<rftype::Word>("!=");
  _c_124 = Expr::create<rftype::Word>("-");
  _c_125 = Expr::create<rftype::Word>("%");
  _c_126 = Expr::create<rftype::Word>("*");
  _c_127 = Expr::create<rftype::Word>("/");
  _c_128 = Expr::create<rftype::Word>("INC-ITER");
  _c_129 = rftype::Char::create_expr (L")++");
  _c_130 = Expr::create<rftype::Word>("DEC-ITER");
  _c_131 = rftype::Char::create_expr (L")--");
  _c_132 = Expr (_c_162, 10, 5);
  _c_133 = rftype::Char::create_expr (L"tval Expr (");
  _c_134 = Expr (_c_154, 0, 1);
  _c_136 = rftype::Char::create_expr (L" + Char::create_expr (\"");
  _c_135 = Expr (_c_136, 0, 3);
  _c_137 = rftype::Char::create_expr (L") ()");
  _c_138 = rftype::Char::create_expr (L" + (");
  _c_139 = rftype::Char::create_expr (L" + Expr::create_sym<Func> (");
  _c_140 = Expr (_c_136, 21, 2);
  _c_142 = rftype::Char::create_expr (L" + Expr_create_Word(\"");
  _c_141 = Expr (_c_142, 0, 15);
  _c_144 = rftype::Char::create_expr (L"\\\\");
  _c_143 = Expr (_c_144, 0, 1);
  _c_145 = rftype::Char::create_expr (L"\n");
  _c_146 = rftype::Char::create_expr (L"\\n");
  _c_147 = rftype::Char::create_expr (L"\t");
  _c_148 = rftype::Char::create_expr (L"\\t");
  _c_149 = rftype::Char::create_expr (L"\r");
  _c_150 = rftype::Char::create_expr (L"\\r");
  _c_151 = Expr (_c_140, 1, 1);
  _c_152 = rftype::Char::create_expr (L"\\\"");
  _c_153 = rftype::Char::create_expr (L"RF_VOID");
  _c_155 = rftype::Char::create_expr (L";;)");
  _c_159 = Expr::create<rftype::Integer>("1");
  _c_160 = rftype::Char::create_expr (L" Expr var_");
}

static AtStart init_registrator_ (&init_);

}

}
