#include <rf_core.hh>
#include <refal/Box.hh>
#include <refal/Arithm.hh>
#include "rfp_src.hh"
#include <refal/StdIO.hh>

namespace refal
{

using namespace rfrt;

namespace rfp__err
{

Expr Error_m_Counter;

Expr Warning_m_Counter;

RF_DECL (RFP_m_Error);

RF_DECL (RFP_m_Warning);

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

RF_FUNC (RFP_m_Error, (RF_ARG _ge_arg1, _ge_arg2;;), RF_VOID)
  Expr _v_compose1 ((_ge_arg1 () + _ge_arg2 ()));
  if (_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (_v_compose1, 0);
  Expr _v_deref__compose12 (_v_compose1, (0 + 1));
  if (_v_deref__compose1.get_len () != 4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len1 = _v_deref__compose12.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__message = (_v_len1 - _v_len2);
  if (!_v_deref__compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_deref__compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_deref__compose1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_deref__compose1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_idx (_v_deref__compose1, 0, 1);
  Expr _vs_type (_v_deref__compose1, (0 + 1), 1);
  Expr _vs_row (_v_deref__compose1, (0 + 1 + 1), 1);
  Expr _vs_column (_v_deref__compose1, (0 + 1 + 1 + 1), 1);
  Expr _ve_message (_v_deref__compose12, 0, _v_len__message);
  Expr _vs_n;
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, Error_m_Counter, _v__q_1);
      if (_v__q_1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v__q_1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _gs_n__2 (_v__q_1, 0, 1);
      _vs_n = _gs_n__2;
      goto _block1;
    }
  _block1__branch1: {}
    _vs_n = _c_0;
  }
_block1: {}
  Expr _gs_auxcall1;
  RF_CALL (Arithm::_p_, (_vs_n, _c_1), _gs_auxcall1);
  RF_CALL (Box::Store, (Error_m_Counter, _gs_auxcall1), /*void*/);
  Expr _ge_auxcall2;
  RF_CALL (rfp__src::RFP_m_Source_m_File_m_Name, _vs_idx, _ge_auxcall2);
  RF_TAILCALL (StdIO::PrintLN, (_ge_auxcall2 + _c_4 + _vs_row + _c_3 + _vs_column + _c_2 + _ve_message), /*void*/);
RF_END

RF_FUNC (RFP_m_Warning, (RF_ARG _ge_arg1, _ge_arg2;;), RF_VOID)
  Expr _v_compose1 ((_ge_arg1 () + _ge_arg2 ()));
  if (_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (_v_compose1, 0);
  Expr _v_deref__compose12 (_v_compose1, (0 + 1));
  if (_v_deref__compose1.get_len () != 4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len1 = _v_deref__compose12.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__message = (_v_len1 - _v_len2);
  if (!_v_deref__compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_deref__compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_deref__compose1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_deref__compose1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_idx (_v_deref__compose1, 0, 1);
  Expr _vs_type (_v_deref__compose1, (0 + 1), 1);
  Expr _vs_row (_v_deref__compose1, (0 + 1 + 1), 1);
  Expr _vs_column (_v_deref__compose1, (0 + 1 + 1 + 1), 1);
  Expr _ve_message (_v_deref__compose12, 0, _v_len__message);
  Expr _vs_n;
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, Warning_m_Counter, _v__q_1);
      if (_v__q_1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v__q_1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _gs_n__2 (_v__q_1, 0, 1);
      _vs_n = _gs_n__2;
      goto _block1;
    }
  _block1__branch1: {}
    _vs_n = _c_0;
  }
_block1: {}
  Expr _gs_auxcall1;
  RF_CALL (Arithm::_p_, (_vs_n, _c_1), _gs_auxcall1);
  RF_CALL (Box::Store, (Warning_m_Counter, _gs_auxcall1), /*void*/);
  Expr _ge_auxcall2;
  RF_CALL (rfp__src::RFP_m_Source_m_File_m_Name, _vs_idx, _ge_auxcall2);
  RF_TAILCALL (StdIO::PrintLN, (_ge_auxcall2 + _c_4 + _vs_row + _c_3 + _vs_column + _c_5 + _ve_message), /*void*/);
RF_END

}

namespace rfp__err
{

static void init_ ()
{
  Error_m_Counter = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Error-Counter");
  Warning_m_Counter = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Warning-Counter");
  _c_0 = Expr::create<rftype::Integer>("0");
  _c_1 = Expr::create<rftype::Integer>("1");
  _c_2 = Expr::create<rftype::Word>(" --- Error: ");
  _c_3 = Expr::create<rftype::Word>(", ");
  _c_4 = Expr::create<rftype::Word>(": ");
  _c_5 = Expr::create<rftype::Word>(" --- Warning: ");
}

static AtStart init_registrator_ (&init_);

}

}
