#ifndef __rfp__src_hh__
#define __rfp__src_hh__

#include <rf_core.hh>

namespace refal
{

using namespace rfrt;

namespace rfp__src
{

RF_DECL (RFP_m_Src_m_Open_m_File);

RF_DECL (RFP_m_Src_m_Open_m_StdIN);

RF_DECL (RFP_m_Src_m_Close);

RF_DECL (RFP_m_Src_m_Get_m_Line);

RF_DECL (RFP_m_Get_m_Line_m_From_m_File);

RF_DECL (RFP_m_Get_m_Line_m_From_m_StdIN);

RF_DECL (RFP_m_Next_m_Row);

RF_DECL (RFP_m_Next_m_Column);

RF_DECL (RFP_m_Source_m_File_m_Name);

RF_DECL (RFP_m_Dir_m_Name);

RF_DECL (RFP_m_File_m_Name);

RF_DECL (RFP_m_Module_m_Name);

extern Expr RFP_m_Sources;

}

}

#endif // __rfp__src_hh__
