// $Id: sep.cc 2187 2006-12-15 00:17:56Z orlov $

#include <rf_core.hh>

namespace refal {

namespace File {

using namespace rftype;

Expr Path_m_Separator;
Expr Dir_m_Separator;

static void init_ ()
{
  #ifdef WINDOWS
    Path_m_Separator = Expr::create_sym<BoxContents>(Expr::create<Char>(L';'));
    Dir_m_Separator  = Expr::create_sym<BoxContents>(Expr::create<Char>(L'\\'));
  #else
    Path_m_Separator = Expr::create_sym<BoxContents>(Expr::create<Char>(L':'));
    Dir_m_Separator  = Expr::create_sym<BoxContents>(Expr::create<Char>(L'/'));
  #endif
}

static AtStart init_registrator_ (&init_);

}
}
