#include <rf_core.hh>
#include <refal/Apply.hh>
#include <refal/Convert.hh>
#include <refal/Class.hh>
#include "java_specific.hh"
#include <refal/List.hh>

namespace refal
{

using namespace rfrt;

namespace JavaMangle
{

static Expr Conv_m_Table;

RF_DECL (Rfp2Java);

RF_DECL (Qualifier2Java);

RF_DECL (Chars2Java);

RF_DECL (A_m_Char2Java);

RF_DECL (Char_m_To_m_Unicode);

RF_DECL (Java2Rfp);

RF_DECL (Qualifiers2Rfp);

RF_DECL (Chars2Rfp);

RF_DECL (Codes2Rfp);

RF_DECL (Reserved_m_Word_q___0);

static Expr _c_0;

static Expr _c_36;

static Expr _c_12;

static Expr _c_1;

static Expr _c_2;

static Expr _c_11;

static Expr _c_3;

static Expr _c_4;

static Expr _c_38;

static Expr _c_14;

static Expr _c_5;

static Expr _c_6;

static Expr _c_39;

static Expr _c_15;

static Expr _c_7;

static Expr _c_9;

static Expr _c_8;

static Expr _c_10;

static Expr _c_37;

static Expr _c_13;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_26;

static Expr _c_27;

static Expr _c_28;

static Expr _c_29;

static Expr _c_30;

static Expr _c_31;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

static Expr _c_40;

static Expr _c_41;

RF_FUNC (Rfp2Java, (RF_ARG _ve_rfp_m_obj;;), (RF_RES _v_res1;;))
  Expr _ve_ident;
  {
    {
      Expr _ve_prefix;
      Expr _ve_name;
      {
        {
          if ((_ve_rfp_m_obj.get_len () != 1))
          {
            goto _block2__branch1;
          }
          if (_ve_rfp_m_obj.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__rfp_m_obj (_ve_rfp_m_obj, 0);
          uintptr_t _v_len1 = _v_deref__rfp_m_obj.get_len ();
          uintptr_t _v_len2 = 2;
          if ((_v_len1 < _v_len2))
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__ns = (_v_len1 - _v_len2);
          if (_v_deref__rfp_m_obj.symbol_at ((_v_len__ns + 1)))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__deref__rfp_m_obj (_v_deref__rfp_m_obj, (_v_len__ns + 1));
          uintptr_t _v_len3 = _v_deref__deref__rfp_m_obj.get_len ();
          uintptr_t _v_len4 = 1;
          if ((_v_len3 < _v_len4))
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__name__1 = (_v_len3 - _v_len4);
          if (!_v_deref__rfp_m_obj.symbol_at (0))
          {
            goto _block2__branch1;
          }
          if (!_v_deref__deref__rfp_m_obj.symbol_at (_v_len__name__1))
          {
            goto _block2__branch1;
          }
          Expr _vs_tag (_v_deref__rfp_m_obj, 0, 1);
          Expr _ve_ns (_v_deref__rfp_m_obj, 1, _v_len__ns);
          Expr _v_name__1 (_v_deref__deref__rfp_m_obj, 0, _v_len__name__1);
          Expr _vs_last (_v_deref__deref__rfp_m_obj, _v_len__name__1, 1);
          if (!RF_CALL (Class::Int_q_, _vs_last, /*void*/))
          {
            goto _block2__branch1;
          }
          Expr _vs_t;
          {
            {
              if (!_vs_tag.term_eq (_c_0, 0))
              {
                goto _block3__branch1;
              }
              _vs_t = _c_1;
              goto _block3;
            }
          _block3__branch1: {}
            {
              if (!_vs_tag.term_eq (_c_2, 0))
              {
                goto _block3__branch2;
              }
              _vs_t = _c_3;
              goto _block3;
            }
          _block3__branch2: {}
            {
              if (!_vs_tag.term_eq (_c_4, 0))
              {
                goto _block3__branch3;
              }
              _vs_t = _c_5;
              goto _block3;
            }
          _block3__branch3: {}
            if (!_vs_tag.term_eq (_c_6, 0))
            {
              goto _block2__branch1;
            }
            _vs_t = _c_7;
          }
        _block3: {}
          _ve_prefix = (_c_9 + _vs_t + _ve_ns + _c_8);
          _ve_name = (_v_name__1 + _vs_last);
          goto _block2;
        }
      _block2__branch1: {}
        {
          if ((_ve_rfp_m_obj.get_len () != 1))
          {
            goto _block2__branch2;
          }
          if (_ve_rfp_m_obj.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__rfp_m_obj2 (_ve_rfp_m_obj, 0);
          uintptr_t _v_len5 = _v_deref__rfp_m_obj2.get_len ();
          uintptr_t _v_len6 = 2;
          if ((_v_len5 < _v_len6))
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len__ns2 = (_v_len5 - _v_len6);
          if (_v_deref__rfp_m_obj2.symbol_at ((_v_len__ns2 + 1)))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__deref__rfp_m_obj2 (_v_deref__rfp_m_obj2, (_v_len__ns2 + 1));
          uintptr_t _v_len7 = _v_deref__deref__rfp_m_obj2.get_len ();
          uintptr_t _v_len8 = 0;
          if ((_v_len7 < _v_len8))
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len__name__12 = (_v_len7 - _v_len8);
          if (!_c_10.term_eq (_v_deref__rfp_m_obj2, 0))
          {
            goto _block2__branch2;
          }
          Expr _ve_ns (_v_deref__rfp_m_obj2, 1, _v_len__ns2);
          Expr _v_name__1 (_v_deref__deref__rfp_m_obj2, 0, _v_len__name__12);
          _ve_prefix = (_c_11 + _ve_ns + _c_8);
          _ve_name = _v_name__1;
          goto _block2;
        }
      _block2__branch2: {}
        {
          if ((_ve_rfp_m_obj.get_len () != 1))
          {
            goto _block2__branch3;
          }
          if (_ve_rfp_m_obj.symbol_at (0))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__rfp_m_obj3 (_ve_rfp_m_obj, 0);
          uintptr_t _v_len9 = _v_deref__rfp_m_obj3.get_len ();
          uintptr_t _v_len10 = 2;
          if ((_v_len9 < _v_len10))
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len__ns3 = (_v_len9 - _v_len10);
          if (_v_deref__rfp_m_obj3.symbol_at ((_v_len__ns3 + 1)))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__deref__rfp_m_obj3 (_v_deref__rfp_m_obj3, (_v_len__ns3 + 1));
          uintptr_t _v_len11 = _v_deref__deref__rfp_m_obj3.get_len ();
          uintptr_t _v_len12 = 0;
          if ((_v_len11 < _v_len12))
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len__name__13 = (_v_len11 - _v_len12);
          if (!_c_0.term_eq (_v_deref__rfp_m_obj3, 0))
          {
            goto _block2__branch3;
          }
          Expr _ve_ns (_v_deref__rfp_m_obj3, 1, _v_len__ns3);
          Expr _v_name__1 (_v_deref__deref__rfp_m_obj3, 0, _v_len__name__13);
          _ve_prefix = (_c_12 + _ve_ns + _c_8);
          _ve_name = _v_name__1;
          goto _block2;
        }
      _block2__branch3: {}
        {
          if ((_ve_rfp_m_obj.get_len () != 1))
          {
            goto _block2__branch4;
          }
          if (_ve_rfp_m_obj.symbol_at (0))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__rfp_m_obj4 (_ve_rfp_m_obj, 0);
          uintptr_t _v_len13 = _v_deref__rfp_m_obj4.get_len ();
          uintptr_t _v_len14 = 2;
          if ((_v_len13 < _v_len14))
          {
            goto _block2__branch4;
          }
          uintptr_t _v_len__ns4 = (_v_len13 - _v_len14);
          if (_v_deref__rfp_m_obj4.symbol_at ((_v_len__ns4 + 1)))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__deref__rfp_m_obj4 (_v_deref__rfp_m_obj4, (_v_len__ns4 + 1));
          uintptr_t _v_len15 = _v_deref__deref__rfp_m_obj4.get_len ();
          uintptr_t _v_len16 = 0;
          if ((_v_len15 < _v_len16))
          {
            goto _block2__branch4;
          }
          uintptr_t _v_len__name__14 = (_v_len15 - _v_len16);
          if (!_c_2.term_eq (_v_deref__rfp_m_obj4, 0))
          {
            goto _block2__branch4;
          }
          Expr _ve_ns (_v_deref__rfp_m_obj4, 1, _v_len__ns4);
          Expr _v_name__1 (_v_deref__deref__rfp_m_obj4, 0, _v_len__name__14);
          _ve_prefix = (_c_13 + _ve_ns + _c_8);
          _ve_name = _v_name__1;
          goto _block2;
        }
      _block2__branch4: {}
        {
          if ((_ve_rfp_m_obj.get_len () != 1))
          {
            goto _block2__branch5;
          }
          if (_ve_rfp_m_obj.symbol_at (0))
          {
            goto _block2__branch5;
          }
          Expr _v_deref__rfp_m_obj5 (_ve_rfp_m_obj, 0);
          uintptr_t _v_len17 = _v_deref__rfp_m_obj5.get_len ();
          uintptr_t _v_len18 = 2;
          if ((_v_len17 < _v_len18))
          {
            goto _block2__branch5;
          }
          uintptr_t _v_len__ns5 = (_v_len17 - _v_len18);
          if (_v_deref__rfp_m_obj5.symbol_at ((_v_len__ns5 + 1)))
          {
            goto _block2__branch5;
          }
          Expr _v_deref__deref__rfp_m_obj5 (_v_deref__rfp_m_obj5, (_v_len__ns5 + 1));
          uintptr_t _v_len19 = _v_deref__deref__rfp_m_obj5.get_len ();
          uintptr_t _v_len20 = 0;
          if ((_v_len19 < _v_len20))
          {
            goto _block2__branch5;
          }
          uintptr_t _v_len__name__15 = (_v_len19 - _v_len20);
          if (!_c_4.term_eq (_v_deref__rfp_m_obj5, 0))
          {
            goto _block2__branch5;
          }
          Expr _ve_ns (_v_deref__rfp_m_obj5, 1, _v_len__ns5);
          Expr _v_name__1 (_v_deref__deref__rfp_m_obj5, 0, _v_len__name__15);
          _ve_prefix = (_c_14 + _ve_ns + _c_8);
          _ve_name = _v_name__1;
          goto _block2;
        }
      _block2__branch5: {}
        {
          if ((_ve_rfp_m_obj.get_len () != 1))
          {
            goto _block2__branch6;
          }
          if (_ve_rfp_m_obj.symbol_at (0))
          {
            goto _block2__branch6;
          }
          Expr _v_deref__rfp_m_obj6 (_ve_rfp_m_obj, 0);
          uintptr_t _v_len21 = _v_deref__rfp_m_obj6.get_len ();
          uintptr_t _v_len22 = 2;
          if ((_v_len21 < _v_len22))
          {
            goto _block2__branch6;
          }
          uintptr_t _v_len__ns6 = (_v_len21 - _v_len22);
          if (_v_deref__rfp_m_obj6.symbol_at ((_v_len__ns6 + 1)))
          {
            goto _block2__branch6;
          }
          Expr _v_deref__deref__rfp_m_obj6 (_v_deref__rfp_m_obj6, (_v_len__ns6 + 1));
          uintptr_t _v_len23 = _v_deref__deref__rfp_m_obj6.get_len ();
          uintptr_t _v_len24 = 0;
          if ((_v_len23 < _v_len24))
          {
            goto _block2__branch6;
          }
          uintptr_t _v_len__name__16 = (_v_len23 - _v_len24);
          if (!_c_6.term_eq (_v_deref__rfp_m_obj6, 0))
          {
            goto _block2__branch6;
          }
          Expr _ve_ns (_v_deref__rfp_m_obj6, 1, _v_len__ns6);
          Expr _v_name__1 (_v_deref__deref__rfp_m_obj6, 0, _v_len__name__16);
          _ve_prefix = (_c_15 + _ve_ns + _c_8);
          _ve_name = _v_name__1;
          goto _block2;
        }
      _block2__branch6: {}
        {
          if ((_ve_rfp_m_obj.get_len () != 1))
          {
            goto _block2__branch7;
          }
          if (_ve_rfp_m_obj.symbol_at (0))
          {
            goto _block2__branch7;
          }
          Expr _v_deref__rfp_m_obj7 (_ve_rfp_m_obj, 0);
          if ((_v_deref__rfp_m_obj7.get_len () != 2))
          {
            goto _block2__branch7;
          }
          if (_v_deref__rfp_m_obj7.symbol_at (1))
          {
            goto _block2__branch7;
          }
          Expr _v_deref__deref__rfp_m_obj7 (_v_deref__rfp_m_obj7, 1);
          uintptr_t _v_len25 = _v_deref__deref__rfp_m_obj7.get_len ();
          uintptr_t _v_len26 = 0;
          if ((_v_len25 < _v_len26))
          {
            goto _block2__branch7;
          }
          uintptr_t _v_len__name__17 = (_v_len25 - _v_len26);
          if (!_c_16.term_eq (_v_deref__rfp_m_obj7, 0))
          {
            goto _block2__branch7;
          }
          Expr _v_name__1 (_v_deref__deref__rfp_m_obj7, 0, _v_len__name__17);
          _ve_prefix = _c_17;
          _ve_name = _v_name__1;
          goto _block2;
        }
      _block2__branch7: {}
        if ((_ve_rfp_m_obj.get_len () != 1))
        {
          goto _block1__branch1;
        }
        if (_ve_rfp_m_obj.symbol_at (0))
        {
          goto _block1__branch1;
        }
        Expr _v_deref__rfp_m_obj8 (_ve_rfp_m_obj, 0);
        if ((_v_deref__rfp_m_obj8.get_len () != 2))
        {
          goto _block1__branch1;
        }
        if (_v_deref__rfp_m_obj8.symbol_at (1))
        {
          goto _block1__branch1;
        }
        Expr _v_deref__deref__rfp_m_obj8 (_v_deref__rfp_m_obj8, 1);
        uintptr_t _v_len27 = _v_deref__deref__rfp_m_obj8.get_len ();
        uintptr_t _v_len28 = 0;
        if ((_v_len27 < _v_len28))
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len__name__18 = (_v_len27 - _v_len28);
        if (!_c_18.term_eq (_v_deref__rfp_m_obj8, 0))
        {
          goto _block1__branch1;
        }
        Expr _v_name__1 (_v_deref__deref__rfp_m_obj8, 0, _v_len__name__18);
        _ve_prefix = _c_8;
        _ve_name = _v_name__1;
      }
    _block2: {}
      Expr _v_Chars2Java1;
      RF_CALL (Chars2Java, _ve_name, _v_Chars2Java1);
      _ve_ident = (_ve_prefix + _v_Chars2Java1);
      goto _block1;
    }
  _block1__branch1: {}
    {
      Expr _v_auxblock1;
      {
        {
          if ((_ve_rfp_m_obj.get_len () != 1))
          {
            goto _block4__branch1;
          }
          if (_ve_rfp_m_obj.symbol_at (0))
          {
            goto _block4__branch1;
          }
          Expr _v_deref__rfp_m_obj9 (_ve_rfp_m_obj, 0);
          uintptr_t _v_len29 = _v_deref__rfp_m_obj9.get_len ();
          uintptr_t _v_len30 = 1;
          if ((_v_len29 < _v_len30))
          {
            goto _block4__branch1;
          }
          uintptr_t _v_len__names = (_v_len29 - _v_len30);
          if (!_c_19.term_eq (_v_deref__rfp_m_obj9, 0))
          {
            goto _block4__branch1;
          }
          Expr _ve_names (_v_deref__rfp_m_obj9, 1, _v_len__names);
          _v_auxblock1 = _ve_names;
          goto _block4;
        }
      _block4__branch1: {}
        {
          if ((_ve_rfp_m_obj.get_len () != 1))
          {
            goto _block4__branch2;
          }
          if (_ve_rfp_m_obj.symbol_at (0))
          {
            goto _block4__branch2;
          }
          Expr _v_deref__rfp_m_obj10 (_ve_rfp_m_obj, 0);
          uintptr_t _v_len31 = _v_deref__rfp_m_obj10.get_len ();
          uintptr_t _v_len32 = 0;
          if ((_v_len31 < _v_len32))
          {
            goto _block4__branch2;
          }
          uintptr_t _v_len__names2 = (_v_len31 - _v_len32);
          Expr _ve_names (_v_deref__rfp_m_obj10, 0, _v_len__names2);
          _v_auxblock1 = _ve_names;
          goto _block4;
        }
      _block4__branch2: {}
        uintptr_t _v_len33 = _ve_rfp_m_obj.get_len ();
        uintptr_t _v_len34 = 0;
        if ((_v_len33 < _v_len34))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len__names3 = (_v_len33 - _v_len34);
        Expr _ve_names (_ve_rfp_m_obj, 0, _v_len__names3);
        _v_auxblock1 = _ve_names;
      }
    _block4: {}
      uintptr_t _v_len35 = _v_auxblock1.get_len ();
      uintptr_t _v_len36 = 1;
      if ((_v_len35 < _v_len36))
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__qualifiers = (_v_len35 - _v_len36);
      if (!_v_auxblock1.symbol_at (_v_len__qualifiers))
      {
        goto _block1__branch2;
      }
      Expr _ve_qualifiers (_v_auxblock1, 0, _v_len__qualifiers);
      Expr _vs_name (_v_auxblock1, _v_len__qualifiers, 1);
      Expr _v_Map1;
      RF_CALL (List::Map, (_c_20, empty, _ve_qualifiers), _v_Map1);
      Expr _v_Chars2Java2;
      RF_CALL (Chars2Java, _vs_name, _v_Chars2Java2);
      _ve_ident = (_v_Map1 + _v_Chars2Java2);
      goto _block1;
    }
  _block1__branch2: {}
    _ve_ident = empty;
  }
_block1: {}
  {
    {
      Expr _v_Apply1;
      if (!RF_CALL (Apply::Apply, (_c_21, _ve_ident), _v_Apply1))
      {
        goto _block5__branch1;
      }
      uintptr_t _v_len37 = _v_Apply1.get_len ();
      uintptr_t _v_len38 = 0;
      if ((_v_len37 < _v_len38))
      {
        goto _block5__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m__s__s_JavaMangle_s_refal_s_JavaManglerf_m_81_m_40 = (_v_len37 - _v_len38);
      Expr _ve__e__e_tmp_m__s__s_JavaMangle_s_refal_s_JavaManglerf_m_81_m_40 (_v_Apply1, 0, _v_len___e__e_tmp_m__s__s_JavaMangle_s_refal_s_JavaManglerf_m_81_m_40);
      _v_res1 = (_c_22 + _ve_ident);
      goto _block5;
    }
  _block5__branch1: {}
    _v_res1 = _ve_ident;
  }
_block5: {}
RF_END

RF_FUNC (Qualifier2Java, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  if ((_v_arg1.get_len () != 1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_qualifier (_v_arg1, 0, 1);
  Expr _v_Chars2Java1;
  RF_CALL (Chars2Java, _vs_qualifier, _v_Chars2Java1);
  _v_res1 = (_v_Chars2Java1 + java__specific::Namespace_m_Delimeter);
RF_END

RF_FUNC (Chars2Java, (RF_ARG _ve_name;;), (RF_RES _v_res1;;))
  Expr _v_To_m_Chars1;
  RF_CALL (Convert::To_m_Chars, _ve_name, _v_To_m_Chars1);
  RF_TAILCALL (List::Map, (_c_23, empty, _v_To_m_Chars1), _v_res1);
RF_END

RF_FUNC (A_m_Char2Java, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  if ((_v_arg1.get_len () != 1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_char (_v_arg1, 0, 1);
  {
    {
      if (!RF_CALL (Class::Digit_q_, _vs_char, /*void*/))
      {
        goto _block1__branch1;
      }
      _v_res1 = _vs_char;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!RF_CALL (Class::Letter_q_, _vs_char, /*void*/))
      {
        goto _block1__branch2;
      }
      {
        RF_lsplit (_c_24, 0, _ve__e__e_tmp_m__s__s_JavaMangle_s_refal_s_JavaManglerf_m_91_m_34, _v_lsplit__24);
        for ( ; ; RF_iter(_c_24)++)
        {
          {
            if (!RF_iter(_c_24))
            {
              goto _negation1;
            }
            uintptr_t _v_len1 = _v_lsplit__24.get_len ();
            uintptr_t _v_len2 = 1;
            if ((_v_len1 < _v_len2))
            {
              goto _negation1;
            }
            uintptr_t _v_len___e__e_tmp_m__s__s_JavaMangle_s_refal_s_JavaManglerf_m_91_m_43 = (_v_len1 - _v_len2);
            if (!_vs_char.term_eq (_v_lsplit__24, 0))
            {
              goto _continue1;
            }
            Expr _ve__e__e_tmp_m__s__s_JavaMangle_s_refal_s_JavaManglerf_m_91_m_43 (_v_lsplit__24, 1, _v_len___e__e_tmp_m__s__s_JavaMangle_s_refal_s_JavaManglerf_m_91_m_43);
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
        goto _block1__branch2;
      }
    _negation1: {}
      _v_res1 = _vs_char;
      goto _block1;
    }
  _block1__branch2: {}
    {
      RF_lsplit (Conv_m_Table, 0, _ve__e__e_tmp_m__s__s_JavaMangle_s_refal_s_JavaManglerf_m_92_m_18, _v_lsplit__Conv_m_Table);
      for ( ; ; RF_iter(Conv_m_Table)++)
      {
        {
          if (!RF_iter(Conv_m_Table))
          {
            goto _block1__branch3;
          }
          uintptr_t _v_len3 = _v_lsplit__Conv_m_Table.get_len ();
          uintptr_t _v_len4 = 1;
          if ((_v_len3 < _v_len4))
          {
            goto _block1__branch3;
          }
          uintptr_t _v_len___e__e_tmp_m__s__s_JavaMangle_s_refal_s_JavaManglerf_m_92_m_36 = (_v_len3 - _v_len4);
          if (_v_lsplit__Conv_m_Table.symbol_at (0))
          {
            goto _continue2;
          }
          Expr _v_deref__lsplit__Conv_m_Table (_v_lsplit__Conv_m_Table, 0);
          uintptr_t _v_len5 = _v_deref__lsplit__Conv_m_Table.get_len ();
          uintptr_t _v_len6 = 1;
          if ((_v_len5 < _v_len6))
          {
            goto _continue2;
          }
          uintptr_t _v_len__code = (_v_len5 - _v_len6);
          if (!_vs_char.term_eq (_v_deref__lsplit__Conv_m_Table, 0))
          {
            goto _continue2;
          }
          Expr _ve__e__e_tmp_m__s__s_JavaMangle_s_refal_s_JavaManglerf_m_92_m_36 (_v_lsplit__Conv_m_Table, 1, _v_len___e__e_tmp_m__s__s_JavaMangle_s_refal_s_JavaManglerf_m_92_m_36);
          Expr _ve_code (_v_deref__lsplit__Conv_m_Table, 1, _v_len__code);
          _v_res1 = (_c_8 + _ve_code + _c_8);
          goto _exit2;
        }
    _continue2: {}
      }
    _exit2: {}
      goto _block1;
    }
  _block1__branch3: {}
    Expr _v_Char_m_To_m_Unicode1;
    RF_CALL (Char_m_To_m_Unicode, _vs_char, _v_Char_m_To_m_Unicode1);
    _v_res1 = (_c_8 + _v_Char_m_To_m_Unicode1 + _c_8);
  }
_block1: {}
RF_END

RF_FUNC (Char_m_To_m_Unicode, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (!_v_arg1.term_eq (_c_25, 0))
      {
        goto _block1__branch1;
      }
      _v_res1 = _c_26;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_v_arg1.term_eq (_c_27, 0))
      {
        goto _block1__branch2;
      }
      _v_res1 = _c_28;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_v_arg1.term_eq (_c_29, 0))
      {
        goto _block1__branch3;
      }
      _v_res1 = _c_30;
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (!_v_arg1.term_eq (_c_3, 0))
      {
        goto _block1__branch4;
      }
      _v_res1 = _c_31;
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (!_v_arg1.term_eq (_c_32, 0))
      {
        goto _block1__branch5;
      }
      _v_res1 = _c_33;
      goto _block1;
    }
  _block1__branch5: {}
    if (!_v_arg1.term_eq (_c_34, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = _c_35;
  }
_block1: {}
RF_END

RF_FUNC (Java2Rfp, (RF_ARG _ve_ident;;), (RF_RES _v_res1;;))
  Expr _v_To_m_Chars1;
  RF_CALL (Convert::To_m_Chars, _ve_ident, _v_To_m_Chars1);
  Expr _v_auxblock1;
  {
    {
      uintptr_t _v_len1 = _v_To_m_Chars1.get_len ();
      uintptr_t _v_len2 = (1 + 1 + 1);
      if (((_v_len1 < (_v_len2 + (0 * 1)))))
      {
        goto _block1__branch1;
      }
      if (((_v_len1 - _v_len2) % 1))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__name = ((_v_len1 - _v_len2) / 1);
      if (!_c_22.eq (_v_To_m_Chars1, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve_name (_v_To_m_Chars1, (0 + 1 + 1 + 1), _v_len__name);
      _v_auxblock1 = _ve_name;
      goto _block1;
    }
  _block1__branch1: {}
    uintptr_t _v_len3 = _v_To_m_Chars1.get_len ();
    uintptr_t _v_len4 = 0;
    if (((_v_len3 < (_v_len4 + (0 * 1)))))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (((_v_len3 - _v_len4) % 1))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__name2 = ((_v_len3 - _v_len4) / 1);
    Expr _ve_name (_v_To_m_Chars1, 0, _v_len__name2);
    _v_auxblock1 = _ve_name;
  }
_block1: {}
  {
    {
      uintptr_t _v_len5 = _v_auxblock1.get_len ();
      uintptr_t _v_len6 = (1 + 1 + 1 + 1);
      if (((_v_len5 < (_v_len6 + (0 * 1)))))
      {
        goto _block2__branch1;
      }
      if (((_v_len5 - _v_len6) % 1))
      {
        goto _block2__branch1;
      }
      uintptr_t _v_len__name3 = ((_v_len5 - _v_len6) / 1);
      if (!_c_36.eq (_v_auxblock1, 0))
      {
        goto _block2__branch1;
      }
      Expr _ve_name (_v_auxblock1, (0 + 1 + 1 + 1 + 1), _v_len__name3);
      Expr _v_Chars2Rfp1;
      if (!RF_CALL (Chars2Rfp, _ve_name, _v_Chars2Rfp1))
      {
        RF_RETFAIL;
      }
      _v_res1 = (_c_0 + _v_Chars2Rfp1 ()) ();
      goto _block2;
    }
  _block2__branch1: {}
    {
      uintptr_t _v_len7 = _v_auxblock1.get_len ();
      uintptr_t _v_len8 = (1 + 1 + 1 + 1);
      if (((_v_len7 < (_v_len8 + (0 * 1)))))
      {
        goto _block2__branch2;
      }
      if (((_v_len7 - _v_len8) % 1))
      {
        goto _block2__branch2;
      }
      uintptr_t _v_len__name4 = ((_v_len7 - _v_len8) / 1);
      if (!_c_37.eq (_v_auxblock1, 0))
      {
        goto _block2__branch2;
      }
      Expr _ve_name (_v_auxblock1, (0 + 1 + 1 + 1 + 1), _v_len__name4);
      Expr _v_Chars2Rfp2;
      if (!RF_CALL (Chars2Rfp, _ve_name, _v_Chars2Rfp2))
      {
        RF_RETFAIL;
      }
      _v_res1 = (_c_2 + _v_Chars2Rfp2 ()) ();
      goto _block2;
    }
  _block2__branch2: {}
    {
      uintptr_t _v_len9 = _v_auxblock1.get_len ();
      uintptr_t _v_len10 = (1 + 1 + 1 + 1);
      if (((_v_len9 < (_v_len10 + (0 * 1)))))
      {
        goto _block2__branch3;
      }
      if (((_v_len9 - _v_len10) % 1))
      {
        goto _block2__branch3;
      }
      uintptr_t _v_len__name5 = ((_v_len9 - _v_len10) / 1);
      if (!_c_38.eq (_v_auxblock1, 0))
      {
        goto _block2__branch3;
      }
      Expr _ve_name (_v_auxblock1, (0 + 1 + 1 + 1 + 1), _v_len__name5);
      Expr _v_Chars2Rfp3;
      if (!RF_CALL (Chars2Rfp, _ve_name, _v_Chars2Rfp3))
      {
        RF_RETFAIL;
      }
      _v_res1 = (_c_4 + _v_Chars2Rfp3 ()) ();
      goto _block2;
    }
  _block2__branch3: {}
    {
      uintptr_t _v_len11 = _v_auxblock1.get_len ();
      uintptr_t _v_len12 = (1 + 1 + 1 + 1);
      if (((_v_len11 < (_v_len12 + (0 * 1)))))
      {
        goto _block2__branch4;
      }
      if (((_v_len11 - _v_len12) % 1))
      {
        goto _block2__branch4;
      }
      uintptr_t _v_len__name6 = ((_v_len11 - _v_len12) / 1);
      if (!_c_39.eq (_v_auxblock1, 0))
      {
        goto _block2__branch4;
      }
      Expr _ve_name (_v_auxblock1, (0 + 1 + 1 + 1 + 1), _v_len__name6);
      Expr _v_Chars2Rfp4;
      if (!RF_CALL (Chars2Rfp, _ve_name, _v_Chars2Rfp4))
      {
        RF_RETFAIL;
      }
      _v_res1 = (_c_6 + _v_Chars2Rfp4 ()) ();
      goto _block2;
    }
  _block2__branch4: {}
    uintptr_t _v_len13 = _v_auxblock1.get_len ();
    uintptr_t _v_len14 = 0;
    if (((_v_len13 < (_v_len14 + (0 * 1)))))
    {
      RF_RETFAIL;
    }
    if (((_v_len13 - _v_len14) % 1))
    {
      RF_RETFAIL;
    }
    uintptr_t _v_len__name7 = ((_v_len13 - _v_len14) / 1);
    Expr _ve_name (_v_auxblock1, 0, _v_len__name7);
    RF_TAILCALL (Qualifiers2Rfp, _ve_name, _v_res1);
  }
_block2: {}
RF_END

RF_FUNC (Qualifiers2Rfp, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (((_v_arg1.get_len () < (1 + 1 + 0 + 0))))
      {
        goto _block1__branch1;
      }
      RF_lsplit (_v_arg1, 0, _ve_qualifier, _v_lsplit__arg1);
      for ( ; ; RF_iter(_v_arg1)++)
      {
        {
          if (!RF_iter(_v_arg1))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_lsplit__arg1.get_len ();
          uintptr_t _v_len2 = (1 + 1);
          if (((_v_len1 < (_v_len2 + (0 * 1)))))
          {
            goto _block1__branch1;
          }
          if (((_v_len1 - _v_len2) % 1))
          {
            goto _continue1;
          }
          uintptr_t _v_len__rest = ((_v_len1 - _v_len2) / 1);
          if (!java__specific::Namespace_m_Delimeter.eq (_v_lsplit__arg1, 0))
          {
            goto _continue1;
          }
          Expr _ve_rest (_v_lsplit__arg1, (0 + 1 + 1), _v_len__rest);
          Expr _v_Chars2Rfp1;
          if (!RF_CALL (Chars2Rfp, _ve_qualifier, _v_Chars2Rfp1))
          {
            RF_RETFAIL;
          }
          Expr _v_Qualifiers2Rfp1;
          if (!RF_CALL (Qualifiers2Rfp, _ve_rest, _v_Qualifiers2Rfp1))
          {
            RF_RETFAIL;
          }
          _v_res1 = (_v_Chars2Rfp1 + _v_Qualifiers2Rfp1);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    if (!RF_CALL (Chars2Rfp, _v_arg1, _v_res1))
    {
      RF_RETFAIL;
    }
  }
_block1: {}
RF_END

RF_FUNC (Chars2Rfp, (RF_ARG _ve_name;;), (RF_RES _v_res1;;))
  Expr _v_Codes2Rfp1;
  if (!RF_CALL (Codes2Rfp, _ve_name, _v_Codes2Rfp1))
  {
    RF_RETFAIL;
  }
  RF_TAILCALL (Convert::To_m_Word, _v_Codes2Rfp1, _v_res1);
RF_END

RF_FUNC (Codes2Rfp, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (((_v_arg1.get_len () < (1 + 1 + 0 + 0))))
      {
        goto _block1__branch1;
      }
      if (!_c_8.term_eq (_v_arg1, 0))
      {
        goto _block1__branch1;
      }
      Expr _v_subexpr__arg1 (_v_arg1, (0 + 1), (_v_arg1.get_len () - (0 + 1 + 0)));
      RF_lsplit (_v_subexpr__arg1, 0, _ve_code, _v_lsplit__arg1);
      for ( ; ; RF_iter(_v_subexpr__arg1)++)
      {
        {
          if (!RF_iter(_v_subexpr__arg1))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_lsplit__arg1.get_len ();
          uintptr_t _v_len2 = 1;
          if (((_v_len1 < (_v_len2 + (0 * 1)))))
          {
            goto _block1__branch1;
          }
          if (((_v_len1 - _v_len2) % 1))
          {
            goto _continue1;
          }
          uintptr_t _v_len__rest = ((_v_len1 - _v_len2) / 1);
          if (!_c_8.term_eq (_v_lsplit__arg1, 0))
          {
            goto _continue1;
          }
          Expr _ve_rest (_v_lsplit__arg1, (0 + 1), _v_len__rest);
          if ((((1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1) < (1 + 0 + 0))))
          {
            RF_RETFAIL;
          }
          RF_lsplit (Conv_m_Table, 0, _ve__e__e_tmp_m__s__s_JavaMangle_s_refal_s_JavaManglerf_m_135_m_20, _v_lsplit__Conv_m_Table);
          for ( ; ; RF_iter(Conv_m_Table)++)
          {
            {
              if (!RF_iter(Conv_m_Table))
              {
                RF_RETFAIL;
              }
              uintptr_t _v_len3 = _v_lsplit__Conv_m_Table.get_len ();
              uintptr_t _v_len4 = 1;
              if (((_v_len3 < (_v_len4 + (0 * 1)))))
              {
                RF_RETFAIL;
              }
              if (((_v_len3 - _v_len4) % 1))
              {
                goto _continue2;
              }
              uintptr_t _v_len___e__e_tmp_m__s__s_JavaMangle_s_refal_s_JavaManglerf_m_135_m_38 = ((_v_len3 - _v_len4) / 1);
              if (_v_lsplit__Conv_m_Table.symbol_at (0))
              {
                goto _continue2;
              }
              Expr _v_deref__lsplit__Conv_m_Table (_v_lsplit__Conv_m_Table, 0);
              if ((_v_deref__lsplit__Conv_m_Table.get_len () != (1 + _ve_code.get_len ())))
              {
                goto _continue2;
              }
              if (!_v_deref__lsplit__Conv_m_Table.symbol_at (0))
              {
                goto _continue2;
              }
              if (!_ve_code.eq (_v_deref__lsplit__Conv_m_Table, (0 + 1)))
              {
                goto _continue2;
              }
              Expr _ve__e__e_tmp_m__s__s_JavaMangle_s_refal_s_JavaManglerf_m_135_m_38 (_v_lsplit__Conv_m_Table, (0 + 1), _v_len___e__e_tmp_m__s__s_JavaMangle_s_refal_s_JavaManglerf_m_135_m_38);
              Expr _vs_char (_v_deref__lsplit__Conv_m_Table, 0, 1);
              Expr _v_Codes2Rfp1;
              if (!RF_CALL (Codes2Rfp, _ve_rest, _v_Codes2Rfp1))
              {
                RF_RETFAIL;
              }
              _v_res1 = (_vs_char + _v_Codes2Rfp1);
              goto _exit2;
            }
        _continue2: {}
          }
        _exit2: {}
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len5 = _v_arg1.get_len ();
      uintptr_t _v_len6 = 1;
      if (((_v_len5 < (_v_len6 + (0 * 1)))))
      {
        goto _block1__branch2;
      }
      if (((_v_len5 - _v_len6) % 1))
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__rest2 = ((_v_len5 - _v_len6) / 1);
      if (!_v_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _vs_char (_v_arg1, 0, 1);
      Expr _ve_rest (_v_arg1, (0 + 1), _v_len__rest2);
      {
        {
          if (!RF_CALL (Class::Digit_q_, _vs_char, /*void*/))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        if (!RF_CALL (Class::Letter_q_, _vs_char, /*void*/))
        {
          RF_RETFAIL;
        }
        {
          {
            if ((1 != 1))
            {
              goto _negation1;
            }
            if (!_vs_char.term_eq (_c_40, 0))
            {
              goto _negation1;
            }
          }
        _block3: {}
          RF_RETFAIL;
        }
      _negation1: {}
      }
    _block2: {}
      Expr _v_Codes2Rfp2;
      if (!RF_CALL (Codes2Rfp, _ve_rest, _v_Codes2Rfp2))
      {
        RF_RETFAIL;
      }
      _v_res1 = (_vs_char + _v_Codes2Rfp2);
      goto _block1;
    }
  _block1__branch2: {}
    if ((_v_arg1.get_len () != 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Reserved_m_Word_q___0, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = _v_arg1.get_len ();
  uintptr_t _v_len2 = 0;
  if (((_v_len1 < (_v_len2 + (0 * 1)))))
  {
    RF_ERROR (_c_41);
  }
  if (((_v_len1 - _v_len2) % 1))
  {
    RF_ERROR (_c_41);
  }
  uintptr_t _v_len__stub1 = ((_v_len1 - _v_len2) / 1);
  Expr _v_stub1 (_v_arg1, 0, _v_len__stub1);
  if (!RF_CALL (java__specific::Reserved_m_Word_q_, _v_stub1, /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

}

namespace JavaMangle
{

static void init_ ()
{
  Conv_m_Table = (Char::create_expr (L"!e")) () + (Char::create_expr (L"?q")) () + (Char::create_expr (L"_")) () + (Char::create_expr (L"-m")) () + (Char::create_expr (L"+p")) () + (Char::create_expr (L"<lt")) () + (Char::create_expr (L">gt")) () + (Char::create_expr (L"=eq")) () + (Char::create_expr (L"*a")) () + (Char::create_expr (L"/s")) () + (Char::create_expr (L" sp")) () + (Char::create_expr (L"\\bs")) () + (Char::create_expr (L"|bar")) () + (Char::create_expr (L"~tilde")) () + (Char::create_expr (L"@at")) () + (Char::create_expr (L"#num")) () + (Char::create_expr (L"$dollar")) () + (Char::create_expr (L"%percnt")) () + (Char::create_expr (L"^circ")) () + (Char::create_expr (L"&amp")) () + (Char::create_expr (L"(lpar")) () + (Char::create_expr (L")rpar")) () + (Char::create_expr (L"[lsqb")) () + (Char::create_expr (L"]rsqb")) () + (Char::create_expr (L"{lcub")) () + (Char::create_expr (L"}rcub")) () + (Char::create_expr (L"`grave")) () + (Char::create_expr (L"'apos")) () + (Char::create_expr (L"\"quot")) () + (Char::create_expr (L",comma")) () + (Char::create_expr (L".period")) () + (Char::create_expr (L":colon")) () + (Char::create_expr (L";semi")) ();
  _c_0 = Expr::create<Word>("EVAR");
  _c_36 = Char::create_expr (L"_ve_");
  _c_12 = Expr (_c_36, 0, 3);
  _c_1 = Expr (_c_12, 2, 1);
  _c_2 = Expr::create<Word>("VVAR");
  _c_11 = Expr (_c_12, 0, 2);
  _c_3 = Expr (_c_11, 1, 1);
  _c_4 = Expr::create<Word>("TVAR");
  _c_38 = Char::create_expr (L"_vt_");
  _c_14 = Expr (_c_38, 0, 3);
  _c_5 = Expr (_c_14, 2, 1);
  _c_6 = Expr::create<Word>("SVAR");
  _c_39 = Char::create_expr (L"_vs_");
  _c_15 = Expr (_c_39, 0, 3);
  _c_7 = Expr (_c_15, 2, 1);
  _c_9 = Char::create_expr (L"_g");
  _c_8 = Expr (_c_9, 0, 1);
  _c_10 = Expr::create<Word>("VAR");
  _c_37 = Char::create_expr (L"_vv_");
  _c_13 = Expr (_c_37, 0, 3);
  _c_16 = Expr::create<Word>("STATIC");
  _c_17 = Char::create_expr (L"_c_");
  _c_18 = Expr::create<Word>("LABEL");
  _c_19 = Expr::create<Word>("OBJ");
  _c_20 = Expr::create_sym<Func> (Qualifier2Java);
  _c_21 = Expr::create_sym<Func> (Reserved_m_Word_q___0);
  _c_22 = Char::create_expr (L"_r_");
  _c_23 = Expr::create_sym<Func> (A_m_Char2Java);
  _c_24 = Char::create_expr (L"?!");
  _c_25 = Char::create_expr (L"b");
  _c_26 = Char::create_expr (L"08");
  _c_27 = Char::create_expr (L"\t");
  _c_28 = Char::create_expr (L"09");
  _c_29 = Char::create_expr (L"\n");
  _c_30 = Char::create_expr (L"0A");
  _c_31 = Char::create_expr (L"0B");
  _c_32 = Char::create_expr (L"f");
  _c_33 = Char::create_expr (L"0C");
  _c_34 = Char::create_expr (L"\r");
  _c_35 = Char::create_expr (L"0D");
  _c_40 = Expr (_c_24, 0, 1);
  _c_41 = Expr::create<Word>("Apply") + Expr::create<Word>("Apply") + Expr::create<Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}
