#include <rf_core.hh>
#include <refal/Convert.hh>
#include "java_specific.hh"

namespace refal
{

using namespace rfrt;

namespace java__specific
{

Expr Namespace_m_Delimeter;

static Expr Reserved_m_Words;

RF_FUNC (Reserved_m_Word_q_, (RF_ARG _ve_word;;), RF_VOID)
  Expr _vs_word;
  RF_CALL (Convert::To_m_Word, _ve_word, _vs_word);
  RF_lsplit (Reserved_m_Words, 0, _ve__e__e_tmp_m_java__specificrf_m_28_m_50, _v_lsplit__Reserved_m_Words);
  for ( ; ; RF_iter(Reserved_m_Words)++)
  {
    {
      if (!RF_iter(Reserved_m_Words))
      {
        RF_RETFAIL;
      }
      uintptr_t _v_len1 = _v_lsplit__Reserved_m_Words.get_len ();
      uintptr_t _v_len2 = 1;
      if ((_v_len1 < _v_len2))
      {
        RF_RETFAIL;
      }
      uintptr_t _v_len___e__e_tmp_m_java__specificrf_m_28_m_59 = (_v_len1 - _v_len2);
      if (!_vs_word.term_eq (_v_lsplit__Reserved_m_Words, 0))
      {
        goto _continue1;
      }
      Expr _ve__e__e_tmp_m_java__specificrf_m_28_m_59 (_v_lsplit__Reserved_m_Words, 1, _v_len___e__e_tmp_m_java__specificrf_m_28_m_59);
      goto _exit1;
    }
_continue1: {}
  }
_exit1: {}
RF_END

}

namespace java__specific
{

static void init_ ()
{
  Namespace_m_Delimeter = Char::create_expr (".");
  Reserved_m_Words = Expr::create<Word>("abstract") + Expr::create<Word>("continue") + Expr::create<Word>("for") + Expr::create<Word>("new") + Expr::create<Word>("switch") + Expr::create<Word>("assert") + Expr::create<Word>("default") + Expr::create<Word>("goto") + Expr::create<Word>("package") + Expr::create<Word>("synchronized") + Expr::create<Word>("boolean") + Expr::create<Word>("do") + Expr::create<Word>("if") + Expr::create<Word>("private") + Expr::create<Word>("this") + Expr::create<Word>("break") + Expr::create<Word>("double") + Expr::create<Word>("implements") + Expr::create<Word>("protected") + Expr::create<Word>("throw") + Expr::create<Word>("byte") + Expr::create<Word>("else") + Expr::create<Word>("import") + Expr::create<Word>("public") + Expr::create<Word>("throws") + Expr::create<Word>("case") + Expr::create<Word>("enum") + Expr::create<Word>("instanceof") + Expr::create<Word>("return") + Expr::create<Word>("transient") + Expr::create<Word>("catch") + Expr::create<Word>("extends") + Expr::create<Word>("int") + Expr::create<Word>("short") + Expr::create<Word>("try") + Expr::create<Word>("char") + Expr::create<Word>("final") + Expr::create<Word>("interface") + Expr::create<Word>("static") + Expr::create<Word>("void") + Expr::create<Word>("class") + Expr::create<Word>("finally") + Expr::create<Word>("long") + Expr::create<Word>("strictfp") + Expr::create<Word>("volatile") + Expr::create<Word>("const") + Expr::create<Word>("float") + Expr::create<Word>("native") + Expr::create<Word>("super") + Expr::create<Word>("while") + Expr::create<Word>("false") + Expr::create<Word>("true") + Expr::create<Word>("null");
}

static AtStart init_registrator_ (&init_);

}

}
