#ifndef __Lexer_hh__
#define __Lexer_hh__

#include <rf_core.hh>

namespace refal
{

using namespace rfrt;

namespace Lexer
{

RF_DECL (Skip_m_Blank_q_);

RF_DECL (Skip_m_Comment_q_);

RF_DECL (Scan_m_Keyword_q_);

RF_DECL (Scan_m_Number_q_);

RF_DECL (Scan_m_Variable_q_);

RF_DECL (Scan_m_Identifier_q_);

RF_DECL (Scan_m_Quoted_m_Word_q_);

RF_DECL (Scan_m_String_q_);

RF_DECL (Scan_m_Char_q_);

RF_DECL (Read_m_Term_q_);

RF_DECL (Start_m_Collect_m_Errors);

RF_DECL (Stop_m_Collect_m_Errors);

RF_DECL (Collecting_m_Errors_q_);

extern Expr Case_m_Insensitive;

}

}

#endif // __Lexer_hh__
